var shareReport={};
shareReport.isInitialized = false;
shareReport.isFirstLoaded = true;
var cachedData = null;
shareReport.eventsAdded=false;
var customReport = {};
var totalUsersLoaded;
var searchText="";
var searchLimit=100;
shareReport.initComponents= function initComponents(fromHomePage) {
	$(".nextButton").css("display","none");
	$(".saveButton").css("display","");
	
	$('#content').mask('');
	$("#security-dialog-form").mask("");
	searchText = searchText.replace(/^\s+|\s+$/g,''); //trimming lead and trail spaces with old browser compatibility
	var usersDataSetUrl="/api/cr/reportsplusengine/datasets/47d3afa6-1222-42ae-ad76-e767f5a481a9/data?orderby=%5BType%5D Desc,%5Bname%5D Asc&isExport=false&cacheId="+shareReport.generateUUID(); //Uses Security API Built in Custom Report
	if(searchText!=""){
		usersDataSetUrl += "&where=%5Bname%5D = _exprString (\"" + encodeURIComponent(searchText) + "\",\"contains\")";
	}
	var xhrUsers = $.get( cvUtil.getContextPath() + usersDataSetUrl , function(data) {
		$('#content').unmask('');

		var jsonData=JSON.parse(data)["records"];
		var finalData = new Array();

			for(var i=0 ; i < jsonData.length ; i++ ){
				var indData = {
					"id" : jsonData[i][2],
					"login" : jsonData[i][3],
					"type" : jsonData[i][4] 
			};
			finalData.push(indData);
		}

		if(cachedData==null || shareReport.isInitialized==false ){
			cachedData = finalData;
			shareReport.populateColumns(finalData, fromHomePage,true);
		}
		shareReport.isInitialized=true;
	})
	.fail(function() {
		$("#content").unmask();
		cvUtil.errorToast("Failed Calling Security API Dataset");
		$("#queryName").val("");
	});
	
	$( "#security-dialog-form" ).dialog({
	      autoOpen: false,
	      height: 440,
	      width: 790,
	      resizable: false,
	      modal: true,
	      buttons: [ 
	    	  {
		    	  text:"Cancel",
		    	  click: function() {
		    		  $("#security-dialog-form").dialog( "close" );
					  $("#security-dialog-form").dialog("destroy");
		    		  if(!fromHomePage) {
			        	  $("#security-dialog-form #selectedUserList").empty();	
			        	  shareReport.populateColumns(cachedData, fromHomePage);
			          }
		    	  }
	    	  },
	    	  {
		    	  text:"Ok",
		    	  click: function() {
		    		  	// code for sharing report...
			        	var withinReport = $("#withinReport").val();
//			        	if(withinReport === 'false') {
			        		// send a request to update the share information of the report.
			        		updateShareOptions();
//			        	} else {
			        		// do nothing. The share info will be saved as part of report data.
//			        		$( this ).dialog( "close" );
//			        	}
		    	  },
		    	  "class" : "okSaveButton"
	    	  }
	        
	      ],
	      close: function() {
	    	  resetSearch();
	    	  shareReport.isInitialized = false;
	      }
	    });
};

shareReport.generateUUID = function() {
	if(!shareReport.cacheID){
		var currentTime = new Date().getTime();
		shareReport.cacheID = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(chr) {
			var randomNum = (currentTime + Math.random() * 16) % 16 | 0;
			currentTime = Math.floor(currentTime / 16);
			return (chr == 'x' ? randomNum : (randomNum & 0x7 | 0x8)).toString(16);
		});
	}
	return shareReport.cacheID;
};

function addEvents() {
	$("#shareButton").click(function(event){
		// create and display users dialog.
		var data = $("#shareButton").data();
//		customReport.id = data.reportid;
		shareReport.doOpenDialog(false);
	});
	
	$("#shareButton2").click(function(event){
		shareReport.doOpenDialog(false);
	});
	
	// moveRight and moveRight buttons in the dialog.
	
	$("#moveRight").click(function(){
		$("#security-dialog-form #availableUserList .selectedUser").each(function() {
			$(this).removeClass("selectedUser");
			var idValue= "#selectable"+$(this).attr("data-usertype")+$(this).attr("data-userid");
			if($("#security-dialog-form #selectedUserList").find(idValue).length<1){
				$(this).appendTo("#security-dialog-form #selectedUserList");
			}else{
				$(this).remove();
			}
			resetSearch();
		});
	});
	$("#moveLeft").click(function(){
		$("#security-dialog-form #selectedUserList .selectedUser").each(function() {
			var idValue= "#selectable"+$(this).attr("data-usertype")+$(this).attr("data-userid");
			$(this).removeClass("selectedUser");
			if($("#security-dialog-form #availableUserList").find(idValue).length<1){
				$(this).appendTo("#security-dialog-form #availableUserList");
			}else{
				$(this).remove();
			}
			resetSearch();
		});
	});
}

function resetSearch(){
	if($("#cr-security-search-user").val()!=""){
		$("#cr-security-search-user").val("");
		$("#cr-security-search-user").trigger("change");
	}
}

function updateShareOptions() {
	var options = shareReport.getShareOptions();
	$("#security-dialog-form").mask("");
	cvUtil.loadPageWithSessionCheck(cvUtil.getContextPath() + "/server/updateSecurityAssociation.do",
			{	
				"id": customReport.reportId,
				"users" : options.users,
				"userGroups" : options.userGroups,
				"externalGroups" : options.externalGroups,
				"reportName" : customReport.reportName
			},
			function(data){
				customReport.user = options.users;
				customReport.userGroup = options.userGroups;
				customReport.externalGroups = options.externalGroups;
				var elem = $("#"+customReport.reportId+"_action-share"); 
				elem.attr("data-user", options.users);
				elem.attr("data-userGroup", options.userGroups);
				elem.attr("data-externalGroups", options.externalGroups);
				cvUtil.logGUIEvent("ReportLevel=[CustomReport] Report=["+customReport.reportName+"] Action=[share] SelectedUsers=["+options.userNames+"] SelectedGroups=["+options.userGroupNames+"] SelectedExternalGroups=["+options.externalGroupNames+"]");
				cvUtil.toast(data,30000);
				
				$("#security-dialog-form").unmask("");
				$("#security-dialog-form").dialog( "close" );
				$("#security-dialog-form").dialog("destroy");
			},
			function(xhr, ajaxOptions, thrownError){
				$("#security-dialog-form").unmask("");
				cvUtil.errorToast($.trim(xhr.responseText),30000);
			});
}

shareReport.populateColumns = 	function populateColumns(data, fromHomePage,unmask) {
		cvUtil.loadPageWithSessionCheck(cvUtil.getContextPath() + "/server/getSecurityAssociation.do",
				{	
					"id": customReport.reportId
				},
				function(associations){
					//associations = associations.members;
					customReport.user = associations.users;
					customReport.userGroup = associations.userGroups;
					customReport.externalGroups = associations.externalGroups;
					shareReport.doPopulate(data, fromHomePage);
					if(unmask)
						$("#security-dialog-form").unmask("");	
				},
				function(xhr, ajaxOptions, thrownError){
					cvUtil.errorToast($.trim(xhr.responseText),30000);
				});
}

shareReport.createLiElement = function createLiElement(user){
	var sourceLi = $("<li></li>", {
		text:user.login,
		class:"selectableuser",
		id:"selectable"+user.type+user.id,
		"data-user":user.login,
		"data-userType":user.type,
		"data-userId":user.id
	});
	if(user.type ==2 || user.type ==3){	
		sourceLi.addClass('selectableUserGroup');
	}
	
	return sourceLi;
}

shareReport.doPopulate = 	function populateColumns(data, fromHomePage) {
	totalUsersLoaded=0;
	var unsavedSelectedUsers = [];
	if(!fromHomePage) {
		unsavedSelectedUsers = getSelectedUsers();
	}
	var priorSelectedList=$("#security-dialog-form #selectedUserList").html();
	clearAll();
	if(priorSelectedList!=""){
		$("#security-dialog-form #selectedUserList").html(priorSelectedList);
	}
	if (Array.isArray(data)) {
		/*data.sort(function(a,b){
			if(a.type > 1 && b.type > 1){
				return a.login - b.login;
			}
			return a.type < b.type;
		});*/
		$.each( data ,function(i,user){
			if(totalUsersLoaded>=searchLimit){
				return false; //"break" equivalent for jQuery $.each
			}
			var sourceLi=shareReport.createLiElement(user);
			var idValue= "#selectable"+user.type+user.id;
			if($("#security-dialog-form #selectedUserList").find(idValue).length<1){
				$("#security-dialog-form #availableUserList").append(sourceLi);
				totalUsersLoaded++;
			}
		});
	}
	
	
//	$('#cr-security-search-user').keyup(function(event) {
//		var search_text = $('#cr-security-search-user').val();
//		var rg = new RegExp(search_text,'i');
//		$("#security-dialog-form #availableUserList li").each(function(i){
//			if($.trim($(this).html()).search(rg) == -1) {
//				$(this).css('display', 'none');				
//			}	
//			else {
//				$(this).css('display', '');
//			}
//		});
//	});
	
	$('#cr-security-search-user').change(function(event) {
		loadAgainFromDataset(fromHomePage);
	});
	
	$('#cr-security-search-user').focusout(function(event) {
		$("#typeEnterMessage").hide();
	});
	
	if(isFirstLoaded()){
		if(typeof customReport !== 'undefined' && customReport != null){		
			if($.trim(customReport.user) != '')
				setShareOptions(customReport.user,1);
			if($.trim(customReport.userGroup) != '')
				setShareOptions(customReport.userGroup,2);
			if($.trim(customReport.externalGroups) != '')
				setShareOptions(customReport.externalGroups,3);
		} else {
		}
		
		if(unsavedSelectedUsers.length) {
			var i;
			for(i=0; i<unsavedSelectedUsers.length; i++) {
				addUserToSelectedList(unsavedSelectedUsers[i].userid,unsavedSelectedUsers[i].usertype);
			}
		}
	}
	$(".selectableuser").click(function(){
		$(this).toggleClass('selectedUser');
	});
};

function isFirstLoaded(){
	var val = shareReport.isFirstLoaded;
	shareReport.isFirstLoaded=false;
	return val;
}
 function loadAgainFromDataset(fromHomePage){
	 cachedData=null;
	 searchText= $('#cr-security-search-user').val();
	 shareReport.initComponents(fromHomePage);
 }
 
 function setShareOptions(users,type){	
	$.each(users,function(i,value){
		addUserToSelectedList(value,type);
		
	});
}
 
 function addUserToSelectedList(userid,type){
	 var element = removeFromSelectedList("#selectable"+type+userid);	 
	 //element.removeClass('selectableuser');
	 if(element.hasClass('selectedUser')) {
		 element.removeClass('selectedUser');
	 }
	 if(element[0]!=undefined){
		 $("#security-dialog-form #selectedUserList").append(element[0]);
	 }
	 else{
		 var idValue= "#selectable"+type+userid;
		 if($("#security-dialog-form #selectedUserList").find(idValue).length<1 
				 && $("#security-dialog-form #availableUserList").find(idValue).length<1 ){
			 for( var i=0; i<cachedData.length;i++){
				 if(cachedData[i].id==userid && cachedData[i].type==type ){
					 var sourceLi = shareReport.createLiElement(cachedData[i]);
					 $("#security-dialog-form #selectedUserList").append(sourceLi);
					 break;
				 }
			 }
		 }
	 }
 }
 
function removeFromSelectedList(id){
	 return $("#security-dialog-form #availableUserList").find(id).remove();
 }

function showAllAvailableUsers(){
	$("#security-dialog-form #availableUserList li").each(function() {
		$(this).css('display', '');
	});
}

shareReport.getShareOptions = function getShareOptions(){
	var options= {};
	var selectedUsers="";
	var selectedUserNames = ""; 
	var selectedUserGroups="";
	var selectedUserGroupNames="";
	var selectedExternalGroups="";
	var selectedExternalGroupNames="";
	$("#security-dialog-form #selectedUserList li").each(function(i){
		if($(this).data('usertype') == 1){
			if(selectedUsers == ""){
				selectedUsers=$(this).data('userid')+"";
				selectedUserNames = $(this).text()+"";
			}else{				
				selectedUsers=selectedUsers+","+$(this).data('userid');
				selectedUserNames = selectedUserNames+","+$(this).text();
			}
		}	
		else if($(this).data('usertype') == 2){
			if(selectedUserGroups == ""){
				selectedUserGroups=$(this).data('userid')+"";
				selectedUserGroupNames =$(this).text()+"";; 
			}else{				
				selectedUserGroups = selectedUserGroups+","+$(this).data('userid');
				selectedUserGroupNames = selectedUserGroupNames + "," +$(this).text();
			}
		}	
		else if($(this).data('usertype') == 3){
			if(selectedExternalGroups == ""){
				selectedExternalGroups=$(this).data('userid')+"";
				selectedExternalGroupNames =$(this).text()+"";; 
			}else{				
				selectedExternalGroups=selectedExternalGroups+","+$(this).data('userid');
				selectedExternalGroupNames = selectedExternalGroupNames + "," +$(this).text();
			}
		}	
	});
	
	options.users=selectedUsers.substring(0,selectedUsers.length);
	options.userGroups=selectedUserGroups.substring(0,selectedUserGroups.length);
	options.externalGroups=selectedExternalGroups.substring(0,selectedExternalGroups.length);
	options.userNames=selectedUserNames.substring(0,selectedUserNames.length);
	options.userGroupNames=selectedUserGroupNames.substring(0,selectedUserGroupNames.length);
	options.externalGroupNames=selectedExternalGroupNames.substring(0,selectedExternalGroupNames.length);
	
	return options;
};

shareReport.getShareOptionsFromCustomReport = function getShareOptions(){
	var options= {};
	options.users=customReport.user;
	options.userGroups=customReport.userGroup;
	options.externalGroups=customReport.externalGroups;
	return options;
};

shareReport.doOpenDialog = function(fromHomePage, report) {
	$("#security-dialog-form").dialog("destroy");
	if (report) { // coming from report manager
		customReport.reportId = report.reportId;
		customReport.reportName = report.reportName;
	}
	clearAll();
	cachedData=null;
	shareReport.isFirstLoaded = true;
	shareReport.initComponents(fromHomePage);
	$("#dialogReportName").text(customReport.reportName);
	
	$("#security-dialog-form").removeClass("hidden");
	$( "#security-dialog-form" ).dialog( "open" );

};

function clearAll(){
	$("#security-dialog-form #availableUserList").empty();
	$("#security-dialog-form #selectedUserList").empty();	
}

function getSelectedUsers() {
	var list = [];
	$("#security-dialog-form #selectedUserList li").each(function(i){
		var userObj = {};
		userObj.user = $(this).data('user');
		userObj.userid = $(this).data('userid');
		userObj.usertype = $(this).data('usertype');
		
		list.push(userObj);
	});
	return list;
}

$(document).ready(function() {
	/*
	if($("#customReportsEnabled").val() === 'true') {
		shareReport.initComponents();
		
	}
	*/
	if(!shareReport.eventsAdded) {
		addEvents();
		shareReport.eventsAdded = true;
	}
});
