
<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv"%>

<fmt:bundle basename="localization.SurveyMessages">
<jsp:include page="../common/header.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.min.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />
	<jsp:param value="webconsole" name="applicationName" />
	<jsp:param value="reports/reportsBase.jsp" name="jsp" />
	<jsp:param value="reportsplus/reportHeader.jsp" name="jsp" />
	<jsp:param value="true" name="includeHistory"/>
	<jsp:param value="false" name="includeJqueryUI" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/survey/css/surveystyles.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/survey/css/surveyheader.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/survey/css/alarms.css" name="css" />
	<jsp:param value="Health Report" name="titleLocalized" />
    <jsp:param value="Health Report" name="headerTitleLocalized" />
    <jsp:param value="true" name="bootstrapped" />
	<jsp:param value="true" name="reportsNav" />
</jsp:include>


<c:set var="searchEnabled" value='true' scope="page" />
<c:set var="changePage" value='true' scope="page" />
<c:if test="${empty fn:escapeXml(param.commUniId) or fn:escapeXml(param.commUniId) <=0}">
	<c:set var="searchEnabled" value='false' scope="page" />
	<c:set var="changePage" value='' scope="page" />	
</c:if>


 <jsp:include page="../survey/reports/surveyHeader.jsp">
	<jsp:param name="changePage" value="${changePage}" />
	<jsp:param name="exportPdf" value="true" />
	<jsp:param name="exportWord" value="true" />
	<jsp:param name="exportPpt" value="true" />
	<jsp:param name="enableReportAlert" value="true" />
	<jsp:param name="searchCC" value="${searchEnabled}" />
	<jsp:param name="isHealthReport" value="true" />
	<jsp:param value="true" name="includeCROptionBeforeSearch"/>
	<jsp:param value="true" name="exportEnabled"/>
</jsp:include>

<fmt:message key="CriticalStatus" var="criticalStatus" />
<fmt:message key="WarningStatus" var="warningStatus" />
<fmt:message key="GoodStatus" var="goodStatus" />
<fmt:message key="InfoStatus" var="infoStatus" />
<fmt:message key="Health_Parameter" var ="healthParameter"/>
<fmt:message key="Health_Report" var ="healthReport"/>

<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular/angular.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular-sanitize/angular-sanitize.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular/ui-bootstrap-tpls-0.11.0.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/moment.js?${applicationScope.BUILD_TS}"></script>


<!-- grid layout -->
	<link rel="stylesheet" href="${pageContext.request.contextPath}/reportsplus/js/angular-gridster/angular-gridster.min.css?${applicationScope.BUILD_TS}">
	<link rel="stylesheet" href="${pageContext.request.contextPath}/health/css/healthdashboard.css?${applicationScope.BUILD_TS}">
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular-gridster/jquery.resize.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reportsplus/js/angular-gridster/angular-gridster.min.js?${applicationScope.BUILD_TS}"></script>

<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/health/js/healthApp.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/health/js/healthService.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/health/js/healthAppUtilService.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/health/js/healthAppConfig.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/health/js/controller.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/health/js/tileController.js?${applicationScope.BUILD_TS}"></script>

 <jsp:include page="../survey/reports/alarmdialog.jsp">
		<jsp:param value="true" name="healthReport"/>
</jsp:include>

	   
<div id="generatedOnText" class="showOnExportFriendly rghtFloat clearfix reportView generatedOnSpan">
	<fmt:message key="ReportGeneratedOn"/> <span id="generatedOnSpan"></span>
</div>	
   
<div id="healthContent"  data-ng-app="healthDashboardApp" data-ng-controller="healthDashboardCtrl" data-ng-init="initialize()" data-ng-class="{hasNoData:hasHealthData!==true}">
<div id="noDataNotificationPanel" data-ng-show="hasHealthData!==true && loaded ===true">  
	<p id="infoErrorMessage"><fmt:message key="health.no_data_available"/></p>
</div>
<div id="contentDataWrapper" data-ng-class="{setVisible: hasHealthData}">
<div id="tilesControlPanel" >
	
	<div  class="viewOptions hideOnExportFriendly" >
			<ul class="toggleButtons health-report-opts">
				<button class="btn  health-btn"  data-ng-class="{selected:sorting=='category'}" data-ng-click="viewChanged('category')"><fmt:message key="health.bycategory" /></button>
				<button class="btn health-btn"  data-ng-class="{selected:sorting=='severity'}" data-ng-click="viewChanged('severity')"><fmt:message key="health.byseverity" /></button>
			</ul>

			<div id="hiddenTileOptDiv"   data-ng-class="{disabled:  hiddenTiles.length <= 0}" > 
				<button id="showAllTile" data-ng-click="showAllTiles()" class="btn  health-report-opts health-btn"><fmt:message key="health.show_all_tiles" /></button>	
				<div id="hiddenTileWrapper" data-ng-click="showHiddenTileMenu=true">
					<span><fmt:message key="health.show_hidden_tile"/></span>
					<img src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png">
					<div id="showHiddenTile" data-ng-show="showHiddenTileMenu === true"  data-ng-mouseleave="showHiddenTileMenu = false" class="optionMenu hideOnExportFriendly">
						<ul >
							<li data-ng-repeat="hTile in hiddenTilesMap" data-ng-click="showTile(hTile)">{{hTile.tileName}}</li>
						</ul>
					</div>
				</div>
				
			</div>
	</div>		
			
	
</div>
<div id="aggregate" >
	<div id="criticalStatus" class="devicesCount"   data-ng-click="updateTiles(4)" data-ng-class="{activeFilter:filterStatus === 4}" title='<fmt:message key="Health_Critical_ToolTip" />'>
		<div class="agg-wrapper sprite reports-health-aggregate-critical"></div>
		<div class="dash-status-number">{{aggregate.criticalCount}}</div>
		<div class="event-status-wrapper">
		  <div class="dash-event-status"><fmt:message key="CriticalStatus" /></div>
		</div>
	</div>
	<div id="warningStatus" class="devicesCount"   data-ng-click="updateTiles(3)" data-ng-class="{activeFilter:filterStatus === 3}" title='<fmt:message key="Health_Warning_ToolTip" />'>
		<div class="agg-wrapper sprite reports-health-aggregate-warning"></div>
		<div class="dash-status-number">{{aggregate.warningCount}}</div>
		<div class="event-status-wrapper">
		  <span class="dash-event-status"  ><fmt:message key="WarningStatus" /></span>
		</div>
	</div>
	<div id="goodStatus"  class="devicesCount"   data-ng-click="updateTiles(2)" data-ng-class="{activeFilter:filterStatus === 2}" title='<fmt:message key="Health_Good_ToolTip"/>'>
		<div class="agg-wrapper sprite reports-health-aggregate-good"></div>
		<div class="dash-status-number">{{aggregate.goodCount}}</div>
		<div class="event-status-wrapper">
		  <span class="dash-event-status" ><fmt:message key="GoodStatus" /></span>
		</div>
	</div>
	<div id="infoStatus" class="devicesCount"   data-ng-click="updateTiles(1)" data-ng-class="{activeFilter:filterStatus === 1}" title='<fmt:message key="Health_Info_ToolTip"/>'>
		<div class="agg-wrapper sprite reports-health-aggregate-info"></div>
		<div class="dash-status-number">{{aggregate.infoCount}}</div>
		<div class="event-status-wrapper">
		  <span class="dash-event-status"><fmt:message key="InfoStatus" /></span>
		</div>
	</div>

</div>
<div id="tilesPanel">
<div>
	<div data-ng-repeat="group in tileGroups">
		<div class="groupTitle">
			<h3>{{group.name}}</h3>
		</div>	
		<div data-gridster="gridsterOpts" >
			<ul>
				<li data-gridster-item="tile"   class="customReport" data-ng-repeat="tile in group.tiles" data-ng-init="setTileIndex(tile)">	
					<div  data-ng-include="'${pageContext.request.contextPath}/health/tile.jsp'" ></div>
				</li>
			</ul>
		</div>		
	</div>
</div>
</div>
</div>  <!--  end contentDataWrapper -->
</div> <!--  end health content -->

 <form id="exportForm" action="${pageContext.request.contextPath}/server/doDownload" method="get">
   <input id="downloadType" type='hidden' name='type' value='report' />
   <input id="fileNameToDownload" type='hidden' name='fileName' value='' />
</form>

 <div id="dialog-Health-form" style="display:none;" title="Please fill in required information">
		  <p class="validateTips" ><fmt:message key="health.error.All_fields_are_required" /> </p>
	<fieldset>
		    <label for="name"><fmt:message key="health.label.Customer_Name" /></label>
		    <input type="text" name="field_name" id="name" class="text ui-widget-content ui-corner-all" />
		    <label for="location"><fmt:message key="health.label.Data_Center_Location" /></label>
		    <input type="text" name="field_location" id="location" class="text ui-widget-content ui-corner-all" />
	</fieldset>
</div>

 <jsp:include page="../common/footer.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/mustache.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/survey/js/survey_templates.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/survey/js/alarms.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/js/reportsUtil.js" name="js" />
	<jsp:param value="true" name="bootstrapped" />
</jsp:include>


<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
	var localMsg = localMsg || {};
	localMsg.criticalStatus="${criticalStatus}";
	localMsg.warningStatus="${warningStatus}";
	localMsg.goodStatus="${goodStatus}";
	localMsg.infoStatus="${infoStatus}";
	localMsg.healthParameter = "${healthParameter}";
	localMsg.healthReport = "${healthReport}";
</script>


</fmt:bundle>