(function() {
	'use strict';

	// poly fill for the phanton js issue reported here
	// https://github.com/angular/angular.js/issues/13794
	if (typeof Function.prototype.bind != 'function') {
		Function.prototype.bind = function bind(obj) {
			var args = Array.prototype.slice.call(arguments, 1), self = this, nop = function() {
			}, bound = function() {
				return self.apply(this instanceof nop ? this : (obj || {}), args.concat(Array.prototype.slice
						.call(arguments)));
			};
			nop.prototype = this.prototype || {};
			bound.prototype = new nop();
			return bound;
		};
	}

	angular.module("healthDashboardApp").controller("healthAlertCtrl",
			[
					"$scope",
					"healthService",
					function($scope, healthService) {
						$scope.hasHealthData = false;
						healthService.getHealthAlertTable(cvUtil.getParameter("tileId"),
								cvUtil.getParameter("tileStatus")).then(function(response) {
							cvUtil.unmask("#healthAlarmContent");
							var errorMsg = response.data.data.errorMsg || response.data.data.error;
							if (errorMsg) {
								angular.element("#infoErrorMessage").html(errorMsg);
								$scope.hasHealthData = false;
							} else {
								$scope.hasHealthData = true;
								$scope.drawTable(response.data.data.healthData);
							}

						}, function() {
							cvUtil.unmask("#healthAlarmContent");
						});

						$scope.drawTable = function(data) {
							var view = {};
							view.title = '';
							view.filters = false;
							view.collapsible = false;
							view.alarm = false;
							view.exportExcel = false;
							view.colChooser = false;
							$('#tableWrapper').append(SurveyTemplates.makeReportTable("table_0", view));

							//					this.report = new Reports.initReport({
							//						type : "healthAlert",
							//						directPrint : true
							//					});
							//					Reports.configureClientSideTable("dataTable", '', tableData);

							var gridid = "table_0";
							var dataTabl = $('#' + gridid + CVTable.table).hasClass('initialized');
							if (dataTabl) {
								$('#' + gridid + CVTable.table).removeClass('initialized');
								$('#' + gridid + CVTable.table).dataTable().fnClearTable();
								$('#' + gridid + CVTable.table).dataTable().fnDestroy();
								$('#' + gridid + CVTable.table).empty();
								$("#" + gridid + "_FilterButton").removeClass("filterOn");
							}

							var originalColumns = data.aoColumns;
							$('#' + gridid + CVTable.table).addClass('initialized').dataTable({
								"aaData" : data.aaData,
								"bFilter" : false,
								"aoColumns" : data.aoColumns,
								"aoColumnDefs" : data.aoColumnDefs,
								"bRetrieve" : false,
								"bInfo" : false,
								"bAutoWidth" : false,
								"sDom" : "Rlrti",
								"bLengthChange" : false,
								"aaSorting" : {},
								"iDisplayLength" : data.aaData.length,
								"bUseRendered" : false,
								"oLanguage" : {
									"sEmptyTable" : "No data available"
								}
							});
							var dataTable = $('#' + gridid + CVTable.table).dataTable();
							$('#' + gridid + CVTable.table + ' thead th').each(function(index, value) {
								$(value).attr('title', $(value).text());
							});

							$('#' + gridid + CVTable.table + '>tbody>tr>td').each(function(index, value) {
								$(value).attr('data-label',
										$('#' + gridid + CVTable.table + ' thead th')[index %
												($('#' + gridid + CVTable.table + ' thead th').length)].innerText);
							});

							$('.dataTable tbody td').each(function(index) {
								var td = $(this);
								var titleVal = td.text();
								if (titleVal != '') {
									td.attr('title', titleVal);
								}
							});

							$("#table_0 th").removeClass("sorting_asc");
						}

					} ]);
}());