(function() {
	var COLORS = {
		INFORMATION : "#7cb5ec",
		GOOD : "#00b300",
		WARNING : "#ff9900",
		CRITICAL : "#cc3300",
		UNKNOWN : "#a6a6a6",
		SUCCESS : "#26c24c", //green
		FAILED : "#e8dc6d", //gold
		KILLED : "#f05050", //red
		CWW : "#02557d", //dark blue
		CWE : "#22b7e5", //baby blue
		LIGHT_BLUE : "#22b7e5", //baby blue
		DARK_BLUE : "#02557d",
		GOLD : "#e8dc6d", //gold
		PURPLE: '#6f42c1' //purple
	}

	var app = angular.module("healthDashboardApp");
	app
			.service("healthUtilService",
					[
							'$timeout',
							function($timeout) {
								var utilServiceHolder = {};

								utilServiceHolder.readCookie = function(name) {
									var nameEQ = name + "=";
									var ca = document.cookie.split(';');
									for (var i = 0; i < ca.length; i++) {
										var c = ca[i];
										while (c.charAt(0) == ' ') {
											c = c.substring(1, c.length);
										}
										if (c.indexOf(nameEQ) == 0) {
											return c.substring(nameEQ.length, c.length);
										}
									}
									return null;
								};

								utilServiceHolder.getColors = function() {
									return COLORS;
								}

								utilServiceHolder.setParamsTable = function(params) {
									utilServiceHolder.paramsTable = params;
								}

								utilServiceHolder.getParamsTable = function() {
									return utilServiceHolder.paramsTable;
								}

								utilServiceHolder.exportX = function(exportType, customerName) {
									var arrayOfParam = [];
									if (exportType == "valassessppt") {
										utilServiceHolder.exportingModule(arrayOfParam, exportType, customerName);
									} else {
										angular.element("#dialog-Health-form fieldset input").live("focus", function() {
											$(this).css("background-color", "#cccccc");
										});
										$(function() {
											$("[name^='field_']").focus(function() {
												$(":focus").addClass("ui-state-highlight");
											});
											$("#location,#name,#fromdate,#todate").blur(function() {
												$("#location,#name,#fromdate,#todate")
														.removeClass("ui-state-highlight");
											});
											var location = $("#location"), name = $("#name"), fromdate = $("#fromdate"), todate = $("#todate"), allFields = $([])
													.add(location).add(name).add(fromdate).add(todate), tips = $(".validateTips");

											function updateTips(t) {
												tips.removeClass("location");
												tips.text(t).addClass("ui-state-highlight");
												setTimeout(function() {
													tips.removeClass("ui-state-highlight", 4500);
												}, 500);
												setTimeout(function() {
													tips.text("All fields are required.", 1000);
												}, 4500);

											}

											function checkLength(o, n, min, max) {
												if (o.val().length > max || o.val().length < min) {
													o.addClass("ui-state-error");
													updateTips(n + " field must not be blank " + ".");
													setTimeout(function() {
														o.removeClass("ui-state-error", 3500);
													}, 500);
													return false;
												} else {
													return true;
												}
											}

											function checkRegexp(o, regexp, n) {
												if (!(regexp.test(o.val()))) {
													o.addClass("ui-state-error");
													updateTips(n);
													setTimeout(function() {
														o.removeClass("ui-state-error", 3500);
													}, 500);
													return false;
												} else {
													return true;
												}
											}

											angular.element("#dialog-Health-form").show().dialog({
												autoOpen : false,
												height : 370,
												width : 360,
												modal : true,
												buttons : {
													Cancel : function() {
														$(this).dialog("close");

													},
													"Proceed" : function() {
														var bValid = true;
														allFields.removeClass("ui-state-error");
														bValid = bValid && checkLength(name, "name", 1, 50);

														bValid = bValid && checkLength(location, "location", 1, 50);
														if (bValid) {
															arrayOfParam = 'name=' +
																	escape(window.encodeURIComponent(name.val())) +
																	'&' + 'location=' + escape(location.val());

															$(this).dialog("close");
															utilServiceHolder.exportingModule(arrayOfParam,
																	exportType,
																	customerName);

														}
													}
												},
												close : function() {
													allFields.val("").removeClass("ui-state-error");

												}
											});

											angular.element("#dialog-Health-form").dialog("open");
										});
									}
								};

								utilServiceHolder.exportingModule = function(arrayOfParam, exportTypeParam,
										customerName) {
									var commUniId = cvUtil.getParameter('commUniId', -1);
									var url = document.URL;
									var paramString = exportTypeParam;
									if (arrayOfParam.length > 0) {
										paramString += '&' + arrayOfParam;
									}

									var params = 'exportType=' + paramString + '&commUniId=' + commUniId;
									var link = 'commUniId=' + commUniId + '&directDownload=false&exportType=' +
											paramString + '&module=health&reportName=' + customerName +
											' - HealthReport';

									angular.element("#content").mask(localMsg['WaitMsg'] + "&nbsp&nbsp", 0, function() {
										exportajaxRequest.abort('userAborted');
									});

									var positionToInsert = url.lastIndexOf("?") + 1;
									if (positionToInsert < 1) {
										url = url + '?' + params;
									} else {
										url = [
												url.slice(0, positionToInsert),
												params + '&',
												url.slice(positionToInsert) ].join(''); //we can't just append at the end because of IE9
									}

									var URL = cvUtil.getContextPath() + '/reports/exp.do?' + link;
									var exportajaxRequest = cvUtil.loadPageWithGET(URL, "", function(data1) {
										if (!data1 || data1 == "" || data1 == 'null') {
											alert(cvUtil.cvLocalize('ExportError'));
										} else {
											downloadReportFile(data1);
										}
										angular.element("#content").unmask();
									}, function(xhr, ajaxOptions, thrownError) {
										if (thrownError != 'userAborted') {
											cvUtil.handleError(xhr, ajaxOptions, thrownError);
										}
									});
									//				requestString.invisible.exportType=undefined;
									//				isExport = false;
									//				requestString.invisible.exportAll=false;
									//				requestString.invisible.chartsSVGs=null;
								}

								utilServiceHolder.saveReportAs = function(exportType, customerName) {
									var filePrefix = utilServiceHolder.getFilePrefix(customerName);
									var url = document.URL;
									url = url + "&exportType=" + exportType;

									angular.element("#content").mask(localMsg['WaitMsg'] + "&nbsp&nbsp", 0, function() {
										return (exportajaxRequest && exportajaxRequest.abort());
									});

									if (exportType === "healthppt" || exportType == "word" ||
											exportType == "valassessppt") {
										angular.element("#content").unmask();
										utilServiceHolder.exportX(exportType, customerName);
										return;
									}

									var saveAsUrl = cvUtil.getContextPath() +
											'/reports/exp.do?orientation=landscape&exportType=' + exportType +
											'&viewportWidth=1600&commUniId=' + cvUtil.getParameter("commUniId");
									var params = {
										url : url,
										filePrefix : filePrefix,
										directDownload : false,
										type : 'report'
									};
									var exportajaxRequest = healthService.saveAs(saveAsUrl, params);

									exportajaxRequest.then(function(data) {
										if (data) {
											var data1 = data.data;
											angular.element("#content").unmask();
											if (!data1 || data1 == "" || data1 == 'null') {
												alert(localMsg['ExportError']);
											} else {
												downloadReportFile(data1);
											}
										}

									}, function(error) {
										angular.element("#content").unmask();
										if (error != 'userAborted') {
											customReportSvc.errorToast(error); //cvUtil.handleError(xhr, ajaxOptions, thrownError);
										}
									});
								}

								utilServiceHolder.getFilePrefix = function(customerName) {
									var filePrefix = "HealthReport";
									if (customerName) {
										filePrefix = customerName + ' - ' + filePrefix;
									}

									return filePrefix;
								}

								return utilServiceHolder;
							} ]);

}());