(function() {
	'use strict';

	var healthApp = angular.module("healthDashboardApp");

	healthApp
			.controller("solidDonutController",
					[
							"$scope",
							"healthUtilService",
							function($scope, healthUtilService) {

								$scope.chartConfig = getChartConfig();
								$scope.isChartable = isChartable();

								function isChartable() {
									return ($scope.outcome.outcomeType !== "Text" &&
											$scope.outcome.outcomeType !== "Title" && $scope.outcome.outcomeType !== undefined);
								}

								function getChartConfig() {
									var chartConfig = {
										size : {
											width : 110,
											height : 110
										},
										options : {
											chart : {
												type : "pie",
												zoomType : 'x',
												animation : false,
												interactiveEnabled : false,
												marginTop : 0,
												spacingTop : 0,
												spacingBottom : 0,
												spacingLeft : 0,
												spacingRight : 0
											},
											exporting : {
												enabled : false
											},
											legend : {
												enabled : false,
											},
											credits : {
												enabled : false
											},
											tooltip : {
												enabled : false,
												animation : false
											},
											plotOptions : {
												series : {
													animation : false,
													interactiveEnabled : false
												},
												pie : {
													size : "100%",
													borderWidth : 0,
													dataLabels : {
														enabled : false,
														format : undefined
													}
												}
											}
										},
										title : {
											text : $scope.outcome.value,
											align : "center",
											verticalAlign : "middle",
											y : 5,
											style : {
												"color" : "#777",
												"font-family" : "Helvetica,Arial,sans-serif",
												"font-size" : "22px",
												"font-weight" : "bold"
											}

										},
										series : [ {
											data : [ {
												color : getColor(),
												y : 100,
												name : 100
											} ],
											size : "100%",
											innerSize : 84,
											startAngle : 0,
											endAngle : 360,
											pointPadding : 0,
											stacking : "normal"
										} ],
										loading : false,
										noData : true
									}

									return chartConfig;
								}

								function getColor() {
									var COLORS = healthUtilService.getColors();
									if ($scope.outcome.property == undefined) {
										return;
									}
									if ($scope.outcome.property.style === "Information") {
										return COLORS.INFORMATION;
									} else if ($scope.outcome.property.style === "Good") {
										return COLORS.GOOD;
									} else if ($scope.outcome.property.style === "Warning") {
										return COLORS.WARNING;
									} else if ($scope.outcome.property.style === "Critical") {
										return COLORS.CRITICAL;
									} else if ($scope.outcome.property.style === "Unknown") {
										return COLORS.UNKNOWN;
									} else {
										return COLORS.GOOD;
									}
								}

							} ]);
}());