<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv"%>

<fmt:bundle basename="localization.SurveyMessages">

<div id="tile" data-name="{{tile.tileName}}" data-ng-controller="tileController" data-ng-mouseover="showOptions()" data-ng-mouseleave="hideOptions()"  >


	<div id="tileHeader">
		<h4 class="tileTitle" >  <label class="tileIcon" data-ng-class="{'sprite reports-health-critical': isCritical(tile),'sprite reports-health-warning': isWarning(tile),
		'sprite reports-health-good': isGood(tile),'sprite reports-health-info': isInfo(tile)}">
		<span class ="tileTooltipText" data-ng-bind-html="thresholds" data-ng-show="thresholds!=''" ></span>
		</label>
		<div class="titleWrapper" data-ng-if="isDetailApplicable()" >
 			<a class="healthDetailExport tileTitleText"  data-ng-class="{'detailAvailable':isDetailApplicable()}" title="{{tile.tileName}}"
   				href="{{detailHref}}"  data-name="{{tile.tileName}}" data-position="{{tile.tilePositionIndex}}" target="_blank">{{tile.tileName}}</a>
   		</div>
   		<div class="titleWrapper" data-ng-if="!isDetailApplicable()" >
	   		<label class="tileTitleText staticTitle"  data-ng-class="{'detailAvailable':isDetailApplicable()}"
	   		 title="{{tile.tileName}}">{{tile.tileName}} </label>
		</div>
		</h4>

		<div class="floatingActionDiv" data-ng-show="isShowOptions">
			<ul>
				<li class="sprite reports-health-hide-tile floatingAction" data-ng-click = "hideTile()" title='<fmt:message key="Health_Hide_Tile_Tooltip" />'> </li>
				<li data-ng-show="!isInfo(tile)"  class="sprite reports-health-alert floatingAction" data-ng-click="addAlert()" title='<fmt:message key="Health_Create_Alert_Tooltip" />' > </li>
				<li data-ng-show="isDetailApplicable()" class="sprite reports-health-detail floatingAction"  data-ng-click="viewDetails()" title='<fmt:message key="Health_View_Details_Tooltip" />'> </li>

			</ul>

		</div>
	</div>
	<div id="statusDiv" data-ng-class="{'tileWarning': isWarning(tile), 'tileCritical':isCritical(tile), 'tileGood':isGood(tile), 'tileInfo':isInfo(tile)}">
	</div>
	<div class="tileDetail" data-ng-class="{halfTile:isHalfTile(), fullTile:isFullTile()}">
		<div data-ng-show="isText()">
			<ul data-ng-show="isText()">
				<li ng-bind-html="outcome.key" data-ng-repeat="outcome in tile.outcomes"> </li>
			</ul>
		</div>

		<div data-ng-show="isChart()"  >
				<div data-ng-show="isTitleApplicable()" class="tileLabels" >
					<p data-ng-repeat="label in tileOutcomeLabels"> {{label}} </p>
				</div>
				<div id="chartArea">
					<div data-ng-if="isSolidDonutChart()" class="solidDonutsWrapper">
						<div data-ng-show="isChartable" class="solidDonuts" data-ng-repeat="outcome in tile.outcomes"  ng-controller="solidDonutController">
							<highchart    config="chartConfig">
							</highchart>
							<div class="donutLabel">{{outcome.key}}</div>
						</div>
					</div>

					<div data-ng-if="isDonutChart()">
					    <div class="outcomeText">
							<p> {{donutLabel}}</p>
						</div>
						<div   data-ng-show="!isTitleApplicable()" ng-controller="donutController" class="donuts">
							<highchart    config="chartConfig">
							</highchart>
						</div>
					</div>

					<div data-ng-if="isPieChart()">
						<div data-ng-show="hasChartData()" data-ng-controller="pieBarChartController" class="pies">
							<highchart    config="chartConfig">
							</highchart>
						</div>
					</div>

					<div data-ng-if="isBarChart() ">
						<div data-ng-show="hasChartData()" data-ng-controller="pieBarChartController"  class="bars" >
							<highchart   config="chartConfig">
							</highchart>
						</div>
					</div>

				</div>
		</div>

		<div data-ng-show="isIconText()" data-ng-controller="iconTextController">
			<div data-ng-show="isTitleApplicable()" class="tileLabels" >
					<p data-ng-repeat="label in tileOutcomeLabels"> {{label}} </p>
			</div>
			<div data-ng-show="isStrike()">
				<ul>
					<li data-ng-show="hasStrike3">
						<span >
							<span class='sprite icon-dot-red strikeDots'> </span>
							<span class='sprite icon-dot-red strikeDots'> </span>
							<span class='sprite icon-dot-red strikeDots'> </span>
							<span class='stikeText'>{{strike3Text}}</span>
						</span>
					</li>
					<li data-ng-show="hasStrike2">
						<span>
							<span class='sprite icon-dot-orange strikeDots'> </span>
							<span class='sprite icon-dot-orange strikeDots'> </span>
							<span class='stikeText'>{{strike2Text}}</span>
						</span>
					</li>
					<li data-ng-show="hasStrike1">
						<span>
							<span class='sprite icon-dot-yellow strikeDots'> </span>
							<span class='stikeText'>{{strike1Text}}</span>
						</span>
					</li>
				</ul>
			</div>

		</div>


	</div>

	<div id ="remarks_{{tile.tileIndex}}" class="remarks">
		<p> Remarks </p>
			<p class="remarkItem" ng-bind-html="remark.text" title="{{remark.tooltip}}" data-ng-repeat="remark in tile.remarks"> </p>
	</div>

	<cv:reportsTag name="adminRight" id="999">
		<div class="actionDiv" data-ng-class="{'hideBorder': hasNoFixit() }" >
			<label class="fixItLabel" data-ng-click="runFixIt($event, defaultFixIt.fixName, defaultFixIt.fixId)"  data-ng-show="!isMultipleFixIt()">{{defaultFixIt.fixDisplayName}}</label>
			<div class="fixMenuButton" data-ng-click="showFixItMenu($event)"  data-ng-show="isMultipleFixIt()">
				<span class="defaultAction">{{defaultFixIt.fixDisplayName}}</span>
				<img src="${pageContext.request.contextPath}/common/img/dropdown_triangle_icon.png">
				<div class="fixActionMenuDiv" id="tileFixMenu_{{tile.tileId}}">
					<ul class="fixActionMenu" >
						<li  class="fixItem" ng-bind-html="fixItem.fixName"  data-ng-click="runFixIt($event, fixItem.fixName, fixItem.fixId)" data-ng-repeat="fixItem in fixItItems"></li>
					</ul>
				</div>
			</div>

		</div>
	</cv:reportsTag>
</div>
</fmt:bundle>