<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>

<fmt:bundle basename="commvault.web.reports.ReportsMessages">

	<jsp:include page="../common/header.jsp">	
		<jsp:param value="true" name="includeSecHeader" />
		<jsp:param value="true" name="showSettings" />
		<jsp:param value="true" name="exportOptions"/>
		<jsp:param value="true" name="noSearchReport"/>
		<jsp:param value="true" name="changePage" />
		<jsp:param value="Advanced_Snap_Report" name="title" />
		<jsp:param value="Advanced_Snap_Report" name="headerTitle" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
	 	<jsp:param value="${pageContext.request.contextPath}/common/dynatree/ui.dynatree.css" name="css"/>
	 	<jsp:param value="${pageContext.request.contextPath}/common/css/ui.spinner.css" name="css"/>
	 	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
	 	<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css" name="css"/>
	  	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css"/>
	 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
		<jsp:param value="reports/reportsBase.jsp" name="jsp"/> 	
	 	<jsp:param value="true" name="includeJqueryUI"/>
	 	<jsp:param value="true" name="includeHistory"/> 	
	 	<jsp:param value="true" name="includeTableSupport"/>
	 	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
	</jsp:include>
	
	
	<%@ include file="reportsBaseBody.jsp" %>
	
	
	
	<div id="ContentWrapper">	
			<div id="filter-panel-cont">
			<div id="filter-panel-wrapper">
			<div id="filterPanel">
				<h3><a href="#">Clients</a></h3>
				<div>
					<div id="tree">  </div>
				</div>
				
				<h3><a href="#">Array</a></h3>
					<div id="arrayParent" class="clearFloat option">
					
						<div id="arrayAllDiv">
							 <div class="custom-cb" id="all" data-state="unchecked"></div><span class="custom-cb-label" >All</span>
						</div>
						<ul>
							<li> <div id="array1" class="custom-cb jobstatus" data-state="unchecked"></div><span class="custom-cb-label" >Array1</span></li>
							<li> <div id="array2" class="custom-cb jobstatus" data-state="unchecked"></div><span class="custom-cb-label" >Array2</span></li>
						</ul>
						<div id="jobstatus-error" class="error-note"><span class="paintred" >Note:</span> Please select atleast one array</div>
					</div>
					
					
				<h3><a href="#">Control Host</a></h3>
					<div id="controlHostParent" class="clearFloat option">
					
						<div id="controlHostAllDiv">
							 <div class="custom-cb" id="all" data-state="unchecked"></div><span class="custom-cb-label" >All</span>
						</div>
						<ul>
							<li> <div id="ch1" class="custom-cb jobstatus" data-state="unchecked"></div><span class="custom-cb-label" >ControlHost1</span></li>
							<li> <div id="ch2" class="custom-cb jobstatus" data-state="unchecked"></div><span class="custom-cb-label" >ControlHost2</span></li>
						</ul>
						<div id="jobstatus-error" class="error-note"><span class="paintred" >Note:</span> Please select atleast one control host</div>
					</div>
				
				<h3 class="lastAccordian"><a href="#">Time Frame</a></h3>
					<div class="clearFloat option lastAccordian">
						<%@ include file="timeframe.jsp" %>
					</div>			
			</div>							
			</div>
			<input id="btngenerate" type="button" value='<fmt:message key="Generate" />'>
			</div>
			
			<div id="chartContentWrapper">
				
				<ul id="breadCrumbPanel">
				</ul>		
				
				<div id="chartTitleDiv">
					<div id="chartTitle"></div>
				</div>
				<div id="selectGrpDiv">
					<div class="selectWrapper">
						<select id="groupByPanel">
							<option id="By_Array"><fmt:message key="By_Array" /></option>
							<option id="By_Host"><fmt:message key="By_Host" /></option>
							<option id="By_AgentType"><fmt:message key="By_AgentType" /></option>
							<option id="By_StoragePolicy"><fmt:message key="By_StoragePolicy" /></option>
						</select>
					</div>
				</div>
				<div id="piechartcontainer">
				</div>				
			</div>					
	</div>
							
	<jsp:include page="reportstable.jsp">	
		<jsp:param name="id" value="summarytable" />
		<jsp:param name="tabletitle" value='Arrays' />
		<jsp:param name="clientside" value="true" />
	</jsp:include>
	
	<jsp:include page="reportstable.jsp">	
		<jsp:param name="id" value="snapDetail" />
		<jsp:param name="tabletitle" value='Snapshot Details' />
	</jsp:include>
		
</fmt:bundle>

<div class="clearFloat"></div>
<jsp:include page="../common/footer.jsp">
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/custom-pie.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/dynatree/jquery.dynatree.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/js/advancedsnap.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/> 
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ui.spinner.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/multiselect/js/ui.multiselect.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
</jsp:include>