var system = require('system');
var fs = require('fs');

TABLESIZE_THRESHOLD_FOR_PDFQUALITY = 1000;
MAX_ACTIVE_PAGES = 10;

function exitPhantom(exitCode) {
	setTimeout(function() {
		phantom.exit(exitCode);
	}, 0);
}

if (console) {
	console.error = function(msg) {
		console.log('Error: ' + msg);
	};
}

try {
	var counter = 0;
	var countActivePages = 0;
	var currentPage = 0;
	var pageArray = [];
	var pageAlreadyLoadedArray = [];
	var linksLoaded = 0;
	phantom.cookiesEnabled = true;
	var JSONInput = fs.read(system.args[1]);
	fs.remove(system.args[1]);
	console.log('Json is: ' + system.args[1]);
	var fileOptionsArg;
	fileOptionsArg = system.args[2];
	fileOptionsArg = fileOptionsArg.replace(/\\"/g, '"');
	console.log('fileOptions : ' + fileOptionsArg);
	var fileOptions = JSON.parse(fileOptionsArg);
	var screenshot = JSON.parse(JSONInput);
	screenshot.outputFileName = fileOptions.outputFileName;
	var outputFileName = screenshot.outputFileName;
	var mainPage;
	var totalRowsInPage = 0;
	var successStatus = 0;
	window.pendingRequests = 0; // to wait for any custom report xhr calls to complete.
	phantom.onError = function(msg, trace) {
		var msgStack = [ 'PHANTOM ERROR: ' + msg ];
		if (trace && trace.length) {
			msgStack.push('TRACE:');
			trace.forEach(function(t) {
				msgStack.push(' -> ' + (t.file || t.sourceURL) + ': ' + t.line +
						(t["function"] ? ' (in function ' + t["function"] + ')' : ''));
			});
		}
		console.error(msgStack.join('\n'));
		//exitPhantom(1);
	};
	var outputType = outputFileName.substr(outputFileName.lastIndexOf(".") + 1);
	var mainPageLoadCallBack = function(status, page) {
		window.mainPage = page;
		if (counter > 0) {
			return; //this is called for each frame/iframe, so execute only once
		}
		counter++;
		try {
			console.log('main page loaded with status: ');
			console.log(status);
			if (status !== 'success') {
				console.error("Pageload status is " + status + ".\n Exiting with return code 1");
				exitPhantom(1);
				return;
			}
			console.error("Page url is:" + page.url);
			if (page.url.indexOf('noPermission.jsp') != -1 || page.url.indexOf('/applications/') != -1) {
				console.error("loaded page is nopermission.jsp or /aapplications/ ...exiting");
				exitPhantom(403);
				return;
			}
			waitFor(function() {
				return page.evaluate(function() {
					var retVal = true;
					console.log('export::mainPageLoadCallBack():waitFor ::window.jQuery = ' + window.jQuery);
					console.log('export::mainPageLoadCallBack():waitFor ::window.allOnReadiesExecuted = ' +
							window.allOnReadiesExecuted);
					console.log('export::mainPageLoadCallBack():waitFor ::$.active = ' + $.active);
					if (!window.jQuery || !window.allOnReadiesExecuted || $.active > 0) {
						console.log('export::mainPageLoadCallBack(): ::waitFor ::condition is...false');
						return false;
					}
					var loadmask = $(".loadmask:visible");
					console.log('export::mainPageLoadCallBack():waitFor ::loadmask.length = ' + loadmask.length);
					retVal = retVal && loadmask.length == 0;
					var datatables = $(".dataTable:visible:not(.drawn)").length == 0;
					console.log('export::mainPageLoadCallBack():waitFor ::datatables.length = ' +
							$(".dataTable:visible:not(.drawn)").length);
					retVal = retVal && datatables; //this assumes that when all the tables are drawn completely, we consider page complete. reportsbase.js adds drawn class ontablerendercallback
					console.log('export::mainPageLoadCallBack():waitFor ::condition is...' + retVal);
					return retVal;
				});
			}, function() {
				var pageAttrs = page.evaluate(function() {
					pageAttrs = {};
					if (window.Reports && Reports.hasFatalError && Reports.hasFatalError()) {
						pageAttrs.error = true;
						pageAttrs.errorMessage = Reports.getFatalError();
					} else {
						pageAttrs.error = false;
					}
					return pageAttrs;
				});
				if (pageAttrs.error) {
					console.error("Error on report. " + pageAttrs.errorMessage + ". Exiting with error code 2");
					exitPhantom(2);
					return;
				}

				totalRowsInPage += page.evaluate(function() {
					return $(".dataTable tbody tr").filter(':visible').length;
				});
				page.evaluate(function() {
					$("body").addClass("exportfriendly");
				});
				var links = [];
				if (outputType == "pdf") {
					links = page.evaluate(function(outputType) {
						console.log("Getting followForExport links from main page:");
						$("body").addClass("exportfriendly");
						var retVal = [];
						var allLinks = $(".followForExport:visible");
						var healthDetailExport = $(".healthDetailExport");

						if (healthDetailExport && healthDetailExport.length > 0) {
							var tilePositions = [];
							//sort the links because in health the tiles are re-ordered through grid after DOM are created.
							$.each(healthDetailExport, function(i, tile) {
								tilePositions.push(parseInt($(tile).attr("data-position")));
							});
							tilePositions = tilePositions.sort(function(a, b) {
								return a - b;
							});

							console.log("positions: " + tilePositions);

							allLinks = [];

							$.each(tilePositions, function(i, pos) {
								for (var idx = 0; idx < healthDetailExport.length; idx++) {
									var tile = healthDetailExport[idx];
									if (pos === parseInt($(tile).attr("data-position"))) {
										allLinks.push(tile);
										console.log("pushing tile, name: " + $(tile).attr("data-name"));
										break;
									}
								}
							});

						}
						console.log("number of links: " + allLinks.length);
						$.each(allLinks, function(index, value) {
							//if(index<=27){ //defensive check as it doesn't scale beyond 28 links.
							var v = value.href;
							if (window.convertToExportUrl) {
								v = convertToExportUrl(v, outputType, 100);
							}
							console.log("href:" + v);
							retVal.push(v);
							$(value).attr("href", "#crawled" + index);
							$(value).addClass("crawledLink");
						});

						return retVal;
					}, outputType);
				}
				page.evaluate(function(server) {
					console.log("Replacing localhost in href");
					$.each($("a:not(.crawledLink)").filter("[href*='//localhost']"), function(index, value) {
						var el = $(value);
						var h = el.attr("href").replace(/https?:\/\/localhost[:]?[\d]*/g, server);
						console.log("Replacing " + el.attr("href") + " with " + h);
						el.attr("href", h);
					});
					$('a:not(.crawledLink)').not('[href^="http"],[href^="https"],[href^="mailto:"],[href^="#"]')
							.each(function(index, value) {
								$(value).attr("href", server + value.pathname + value.search + value.hash);
							});
					$("svg a").contents().unwrap();
				}, screenshot.server);
				console.log("Got links from main page:" + links.length);
				var heights = [];
				links.forEach(function(value, index, a) { //create html file for each followforlink url
					loadPage(value + "&dashboardExport=true", function(status, otherPage) {
						console.log(value + " loaded with " + status);
						if (status !== 'success') {
							console.error("Error while loading " + value);
							console.error("Pageload status is " + status + ".\n Exiting with return code 1");
							exitPhantom(1);
							return;
						}
						waitFor(function() {
							console.log('evaluating waitfor condition...');
							return otherPage.evaluate(function() {
								var retVal = true;
								if (!window.jQuery) {//Wait for jquery to load - Requires that target page has jquery
									console.debug('jQuery not loaded...');
									console.debug("location: " + this.location.href);
									return false;
								}
								if (!window.allOnReadiesExecuted) { //at the bottom of the page in footer.jsp, this variable is initialized
									console.debug('allOnReadies not executed...');
									console.debug("location: " + this.location.href);
									return false;
								}
								if ($.active > 0) { //any active ajax requests pending?
									console.debug('active AJAX exists...');
									console.debug("location: " + this.location.href);
									return false;
								}

								if (window.pendingRequests > 0) {
									return false;
								}
								var loadmask = $(".loadmask:visible");
								retVal = retVal && loadmask.length == 0;
								var datatables = $(".dataTable:visible:not(.drawn)").length == 0;
								retVal = retVal && datatables; //this assumes that when all the tables are drawn completely, we consider page complete. reportsbase.js adds drawn class ontablerendercallback
								var maskLayerLabel = $(".maskLayerLabel:visible");
								retVal = retVal && maskLayerLabel.length == 0;
								console.log('waitfor condition is...' + retVal);
								return retVal;
							});
						}, function() {
							window.setTimeout(function() {
								for (var i = 0; i < pageAlreadyLoadedArray.length; i++) {
									if (pageAlreadyLoadedArray[i] == value) {
										return;
									}
								}
								heights[index] = otherPage.evaluate(function(server) {

									console.log("Replacing localhost in href");
									$.each($("a:not(.crawledLink)").filter("[href*='//localhost']"), function(index,
											value) {
										var el = $(value);
										var h = el.attr("href").replace(/https?:\/\/localhost[:]?[\d]*/g, server);
										console.log("Replacing " + el.attr("href") + " with " + h);
										el.attr("href", h);
									});
									$('a:not(.crawledLink)')
											.not('[href^="http"],[href^="https"],[href^="mailto:"],[href^="#"]')
											.each(function(index, value) {
												$(value).attr("href",
														server + value.pathname + value.search + value.hash);
											});
									$("svg a").contents().unwrap();

									/*************************************************************************
									 * Start code hack to get around this bug of wkhtmltopdf
									 * https://github.com/wkhtmltopdf/wkhtmltopdf/issues/1524
									 ************************************************************************/
									$.each($(".reportTable thead"), function(index, value) {
										var el = $(value);
										el.next().prepend(el.contents());
										el.remove();
									});
									$(".reportTable th").each(function(index) {
										var thisTD = this;
										var newElement = $("<td></td>");
										$.each(this.attributes, function(index) {
											$(newElement).attr(thisTD.attributes[index].name,
													thisTD.attributes[index].value);
										});
										$(newElement).addClass('tableheadertd');
										$(newElement).html($(this).html());
										$(this).after(newElement).remove();
									});
									/** End code hack for wkhtmltopdf* */
									console.log('getting height');
									if (!document.body.className) {
										document.body.className = "";
									}
									$('a.disableOnEmbedded').contents().unwrap();
									document.body.className += " embedded exportfriendly";
									return document.body.scrollHeight;
								}, screenshot.server);
								totalRowsInPage += otherPage.evaluate(function() {
									return $(".dataTable tbody tr").filter(':visible').length;
								});
								var otherFileName = outputFileName + "test" + index;
								/**
								 * ************Convert all svgs to images because wkhtmltopdf and mhtml
								 * doesn't support
								 * svgs**************************************************************************************
								 */
								//mhtml(otherPage, otherFileName);
								/** ************************************************************************************************** */
								var content = otherPage.content;
								//					        		if(outputType=="mhtml"){ //remove script tags otherwise IE will try to execute scripts in mhtml
								var rscript = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi; //remove script tags
								content = content.replace(rscript, '');
								//					        		}
								console.log('writing html file at ' + "WEB-INF//export//temp//" + otherFileName +
										".html");
								fs.write("../../WEB-INF/export/temp/" + otherFileName + ".html", content, "w");
								pageAlreadyLoadedArray.push(value);
								closePage(otherPage);
								linksLoaded++;
							}, 500); //end settimeout
						}, 5 * 60 * 1000); //5 min. timeout - end waitfor
					}); //end loadpage
				});//end links.foreach
				if (totalRowsInPage > TABLESIZE_THRESHOLD_FOR_PDFQUALITY) {
					successStatus = 11; //there is no confirmation in documentation but in all likelihood and assumption, this is not being used internally phantomjs
				}
				//mhtml(page, outputFileName);
				waitFor(function() {
					var retVal = true;
					retVal = links.length == linksLoaded;
					console.log('waitfor condition is...' + retVal + ". Number of links loaded:" + linksLoaded);
					if (screenshot.isCustomAlarmv2 == 'true') {
						retVal = page.evaluate(function() {
							console.log("Pending requests " + window.pendingRequests);
							if (window.pendingRequests > 0) {
								return false;
							} else {
								return true;
							}
						});
					}
					return retVal;
				}, function() {
					console.log('Main page and all links loaded, writing main page');
					page.evaluate(function(outputFileName, heights) {
						/*************************************************************************************
						 * Start code hack to get around this bug of wkhtmltopdf
						 * https://github.com/wkhtmltopdf/wkhtmltopdf/issues/1524
						 ************************************************************************************/
						$.each($(".reportTable thead"), function(index, value) {
							var el = $(value);
							el.next().prepend(el.contents());
							el.remove();
						});
						$(".reportTable th").each(function(index) {
							var thisTD = this;
							var newElement = $("<td></td>");
							$.each(this.attributes, function(index) {
								$(newElement).attr(thisTD.attributes[index].name, thisTD.attributes[index].value);
							});
							$(newElement).addClass('tableheadertd');
							$(newElement).html($(this).html());
							$(this).after(newElement).remove();
						});
						/** End code hack for wkhtmltopdf* */
						for (var i = 0; i < heights.length; i++) {
							var height = heights[i];
							console.log('creating iframe');
							var crawled = $('<iframe style="height:' + height +
									'px;" scrolling="no" frameborder="0" class="crawled" id="crawled' + i +
									'"></iframe>');
							crawled.attr("src", "mhtml.do?file=" + outputFileName + "test" + i + ".html");
							var d = $('<div class="crawledWrapper"></div>').append(crawled);
							$("#container").append(d);
						}
						localStorage.clear();
					}, outputFileName, heights);

					try {
						if (screenshot.outputFileName.indexOf(".csv") == screenshot.outputFileName.length - 4) {
							isCSVMetaDataHidden = (screenshot.HideCSVAdditionalInfo && screenshot.HideCSVAdditionalInfo == "true" ) ? true : false ; //HideCSVAdditionalInfo key had to be converted to string when inserting to Hashmap in Java ; Reversing to boolean
							screenshot.isAlarm = screenshot.isAlarm == true || screenshot.isAlarm == "true" ? true
									: false;
							console.log('screenshot.isCustomAlarmv2 is ' + screenshot.isCustomAlarmv2);
							console.log('screenshot.isReportMetadataCall:  ' + screenshot.isReportMetadataCall);

							if (screenshot.isCustomAlarmv2 == 'false') {
								if (screenshot.isAlarm) {
									var ndx = screenshot.url.indexOf("filteredTable-0=") > -1 ? (screenshot.url
											.indexOf("filteredTable-0=") + "filteredTable-0=".length) : -1;
									var nxtAnd = screenshot.url.indexOf("&", ndx);
									var tableSelected = "";
									if (ndx > -1) {
										if (nxtAnd > -1) {
											tableSelected = screenshot.url.substring(ndx, nxtAnd);
										} else {
											tableSelected = screenshot.url.substring(ndx);
										}
									} else {
										tableSelected = "table_0";
									}
									console.log("TableSelected : " + tableSelected);
									var tableId = tableSelected + "_table";
									csv(page,
											screenshot.outputDir + screenshot.outputFileName,
											screenshot.isAlarm,
											tableId,
											screenshot.isReportMetadataCall,
											isCSVMetaDataHidden);
								} else {
									csv(page,
											screenshot.outputDir + screenshot.outputFileName,
											false,
											0,
											screenshot.isReportMetadataCall,
											isCSVMetaDataHidden);
								}
							}
						} else if (screenshot.outputFileName.indexOf(".pdf") == screenshot.outputFileName.length - 4) {
							console.log('writing html file at ' + "WEB-INF\\export\\temp\\" + outputFileName);
							//feature is not complete - will remove check in next form
							if (screenshot.isCustomAlarmv2 == 'true') {
								page.evaluate(function() {
									var reportTables = $('.reportTable:visible');
									if (reportTables && reportTables.length > 0) {

										// Demarcate the table contents for processing at the backend.
										$('tbody[role=rowgroup]', reportTables).each(function() {
											var tableId = $(this).parents('.reportTable').attr('id');
										    $(this).before('<input type="hidden" name="table_' + tableId + '-TBODY_BEGIN" />')
										    		.after('<input type="hidden" name="table_' + tableId + '-TBODY_END" />');
										});
									}

									$("#content #reportArea #pageDiv div[data-gridster]").css({
										height : 'auto'
									});
									$.each($("#content #reportArea #pageDiv div[data-gridster] ul li[comp]"), function(
											index, value) {
										$(value).css({
											position : 'static',
											height : 'auto'
										});
									});

								});
								fs.write("../../WEB-INF/export/temp/" + outputFileName + ".JSON", JSON.stringify(page
										.evaluate(function() {
											return window.reportMetaData;
										})), "w");
							}
							var content = page.content;
							//		        		if(outputType="mhtml"){ //remove script tags otherwise IE will try to execute scripts in mhtml
							var rscript = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi; //remove script tags
							content = content.replace(rscript, '');
							//		        		}
							fs.write("../../WEB-INF/export/temp/" + outputFileName + ".html", content, "w");
						} else if (screenshot.outputFileName.indexOf(".png") == screenshot.outputFileName.length - 4) {
							console.log('writing png file at ' + "WEB-INF\\export\\temp\\" + outputFileName);
							page.render(screenshot.outputDir + screenshot.outputFileName, {
								format : 'png',
								quality : '70'
							});

						}
						console.log('Exiting with return code 0');
						//setTimeout(function(){
						exitPhantom(successStatus);
						//}, 5000);
					} catch (e) {
						console.error("Error while exporting after page load" + e);
						console.error("Exiting with error code 1");
						exitPhantom(1);
					}
				}, 15 * 60 * 1000); //10 min. timeout
			}, 5 * 60 * 1000); //5 min timeout
		} catch (e) {
			console.error("Error on pageload " + e);
			console.error("Exiting with error code 1");
			exitPhantom(1);
		}
	};
	loadPage(screenshot.url, mainPageLoadCallBack);
} catch (e) {
	console.error("Error while initializing page in screenshot.js" + e.name + " " + e.message + "\n" + e.stack);
	console.error("Exiting with return code 1");
	exitPhantom(1);
}
function mhtml(otherPage, otherFileName) {
	/**
	 * **Convert all svgs to images because wkhtmltopdf and mhtml (in IE 9 or below) doesn't support svgs****
	 */
	//	var items = otherPage.evaluate(function() {
	//		$("body").addClass("mhtmlsvgfriendly"); //sometimes a label has top margin <0 so as to overlap with svg and then interferes with image clipping - an example is in viewreport.css in customreports
	//		var result = [];
	//		var svgs = $("svg");
	//		$.each(svgs, function(svgindex, svgvalue) {
	//			var el = $(svgvalue).parent();
	//			result[svgindex] = {
	//				offsetTop : el.offset().top,
	//				offsetLeft : el.offset().left,
	//				offsetWidth : el.width(),
	//				offsetHeight : el.height()
	//			};
	//		});
	//		return result;
	//	});
	//	items.forEach(function(svgvalue, svgindex, array) {
	//		otherPage.clipRect = {
	//			top : svgvalue.offsetTop,
	//			left : svgvalue.offsetLeft,
	//			width : svgvalue.offsetWidth,
	//			height : svgvalue.offsetHeight
	//		};
	//		otherPage.render("..\\..\\export\\temp\\images\\" + otherFileName + svgindex + ".png");
	//	});
	//	console.log(items.length + ' images created');
	//	otherPage.evaluate(function(otherFileName) {
	//		var result = [];
	//		var svgs = $("svg");
	//		$.each(svgs, function(index, value) {
	//			$(value).parent().append('<img class="exportsvgimage" src="' + cvUtil.getContextPath() +
	//					'/reports/export/temp/images/' + otherFileName + index + '.png" />');
	//			var d = $("<div></div>");
	//			$(value).parent().append(d);
	//			d.append($(value));
	//			d.addClass("exportsvg"); //we retain both svg and img because winnovative library shows svg better than image, but wkhtmltopdf can't render svg - at this time we don't know which library will be used so retain both. We add svg to another div as wkhtmltopdf doesn't honor display:none on svg and renders useless text from svg on top of the image
	//		});
	//		$("body").removeClass("mhtmlsvgfriendly");
	//		return result;
	//	}, otherFileName);
}
function csv(page, outFile, isAlarm, alarmOnTableId, isReportMetadataCall, hideCSVAdditionalInfo) { //it could be done in servlet layer using data model itself but then we'd lose any client side rendering
	var fs = require('fs');
	var delimiter = ',';
	var nl = '\r\n';
	var csv = page.evaluate(function(delimiter, nl, isAlarm, alarmOnTableId, isReportMetadataCall,hideCSVAdditionalInfo) {
		console.log("exporting to csv");
		$(".hideInCsv").remove();
		window.htmlDecode = function(input) { //make escape characters e.g. &nbsp; to appear as unescaped values e.g. space
			//			var map = {"gt":">", "nbsp":" ", "amp":"&"};
			//		    return input.replace(/&(#(?:x[0-9a-f]+|\d+)|[a-z]+);?/gi, function($0, $1) {
			//		        if ($1[0] === "#") {
			//		            return String.fromCharCode($1[1].toLowerCase() === "x" ? parseInt($1.substr(2), 16)  : parseInt($1.substr(1), 10));
			//		        } else {
			//		            return map.hasOwnProperty($1) ? map[$1] : $0;
			//		        }
			//		    });
			return input;
		};
		var csv = ''; //any report specific changes should be done by creating a function in reports js file and then calling that from here say, if(window.tasksummary) tasksummary(); and tasksummary can be defined in your js file

		function addLine(text) {
			if (text != '""') {
				csv += text + nl;
			}
		}
		function createField(text) {

			var field = text.trim().replace(/\"/g, "\"\"");
			if (isNaN(field)) {
				if (window.checkCSVInjection && isCSVInjectionDetected(field)) {
					field = "'" + field;
				}
				return '"' + field + '"';
			} else {
				return '"' + " " + field + '"'; //  space is given in the begining to stop Excel from formatting the data automatically
			}

			function isCSVInjectionDetected(val) {
		        return (val.indexOf("+") == 0) || (val.indexOf("-") == 0)|| (val.indexOf("=") == 0) || (val.indexOf("@") == 0);
		    }
		}
		var breadcrumb = '';
		$.each($("#breadcrumbMain a").filter(":visible"), function(index, value) {
			breadcrumb += htmlDecode($(value).text()) + " > ";
		});

		console.log("isAlarm " + isAlarm);
		console.log("isReportMetadataCall: " + isReportMetadataCall);

		if (!isAlarm) {
			csv += '\uFEFF';
		}
		if ((breadcrumb != '' && !isAlarm)) {
			addLine(createField(breadcrumb));
		}
		if (!isAlarm && !hideCSVAdditionalInfo) {
			if ($("#welcomeMsg").text() != null && $("#welcomeMsg").text().length != 0) {
				addLine(createField($("#welcomeMsg").text()));
			}

			if (isReportMetadataCall !== 'true') {
				if (($("#custName").text() != null && $("#custName").text().length != 0)) {
					addLine(createField($("#custName").text()));
				}
			}

			if (($("#surveyName").text() != null && $("#surveyName").text().length != 0)) {
				var title = $("#surveyName").text();
				addLine(createField(title));
			}
			var reportDesc = "";
			if ($('#reportDesc').length && $("#reportDesc").text() != null && $("#reportDesc").is(":visible")) {
				reportDesc = $("#reportDesc").text();

			}
			if (($("#sectionTitle").text() != null && $("#sectionTitle").text().length != 0)) {
				addLine(createField(htmlDecode($("#sectionTitle").text())));
			}
			if ($("#generatedOnText").is(":visible")) {
				if (($("#generatedOnText").text() != null && $("#generatedOnText").text().length != 0)) {
					addLine(createField(htmlDecode($("#generatedOnText").text())));
					csv += nl; // add an extra line after title
				}
			}
			if (($("#commcelltext").text() != null && $("#commcelltext").text().length != 0)) {
				addLine(createField(htmlDecode($("#commcelltext").text().trim())));

			}
			if (($("#asoftext").text() != null && $("#asoftext").text().length != 0)) {
				addLine(createField(htmlDecode($("#asoftext").text().trim())));
			}
			if (($("#infoDiv").text() != null && $("#infoDiv").text().length != 0)) {
				addLine(createField(htmlDecode($("#infoDiv").text().trim())));
			}
			var line = '';
			$.each($("#reportTaskSummary li").filter(":visible"), function(index, value) {
				if ($(value).hasClass("col1")) {
					csv += createField(line) + nl;
					line = htmlDecode($(value).text());
				} else {
					line += htmlDecode($(value).text());
				}
			});
			if (line.length > 0) {
				csv += createField(line) + nl;
			}

			if ($("#searchKeywordid").is(":visible")) {
				if (($("#searchKeywordid").text() != null && $("#searchKeywordid").text().length != 0)) {
					csv += nl;
					addLine(createField(htmlDecode($("#searchKeywordid").text())).trim().replace(/(\r\n|\n|\r)/gm, '')
							.trim());
				}
			}
			var line = '';
			if ($(".appliedFiltersDiv").is(":visible")) {
				csv += nl;
				csv += createField(htmlDecode($(".filterText").text()).trim());
				$.each($("#appliedFilterLst li").filter(":visible"), function(index, value) {
					var line = '';
					csv += nl;
					line += createField((htmlDecode($(value).text()).trim().replace(/(\r\n|\n|\r)/gm, '').trim()));
					csv += (line);
				});
				csv += nl;
			}
			var line = '';
			if ($(".additionalFilters").is(":visible")) {
				csv += nl;
				csv += createField(htmlDecode($(".additionalFilterText").text()).trim());
				$.each($("#additionalFilterLst li").filter(":visible"), function(index, value) {
					var line = '';
					csv += nl;
					line += createField((htmlDecode($(value).text()).trim().replace(/(\r\n|\n|\r)/gm, '').trim()));
					csv += (line);
				});
				csv += nl;
			}

		}

		var sectionTitle = "";
		var summaryExist = false;
		$.each($("table").filter(":visible"), function(index, table) {
			var tableId = $(table).attr("id");
			if (isAlarm && alarmOnTableId != tableId) {
				return true; // continue; $.each -- continue to next iteration
			}
			if (hideCSVAdditionalInfo && tableId == "reportSummary") {
				summaryExist = true;
				return true;
			}
			var repSubtitlePresent = false;
			var newsectionTitle = $(table).closest(".repHolder").find(".repSubTitle").text();
			if (newsectionTitle.length > 0 && newsectionTitle != sectionTitle) {
				csv += nl + createField(newsectionTitle) + nl;
				sectionTitle = newsectionTitle;
			}
			if (newsectionTitle.length > 0) {
				repSubtitlePresent = true;
			}
			var tabletitle = $(table).attr("id");
			if (tabletitle && tabletitle.indexOf("_table") > -1 && !isAlarm && !hideCSVAdditionalInfo) {
				if (reportDesc) {
					csv += nl + reportDesc;
				}
				if (repSubtitlePresent) {
					csv += nl + delimiter + $("#" + $(table).attr("id").replace("_table", "_title")).text() + nl;
				} else if ($("#" + $(table).attr("id").replace("_table", "_title")).text() != null &&
						$("#" + $(table).attr("id").replace("_table", "_title")).text().trim() != "") {
					csv += nl + $("#" + $(table).attr("id").replace("_table", "_title")).text() + nl;
				} else {
					csv += nl;
				}

			} else if (hideCSVAdditionalInfo && index != 0) {
				if (!(summaryExist && index == 1)) {
					csv += nl;
				}
			}
			if (isReportMetadataCall === 'true') {
				console.log("getting metadata");
				if ($(table).parent("#statusRow").length > 0) {
					//do nothing
				} else {
					console.log("table" + $(table), "tablename: " + table);

					var ar = $.map($(table).dataTable().fnSettings().aoColumns, function(colMetaData, index2) {
						console.log("metadata: " + colMetaData + ", " + index2 + ", " + colMetaData.sTitle);
						return createField(htmlDecode(colMetaData.sTitle));
					});

					csv += ar.join(delimiter) + nl;
					ar = $.map($(table).dataTable().fnSettings().aoColumns, function(colMetaData, index2) {
						console.log("sType: " + colMetaData.sType + ", sqlType: " + colMetaData.sqlType);
						var colType = colMetaData.sType;
						if (colType == null) {
							if (colMetaData.sqlType != null) {
								colType = colMetaData.sqlType.toLowerCase();
							} else {
								colType = "string";
							}
						}

						if (colMetaData.rendererType === 'capacityMB' || colType == 'html') {
							colType = "string";
						}
						return createField(htmlDecode(colType));
					});
					csv += ar.join(delimiter) + nl;
				}
			} else {
				if ($(table).parent("#statusRow").length > 0) {
					//do nothing
				}else{
					$.each($(table).find('tr'), function(index2, tr) {
						var ar = $.map($(tr).find('th'), function(th, index3) {
							return createField(htmlDecode($(th).text()));
						});
						if (repSubtitlePresent) {
							csv += delimiter + ar.join(delimiter);
						} else {

							csv += ar.join(delimiter);
						}
						var tid = $(tr).attr("id") || "";
						var fIndx = tid.indexOf("filterRow");
						if (fIndx == -1) {
							ar = $.map($(tr).find('td'), function(td, index3) {
								if (isAlarm) {
									if ($(td).hasClass("dataTables_empty")) {
										// no rows in the table.. return empty;
										csv = "";
										return "";
									}
									return createField(htmlDecode($(td).html())); //do not remove any inner html
								} else {
									var renderedHtml = $(td).find(".csvText"); //if there is a renderer with some html then text value should be inside span/div with class csvText which will be displayed in csv
									if (renderedHtml.length > 0) {
										return createField(htmlDecode(renderedHtml.text()));
									} else {
										return createField(htmlDecode($(td).text().replace(/<[^>]*>/g, ""))); //remove any inner html, just display text
									}

								}
							});
							csv += ar.join(delimiter) + nl;
						}
					});
				}
			}
		});
		if (!isAlarm) {
			if ($("#error_message").text() != null && $("#error_message").is(":visible")) {
				addLine(nl + createField($("#error_message").contents(':not(div)').text()));
			}

			if ($('.exportError').text() != null && $.trim($('.exportError').text()) != '') {
				addLine(nl + createField($('.exportError').text()));
			}
		}

		console.log("returning csv string: " + csv);
		return csv;
	}, delimiter, nl, isAlarm, alarmOnTableId, isReportMetadataCall, hideCSVAdditionalInfo);
	fs.write(outFile, csv, "w");
	try {
		var columnModel = page.evaluate(function() {
			if (window.Reports) {
				return Reports.columnModelForExport;
			}
		});
		if (columnModel) {
			fs.write(screenshot.outputDir + screenshot.sessionid + 'temp.txt', JSON.stringify(columnModel), "w");
		}
	} catch (e) {
		console.error("Error while writing columnModel for big export " + e);
		console.error("Ignoring error and continuing with export");
	}
}
function waitFor(testFx, onReady, timeOutMillis) {
	var maxtimeOutMillis = timeOutMillis ? timeOutMillis : 60000, //< Default Max Timout is 60s
	start = new Date().getTime(), condition = false, interval = setInterval(function() {
		if ((new Date().getTime() - start < maxtimeOutMillis) && !condition) {
			// If not time-out yet and condition not yet fulfilled
			condition = (typeof (testFx) === "string" ? eval(testFx) : testFx()); //< defensive code
		} else {
			if (!condition) {
				// If condition still not fulfilled (timeout but condition is 'false')
				console.error("'waitFor()' timeout");
				exitPhantom(1);
				return;
			} else {
				// Condition fulfilled (timeout and/or condition is 'true')
				console.log("'waitFor()' finished in " + (new Date().getTime() - start) + "ms.");
				typeof (onReady) === "string" ? eval(onReady) : onReady(); //< Do what it's supposed to do once the condition is fulfilled
				clearInterval(interval); //< Stop this interval
			}
		}
	}, 250); //< repeat check every 250ms
}
function loadPage(url, onPageLoadCallBack) {
	pageArray.push({
		'url' : url,
		'onPageLoadCallBack' : onPageLoadCallBack
	});
	if (countActivePages < MAX_ACTIVE_PAGES) {
		actualLoadPage();
	}
}
function actualLoadPage() {
	if (pageArray.length <= currentPage) {
		return;
	}
	var url = pageArray[currentPage].url, onPageLoadCallBack = pageArray[currentPage].onPageLoadCallBack;
	countActivePages++;
	currentPage++;

	var page = new WebPage();
	var results = (new RegExp("[\\?&]viewportWidth=([^&#]*)")).exec(url);
	var viewportWidth = "1720";
	if (results && results.length > 1) {
		viewportWidth = results[1];
	}
	if (screenshot.viewportWidth || viewportWidth) {
		page.viewportSize = {
			width : parseInt(screenshot.viewportWidth || viewportWidth),
			height : 800
		};
	}
	page.settings.userAgent = 'Simpana PhantomJS';
	page.onConsoleMessage = function(msg, line, source) {
		console.log(source + " " + line + ":" + msg);
	};
	page.onError = function(msg, trace) {
		var msgStack = [ 'ERROR ON PAGE: ' + msg ];
		if (trace) {
			msgStack.push('TRACE:');
			trace.forEach(function(t) {
				msgStack.push(' -> ' + t.file + ': ' + t.line +
						(t["function"] ? ' (in function "' + t["function"] + '")' : ''));
			});
		}
		console.error(msgStack.join('\n')); //should phantom.exit(1) be called here also ??
	};
	for (var i = 3; i < system.args.length; i++) {
		console.log(system.args[i]);
		var cookie = system.args[i].split("=");
		console.log("COOKIE NAME: " + cookie[0]);
		console.log("COOKIE VALUE: " + cookie[1]);
		phantom.addCookie({
			'name' : cookie[0],
			'value' : cookie[1],
			'domain' : screenshot.domain
		});
	}
	page.onLoadFinished = function(status) {
		setTimeout(onPageLoadCallBack(status, page), 500); //give the page 500 ms to load any js if it is
	};
	console.log("opening: ");
	console.log(url);
	page.open(url);
}
function closePage(page) {
	page.close();
	countActivePages--;
	actualLoadPage();
}