var system = require('system');
var fs = require('fs');

TABLESIZE_THRESHOLD_FOR_PDFQUALITY = 1000;
MAX_ACTIVE_PAGES = 10;

function exitPhantom(exitCode) {
	setTimeout(function() {
		phantom.exit(exitCode);
	}, 0);
};

if (console) {
	console.error = function(msg) {
		console.log('Error: ' + msg);
	};
}

try {
	var counter = 0;
	var countActivePages = 0;
	var currentPage = 0;
	var pageArray = [];
	var pageAlreadyLoadedArray = [];
	var linksLoaded = 0;
	phantom.cookiesEnabled = true;
	var JSONInput = fs.read(system.args[1]);
	fs.remove(system.args[1]);
	console.log('Json is: ' + system.args[1]);
	var fileOptionsArg;
	fileOptionsArg = system.args[2];
	fileOptionsArg = fileOptionsArg.replace(/\\\"/g, "\"");
	console.log('fileOptions : ' + fileOptionsArg);
	var fileOptions = JSON.parse(fileOptionsArg);
	var screenshot = JSON.parse(JSONInput);
	screenshot.outputFileName = fileOptions.outputFileName;
	var outputFileName = screenshot.outputFileName;
	var isAlarm = screenshot.isAlarm;
	var isAlertCriteriaTest = screenshot.isAlertCriteriaTest;
	var isReportAsEmailBody = (screenshot.isReportAsEmailBody === 'true') ? true : false;
	var mainPage;
	var totalRowsInPage = 0;
	var successStatus = 0;
	phantom.onError = function(msg, trace) {
		var msgStack = [ 'PHANTOM ERROR: ' + msg ];
		if (trace && trace.length) {
			msgStack.push('TRACE:');
			trace.forEach(function(t) {
				msgStack.push(' -> ' + (t.file || t.sourceURL) + ': ' + t.line +
						(t["function"] ? ' (in function ' + t["function"] + ')' : ''));
			});
		}
		console.error(msgStack.join('\n'));
	};

	console.log('loading module');
	var base64Images = require("./base64Images");
	var cssInliner = require('./cssInliner');
	var readmeCss = "";

	if (!!base64Images && typeof base64Images.base64Fonts !== 'undefined' &&
			typeof base64Images.base64Fonts['glyphicons-halflings-regular'] !== 'undefined') {
		readmeCss += "@font-face{font-family:'Glyphicons Halflings';src:url('" +
				base64Images.base64Fonts['glyphicons-halflings-regular'] + "') format('woff');}";
	}

	if (!!base64Images && typeof base64Images.base64Fonts !== 'undefined' &&
			typeof base64Images.base64Fonts['WebComponentsIcons'] !== 'undefined') {
		readmeCss += "@font-face{font-family:'WebComponentsIcons';src:url('" +
				base64Images.base64Fonts['WebComponentsIcons'] + "') format('woff');}";
	}

	console.log('loaded');
	var outputType = outputFileName.substr(outputFileName.lastIndexOf(".") + 1);
	var mainPageLoadCallBack = function(status, page) {
		window.mainPage = page;
		if (counter > 0) {
			return; //this is called for each frame/iframe, so execute only once
		}
		counter++;
		try {
			console.log('main page loaded with status: ');
			console.log(status);
			if (status !== 'success') {
				console.error("Pageload status is " + status + ".\n Exiting with return code 1");
				exitPhantom(1);
				return;
			}
			console.log("Page url is:" + page.url);
			if (page.url.indexOf('noPermission.jsp') != -1 || page.url.indexOf('/applications/') != -1) {
				console.error("loaded page is nopermission.jsp or /aapplications/ ...exiting");
				exitPhantom(403);
				return;
			}
			waitFor(function() {
				return page.evaluate(function() {
					var retVal = true;
					console.log('exportHtml::mainPageLoadCallBack():waitFor ::window.jQuery = ' + window.jQuery);
					console.log('exportHtml::mainPageLoadCallBack():waitFor ::window.allOnReadiesExecuted = ' +
							window.allOnReadiesExecuted);
					console.log('exportHtml::mainPageLoadCallBack():waitFor ::$.active = ' + $.active);
					if (!window.jQuery || !window.allOnReadiesExecuted || $.active > 0) {
						console.log('exportHtml::mainPageLoadCallBack(): ::waitFor ::condition is...false');
						return false;
					}
					var loadmask = $(".loadmask:visible");
					console.log('exportHtml::mainPageLoadCallBack():waitFor ::loadmask.length = ' + loadmask.length);
					retVal = retVal && loadmask.length == 0;
					var datatables = $(".dataTable:visible:not(.drawn)").length == 0;
					console.log('exportHtml::mainPageLoadCallBack():waitFor ::datatables.length = ' +
							$(".dataTable:visible:not(.drawn)").length);
					retVal = retVal && datatables; //this assumes that when all the tables are drawn completely, we consider page complete. reportsbase.js adds drawn class ontablerendercallback
					console.log('exportHtml::mainPageLoadCallBack(): ::waitFor ::condition is...' + retVal);
					return retVal;
				});
			},
					function() {
						var pageAttrs = page.evaluate(function() {
							pageAttrs = {};
							if (window.Reports && Reports.hasFatalError && Reports.hasFatalError()) {
								pageAttrs.error = true;
								pageAttrs.errorMessage = Reports.getFatalError();
							} else {
								pageAttrs.error = false;
							}
							return pageAttrs;
						});
						if (pageAttrs.error) {
							console.error("Error on report. " + pageAttrs.errorMessage + ". Exiting with error code 2");
							exitPhantom(2);
							return;
						}

						totalRowsInPage += page.evaluate(function() {
							return $(".dataTable tbody tr").filter(':visible').length;
						});
						page.evaluate(function() {
							$("body").addClass("exportfriendly htmlExportFriendly");
						});
						var links = [];
						page.evaluate(function(server) {
							console.log("Replacing localhost in href");
							console.log(server);
							$.each($("a:not(.crawledLink)").filter("[href*='//localhost']"), function(index, value) {
								var el = $(value);
								var h = el.attr("href").replace(/https?:\/\/localhost[:]?[\d]*/g, server);
								console.log("Replacing " + el.attr("href") + " with " + h);
								el.attr("href", h);
							});
							$('a:not(.crawledLink)')
									.not('[href^="http"],[href^="https"],[href^="mailto:"],[href^="#"]').each(function(
											index, value) {
										$(value).attr("href", server + value.pathname + value.search + value.hash);
									});
							$("svg a").contents().unwrap();
							// remove empty elements under meta information in metrics reports.
							$("#surveyHeaderRow #meta").find(':empty').remove();
							localStorage.clear();
						}, screenshot.server);
						console.log("Got links from main page:" + links.length);
						var heights = [];
						links
								.forEach(function(value, index, a) { //create html file for each followforlink url
									loadPage(value,
											function(status, otherPage) {
												console.log(value + " loaded with " + status);
												if (status !== 'success') {
													console.error("Error while loading " + value);
													console.error("Pageload status is " + status +
															".\n Exiting with return code 1");
													exitPhantom(1);
													return;
												}
												waitFor(function() {
													console.log('evaluating waitfor condition...');
													return otherPage
															.evaluate(function() {
																var retVal = true;
																console
																		.log('exportHtml::otherPage():waitFor ::window.jQuery = ' +
																				window.jQuery);
																console
																		.log('exportHtml::otherPage():waitFor ::window.allOnReadiesExecuted = ' +
																				window.allOnReadiesExecuted);
																console
																		.log('exportHtml::otherPage():waitFor ::$.active = ' +
																				$.active);
																if (!window.jQuery || !window.allOnReadiesExecuted ||
																		$.active > 0) {
																	return false;
																}
																var loadmask = $(".loadmask:visible");
																retVal = retVal && loadmask.length == 0;
																var datatables = $(".dataTable:visible:not(.drawn)").length == 0;
																retVal = retVal && datatables; //this assumes that when all the tables are drawn completely, we consider page complete. reportsbase.js adds drawn class ontablerendercallback
																console.log('waitfor condition is...' + retVal);
																return retVal;
															});
												},
														function() {
															window
																	.setTimeout(function() {
																		for (var i = 0; i < pageAlreadyLoadedArray.length; i++) {
																			if (pageAlreadyLoadedArray[i] == value) {
																				return;
																			}
																		}
																		heights[index] = otherPage
																				.evaluate(function(server) {

																					console
																							.log("Replacing localhost in href");
																					$
																							.each($("a:not(.crawledLink)")
																									.filter("[href*='//localhost']"),
																									function(index,
																											value) {
																										var el = $(value);
																										var h = el
																												.attr("href")
																												.replace(/https?:\/\/localhost[:]?[\d]*/g,
																														server);
																										console
																												.log("Replacing " +
																														el
																																.attr("href") +
																														" with " +
																														h);
																										el.attr("href",
																												h);
																									});
																					$('a:not(.crawledLink)')
																							.not('[href^="http"],[href^="https"],[href^="mailto:"],[href^="#"]')
																							.each(function(index, value) {
																								$(value)
																										.attr("href",
																												server +
																														value.pathname +
																														value.search +
																														value.hash);
																							});
																					$("svg a").contents().unwrap();

																					/*************************
																					 * Start code hack to get
																					 * around this bug of
																					 * wkhtmltopdf
																					 * https://github.com/wkhtmltopdf/wkhtmltopdf/issues/1524
																					 ************************/
																					$.each($(".reportTable thead"),
																							function(index, value) {
																								var el = $(value);
																								el.next().prepend(el
																										.contents());
																								el.remove();
																							});
																					$(".reportTable th")
																							.each(function(index) {
																								var thisTD = this;
																								var newElement = $("<td></td>");
																								$
																										.each(this.attributes,
																												function(
																														index) {
																													$(newElement)
																															.attr(thisTD.attributes[index].name,
																																	thisTD.attributes[index].value);
																												});
																								$(newElement)
																										.addClass('tableheadertd');
																								$(newElement)
																										.html($(this)
																												.html());
																								$(this)
																										.after(newElement)
																										.remove();
																							});
																					/**
																					 * End code hack for
																					 * wkhtmltopdf*
																					 */
																					console.log('getting height');
																					if (!document.body.className) {
																						document.body.className = "";
																					}

																					$('a.disableOnEmbedded').contents()
																							.unwrap();
																					document.body.className += " embedded exportfriendly";
																					return document.body.scrollHeight;
																				},
																						screenshot.server);
																		totalRowsInPage += otherPage
																				.evaluate(function() {
																					return $(".dataTable tbody tr")
																							.filter(':visible').length;
																				});
																		var otherFileName = outputFileName + "test" +
																				index;
																		var content = otherPage.content;
																		var rscript = /<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi; //remove script tags
																		var comments = /<!--[\s\S]*?-->/g; //removes html comments
																		content = content.replace(rscript, '');
																		content = content.replace(comments, '');

																		console.log('writing html file at ' + "temp\\" +
																				otherFileName + ".html");
																		fs.write("temp\\" + otherFileName + ".html",
																				content,
																				"w");
																		pageAlreadyLoadedArray.push(value);
																		closePage(otherPage);
																		linksLoaded++;
																	},
																			500); //end settimeout
														},
														2 * 60 * 1000); //1 min. timeout - end waitfor
											}); //end loadpage
								});//end links.foreach

						var waitForTime = 2 * 1000;
						var loadMaskTimerStarted = false;
						var start = 0;
						waitFor(function() {
							var retVal = true;
							retVal = links.length == linksLoaded;
							console.log('waitfor condition is...' + retVal + ". Number of links loaded:" + linksLoaded);
							if (screenshot.isCustomAlarmv2 == 'true') {
								retVal = page.evaluate(function() {
									console.log("Pending requests " + window.pendingRequests);
									if (window.pendingRequests > 0) {
										return false;
									} else {
										return true;
									}
								});
							}

							//if (isReportAsEmailBody) {
							if (retVal) {
								if (!loadMaskTimerStarted) {
									// start waitTimer for 2 seconds.
									start = new Date().getTime();
									loadMaskTimerStarted = true;
									console.log('waitfor condition is...' + retVal + ". Number of links loaded:" +
											linksLoaded + ", waiting for 2000ms for any UI rendering to finish");
								}
								var now = new Date().getTime();
								if (now - start < waitForTime) {
									console.log('Waiting for 2000ms, covered so far:' + (now - start) +
											", returning false");
									return false;
								} else {
									console.log('Finished waiting for 2000ms...');
								}
							}
							//}
							return retVal;
						},
								function() {
									console.log('Main page and all links loaded, writing main page');

									if (isReportAsEmailBody) {
										console.log('Going to generate images and placeholders as required...');

										try {
											var components = [];
											var svgComponents = getSVGComponents(page);
											var otherComponents = getOtherComponents(page);

											components = svgComponents.concat(otherComponents);

											convertComponentsToPNG(components, page);
											generateImgElements(page, outputFileName);
											replaceInputElements(page);
											updateReportMetaData(page);
										} catch (ebError) {
											console.error('Failed to generate resources required for email body: ' +
													ebError);
										}
									} else {
										console
												.log('Not generating images and placeholders since the value of isReportAsEmailBody is: ' +
														isReportAsEmailBody);
									}

									phantom.sprite = '.sprite{background-image:url(\'' +
											base64Images.base64Images.sprite + '\');}';
									delete base64Images.base64Images.sprite;

									page
											.evaluate(function(base64Images, spriteCssClassList, sprite,
													isReportAsEmailBody, base64CustomLogo, providerId) {
												console.log('base64Images inside page is: ' + base64Images['pglogo']);
												$.each($('img'), function(index, el) {
													console.log('el.id is: ' + el.id);
													if (base64Images[el.id]) {
														$(el).attr('src', base64Images[el.id]);
													}
												});

												if ($('div#pglogo').length > 0) {
													var icon = base64Images['pglogo'];

													if (providerId && base64CustomLogo &&
															base64CustomLogo['pglogo_custom_' + providerId]) {
														icon = base64CustomLogo['pglogo_custom_' + providerId];
														console.log("Found custom logo ..");
													}

													console.log('Replacing company logo...' + icon);
													$('div#pglogo').css('background-image', 'url(' + icon + ')');

												}

												$("<style>" + sprite + "</style>").appendTo("head");

												$("#reportArea .gridster-loaded li.gridster-item")
														.css("vertical-align", "top");

												//This spriteCssClassList class list should be loaded, otherwise the sprite classes won't be available for the Second phase of export using nashorn engine
												console.log("spriteCssClassList: " + spriteCssClassList);
												$("body").append("<span class='" + spriteCssClassList +
														"' style='display:none'></span>");

												// removing the below elements from the generated html file , as they break the page when the user tries to print the saved html file or attachement from a schedule.
												$(".shareWindow").remove();
												$(".hideOnExportFriendly").remove();
												$(".pglinks").remove();
												$(".hidden").remove();
												$(".wfBottomArea").remove();
												$(".showOnSmallScreens").remove();
												$("#dropDownArrowSpan").remove();
												//Removing overlay and making links invalid
												$(".overlay").remove();

												var linksInPage = $("a");
												var exportUrlParts = null;

												if (typeof webConsoleURLForExports != 'undefined' &&
														webConsoleURLForExports) {
													exportUrlParts = webConsoleURLForExports.split('/');
												}

												if (isReportAsEmailBody) {
													linksInPage
															.each(function(i, e) {
																if (exportUrlParts) {
																	var href = $(e).attr('href');
																	if (href.indexOf('/webconsole/') > -1 ||
																			href.indexOf('/adminconsole/') > -1) {
																		var arr = href.split('/');

																		var res = exportUrlParts[0] +
																				'//' +
																				exportUrlParts[2] +
																				'/' +
																				(arr.length > 3 ? arr.slice(3) : arr)
																						.join('/');
																		$(e).attr('href', res);
																	}
																} else {
																	$(e).replaceWith('<span class="replaced-link">' +
																			$(e).html() + '<span>');
																}
															});
												} else {
													linksInPage.attr('href', '#');
													linksInPage.css("pointer-events", "none");
												}

											},
													base64Images.base64Images,
													base64Images.spriteCssClassList,
													phantom.sprite,
													isReportAsEmailBody,
													base64Images.base64CustomLogo,
													screenshot.providerId);

									if (isAlarm == 'true' && isAlertCriteriaTest == 'true' &&
											screenshot.isCustomAlarmv2 != 'true') {
										// don't do css inline and stuff, just pick the matching html and return
										var tableId = getAlertTableId(screenshot);
										var html = page.evaluate(function(tableId) {
											if (tableId) {
												$('#filterRow_' + tableId, '#' + tableId + '_table').remove();
												var html = $('<div>').append($('#' + tableId).clone()).html();
												return html;
											}
											return '';
										}, tableId);
										fs.write(screenshot.outputDir + screenshot.outputFileName, html, "w");
										exitPhantom(0);
									} else {
										if (isAlertCriteriaTest == 'true' && screenshot.isCustomAlarmv2 == 'true') {
											page.evaluate(function() {
												$(".hideOnTestAlertExport").remove();
												$('li.gridster-item').css({
													position : 'static',
													height : 'auto',
													display : 'inline-block'
												});
											});
										}
										//feature is not complete - will remove check in next form
										if (screenshot.isCustomAlarmv2 == 'true' ||
												screenshot.isMetricsExportv2 == 'true') {
											page
													.evaluate(function(isReportAsEmailBody) {
														var reportTables = $('.reportTable:visible');
														if (reportTables && reportTables.length > 0) {

															// Demarcate the table contents for processing at the backend.
															$('tbody[role=rowgroup]', reportTables).each(function() {
																var tableId = $(this).parents('.reportTable').attr('id');
															    $(this).before('<input type="hidden" name="table_' + tableId + '-TBODY_BEGIN" />')
															    		.after('<input type="hidden" name="table_' + tableId + '-TBODY_END" />');
															});


															$("#content #reportArea #pageDiv div[data-gridster]").css({
																height : 'auto'
															});
															$
																	.each($("#content #reportArea #pageDiv div[data-gridster] ul li[comp]"),
																			function(index, value) {
																				var cssProps = {
																					position : 'static',
																					height : 'auto',
																					display : 'inline-block'
																				};
																				if (!isReportAsEmailBody) {
																					cssProps.marginLeft = '10px';
																				}
																				$(value).css(cssProps);
																			});
														}
														$(".dataTables_paginate").hide();

													},
															isReportAsEmailBody);
										}

										var jsonContent = page.evaluate(function() {
											var metaData = window.reportMetaData;
											return metaData ? JSON.stringify(metaData) : '';
										});
										if (jsonContent) {
											fs.write(screenshot.outputDir + screenshot.outputFileName + ".JSON",
													jsonContent,
													"w");
										}
										cssInliner.startInlineCss(page, page.content);
									}
								},
								15 * 60 * 1000); //10 min. timeout
					},
					5 * 60 * 1000); //5 min timeout
		} catch (e) {
			console.error("Error on pageload " + e);
			console.error("Exiting with error code 1");
			exitPhantom(1);
		}
	};
	loadPage(screenshot.url, mainPageLoadCallBack);
} catch (e) {
	console.error("Error while initializing page in screenshot.js" + e.name + " " + e.message + "\n" + e.stack);
	console.error("Exiting with return code 1");
	exitPhantom(1);
}

function getOtherComponents(page) {
	var items = page.evaluate(function(otherImageComponentSelector) {
		var result = [];
		var j = 0;
		try {
			var otherComponents = $(otherImageComponentSelector);
			if (otherComponents) {
				console.log('Number of other components: ' + otherComponents.length);
				var top = 0;
				var cls = "";
				for (var i = 0; i < otherComponents.length; i++) {
					var comp = $(otherComponents[i]);
					if (comp.is(':visible') && comp.width() > 0 && comp.height() > 0) {

						var compId = comp.attr('comp');
						var compType = comp.attr('data-component-type');
						var offsetX = 0;
						var offsetY = 2;

						if (compType == 'EB_ICON') {
							// EB_ICON components are allowed to be nested inside other components.
							// To maintain uniqueness when processing all components at once, we need to look for the parent component's ID.

							var parentComp = comp.parents("[comp]");
							var parentCompId = '';
							if (parentComp && parentComp.length) {
								parentCompId = $(parentComp[0]).attr('comp');
							}
							// icons will be repeated and can't have the same ID.
							// cls will help identify different rows.
							// can't depend on i or j values as the components can be in multiple times in the same row of a table.
							// seen this kind in health card report.
							var compOffsetTop = comp.offset().top;
							if (top != compOffsetTop) {
								if (cls == 'even') {
									cls = 'odd';
								} else {
									cls = 'even';
								}
								top = compOffsetTop;
							}
							compId = parentCompId + "-" + compId + '-' + cls;
							comp.attr('comp', compId);

						} else {
							offsetX = 5;
						}

						result[j] = {
							compId : compId,
							offsetTop : comp.offset().top,
							offsetLeft : comp.offset().left,
							offsetWidth : comp.width() + offsetX,
							offsetHeight : comp.height() + offsetY
						};
						console.log("Component ID: " + compId + ", Component Type: " + compType);
						j++;
					}
				}
			}
		} catch (err) {
			console.error('getOtherComponents failed: ' + err);
		}
		return result;
	}, getOtherImageComponentSelector());

	if (items && items.length) {
		return items;
	}
	return [];
}

function getSVGComponents(otherPage) {
	var items = otherPage.evaluate(function() {
		var result = [];
		var svgs = $("[data-component-type=CHART] svg.highcharts-root");
		var j = 0;
		$.each(svgs, function(svgindex, svgvalue) {
			var el = $(svgvalue).parent();
			var wrapper = $(svgvalue).parents('li[comp]');
			var compId = wrapper.attr('comp');
			if (compId) {
				if (el.width() > 0 && el.height() > 0) {
					result[j++] = {
						compId : compId,
						offsetTop : el.offset().top,
						offsetLeft : el.offset().left,
						offsetWidth : el.width(),
						offsetHeight : el.height()
					};
				}
			}
		});
		return result;
	});
	if (items && items.length) {
		return items;
	}
	return [];
}

function convertComponentsToPNG(components, otherPage) {
	console.log('Generating images for components...');
	if (components) {
		var images = 0;
		components.forEach(function(comp, ndx) {
			var compId = comp.compId;
			if (comp.offsetHeight > 0 && comp.offsetWidth > 0) {

				otherPage.clipRect = {
					top : comp.offsetTop,
					left : comp.offsetLeft,
					width : comp.offsetWidth,
					height : comp.offsetHeight
				};
				// going with less quality png images to make the email lightweight.
				// the difference in size is quite considerable and quality isn't that bad.
				// besides the backend server has a limit on the size of the email (3MB?).
				otherPage.render(screenshot.outputDir + fs.separator + screenshot.requestId + fs.separator + compId +
						".png", {
					format : 'png',
					quality : '0'
				});
				images++;
			}
		});
		console.log(images + ' images created');
	}
}

function updateReportMetaData(page) {
	page.evaluate(function() {
		if (!window.reportMetaData) {
			window.reportMetaData = {};
		}
		var metaData = window.reportMetaData;
		var renderedComponents = $('[comp]');
		//metaData.reportName = $('#sectionTitle').html();

		console.log('Length of total components: ' + renderedComponents.length);
		var visibleComponents = $.grep(renderedComponents, function(c, i) {
			// excluding search bar components also.
			var compType = $(c).data('component-type');
			return $(c).is(':visible') && (compType != 'SEARCH_BAR' && compType != 'DATE_RANGE' && compType != 'TABS');
		});
		console.log('Length of visible components: ' + visibleComponents.length);
		metaData.orderOfComponents = $.map(visibleComponents, function(c, i) {
			var $c = $(c);
			console.log('Visible Component ID: ' + $(c).attr('comp'));
			return {
				id : $(c).attr('comp'),
				type : $(c).data('component-type'),
				groupId : 'y' + $(c).offset().top
			};
		});
	});
}

function generateImgElements(otherPage, otherFileName) {
	otherPage.evaluate(function(otherFileName, otherImageComponentSelector) {

		var svgs = $("[data-component-type=CHART] svg.highcharts-root");
		var otherComponents = $(otherImageComponentSelector);
		$.each(svgs, function(index, value) {
			var comp = $(value);
			if (comp.is(':visible')) {
				var liItem = comp.parents('li[comp]');
				var compId = liItem.attr('comp');
				liItem.css('margin-left', '0px');
				comp.parent().append('<img class="exportsvgimage" src="cid:' + compId + ".png" + '" />');
				comp.remove();
			}
		});

		console.log('Number of other components found: ' + otherComponents.length);
		$.each(otherComponents, function(index, value) {
			var comp = $(value);
			if (comp.is(':visible')) {
				var compId = comp.attr('comp');
				var style = comp.attr('style') || '';
				console.log('Style: ' + style);
				comp.empty()
						.append('<img class="exportsvgimage" src="cid:' + compId + '.png" style="' + style + '" />');
			}
		});

	}, otherFileName, getOtherImageComponentSelector());
}

function getOtherImageComponentTypes() {
	return [
			'HITS',
			'CUSTOM',
			'METRICS_CHART',
			'MAP',
			'MAP_v2',
			'HEALTH_TILE',
			'EB_IMAGE',
			'EB_ICON',
			'HEAT_MAP',
			'SCATTER',
			'TAG_CLOUD' ];
}

function getOtherImageComponentSelector() {
	var template = '[data-component-type={{type}}]';
	var types = getOtherImageComponentTypes();
	var selector = [];
	for (var i = 0; i < types.length; i++) {
		selector.push(template.replace("{{type}}", types[i]));
	}

	// add EB_IMAGE class to render it as image in email body output.
	// this is required for panels that contain complex data.
	selector.push('.EB_IMAGE');

	var res = selector.join(', ');
	console.log('Other component selector: ' + res);
	return res;
}

function replaceInputElements(page) {
	console.log('Entering replaceInputElements');
	page.evaluate(function() {
		//$('.reportTable .inLineFilter').each(function(i, e) {
		$('input[type=text], select').each(function(i, e) {
			if ($(e).is(':visible')) {
				var val = '';
				if ($(e).is('select')) {
					val = $(e).find("option:selected").text() || '&nbsp;';
					$(e).replaceWith('<span style="font-weight:bold; padding: 2px;">' + val + '</span>');
				} else {
					val = $(e).val() || '&nbsp;';
					$(e).replaceWith('<div style="border:1px solid #BBBBBB;height: 20px; padding: 2px;">' + val +
							'</div>');
				}
			} else {
				var chartColumnsParent = $(e).parents('.chartColumns');
				if (chartColumnsParent.is(':hidden')) {
					chartColumnsParent.remove();
				}
			}
		});
	});
}

function waitFor(testFx, onReady, timeOutMillis) {
	var maxtimeOutMillis = timeOutMillis ? timeOutMillis : 60000, //< Default Max Timout is 60s
	start = new Date().getTime(), condition = false, interval = setInterval(function() {
		if ((new Date().getTime() - start < maxtimeOutMillis) && !condition) {
			// If not time-out yet and condition not yet fulfilled
			condition = (typeof (testFx) === "string" ? eval(testFx) : testFx()); //< defensive code
		} else {
			if (!condition) {
				// If condition still not fulfilled (timeout but condition is 'false')
				console.error("'waitFor()' timeout");
				exitPhantom(1);
				return;
			} else {
				// Condition fulfilled (timeout and/or condition is 'true')
				console.log("'waitFor()' finished in " + (new Date().getTime() - start) + "ms.");
				typeof (onReady) === "string" ? eval(onReady) : onReady(); //< Do what it's supposed to do once the condition is fulfilled
				clearInterval(interval); //< Stop this interval
			}
		}
	}, 250); //< repeat check every 250ms
}
function loadPage(url, onPageLoadCallBack) {
	pageArray.push({
		'url' : url,
		'onPageLoadCallBack' : onPageLoadCallBack
	});
	if (countActivePages < MAX_ACTIVE_PAGES) {
		actualLoadPage();
	}
}
function actualLoadPage() {
	if (pageArray.length <= currentPage) {
		return;
	}
	var url = pageArray[currentPage].url, onPageLoadCallBack = pageArray[currentPage].onPageLoadCallBack;
	countActivePages++;
	currentPage++;

	var page = new WebPage();
	page.settings.userAgent = 'Simpana PhantomJS';
	cssInliner.attachPageEventHandlers(page);
	if (screenshot.operatorCompanyId) {
		page.customHeaders = {
			"operatorCompanyId" : screenshot.operatorCompanyId
		};
	}
	page.onConsoleMessage = function(msg, line, source) {
		console.log(source + " " + line + ":" + msg);
	};
	page.onError = function(msg, trace) {
		var msgStack = [ 'ERROR ON PAGE: ' + msg ];
		if (trace) {
			msgStack.push('TRACE:');
			trace.forEach(function(t) {
				msgStack.push(' -> ' + t.file + ': ' + t.line +
						(t["function"] ? ' (in function "' + t["function"] + '")' : ''));
			});
		}
		console.error(msgStack.join('\n')); //should phantom.exit(1) be called here also ??
	};
	for (var i = 3; i < system.args.length; i++) {
		console.log(system.args[i]);
		var cookie = system.args[i].split("=");
		console.log("COOKIE NAME: " + cookie[0]);
		console.log("COOKIE VALUE: " + cookie[1]);
		phantom.addCookie({
			'name' : cookie[0],
			'value' : cookie[1],
			'domain' : screenshot.domain
		});
	}
	page.onLoadFinished = function(status) {
		setTimeout(onPageLoadCallBack(status, page), 1000); //give the page 1000 ms to load any js if it is
	};
	console.log("opening: ");
	console.log(url);
	page.open(url);
}
function closePage(page) {
	page.close();
	countActivePages--;
	actualLoadPage();
}

function getAlertTableId(screenshot) {
	var ndx = screenshot.url.indexOf("filteredTable-0=") > -1 ? (screenshot.url.indexOf("filteredTable-0=") + "filteredTable-0=".length)
			: -1;
	var nxtAnd = screenshot.url.indexOf("&", ndx);
	var tableSelected = "";
	if (ndx > -1) {
		if (nxtAnd > -1) {
			tableSelected = screenshot.url.substring(ndx, nxtAnd);
		} else {
			tableSelected = screenshot.url.substring(ndx);
		}
	} else {
		tableSelected = "table_0";
	}
	var tableId = tableSelected + "_table";
	console.log("TableSelected : " + tableSelected);
	return tableSelected;
}