var chartData = null;
var chartOtherDrillIndex = 0;
var MAX_NUM_PIE_SLICE = 10;

function AdvancedSnapReport() {

	this.clientPanel = null;
	this.timeFrame = null;

	this.report = new Reports.initReport({
		type : 'advancedsnap',
		generateButtonId : 'btngenerate',
		chartIds : [ 'piechartcontainer' ]
	});
	this.requestString = report.requestString;
	report.initializeDefaults = function() {
		report.requestString["type"] = "advancedsnap";
		report.requestString["includeAllEntities"] = "true";
		report.requestString["entities"] = "";
		report.requestString.timeFrameType = "relative";
		report.requestString.frequency = "Hourly";
		report.requestString.lastN = 24;
		report.requestString.groupBy = "CommCell";
		report.requestString.distribution = "CommCell";
		report.requestString.reportFilters = [];
	};

	report.initComponents = function() {

		timeFrame = new TimeFrame.frame({
			"requestString" : report.requestString
		});

		$("#filterPanel").accordion({
			fillSpace : true
		});
		chartOtherDrillIndex = 0;
	};

	report.initComponentState = function() {

		timeFrame.initComponentState();

		clientPanel = new ClientPanel({
			"treeid" : "#tree",
			"requestString" : report.requestString
		});
	};

	report.beforeLoadReport = function() {
		$("#piechartcontainer").mask();
	};

	report.onLoadReport = function(data1) {
		chartData = data1["chart"]["points"];
		var currentData = [];
		var i = 0;
		var maxSlice = MAX_NUM_PIE_SLICE - 1;
		if (chartData.length > MAX_NUM_PIE_SLICE) {
			for (i = 0; i < chartData.length && i < maxSlice; i++)
				currentData.push(chartData[i]);

			var total = 0;
			while (i++ < chartData.length - 1)
				total += chartData[i].y;

			currentData.push({
				"name" : "Others",
				"y" : total,
				"id" : -1
			});
		} else {
			currentData = chartData;
		}

		createRaphaelchart(currentData);
		$("#chartTitle").html(data1.chart.chartTitle);

		//Reports.configureClientSideTable('jobSummary', 'Summary', data1.jobSummary);	
		Reports.configureTable('snapDetail',
				'Snapshot Details',
				data1.snapDetail,
				report.requestString,
				report.getRequestUrl);
		updateBreadCrumb();
		$("#piechartcontainer").unmask();
	};

	report.updateRequestString = function() {
		//		try{
		clientPanel.updateEntities();
		updateReportOptions();
		timeFrame.updateTimeRange();
		//		}
		//		catch (e) {
		//			alert(e.toString());
		//		}
	};

	report.init();
	report.customizeTable = function(dataTable) {
	};

	this.breadCrumbClick = function(index) {
		if (index == 0) {
			if (this.requestString.reportFilters == null || report.requestString.reportFilters.length == 0) {
				return;
			}
			report.requestString.reportFilters = [];
			report.requestString.groupBy = report.requestString.distribution;
		} else if (report.requestString.reportFilters != null) {
			if (index == report.requestString.reportFilters.length)
				return;
			else {
				report.requestString.groupBy = report.requestString.reportFilters[index].entityType;
				var i = 0;
				for (i = report.requestString.reportFilters.length - 1; i >= index; i--)
					report.requestString.reportFilters.pop();
			}
		}
		chartOtherDrillIndex = 0;
		report.requestString.othersLevel = 0;
		//		updateChartData();
		report.processReport();

	};

	$("#groupByPanel").change(function() {
		$("#groupByPanel option:selected").each(function() {
			handleGroupByChange($(this).attr('id'));
		});
	});

	function handleGroupByChange(distribution) {
		chartDrillDown(0, "", "", distribution);
	}

	function chartDrillDown(entityId, entityName, type, distribution) {
		if (distribution != null) {
			report.requestString.reportFilters = [];
			report.requestString.groupBy = distribution;
			report.requestString.distribution = distribution;
			report.requestString.othersLevel = 0;
			chartData = null;
			chartOtherDrillIndex = 0;
			//			updateChartData();
			report.processReport();
		} else if (entityId == -1) {
			chartOtherDrillIndex++;
			report.requestString.othersLevel = chartOtherDrillIndex;
			report.updateHash(true);
			var currentData = [];
			var seriesCount = 0;
			var startIndex = chartOtherDrillIndex * MAX_NUM_PIE_SLICE - 1;

			for (; startIndex < chartData.length && seriesCount < MAX_NUM_PIE_SLICE; startIndex++, seriesCount++) {
				currentData.push(chartData[startIndex]);
			}

			if (startIndex < chartData.length - 1) {
				var total = 0;
				while (startIndex++ < chartData.length - 1)
					total += chartData[startIndex].y;

				currentData.push({
					"name" : "Others",
					"y" : total,
					"id" : -1
				});
			}
			createRaphaelchart(currentData);
		} else {
			chartOtherDrillIndex = 0;
			report.requestString.othersLevel = 0;
			if (report.requestString.groupBy == "Client")
				return;

			var entity = new Object;
			entity.entityId = entityId;
			entity.entityName = entityName;
			entity.entityType = type;
			entity.order = report.requestString.reportFilters.length;
			report.requestString.reportFilters.push(entity);

			//set the new groupBy
			/*
			 * if (report.requestString.distribution == "JobStatus") { if (report.requestString.groupBy ==
			 * "JobStatus") report.requestString.groupBy = "Agent"; else if (report.requestString.groupBy ==
			 * "Agent") report.requestString.groupBy= "Client"; } else if (report.requestString.distribution ==
			 * "Agent") { if (report.requestString.groupBy == "Agent") report.requestString.groupBy =
			 * "JobStatus"; else if (report.requestString.groupBy == "JobStatus") report.requestString.groupBy =
			 * "Client"; } else if (report.requestString.distribution == "CommCell") { if
			 * (report.requestString.groupBy == "CommCell") report.requestString.groupBy = "JobStatus"; else
			 * if (report.requestString.groupBy == "JobStatus") report.requestString.groupBy = "Agent"; else
			 * if (report.requestString.groupBy == "Agent") report.requestString.groupBy = "Client"; } else if
			 * (report.requestString.distribution == "ClientGroup") { if (report.requestString.groupBy ==
			 * "ClientGroup") report.requestString.groupBy = "JobStatus"; else if
			 * (report.requestString.groupBy == "JobStatus") report.requestString.groupBy = "Agent"; else if
			 * (report.requestString.groupBy == "Agent") report.requestString.groupBy = "Client"; }
			 */
			//			updateChartData();
			report.processReport();
		}

	}

	function updateBreadCrumb() {
		//clear the breadcrumb
		$("#breadCrumbPanel").empty();

		var counter = 0;
		var id = 'path' + counter;
		$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>Total Usage</li>');
		$("#" + id).click(function() {
			breadCrumbClick(this.id.substring('path'.length));
		});
		counter++;
		if (report.requestString.reportFilters != null) {
			$.each(report.requestString.reportFilters, function(index, value) {
				id = 'path' + counter;
				$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>' + value.entityName + '</li>');
				$("#" + id).click(function() {
					breadCrumbClick(this.id.substring('path'.length));
				});
				counter++;
			});

		}
		$('#breadCrumbPanel li').last().css('background-image', 'none');
		$("#breadCrumbPanel").append('<li class="endBreadcrumb"></li>');
	}

	function createRaphaelchart(currentData) {
		$("#piechartcontainer").empty();
		var values = $.map(currentData, function(node) {
			return node["y"];
		});
		currentData.values = values;
		var labels = $.map(currentData, function(node) {
			return node["name"] + " - " + node["y"];
		});
		var events = {};
		events.clickFtn = [];

		var i = 0;
		for (i = 0; i < currentData.length; i++) {
			if (report.requestString.groupBy != "Client" || currentData[i].id == -1) { //Others 
				events.clickFtn[i] = function() {
					chartDrillDown(this.params.id, this.params.name, this.params.type, null);
				};
			}
		}

		Raphael("piechartcontainer", 700, 400).pieChart(250, 180, 150, currentData, labels, 500, 40, "#fff", events);
	}

	function updateReportOptions() {

	}

	report.defaultSortColumn = function() {
		return 'JobID';
	};
}

$(document).ready(function() {
	AdvancedSnapReport();
});
