/*
 3 way checkbox tree using dynatree
 */

function ClientPanel(options) {
	this.options = options;
	this.requestString = options.requestString;
	var inEventHandler = false;
	if (!options.ajaxsource)
		options.ajaxsource = cvUtil.getContextPath() + "/server/report?type=Common&component=CommServTree&reportType=" +
				requestString.type;
	$(options.treeid).dynatree({
		checkbox : true,
		selectMode : 3,
		initAjax : {
			url : options.ajaxsource
		},
		onKeydown : function(node, event) {
			if (event.which == 32) {
				node.toggleSelect();
				return false;
			}
		},
		autoCollapse : false,
		onPostInit : function(isReloading, isError) {
			if (requestString.type == "FileArchiver" && requestString.firstTimeLoading == "true") {
				initTreeForFileArchiverReport();
				options.cvUtil.callback();
			} else {
				initTreeFromRequest();
			}
		},
		onSelect : function(select, node) {
			updateNodeSelection(select, node);
		}
	});

	function updateNodeSelection(select, node) {
		if (requestString.type == "FileArchiver") {
			if (inEventHandler) {
				return;
			}
			if (select) {
				try {
					if (node.data.type == 'bs') {
						inEventHandler = true;
						node.getParent().visit(function(child) {
							child.select(false);
						});
						node.visit(function(childNode) {
							childNode.select(true);
						});

					} else if (node.data.type == 'sc') {
						inEventHandler = true;
						node.getParent().getParent().visit(function(child) {
							if (child != node.getParent() && child.getParent() != node.getParent()) {
								child.select(false);
							}
						});
						node.select(true);
					}
				} finally {
					inEventHandler = false;
				}

			}
		}
	}

	this.updateEntities = function() {
		requestString["entities"] = '';
		var allCommcellsSelected = true;
		var children = $(options.treeid).dynatree("getTree").getRoot().getChildren();
		for ( var i in children) {
			var node = children[i];
			if (isCommcellSelected(node) == false) {
				allCommcellsSelected = false;
				break;
			}
			;
		}
		requestString.includeAllEntities = '' + allCommcellsSelected;
		if (allCommcellsSelected) {
			return false;
		}
		var selectedNodes = $(options.treeid).dynatree("getTree").getSelectedNodes(true);
		var selectedKeys = $.map(selectedNodes, function(node) {
			return getPath(node);
		});
		//alert("Selected keys: " + selectedKeys.join(",")); 
		requestString["entities"] = '[' + selectedKeys.join(",") + ']';
	};

	this.updateSelectedClientPath = function(client) {
		var clietsNode = $(options.treeid).dynatree("getTree").getNodeByKey("Clients");
		for ( var i in clietsNode.getChildren()) {
			var child = clietsNode.getChildren()[i];
			if (child.data.title == client) {
				requestString["entities"] = '[' + getPath(child) + ']';
				break;
			}
		}
	};
	function initTreeFromRequest() {
		if ($(options.treeid).dynatree("getTree").isReloading() == false) {
			if (requestString.includeAllEntities == "true") {
				$(options.treeid).dynatree("getTree").getRoot().select();
			} else {
				var entities = decodeURI('' + requestString.entities).replace('[', '').replace(']', '').split(",");
				$.each(entities, function(index, token) {
					var node = $(options.treeid).dynatree("getTree").getRoot();
					var path = token.split('~');
					for (var i = 0; i < path.length; i++) {
						var entity = path[i];
						var nameValue = entity.split(':');
						var key = nameValue[0];
						var value = nameValue[1];
						//access node, see if there are more entities, then skip else select it
						for ( var i in node.getChildren()) {
							var child = node.getChildren()[i];
							if (child.data.type && child.data.type == key && child.data.key == value) {
								if (i < length - 1)
									node = child;
								else
									node.select();
								break;
							}
						}
					}
				});
			}
		}

	}

	function initTreeForFileArchiverReport() {
		if ($(options.treeid).dynatree("getTree").isReloading() == false) {
			var clietsNode = $(options.treeid).dynatree("getTree").getNodeByKey("Clients");
			var csNode = clietsNode.getParent();
			for ( var i in clietsNode.getChildren()) {
				var child = clietsNode.getChildren()[i];
				if (child.data.title == csNode.data.title) {
					child.select();
					break;
				}
			}
		}
	}

	function isCommcellSelected(parent) {
		if (parent.isSelected())
			return true; //if cc is selected
		for ( var i in parent.getChildren()) {
			var node = parent.getChildren()[i];
			if (node.data.type == "ccs" && node.isSelected())
				return true; //if clients is checked
		}
		return false;
	}
	function getPath(node) {
		var path = "";
		node.visitParents(function(parent) {
			if (parent && parent.data && parent.data.type)
				path = getNodeRequestString(parent) + "~" + path;
		}, true);
		return path.substring(0, path.length - 1);
	}
	function getNodeRequestString(node) {
		return node.data.type + ":" + node.data.key;
	}

}
