if (typeof customReport === 'undefined') {
	var customReport = {};
}
var currEditTag = null;
$("body").on("click",
		"#addToTagList",
		function(e) {
			e.preventDefault();

			if ($(".invalidTag").css("visibility") == "visible") {
				return;
			}
			var tag = $("#newTag").val().trim();

			if (tag != "") {
				var doNothing = false;
				$.each($(this).parents("div").find(".tagsList li"), function() {
					if ($(this).text().toLowerCase() === tag.toLowerCase()) {
						doNothing = true;
						$(this).animate({
							borderColor : "red"
						}, 1000, function() {
							$(this).animate({
								borderColor : "transparent"
							});
						});
						$("#newTag").val("");
						return false;
					}
				});
				if (!doNothing) {
					var tagDetails = "";
					var newTag;
					$.each($(".tagSections"), function(key, value) {
						if ($(value).attr("name") != undefined &&
								($(value).attr("name").toLowerCase() == tag.toLowerCase())) {
							tagDetails = {
								"tagName" : $(value).attr("name"),
								"tagId" : value.id
							};
							return;
						}
					});

					if (tagDetails != "" && tagDetails != null && tagDetails != undefined) {
						newTag = tagDetails;
					} else {
						newTag = {
							"tagName" : tag,
							"tagId" : "-1"
						};
					}

					$(this).parents("div").find(".tagsList").append("<li class='manageTag' tagvalue='" +
							JSON.stringify(newTag) + "'>" + tag + "<a class='deleteTag' href='#'></a></li>");

					$("#newTag").val("");
					$(".okSaveClick").removeClass("btn-disabled");
				}
			}
		});

$("body").on("keyup", "#newTag", function(e) {
	if (e.keyCode == 13) {
		$("#addToTagList").click();
	}
});



function resetEditTagBox() {
	$(".editTagField").hide();
	$(".tagTitle").show();
}

$("body").on("keyup", ".editTagField input", function(e) {
	if (e.keyCode == 27) {
		resetEditTagBox();
		currEditTag = null;
	}

	if (e.keyCode == 13) {
		fnUpdateTag($(this));
	}

});

$(document).mouseup(function(e) {
	if (currEditTag != null && currEditTag.parent().has(e.target).length === 0) {
		fnUpdateTag(currEditTag);
	}

});

function validateTagName(tName, orgTName) {

	$.each($(".tagSections"), function(key, value) {
		if ($(value).attr("name") != undefined && ($(value).attr("name").toLowerCase() != orgTName.toLowerCase()) &&
				($(value).attr("name").toLowerCase() == tName.toLowerCase())) {
			$(".invalidTag").text(localMsg.TagExists);
			$(".invalidTag").css("visibility", "visible");
			return;
		}
	});
	if ($(".invalidTag").css("visibility") == "visible") {
		return false;
	} else {
		return true;
	}
}

function fnUpdateTag(comp) {
	validateTagName($.trim(comp.val()), $(comp).closest(".tagSections").attr("name"));
	if ($("#invalidTagLabel.invalidTag").css("visibility") == "visible")
		return;

	if (comp.val().trim() == "")
		return;

	$(".editTagField").hide();
	$(".tagTitle").show();

	//get the tag detail
	var tagStr = $(comp.parent().parent()).attr("data-tag"), reports = $("li", comp.parent().siblings(".tagReportList"));
	updateTags(comp.val(), tagStr);
	currEditTag = null;
	return;
}

$("body").on("click", "#tagEditIcon", function(e) {
	resetEditTagBox();
	$(this).parent().hide();
	$(".invalidTag").css("visibility", "hidden");
	var tagField = $(this).parent().siblings(".editTagField");
	tagField.show();
	currEditTag = $("input", tagField);
	currEditTag.val($(this).parent().find("h3").text());
	currEditTag.select();
	currEditTag.focus();
});

$("#applyTagToAllCB").on("checkedState", function() {
	$(".okSaveClick").addClass("applyTagSelected");
	$(".okSaveClick").removeClass("btn-disabled");

});

$("#applyTagToAllCB").on("unCheckedState", function() {
	$(".okSaveClick").removeClass("applyTagSelected");
	$(".okSaveClick").removeClass("btn-disabled");

});

$("body").on("click", ".deleteTag", function(ev) {
	ev.preventDefault();
	$(".okSaveClick").removeClass("btn-disabled");
	var taglist = $(this).closest(".tagsList");
	taglist.find($(this).parent("li")).remove();
});

$("body")
		.on("click",
				".actionButtons",
				function(e) {
					if ($(this).hasClass("tag")) {
						e.preventDefault();
						var reportId = $(this).parents("li").data("unique");
						var reportName = $(this).parents("li").children("a").text(), reportItem = $(".cvReports .reportItem[data-unique='" +
								reportId + "']"), title = $(reportItem.find('a')[0]).text() + " - Tag List", reportTags = reportItem
								.data("tag"), tagList = $("#tagReportDialog .tagsList");

						tagList.html('');

						if (reportTags != undefined && reportTags != "") {
							var includedTags = [];
							for (var i = 0; i < reportTags.length; i++) {
								var tName = reportTags[i].tagName;
								if ($.inArray(tName, includedTags) == -1 && tName != '') {
									includedTags.push(tName);
									var tagStr = {
										"tagName" : tName,
										"tagId" : reportTags[i].tagId
									};
									tagStr = JSON.stringify(tagStr);
									tagList.append("<li class='manageTag' tagvalue='" + tagStr + "'>" +
											reportTags[i].tagName + "<a class='deleteTag' href='#'></a></li>");

								}
							}

						}

						$("#newTag").val('');
						$(".invalidTag").css("visibility", "hidden");
						cvUtil.showWarningDialog({
							title : title,
							dialogClass : "tagsDialog",
							yesText : localMsg.save,
							noText : localMsg.cancel
						}, $("#tagReportDialog"), function() {
							if ($(".okSaveClick").hasClass("btn-disabled")) {
								return;
							}
							var filteredTags = []
							$.each($(".manageTag"), function(key, tag) {
								//if(!$(tag).hasClass("tagDeleted")){
								filteredTags.push(tag);
								//}					
							});
							var publishToAll = false;
							if ($("#adminOptDiv #applyTagToAllCB").attr("data-state") == 'checked') {
								publishToAll = true;
							}
							var tagLists = [];
							for (var i = 0; i < filteredTags.length; i++) {
								var tag = $(filteredTags[i]).attr('tagvalue');
								tagLists.push(JSON.parse(tag));
							}
							addReportsTags(reportId, reportName, JSON.stringify(tagLists), publishToAll);

							return true;
						});
						checkCb($("#applyTagToAllCB"));
						$(".okSaveClick").addClass("btn-disabled");

						return;
					}

					var action = $(this).attr("id").split("-")[1];
					var reportName = $(this).attr("data-name");
					var reportId = $(this).attr("data-repId");

					if (action == 'edit') {
						/*
						 * if(useCrVersion1 != undefined && useCrVersion1 != "false") window.location =
						 * cvUtil.getContextPath() + "/customreports/buildCustomReport.do?reportId="+reportId;
						 * else
						 */
						window.location = cvUtil.getContextPath() + "/reportsplus/index.jsp?reportId=" + reportId;
					} else if (action == 'share') {
						var user = $(this).attr("data-user");
						var userGroup = $(this).attr("data-userGroup");
						var externalGroups = $(this).attr("data-externalGroups");
						customReport.reportId = reportId;
						customReport.user = user;
						customReport.userGroup = userGroup;
						customReport.reportName = reportName;
						customReport.externalGroups = externalGroups;
						shareReport.doOpenDialog(true);
						return false;
					} else if (action == 'delete') {
						e.preventDefault();
						$(this).closest("li").addClass("toBeDeleted");
						$("#crReportName").html("'" + reportName + "'");
						$("#crReportName").attr("reportName", reportName);
						$("#crReportName").attr("reportId", reportId);
						$("#crReportName").attr("queryid", $(this).attr("data-queryid"));
						$("#deleteReportDialog").dialog({
							title : localMsg.confirmDeleteText,
							minHeight : 70,
							width : 400,
							modal : true,
							resizable : false
						});
					} else if (action == 'hide') {
						if ($(".hideHiddenReports").is(":hidden")) {
							var el = $(this).parents(".visibleHiddenReport");
							if (el) {
								el.removeClass("visibleHiddenReport");
							}
						}
						$(this).parents(".reportItem").addClass("true");
						var img = $(this).find("img");
						var src = img.attr("src");
						img.attr("src", src.replace('hide_eye.png', 'show_eye.png'));
						$(this).attr("id", reportId + "_action-show");
						$(this).attr("title", "Show");
						img.attr("alt", "Show");
						$(this).find("span").text("Show");
						updateReportVisibility(reportId, true);

					} else if (action == 'show') {
						$(this).parents(".reportItem").removeClass("true");
						var img = $(this).find("img");
						var src = img.attr("src");
						img.attr("src", src.replace('show_eye.png', 'hide_eye.png'));
						$(this).attr("id", reportId + "_action-hide");
						$(this).attr("title", "Hide");
						img.attr("alt", "Hide");
						$(this).find("span").text("Hide");
						updateReportVisibility(reportId, false);
					}
				});

function addActionEvents() {
	buttonClickFunc = function() {
		var action = $(this).attr("id").split("-")[1];
		var reportName = decodeURIComponent($(this).attr("data-name"));//$(":nth-child(2)", $(this).parent().parent()).find("a").text();
		var reportId = $(this).attr("data-repId");
		var rowId = $(this).attr("data-rowId");

		if (action == 'edit') {
			if (useCrVersion1)
				window.location = cvUtil.getContextPath() + "/customreports/buildCustomReport.do?reportId=" + reportId;
			else
				window.location = cvUtil.getContextPath() + "/reportsplus/index.jsp?reportId=" + reportId;

		} else if (action == 'share') {
			var user = $(this).attr("data-user");
			var userGroup = $(this).attr("data-userGroup");
			var externalGroups = $(this).attr("data-externalGroups");
			customReport.id = reportId;
			customReport.user = user;
			customReport.userGroup = userGroup;
			customReport.reportName = reportName;
			customReport.externalGroups = externalGroups;
			shareReport.doOpenDialog(true);
		} else if (action == 'delete') {
			$("#crReportName").html(reportName);
			$("#crReportName").attr("reportName", reportName);
			$("#crReportName").attr("queryId", reportName);
			$("#crReportName").html("reportId", reportId);
			$("#crReportName").attr("queryId", reportName);
			$("#deleteReportDialog").dialog({
				title : localMsg.confirmDeleteText,
				height : 140,
				width : 400,
				modal : true,
				resizable : false
			});
		} else if (action == 'hide') {
			var oTable = $("#customReportsTable" + CVTable.table).dataTable();
			if (oTable) {
				var data = oTable.fnGetData(rowId);
				data["hidden"] = "true";
			}
			var src = $(this).attr("src");
			$(this).attr("src", src.replace('hide_eye.png', 'show_eye.png'));
			$(this).attr("id", reportId + "_action-show");
			$(this).attr("title", "Show");
			updateReportVisibility(reportId, true);

		} else if (action == 'show') {
			var oTable = $("#customReportsTable" + CVTable.table).dataTable();
			if (oTable) {
				var data = oTable.fnGetData(rowId);
				data["hidden"] = "false";
			}
			var src = $(this).attr("src");
			$(this).attr("src", src.replace('show_eye.png', 'hide_eye.png'));
			$(this).attr("id", reportId + "_action-hide");
			$(this).attr("title", "Hide");
			updateReportVisibility(reportId, false);
		}

	};
}

$("#deleteYesBtn").on("click", function() {
	var rptName = $("#crReportName").attr("reportName");
	var queryId = $("#crReportName").attr("queryid");
	var reportId = $("#crReportName").attr("reportId")
	cvUtil.loadPage(cvUtil.getContextPath() + "/server/deleteCustomReport.do", {
		reportName : rptName,
		queryId : queryId,
		reportId : reportId
	}, function(data) {
		$("#deleteReportDialog").dialog("destroy");
		cvUtil.toast(data, 3000);
		$(".toBeDeleted").remove();
		//window.location.reload();
	}, function(xhr, ajaxOptions, thrownError) {
		cvUtil.errorToast($.trim(xhr.responseText), 30000);
		$("#deleteReportDialog").dialog("destroy");
	});
});

$("#deleteCancelBtn").on("click", function() {
	$(".toBeDeleted").removeClass("toBeDeleted");
	$("#deleteReportDialog").dialog("destroy");
});

var hideRepCount = 0;
if ($("#hiddenReports").data('events')) {
	hideRepCount = $("#hiddenReports").data('events').click.length;

}
if (hideRepCount <= 0) {
	$("#hiddenReports").click(function() {
		if (window["showAllReports"]) {
			window["showAllReports"] = false;
			$(this).html("Show hidden reports");
		} else {
			window["showAllReports"] = true;
			$(this).html("Hide hidden reports");
		}
		reDrawTable();
	});
}

function updateReportVisibility(reportId, hide) {
	cvUtil.loadPage(cvUtil.getContextPath() + "/server/updateReportVisibility.do", {
		reportId : reportId,
		hide : hide
	}, function(data) {
		// hide row or redraw table; // do nothing
		//		reDrawTable();
	}, function(xhr, ajaxOptions, thrownError) {
		cvUtil.errorToast($.trim(xhr.responseText), 30000);
	});
}

function favoritesForReports(favId, el) {
	cvUtil.loadPage(cvUtil.getContextPath() + "/server/favoritesForReports", {
		favId : favId
	}, function(data) {
		// hide row or redraw table; // do nothing
		//		reDrawTable();
		if (data == "true") {
			el.addClass("fav").removeClass("unfav");
			var li = el.closest("li");
			li.clone().appendTo("#favorites").find(".favBox").removeClass().addClass("deleteBox");
			$("#dummyFavItem").hide();
		} else {
			el.addClass("unfav").removeClass("fav");
			var v = el.closest("li").attr("data-fav");
			$("#favoritesContainer").find(".reportItem[data-fav='" + v + "']").remove();
			if ($("#favorites").children().length == 1) {
				$("#dummyFavItem").show();
			}
		}

	}, function(xhr, ajaxOptions, thrownError) {
		cvUtil.errorToast($.trim(xhr.responseText), 30000);
	});
}

function getFavoriteReports() {
	cvUtil.loadPage(cvUtil.getContextPath() + "/server/getFavoriteReports", {}, function(data) {
		// hide row or redraw table; // do nothing
		//		reDrawTable();
		if (data != "") {
			data = cvUtil.parseJSON(data);
			if (data.length > 0) {
				$("#dummyFavItem").hide();
			}
			$.each(data, function(k, v) {
				var el = $(".reportItem[data-fav='" + v + "']");
				el.find(".favBox").addClass("fav").removeClass("unfav");
				el.clone().appendTo("#favorites").find(".favBox").removeClass().addClass("deleteBox");
			});
		}
	}, function(xhr, ajaxOptions, thrownError) {
		cvUtil.errorToast($.trim(xhr.responseText), 30000);
	});
}

function updateTags(newTagName, tagStr) {
	var tag = cvUtil.parseJSON(tagStr);
	if (tag["tagName"] == newTagName.trim())
		return;

	tag["tagName"] = newTagName.trim();
	cvUtil.loadPage(cvUtil.getContextPath() + "/server/updateTags.do", {
		tagId : tag["tagId"],
		tagName : tag["tagName"]
	}, function(data) {
		if (data != "") {
			processDataAndBuildTags(data);
			$.each(data, function(index, tagValue) {
				if (tag.tagName == tagValue.tagName) {
					tag.tagId = tagValue.tagId;
				}
			});
			scollToNewTag(data, JSON.stringify(tag));
		}
	}, function(error) {
		if (error) {
			cvUtil.errorToast(error.responseText, 10000);
		}
	});
	return true;
}
