cvcharts = {};

cvcharts.colors = [
		[ "#508cf5", "#6a9df6", "#8db4f8", "#9fc0fa", "#b9d1fb", "#f9c2ac", "#f7ab8d", "#f59b78", "#f27d4e", "#f0662f" ], //blue
		[ "#f0662f", "#f27d4e", "#f59b78", "#f7ab8d", "#f9c2ac", "#b9d1fb", "#9fc0fa", "#8db4f8", "#6a9df6", "#508cf5" ], //orange
		[ "#007138", "#268656", "#59a37d", "#73b192", "#99c6af", "#d9999d", "#cb7378", "#c1595f", "#ae262e", "#a00009" ], //green
		[ "#902c8e", "#a14b9f", "#b776b5", "#c28bc1", "#d3abd2", "#e7d59d", "#dfc579", "#d9bb60", "#cda62f", "#c4960b" ], //magenta
		[ "#000000", "#191919", "#333333", "#4c4c4c", "#666666", "#7f7f7f", "#999999", "#b2b2b2", "#cccccc", "#e5e5e5" ], //black
		//["#1278B7", "#4DB8DB", "#11A139", "#86D32B", "#E8CF39", "#E1832C", "#A55B49","#A58AA5", "#7250A5", "#2635A5"], //multiple colors
		[
				"#52b0c9",
				"#0083bb",
				"#005371",
				"#b1d575",
				"#59b129",
				"#347016",
				"#ffd964",
				"#ffad00",
				"#fa8600",
				"#9e5b00",
				"#ff9664",
				"#ff662c",
				"#c49ab2",
				"#765276",
				"#7a6854" ], //multiple colors

];

cvcharts.colors3d = [
		[ "#274578", "#4A6EAC", "#637EAE", "#6F86AF", "#6F7D97", "#957467", "#685248", "#674437", "#914B2F", "#903D1C" ], //blue
		[ "#903D1C", "#663825", "#935D48", "#946755", "#957467", "#6F7D97", "#5F7396", "#556C95", "#405E94", "#305493" ], //orange
		[ "#004422", "#175034", "#35624B", "#456A58", "#5C7769", "#825C5E", "#7A4548", "#743539", "#68171C", "#600005" ], //green
		[ "#561A55", "#612D5F", "#6E476D", "#745374", "#7F677E", "#8B805E", "#867649", "#82703A", "#7B641C", "#765A07" ], //magenta
		[ "#000000", "#0F0F0F", "#1F1F1F", "#2E2E2E", "#3D3D3D", "#4C4C4C", "#5C5C5C", "#6B6B6B", "#7A7A7A", "#898989" ], //black
		//["#0D5480","#368199","#0C7128", "#507F1A", "#8B7C22", "#9E5C1F","#63372C","#736173", "#443063", "#172063"], //multiple colors
		[
				"#397B8D",
				"#005C83",
				"#003A4F",
				"#7C9552",
				"#3E7C1D",
				"#244E0F",
				"#B29846",
				"#B27900",
				"#AF5E00",
				"#6F4000",
				"#B26946",
				"#B2471F",
				"#c49ab2",
				"#533953",
				"#55493B" ], //multiple colors
];

cvcharts.createPieChart = function(chartModel, frameid, cx, cy, r, labelxpos, labelypos, stroke, others, colorSet,
		hoverLabels, colorOption, unit) {
	//	if(chartModel.chartTitle)
	//		$("#"+frameid+"_chartTitle").html(chartModel.chartTitle);
	var chartData = chartModel.points;
	$("#" + frameid).empty();
	var currentData = chartData;
	var colors = [];
	var colors3d = [];

	if (chartModel.colors != null && chartModel.colors != undefined && chartModel.colors3d != null &&
			chartModel.colors3d != undefined) {
		colors = chartModel.colors;
		colors3d = chartModel.colors3d;
	} else if (colorSet != null && colorSet != undefined) {
		colors = $.map(currentData, function(node) {
			return colorSet[node["color"]][0];
		});
		colors3d = $.map(currentData, function(node) {
			return colorSet[node["color"]][1];
		});
	} else if (chartModel.colorSet != null && chartModel.colorSet != undefined) {
		var ctr = 0;
		colors = $.map(currentData, function(node) {
			if (chartModel.colorSet[node["name"]] != null)
				return chartModel.colorSet[node["name"]];
			else
				return cvcharts.colors[5][ctr++];
		});

		ctr = 0;
		if (chartModel.colorSet3D != null && chartModel.colorSet3D != undefined) {
			colors3d = $.map(currentData, function(node) {
				if (chartModel.colorSet3D[node["name"]] != null)
					return chartModel.colorSet3D[node["name"]];
				else
					return cvcharts.colors3d[5][ctr++];
			});
		} else {
			colors3d = cvcharts.colors3d[5];
		}
	} else {
		colors = cvcharts.colors[5];
		colors3d = cvcharts.colors3d[5];
	}

	//	if (colorOption !=null && colorOption != undefined) {
	//		var myColor= cvcharts.colors[colorOption];
	//		var myColor3d= cvcharts.colors3d[colorOption];
	//		var index =0;
	//		colors = $.map(currentData, function(node){
	//		    return myColor[index++];
	//		});
	//		index=0;
	//		colors3d = $.map(currentData, function(node){
	//		    return myColor3d[index++];
	//		});
	//	}

	var values = $.map(currentData, function(node) {
		return node["y"];
	});
	if (!unit)
		unit = "";
	currentData.values = values;
	var labels = $.map(currentData, function(node) {
		return modifyLabel(node["name"]) + " : " + node["formattedY"] + " " + unit;
	});
	var events = {};
	events.clickFtn = [];

	var i = 0;
	for (i = 0; i < currentData.length; i++) {
		if (currentData[i].pointData) {
			events.clickFtn[i] = function() {
				report.drillDown(this.params.pointData);
			};
		}
	}

	labels = cvcharts.formatChartLabels(labels, 30, 15);

	var paper = Raphael(frameid);
	paper.pieChart(cx,
			cy,
			r,
			currentData,
			labels,
			labelxpos,
			labelypos,
			stroke,
			events,
			others,
			colors,
			colors3d,
			hoverLabels,
			{
				subTitle : chartModel["yAxisTitle"]
			});

	if (labels.length > 12) {
		var height = parseInt($("#" + frameid).css("height"));
		var minHeight = 390;
		height = (height < minHeight) ? minHeight : height;
		var svg = $("svg", $("#" + frameid));
		svg.attr("height", height);
	}

	return paper;
	//$('#chartTitle').empty().append(chartModel["chartTitle"]);
};
//chartData is json of commvault.web.reports.model.LineChartData
//please document any option that you add here
/**
 * options- thresholdProperties: properties for threshold line; default={thresholdStroke:{"stroke":
 * "#000000","stroke-width": 1, "stroke-dasharray":["--"] }}; axis: raphael's axis property; default="0 0 1 1"
 * legend: -1 - hide legends, 1 - show legends; default=1
 */
cvcharts.createRaphaelLinechart = function(r, chartData, options, clickListener) {
	options = options || {};
	options.axis = options.axis || "0 0 1 1";
	if (typeof options.legend == 'undefined')
		options.legend = 1;
	options.maxLegendLen = options.maxLegendLen || 200;

	var txtattr = {
		fill : "#fff",
		stroke : '#333',
		'stroke-width' : 1,
		"font-weight" : 100,
		font : "12px  Fontin-Sans, sans-serif"
	};

	var minYAxisValue = chartData["yAxis"]["minValue"];
	var smooth = (options.smooth != undefined) ? options.smooth : true;
	var temp = [];
	var temp2 = [];
	var popupLabels = [];
	var pointData = [];
	var seriesLabels = [];
	var thresholdValues = []; //for capacity to show in red green or yellow for each series
	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[i];
		var points = chartData.seriesList[i].points;
		temp[i] = [];
		temp2[i] = [];
		popupLabels[i] = [];
		pointData[i] = [];
		xLabels = [];
		for (var j = 0; j < points.length; j++) {
			temp[i][j] = points[j]["x"];
			xLabels[j] = points[j]["name"];
			temp2[i][j] = points[j]["y"];
			if (points[j]["y"] <= minYAxisValue && j + 1 < points.length)
				if (points[j + 1]["y"] <= minYAxisValue)
					smooth = false; //don't smooth if more than 1 cnsecutive values are 0 in which case it will go below the axis line
			popupLabels[i][j] = points[j]["popupLabel"];
			pointData[i][j] = s["pointData"];
		}
		seriesLabels[i] = s["seriesName"];
		if (s.maxEntityValue && s.maxEntityValue != "" && s.maxEntityValue > 0) {
			thresholdValues[i] = [];
			thresholdValues[i][0] = [ 0.95 * s["maxEntityValue"] ];
			thresholdValues[i][1] = [ 0.8 * s["maxEntityValue"] ];
		}
	}

	var xAxisLabels = chartData["xAxis"]["labels"];
	if (typeof xAxisLabels == 'undefined' || !xAxisLabels.length || xAxisLabels.length < 1)
		xAxisLabels = xLabels;
	xAxisLabels = modifyLabels(xAxisLabels);
	var leftMargin = 20;
	if (chartData["yAxis"] && chartData["yAxis"]["unit"])
		leftMargin = leftMargin + chartData["yAxis"]["unit"].length * 10;
	if (leftMargin < 90) //90px;
		leftMargin = 90;
	if (options.leftMargin) {
		leftMargin = options.leftMargin;
	}
	var thresholdProperties = options.thresholdProperties || {
		thresholdStroke : {
			"stroke" : "#BBB",
			"stroke-width" : 1,
			"stroke-dasharray" : [ "--" ]
		}
	};
	var maxLegendLen = options.legend == 1 ? options.maxLegendLen : -1;
	var clickable = typeof clickListener != 'undefined';

	var numSteps = xAxisLabels.length - 1;
	var maxSteps = options.maxSteps || Math.round(numSteps / 7);
	if (numSteps < maxSteps)
		maxSteps = numSteps;

	if (numSteps == 0) {
		numSteps = 1;
		maxSteps = 1;
	}

	var chartWidth = options.chartWidth || 600;
	var chartHeight = options.chartHeight || 240;
	var topMargin = options.topMargin || 30;
	var legendX = options.legendX || 500;
	var legendY = options.legendY || 85;
	seriesLabels = cvcharts.formatChartLabels(seriesLabels, 30, 15);
	var lines = r.linechart(leftMargin, topMargin, chartWidth, chartHeight, temp, temp2, {
		smooth : smooth,
		numXSteps : maxSteps,
		threshold : chartData["yAxis"]["thresholdValue"],
		thresholdValues : thresholdValues,
		nostroke : false,
		axis : options.axis,
		symbol : "circle",
		axisystep : chartData["yAxis"]["numSteps"],
		miny : minYAxisValue,
		maxy : chartData["yAxis"]["maxValue"],
		maxx : chartData["xAxis"]["maxValue"],
		serieslabels : seriesLabels,
		labelxpos : legendX + leftMargin,
		labelypos : legendY,
		barPointLabelWidth : options.barPointLabelWidth,
		xAxisLabels : xAxisLabels,
		unitstr : chartData["yAxis"]["unit"],
		clickable : clickable,
		dataLabelPos : 100,
		thresholdProperties : thresholdProperties,
		maxLegendLen : maxLegendLen,
		shade : options.shade,
		grid : true,
		width : options.width,
		showLegend : options.showLegend,
		showPartialLine : options.showPartialLine,
		legendAnchor : options.legendAnchor,
		showLegendMultiLines : options.showLegendMultiLines,
		xAxisTitle : chartData["xAxisTitle"],
		yAxisTitle : chartData["yAxisTitle"],
		colors : options.colors
	}, popupLabels, pointData);

	var formattedPointLabels;
	var formattedLabelHeight = 0;
	var maxPointLabelWidth = 0;
	if (options.formatLabels) {
		formattedPointLabels = lines.getFormatlabels();
		for (var i = 0; i < formattedPointLabels.length; i++) {
			if (formattedPointLabels[i].height > formattedLabelHeight) {
				formattedLabelHeight = formattedPointLabels[i].height;
			}
			if (formattedPointLabels[i].width > maxPointLabelWidth) {
				maxPointLabelWidth = formattedPointLabels[i].width;
			}

		}
	}

	if (typeof xAxisLabels != 'undefined' && xAxisLabels.length && xAxisLabels.length > 0) {
		var divisor = numSteps / maxSteps;
		for (var x = 0; x < lines.axis[1].text.items.length; x++) {
			var lastValue = x;
			lastValue = Math.round(divisor * x);
			if (lastValue >= xAxisLabels.length)
				lastValue = xAxisLabels.length - 1;
			if (formattedPointLabels) {
				if (formattedPointLabels[x]) {
					lines.axis[1].text.items[x].attr({
						'text' : formattedPointLabels[x].text
					});
					lines.axis[1].text.items[x].attr({
						'y' : lines.axis[1].text.items[x].attr('y') + formattedLabelHeight
					});
				} else
					lines.axis[1].text.items[x].attr({
						'text' : ''
					});
			} else
				lines.axis[1].text.items[x].attr({
					'text' : xAxisLabels[lastValue]
				});
		}
	}

	for (var x = 0; x < lines.axis[0].text.items.length; x++) { //remove label from right y axis
		lines.axis[0].text.items[x].attr({
			'text' : ''
		});
	}
	if (clickListener) {
		lines.click(function() {
			clickListener(this.pointData);
		});
	}
	if (chartData["yAxis"]["thresholdValue"] || chartData["yAxis"]["thresholdValue"] == 0) {
		lines.paintRange('#d43a52', lines.cvcharts.x2 - 2, 30 + 240 - 10, lines.cvcharts.thresholdY);
		lines.paintRange('rgba(0,153,0,.8)', lines.cvcharts.x2 - 2, lines.cvcharts.thresholdY, 30 + 10);
	}

	lines.symbols.attr({
		r : options.radius
	});

	return lines;
};
cvcharts.wrapText = function(paper, text, x, y, maxWidth) {
	var t = paper.text(x, y).attr('text-anchor', 'start');

	var words = text.split(" ");

	var tempText = "";
	for (var i = 0; i < words.length; i++) {
		t.attr("text", tempText + " " + words[i]);
		if (t.getBBox().width > maxWidth) {
			tempText += "\n" + words[i];
		} else {
			tempText += " " + words[i];
		}
	}
	t.attr("text", tempText.substring(1));
};

cvcharts.createBarChart = function(chartData, frameid, x, y, chartType, chartWidth, chartHeight, colorOption,
		labelxpos, labelypos, pointLabelWidth, topBottomDisplay) {
	$("#" + frameid).empty();
	var r = Raphael(frameid);

	var txtattr = {
		fill : "#fff",
		stroke : '#333',
		'stroke-width' : 1,
		"font-weight" : 100,
		font : "12px  Fontin-Sans, sans-serif"
	};

	var minYAxisValue = chartData["yAxis"]["minValue"];
	var smooth = true;
	var temp = [];
	var temp2 = [];
	var popupLabels = [];
	var pointData = [];
	var seriesLabels = [];
	var thresholdValues = []; //for capacity to show in red green or yellow for each series
	var colors = [];

	var myColor;
	if (chartData.colors != null && chartData.colors) {
		myColor = chartModel.colors;
	} else if (chartData.isStack == true) {
		myColor = cvcharts.colors[5];
	} else if (colorOption != null && colorOption != undefined) {
		myColor = cvcharts.colors[colorOption];
	}

	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[i];
		var ctr = 0;
		for (var i = 0; i < chartData.seriesList.length; i++) {
			var s = chartData.seriesList[i];
			if (chartData.isStack == true) {
				if (chartData.colorSet != null && chartData.colorSet != undefined) {
					if (chartData.colorSet[s["seriesName"]] != null && chartData.colorSet[s["seriesName"]] != undefined) {
						s.color = chartData.colorSet[s["seriesName"]];
					} else {
						s.color = myColor[ctr++];
					}
				} else {
					s.color = myColor[i];
				}
			} else
				s.color = myColor[0];
		}
	}

	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[i];
		var points = chartData.seriesList[i].points;
		temp[i] = [];
		temp2[i] = [];
		popupLabels[i] = [];
		pointData[i] = [];
		xLabels = [];
		colors[i] = s["color"];
		for (var j = 0; j < points.length; j++) {
			temp[i][j] = points[j]["x"];
			xLabels[j] = points[j]["name"];
			temp2[i][j] = points[j]["y"];
			if (points[j]["y"] <= minYAxisValue && j + 1 < points.length)
				if (points[j + 1]["y"] <= minYAxisValue)
					smooth = false; //don't smooth if more than 1 cnsecutive values are 0 in which case it will go below the axis line
			popupLabels[i][j] = points[j]["popupLabel"];
			pointData[i][j] = s["pointData"];
		}
		seriesLabels[i] = s["seriesName"];
		if (s.maxEntityValue && s.maxEntityValue != "" && s.maxEntityValue > 0) {
			thresholdValues[i] = [];
			thresholdValues[i][0] = [ 0.95 * s["maxEntityValue"] ];
			thresholdValues[i][1] = [ 0.8 * s["maxEntityValue"] ];
		}
	}

	var xAxisLabels = chartData["xAxis"]["labels"];
	if (typeof xAxisLabels == 'undefined' || !xAxisLabels.length || xAxisLabels.length < 1)
		xAxisLabels = xLabels;
	xAxisLabels = modifyLabels(xAxisLabels);
	var barH = 30;

	var totalPoints = xAxisLabels.length;
	var width = chartWidth || 600;
	var chart;

	//format labels
	seriesLabels = cvcharts.formatChartLabels(seriesLabels, 30, 15);

	if (chartType == "vbarchart") {
		var height = chartHeight || 300;
		chart = r.barchart(x, y, width, height, temp2, {
			stacked : true,
			nostroke : false,
			axis : "0 0 1 1",
			symbol : "circle",
			smooth : true,
			//maxy:chartData["yAxis"]["maxValue"],
			actualMaxY : chartData["yAxis"]["maxValue"],
			axisxstep : totalPoints,
			//axisystep:chartData["yAxis"]["numSteps"] || 3,
			totalpoints : 5,
			serieslabels : seriesLabels,
			labelxpos : labelxpos || width + 200,
			labelypos : labelypos || 50,
			colors : colors,
			//xaxiswidth:width,
			maxLegendLen : 300,
			showlegend : chartData["isShowLegend"],
			xAxisTitle : chartData["xAxisTitle"],
			yAxisTitle : chartData["yAxisTitle"],
			pointlabels : xAxisLabels,
			barPointLabelWidth : pointLabelWidth,
			topBottomDisplay : topBottomDisplay,
			showpopup : true,
			chartDataType : chartData.chartDataType,
			showGrid : true
		//barActualHeight:20
		}, popupLabels);
		chart.heightAdjustment(frameid);
	} else {
		//format labels
		xAxisLabels = cvcharts.formatChartLabels(xAxisLabels, 30, 15);

		var height = chartHeight || (totalPoints > 4 ? totalPoints * barH : barH * 4), g = null;
		chart = r.hbarchart(x, y, 400, height, temp2, {
			stacked : true,
			nostroke : false,
			axis : "0 0 1 1",
			symbol : "circle",
			smooth : true,
			//maxy:chartData["yAxis"]["maxValue"],
			actualMaxY : chartData["yAxis"]["maxValue"],
			axisxstep : totalPoints,
			//axisystep:chartData["yAxis"]["numSteps"] || 3,
			totalpoints : totalPoints,
			serieslabels : seriesLabels,
			labelxpos : labelxpos || width + 200,
			labelypos : labelypos || 50,
			colors : colors,
			xaxiswidth : width,
			maxLegendLen : 300,
			pointlabels : xAxisLabels,
			showlegend : chartData["isShowLegend"],
			xAxisTitle : chartData["xAxisTitle"],
			yAxisTitle : chartData["yAxisTitle"],
			topBottomDisplay : topBottomDisplay,
			showpopup : true,
			showGrid : true,
			chartDataType : chartData.chartDataType,
			chartTitle : chartData["chartTitle"]
		//barActualHeight:20
		}, popupLabels, null);
		chart.heightAdjustment(frameid);
	}

	chart.label(xAxisLabels, true);

};

cvcharts.formatChartLabels = function(labels, max, halflimit) {
	if (labels != null && labels != undefined) {
		for (var i = 0; i < labels.length; i++) {
			var str = labels[i];
			str = $.trim(str);
			var len = str.length;
			if (len > max) {
				var diff = len - halflimit;
				var sIndex = diff;
				if (diff < halflimit)
					sIndex = len - diff;
				labels[i] = str.substring(0, halflimit) + "..." + str.substring(sIndex, len);

			}
		}
	}
	return labels;
};

function modifyLabels(labels) {
	if (labels != null && labels != undefined) {
		for (var i = 0; i < labels.length; i++) {
			var str = labels[i];
			str = modifyLabel(str);
			labels[i] = str;
		}
	}
	return labels;
}

function modifyLabel(str) {
	if (str.indexOf('linkClass') != -1)
		str = $(str).text();
	return str;
}

cvcharts.createRaphaelLinechartNew = function(r, chartData, options, clickListener) {
	options = options || {};
	options.axis = options.axis || "0 0 1 1";
	if (typeof options.legend == 'undefined')
		options.legend = 1;
	options.maxLegendLen = options.maxLegendLen || 200;

	var txtattr = {
		fill : "#fff",
		stroke : '#333',
		'stroke-width' : 1,
		"font-weight" : 100,
		font : "12px  Fontin-Sans, sans-serif"
	};

	var minYAxisValue = chartData["yAxis"]["minValue"];
	var smooth = (options.smooth != undefined) ? options.smooth : true;
	var temp = [];
	var temp2 = [];
	var popupLabels = [];
	var pointData = [];
	var seriesLabels = [];
	var thresholdValues = []; //for capacity to show in red green or yellow for each series
	for (var i = 0; i < chartData.seriesList.length; i++) {
		var s = chartData.seriesList[i];
		var points = chartData.seriesList[i].points;
		temp[i] = [];
		temp2[i] = [];
		popupLabels[i] = [];
		pointData[i] = [];
		xLabels = [];
		for (var j = 0; j < points.length; j++) {
			temp[i][j] = points[j]["x"];
			xLabels[j] = points[j]["name"];
			temp2[i][j] = points[j]["y"];
			if (points[j]["y"] <= minYAxisValue && j + 1 < points.length)
				if (points[j + 1]["y"] <= minYAxisValue)
					smooth = false; //don't smooth if more than 1 cnsecutive values are 0 in which case it will go below the axis line
			popupLabels[i][j] = points[j]["popupLabel"];
			pointData[i][j] = s["pointData"];
		}
		seriesLabels[i] = s["seriesName"];
		if (s.maxEntityValue && s.maxEntityValue != "" && s.maxEntityValue > 0) {
			thresholdValues[i] = [];
			thresholdValues[i][0] = [ 0.95 * s["maxEntityValue"] ];
			thresholdValues[i][1] = [ 0.8 * s["maxEntityValue"] ];
		}
	}

	var xAxisLabels = chartData["xAxis"]["labels"];
	if (typeof xAxisLabels == 'undefined' || !xAxisLabels.length || xAxisLabels.length < 1)
		xAxisLabels = xLabels;
	xAxisLabels = modifyLabels(xAxisLabels);

	var leftMargin = 20;
	if (chartData["yAxis"] && chartData["yAxis"]["unit"])
		leftMargin = leftMargin + chartData["yAxis"]["unit"].length * 10;
	if (leftMargin < 90) //90px;
		leftMargin = 90;
	if (options.leftMargin) {
		leftMargin = options.leftMargin;
	}
	var thresholdProperties = options.thresholdProperties || {
		thresholdStroke : {
			"stroke" : "#BBB",
			"stroke-width" : 1,
			"stroke-dasharray" : [ "--" ]
		}
	};
	var maxLegendLen = options.legend == 1 ? options.maxLegendLen : -1;
	var clickable = typeof clickListener != 'undefined';

	var numSteps = xAxisLabels.length - 1;
	var maxSteps = options.maxSteps || Math.round(numSteps / 7);
	if (numSteps < maxSteps)
		maxSteps = numSteps;

	if (numSteps == 0) {
		numSteps = 1;
		maxSteps = 1;
	}

	if (options.recalculateYMax) {
		var newYMax = 0;
		for (var i = 0; i < chartData.seriesList.length; i++) {
			var points = chartData.seriesList[i].points;
			for (var j = 0; j < points.length; j++) {
				if (newYMax < points[j]["y"])
					newYMax = points[j]["y"];
			}
		}

		if (newYMax <= 0)
			newYMax = 5;

		if (options.isDataSize) {
			var unitStr = "MB";
			minFactor =1;
			
			if (newYMax > 300000) {
				unitStr = reportsUtil.getMinUnitString(reportsUtil.convertToBytes(newYMax, "MB"));
				minFactor = reportsUtil.getMinFactor(newYMax);
			}

			if (minFactor > 1) {
				newYMax =0;
				temp2 = [];
				for (var i = 0; i < chartData.seriesList.length; i++) {
					var points = chartData.seriesList[i].points;
					temp2[i] = [];
					for (var j = 0; j < points.length; j++) {
						 if ( points[j]["y"] <=-1) {
							 temp2[i][j] =  points[j]["y"];
						 } else {
							 temp2[i][j] = Math.round((points[j]["y"]/ minFactor) * 10)/10;
							 popupLabels[i][j] = cvUtil.cvLocalize("DDBPerformance.chart.popupLabel", temp2[i][j], unitStr, chartData.seriesList[i].seriesName,xAxisLabels[j]);
						 }
						 if (newYMax < temp2[i][j]) {
							 newYMax = temp2[i][j];
						 }
					}
				}
			}
			chartData.yAxisTitle = chartData.yAxisTitle + " (" + unitStr + ")";
		}

		chartData["yAxis"]["maxValue"] = newYMax;
		processSteps(chartData["yAxis"]);
	}

	var chartWidth = options.chartWidth || 600;
	var chartHeight = options.chartHeight || 240;
	var topMargin = options.topMargin || 30;
	var legendX = options.legendX || 500;
	var legendY = options.legendY || 85;
	seriesLabels = cvcharts.formatChartLabels(seriesLabels, 30, 14);
	var lines = r.linechart(leftMargin, topMargin, chartWidth, chartHeight, temp[0], temp2, {
		smooth : smooth,
		numXSteps : maxSteps,
		threshold : chartData["yAxis"]["thresholdValue"],
		thresholdValues : thresholdValues,
		nostroke : false,
		axis : options.axis,
		symbol : "circle",
		axisystep : chartData["yAxis"]["numSteps"],
		miny : minYAxisValue,
		maxy : chartData["yAxis"]["maxValue"],
		maxx : chartData["xAxis"]["maxValue"],
		colors : options.colors,
		showPartialLine : options.showPartialLine,
		serieslabels : seriesLabels,
		labelxpos : legendX + leftMargin,
		labelypos : legendY,
		barPointLabelWidth : options.barPointLabelWidth,
		xAxisLabels : xAxisLabels,
		unitstr : chartData["yAxis"]["unit"],
		clickable : clickable,
		dataLabelPos : 100,
		thresholdProperties : thresholdProperties,
		maxLegendLen : maxLegendLen,
		shade : options.shade,
		grid : true,
		width : options.width,
		showLegend : options.showLegend,
		xAxisTitle : chartData["xAxisTitle"],
		yAxisTitle : chartData["yAxisTitle"],
		thresholdLabelAuto : true,
		thresholdLabel : options.thresholdLabel,
		legendAnchor : options.legendAnchor
	}, popupLabels, pointData);

	var formattedPointLabels;
	var formattedLabelHeight = 0;
	var maxPointLabelWidth = 0;
	if (options.formatLabels) {
		formattedPointLabels = lines.getFormatlabels();
		for (var i = 0; i < formattedPointLabels.length; i++) {
			if (formattedPointLabels[i].height > formattedLabelHeight) {
				formattedLabelHeight = formattedPointLabels[i].height;
			}
			if (formattedPointLabels[i].width > maxPointLabelWidth) {
				maxPointLabelWidth = formattedPointLabels[i].width;
			}

		}
	}

	if (typeof xAxisLabels != 'undefined' && xAxisLabels.length && xAxisLabels.length > 0) {
		var divisor = numSteps / maxSteps;
		for (var x = 0; x < lines.axis[1].text.items.length; x++) {
			var lastValue = x;
			lastValue = Math.round(divisor * x);
			if (lastValue >= xAxisLabels.length)
				lastValue = xAxisLabels.length - 1;
			if (formattedPointLabels) {
				if (formattedPointLabels[x]) {
					lines.axis[1].text.items[x].attr({
						'text' : formattedPointLabels[x].text
					});
					lines.axis[1].text.items[x].attr({
						'y' : lines.axis[1].text.items[x].attr('y') + formattedLabelHeight
					});
				} else
					lines.axis[1].text.items[x].attr({
						'text' : ''
					});
			} else
				lines.axis[1].text.items[x].attr({
					'text' : xAxisLabels[lastValue]
				});
		}
	}

	for (var x = 0; x < lines.axis[0].text.items.length; x++) { //remove label from right y axis
		lines.axis[0].text.items[x].attr({
			'text' : ''
		});
	}
	if (clickListener) {
		lines.click(function() {
			clickListener(this.pointData);
		});
	}
	//    if(chartData["yAxis"]["thresholdValue"]||chartData["yAxis"]["thresholdValue"]==0){
	//    	lines.paintRange('#d43a52', lines.cvcharts.x2-2, 30+240-10, lines.cvcharts.thresholdY);
	//    	lines.paintRange('rgba(0,153,0,.8)', lines.cvcharts.x2-2, lines.cvcharts.thresholdY, 30+10);
	//	}

	lines.symbols.attr({
		r : options.radius
	});

	return lines;
};

function processSteps(yAxis) {
	Math.log(5) / Math.LN10;
	var numSteps = 5, newMax = 100, min = yAxis.minValue == -1.0 ? 0 : yAxis.minValue, maxValue = yAxis.maxValue - min, log = Math
			.floor((Math.log(maxValue) / Math.LN10)), //Math.log10 is not supported in all browser and in phantomJS
	divisor = Math.pow(10, log - 1), normalizedMax = maxValue / divisor;

	if (normalizedMax > 75) {
		numSteps = 5;
		newMax = 100;
	} else if (normalizedMax > 60) {
		numSteps = 5;
		newMax = 75;
	} else if (normalizedMax > 50) {
		numSteps = 6;
		newMax = 60;
	} else if (normalizedMax > 30) {
		numSteps = 5;
		newMax = 50;
	} else if (normalizedMax > 25) {
		numSteps = 6;
		newMax = 30;
	} else if (normalizedMax > 20) {
		numSteps = 5;
		newMax = 25;
	} else {
		//take it to next multiple of 5 or 6 whichever is closer
		max = Math.ceil(normalizedMax);
		while (true) {
			if (max % 5 == 0) {
				numSteps = 5;
				newMax = max;
				break;
			}
			if (max % 6 == 0) {
				numSteps = 6;
				newMax = max;
				break;
			}
			max++;
		}
	}
	yAxis.numSteps = numSteps;
	yAxis.maxValue = newMax * divisor + min;
}
