var chartData = null;
var chartOtherDrillIndex = 0;
var MAX_NUM_PIE_SLICE = 10;
var NORMAL_MAX = 60;
var WARNING_MAX = 75;
var NORMAL_MAX_PERCENT = .60;
var WARNING_MAX_PERCENT = .75;
var NORMAL_COLOR = 'rgba(0,153,0)';
var WARNING_COLOR = 'rgba(233,120,0,.9)';
var CRITICAL_COLOR = 'rgba(225, 0, 0, .8)';

function DedupReport() {

	this.storageFilterPanel = null;
	this.pieChart = null;
	this.barChart = null;
	this.capacityMeter = null;
	this.performanceMeter = null;
	this.growthChartData = null;

	this.report = new Reports.initReport({
		type : 'dedup',
		generateButtonId : 'btngenerate',
		chartIds : [ 'piechartcontainer', 'barChartContainer', 'growthChartContainer', 'gauge1', 'gauge2' ]

	});

	this.requestString = report.requestString;
	report.initializeDefaults = function() {
		report.requestString["type"] = "Dedup";
		report.requestString["includeAllEntities"] = "true";
		report.requestString["entities"] = "";
		report.requestString.frequency = "Daily";
		report.requestString.lastN = 7;
		report.requestString.distribution = "StoragePolicyCopy";
		report.requestString.groupBy = "StoragePolicyCopy";
		report.requestString.reportFilters = [];
		report.requestString["refreshCache"] = "true";
		report.requestString["mode"] = 3;
		report.requestString["copyFilter"] = [ "all" ];
		report.requestString["copyType"] = [ "all" ];
		report.requestString.invisible.refreshCache = true;
		report.requestString.othersLevel = 0;
		chartOtherDrillIndex = 0;

		var groupBy = $('#groupByPanel li');
		var selectedLI = groupBy.index(groupBy.filter('.selectedOption'));
		if (selectedLI != 0) {
			$('#groupByPanel :nth-child(1)').click();
		}

	};

	report.initComponents = function() {

		var copyTypes = $(".copyType");
		var copytype_error = $("#copytype-error");
		var genBtn = $('#btngenerate');
		var none = false;

		copyTypes.each(function() {
			$(this).bind('checkedState', function() {
				none = false;
				copytype_error.css("display", "none");
				genBtn.attr("disabled", false);
				genBtn.removeClass("btnDisabled");
			});
			$(this).bind('unCheckedState', function() {
				none = true;
				copyTypes.each(function() {
					if ($(this).attr("data-state") == "checked") {
						none = false;
						return false;
					}
				});
				if (none) {
					copytype_error.css("display", "block");
					genBtn.attr("disabled", true);
					genBtn.addClass("btnDisabled");
				}
			});
		});

		$("#groupByPanel").customSelect();

		$("#storagePolicies").bind('selectionChanged', function(e, hasSelection) {
			if (hasSelection) {
				genBtn.removeClass("btnDisabled");
				genBtn.attr("disabled", false);
			} else {
				genBtn.addClass("btnDisabled");
				genBtn.attr("disabled", true);
			}
		});
	};

	report.initComponentState = function() {
		$("#" + requestString.distribution).click();

		$.each(report.requestString["copyType"], function(index, value) {
			if (value == 'all') {
				checkCb($('#primary'));
				checkCb($('#secondary'));
			} else if (value == 'primary') {
				checkCb($('#primary'));
			} else if (value == 'secondary') {
				checkCb($('#secondary'));
			}
		});
		storageFilterList = new storageFilterList({
			requestString : report.requestString,
			id : "storagePolicies"
		});

	};

	report.beforeLoadReport = function() {
		$("#chartContentWrapper").mask("");
		$("#chartPanel > .showifnodata").hide();
		$("#chartPanel > .hideifnodata").show();
		$("#groupByPanel").removeAttr("disabled");

		chartOtherDrillIndex = 0;
	};

	report.onLoadReport = function(data) {
		if (report.requestString.invisible.refreshCache = true && data["spTree"] != undefined) {
			storageFilterList.updateList(data["spTree"]);
			storageFilterList.setSelectedList(report.requestString.copyFilter);
			requestString["mode"] = 0;
		}

		if (report.requestString.invisible.refreshCache == true)
			report.requestString.invisible.refreshCache = false;

		var currentData = [];
		var startIndex = 0;
		var seriesCount = 0;
		var maxSlice = MAX_NUM_PIE_SLICE;
		var otherTotal = 0;

		if (data != null && data["pieChart"]) {
			title = data.pieChart.chartTitle;
			if (data["pieChart"]["points"])
				chartData = data["pieChart"]["points"];
		}

		if (this.requestString.othersLevel > 0) {
			chartOtherDrillIndex = this.requestString.othersLevel;
			startIndex = chartOtherDrillIndex * MAX_NUM_PIE_SLICE;
		}

		if (chartData != null) {
			for (; startIndex < chartData.length && seriesCount < maxSlice; startIndex++, seriesCount++) {
				currentData.push(chartData[startIndex]);
			}

			if (startIndex < chartData.length - 1) {
				while (startIndex < chartData.length - 1) {
					otherTotal += chartData[startIndex].y;
					startIndex++;
				}
			}
		}

		$("#detailTableWrapper").hide();
		if (currentData.length == 0) {
			$("#chartPanel > .showifnodata").show();
			$("#chartPanel > .hideifnodata").hide();
			$("#groupByPanel").attr("disabled", "disabled");
			$("#tableWrapper").hide();
			return;
		} else {
			$("#chartPanel > .showifnodata").hide();
			$("#chartPanel > .hideifnodata").show();
			$("#groupByPanel").removeAttr("disabled");
			$("#tableWrapper").show();
		}

		updateBreadCrumb();
		var isDetailsLevel = this.requestString.groupBy == "Detail";
		$("#dedupSavingsLabel").html(data.dedupSavings);
		if (!isDetailsLevel) {
			$("#meterWrapper").hide();
			$("#dedupGrowthChartWrapper").hide();
			$("#pieWrapper").show();
			$("#tableWrapper").show();

			createRaphaelchart(currentData, otherTotal);
			$("#pieChartTitle").html(data.pieChart.chartTitle);

			if (data.tableData)
				Reports.configureClientSideTable('dedupSummary', localMsg.summary, data.tableData);

			if (data.barChart) {
				$("#barChartWrapper").show();
				createRaphaelBarchart(data.barChart);
			} else
				$("#barChartWrapper").hide();

			if (this.requestString.groupBy == "SubStore") {
				$("#detailTableWrapper").show();
				if (data.detailData)
					Reports.configureClientSideTable('storeDetail', "", data.detailData);
			}
		} else {
			$("#pieWrapper").hide();
			$("#barChartWrapper").hide();
			$("#tableWrapper").hide();
			$("#detailTableWrapper").hide();

			$("#meterWrapper").show();
			createGauges(data.meterData);

			if (data.growthChart) {
				this.growthChartData = data.growthChart;
				$("#dedupGrowthChartWrapper").show();
				createGrowthChart(this.growthChartData.capacityChart, localMsg.dedup.totalUniqueBlocksGrowth);
			}
		}

		if (isDetailsLevel) {
			this.growthChartData = data.growthChart;
			$("#meterWrapper").show();
			createGauges(data.meterData);
			$("#growthChartWrapper").show();
			createGrowthChart(this.growthChartData.capacityChart, localMsg.dedup.totalUniqueBlocksGrowth);
		} else {
			$("#meterWrapper").hide();
			$("#growthChartWrapper").hide();
		}

	};

	report.updateRequestString = function() {
		updateReportOptions();
		requestString["mode"] = 0;
	};

	report.init();

	report.customizeTable = function(dataTable) {
		if (this.requestString.groupBy != "Detail")
			return;

		var oSettings = dataTable.fnSettings();
		var freeSpaceCol;
		var freeSpaceIndex = 0;
		for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
			if (oSettings.aoColumns[iColumn].mDataProp == "freeDiskSpaceMB") {
				freeSpaceCol = oSettings.aoColumns[iColumn];
				freeSpaceIndex = iColumn;
			}
		}

		if (freeSpaceCol == null && freeSpaceCol.bVisible == false)
			return;

		var data = oSettings.aoData;
		var htmlRows = $("tr", dataTable);
		var warningColor = "#FF9900";
		var criticalColor = 'rgba(255, 0, 0, .8)';
		for (var i = 0; i < data.length; i++) {
			var rawData = data[i]._aData;
			var freeSpace = parseInt(rawData.freeDiskSpaceMB);
			var minFreeSpace = parseInt(rawData.minimumFreeSpaceMB);
			var freeSpaceWarn = parseInt(rawData.freeSpaceWarningMB);
			var total = parseInt(rawData.dedupDBSizeMB) + freeSpace;
			if (total < 0)
				total = 0;

			var percent = roundNumber((rawData.freeDiskSpaceMB / total) * 100, 2);
			var htmlCols = $("td", htmlRows[i + 1]);
			var col = htmlCols[freeSpaceIndex];
			col.innerHTML = col.innerHTML + " (" + rawData.freeDiskSpaceMBPercent + "%)";

			//apply background colors
			if (freeSpace >= minFreeSpace && freeSpace <= freeSpaceWarn)
				col.style.background = warningColor;
			else if (freeSpace < minFreeSpace)
				col.style.background = criticalColor;
		}
	};

	this.breadCrumbClick = function(index) {
		if (index == 0) {
			if (this.requestString.reportFilters == null || report.requestString.reportFilters.length == 0) {
				return;
			}
			report.requestString.reportFilters = [];
			report.requestString.groupBy = report.requestString.distribution;
		} else if (report.requestString.reportFilters != null) {
			if (index == report.requestString.reportFilters.length)
				return;
			else {
				report.requestString.groupBy = report.requestString.reportFilters[index].entityType;
				var i = 0;
				for (i = report.requestString.reportFilters.length - 1; i >= index; i--)
					report.requestString.reportFilters.pop();
			}
		}
		chartOtherDrillIndex = 0;
		report.requestString.othersLevel = 0;
		requestString["refreshCache"] = false;
		report.processReport();
	};

	$("#groupByPanel").on("customSelectionChanged", function(e, el) {
		handleGroupByChange($(el).attr("id"));
	});

	$("#growthChartType").customSelect(0);
	$("#growthChartType").on("customSelectionChanged", function(e, el) {
		handleChartTypeChange($(el).attr("id"));
	});

	function handleGroupByChange(distribution) {
		chartDrillDown(0, "", "", distribution);
	}

	function chartDrillDown(entityId, entityName, type, distribution) {
		if (distribution != null) {
			report.requestString.reportFilters = [];
			report.requestString.groupBy = distribution;
			report.requestString.distribution = distribution;
			report.requestString.othersLevel = 0;
			chartData = null;
			chartOtherDrillIndex = 0;
			requestString["refreshCache"] = false;
			report.processReport();
		} else if (entityId == "-1") //click on Others
		{
			chartOtherDrillIndex++;
			var currentData = [];
			var seriesCount = 0;
			var startIndex = chartOtherDrillIndex * MAX_NUM_PIE_SLICE;

			for (; startIndex < chartData.length && seriesCount < MAX_NUM_PIE_SLICE; startIndex++, seriesCount++) {
				currentData.push(chartData[startIndex]);
			}

			var otherTotal = 0;
			if (startIndex < chartData.length - 1) {
				while (startIndex < chartData.length - 1) {
					otherTotal += chartData[startIndex].y;
					startIndex++;
				}
			}
			requestString["refreshCache"] = false;
			report.requestString.othersLevel = chartOtherDrillIndex;
			report.updateHash(false);
			createRaphaelchart(currentData, otherTotal);
		} else {
			chartOtherDrillIndex = 0;
			report.requestString.othersLevel = 0;
			if (report.requestString.distribution == "SubStore")
				return;

			var entity = new Object;
			entity.entityId = entityId;
			entity.entityName = entityName;
			entity.entityType = type;
			entity.order = report.requestString.reportFilters.length;
			report.requestString.reportFilters.push(entity);

			//set the new groupBy
			if (report.requestString.distribution == "StoragePolicy") {
				if (report.requestString.groupBy == "StoragePolicy")
					report.requestString.groupBy = "StoragePolicyCopy";
				else if (report.requestString.groupBy == "StoragePolicyCopy")
					report.requestString.groupBy = "SubStore";
				else if (report.requestString.groupBy == "SubStore")
					report.requestString.groupBy = "Detail";
			} else if (report.requestString.distribution == "Library") {
				if (report.requestString.groupBy == "Library")
					report.requestString.groupBy = "Disk";
				else if (report.requestString.groupBy == "Disk")
					report.requestString.groupBy = "StoragePolicyCopy";
				else if (report.requestString.groupBy == "StoragePolicyCopy")
					report.requestString.groupBy = "SubStore";
				else if (report.requestString.groupBy == "SubStore")
					report.requestString.groupBy = "Detail";
			} else if (report.requestString.distribution == "StoragePolicyCopy") {
				if (report.requestString.groupBy == "StoragePolicyCopy")
					report.requestString.groupBy = "SubStore";
				else if (report.requestString.groupBy == "SubStore")
					report.requestString.groupBy = "Detail";
			}

			requestString["refreshCache"] = false;
			report.processReport();
		}

	}

	function updateBreadCrumb() {
		//clear the breadcrumb
		$("#breadCrumbPanel").empty();

		var counter = 0;
		var id = 'path' + counter;
		if (requestString.distribution == "StoragePolicy")
			$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>' + localMsg.dedup.allSps + '</li>');
		else if (requestString.distribution == "StoragePolicyCopy")
			$("#breadCrumbPanel")
					.append('<li class="breadcrumb" id=' + id + '>' + localMsg.dedup.allSPCopies + '</li>');
		else
			$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>' + localMsg.dedup.allLibraries +
					'</li>');

		$("#" + id).click(function() {
			breadCrumbClick(this.id.substring('path'.length));
		});
		counter++;
		if (report.requestString.reportFilters != null) {
			$.each(report.requestString.reportFilters, function(index, value) {
				id = 'path' + counter;
				$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>' + value.entityName + '</li>');
				$("#" + id).click(function() {
					breadCrumbClick(this.id.substring('path'.length));
				});
				counter++;
			});
		}
		$('#breadCrumbPanel li').last().css('background-image', 'none');
		$("#breadCrumbPanel").append('<li class="endBreadcrumb"></li>');
	}

	function createRaphaelchart(currentData, otherTotal) {
		$("#piechartcontainer").empty();
		var values = $.map(currentData, function(node) {
			return node["y"];
		});

		var formattedYs = $.map(currentData, function(node) {
			return node["formattedY"];
		});

		currentData.values = values;
		currentData.formattedYs = formattedYs;
		currentData.maxLegendLen = 300;
		var labels = $.map(currentData, function(node) {
			return node["name"];
		});

		var events = {};
		events.clickFtn = [];
		if (report.requestString.groupBy != "Detail") {
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				events.clickFtn[i] = function() {
					chartDrillDown(this.params.id, this.params.name, this.params.type, null);
				};
			}
		}
		var others = null;
		if (otherTotal != 0) {
			others = {};
			others["text"] = "More...";
			others["clickFtn"] = function() {
				chartDrillDown(-1, "Others", null, null);
			};
		}

		var colors = [
				"#9B75C1",
				"#FFA699",
				"#7B48D1",
				"#2FD195",
				"#FF7D0A",
				"#79D8FF",
				"#863737",
				"#FFB35A",
				"#6EA031",
				"#FFCC00",
				"#A6A37D",
				"#4F8FB5",
				"#C31929",
				"#2D4DB2" ];

		var colors3d = [
				"#70558B",
				"#B8786E",
				"#623AA7",
				"#22966B",
				"#B85A07",
				"#579CB8",
				"#602828",
				"#B88141",
				"#4F7323",
				"#B28F00",
				"#747257",
				"#396782",
				"#8C121E",
				"#203880" ];

		var paper = Raphael("piechartcontainer", 650, 300);
		paper.pieChart(170, 150, 150, currentData, labels, 390, 50, "#fff", events, others, colors, colors3d);
		//		var svg_content = paper.serialize.encode(paper);
		//		var charts = {};
		//		var detail = {};
		//		detail["html"] = svg_content;
		//		detail["height"] = 400;
		//		detail["width"] = 700;
		//		charts["piechartcontainer"] = detail;
		//		report.requestString.invisible.chartsSVGs = detail;
		//		var i;
		//$("#selectGrpDiv").css('visibility','visible');
	}

	function createRaphaelBarchart(data) {
		$("#barChartContainer").empty();
		var r = Raphael("barChartContainer");
		var txtattr = {
			font : "12px 'Fontin Sans', Fontin-Sans, sans-serif"
		};

		var xLabels = data["xLabels"];

		var height = 220, g = null;
		var totalPoints = data["chart"][0].length;
		var chart = r.barchart(100, 10, totalPoints * 150, height, data["chart"], {
			nostroke : false,
			axis : "0 0 1 1",
			symbol : "circle",
			smooth : true,
			maxy : data["yMax"],
			type : "soft",
			axisxstep : totalPoints,
			axisystep : 3,
			totalpoints : 5,
			serieslabels : data["seriesLabels"],
			labelxpos : 570,
			labelypos : 50,
			notes : data["notes"],
			unitstr : data["unitStr"],
			colors : [ "hsb(0.6,.75, .75)", "hsb(0.2,.75, .75)" ],
			xaxiswidth : 500,
			maxLegendLen : 300
		}, data["popupLabels"], data["barLabels"]);

		chart.hover(function() {
			g = this.bar.glow();
			hovertxt = r.text(0, 250, this.bar.popupLabel).attr({
				fill : '#555',
				stroke : "none",
				"font-size" : 12,
				"text-anchor" : 'start',
				"font-weight" : 500,
				"font-family" : "Helevetica,Arial,Sans-serif"
			});
			hoverPosX = (400 - hovertxt.getBBox().width) / 2;
			hovertxt.transform('t' + hoverPosX + ',0');
		}, function() {
			if (hovertxt)
				hovertxt.remove();
			if (g)
				g.remove();
		});

		var z = 30;
		var newLabels = [];
		for (var x = 0; x < totalPoints; x++) {
			var legendLen = xLabels[x].length;
			var displayLabel = xLabels[x];
			if (legendLen > z) {
				displayLabel = displayLabel.substring(0, z - 5) + " ... " +
						displayLabel.substring(legendLen - 5, legendLen);
			}
			newLabels[x] = displayLabel;
		}

		chart.label(newLabels, true);
	}

	function handleChartTypeChange(id) {
		if (id == "Total_Unique_Blocks") {
			createGrowthChart(report.growthChartData.capacityChart, localMsg.dedup.totalUniqueBlocksGrowth);
		} else {
			createGrowthChart(report.growthChartData.performanceChart, localMsg.dedup.avgInsertionTimeGrowth);
		}
	}

	function createGrowthChart(data, title) {
		$("#dedupGrowthChartTitle").html(title);
		$("#growthChartContainer").empty();
		var r = Raphael("growthChartContainer");
		var txtattr = {
			fill : "#fff",
			stroke : '#333',
			'stroke-width' : 1,
			"font-weight" : 100,
			font : "12px  Fontin-Sans, sans-serif"
		};

		var chartData = data["chart"];
		var xValues = [];
		var yValues = [];
		var popupLabels = [];
		var seriesLabels = [];
		var pointData = [];
		var yPos = 50;
		for (var i = 0; i < chartData.length; i++) {
			var s = chartData[i];
			xValues[i] = s["xValues"];
			yValues[i] = s["yValues"];
			popupLabels[i] = s["popupLabels"];
			seriesLabels[i] = s["name"];
			pointData[i] = s["pointData"];
			yPos += 20;
		}

		var xLabels = data["xAxisLabels"];
		var totalPoints = data["totalPoints"];

		var lines = r.linechart(50, 10, 700, 220, xValues, yValues, {
			nostroke : false,
			axis : "0 0 1 1",
			symbol : "circle",
			smooth : true,
			axisystep : 5,
			totalPoints : totalPoints,
			miny : -1,
			maxy : data["yMax"],
			serieslabels : seriesLabels,
			labelxpos : 780,
			labelypos : 100,
			threshold : data["threshold"],
			maxLegendLen : 200,
			dataLabelPos : 260
		}, popupLabels, pointData);

		var midX = xValues[0].length / 2;
		var index = 0;
		var isLeft = true;
		for (var x = 0; x < lines.axis[0].text.items.length; x++) {
			if (x > 0)
				index += 2;

			lines.axis[0].text.items[x].attr({
				'text' : xLabels[index]
			});
		}

		var ranges = [];
		var normalRange = {}, warningRange = {}, criticalRange = {};

		var max = data["threshold"];
		var normalMax = max * NORMAL_MAX_PERCENT;
		var warningMax = max * WARNING_MAX_PERCENT;

		normalRange.start = 0; // Range start point as an angle relative to 0deg (pointing right).
		normalRange.end = normalMax; // Range end point as an angle relative to 0deg (pointing right).
		normalRange.color = 'rgba(0,153,0,.8)'; // Color and alpha (opacity) of the range arc.

		warningRange.start = normalMax; // Range start point as an angle relative to 0deg (pointing right).
		warningRange.end = warningMax; // Range end point as an angle relative to 0deg (pointing right).
		warningRange.color = "#FF9900";// Color and alpha (opacity) of the range arc.

		criticalRange.start = warningMax; // Range start point as an angle relative to 0deg (pointing right).
		criticalRange.end = data["yMax"]; // Range end point as an angle relative to 0deg (pointing right).
		criticalRange.color = 'rgba(255, 0, 0, .8)'; // Color and alpha (opacity) of the range arc.

		ranges[0] = normalRange;
		ranges[1] = warningRange;
		ranges[2] = criticalRange;

		lines.addRanges(ranges);

		//	    lines.hover(function () {
		//	    	g = this.symbol.glow();
		//    		hovertxt = r.text(0, 260,  this.popupLabel).attr({fill: '#555', stroke: "none", "font-size": 12,"text-anchor": 'start',"font-weight": 500,"font-family":"Helevetica,Arial,Sans-serif"});
		//    		hoverPosX = (400-hovertxt.getBBox().width)/2;
		//        	hovertxt.transform('t'+hoverPosX+',0');
		//  	    }, function () {
		//    	        if(g) g.remove();
		//    	        if(hovertxt) hovertxt.remove();
		//      });

		lines.symbols.attr({
			r : 4
		});
		r.raphael.g.txtattr = txtattr;
	}

	function createGauges(data) {
		var ranges = [];
		var normalRange = {}, warningRange = {}, criticalRange = {};
		var performanceMeter = 0;
		var capacityMeter = 0;

		if (data != null && data.capacityMeter != null)
			capacityMeter = roundNumber(data.capacityMeter / 1000000, 2);

		if (data != null && data.performanceMeter != null)
			performanceMeter = data.performanceMeter;

		$("#gauge1").empty();
		$("#gauge2").empty();

		//Capacity Meter
		var max = roundNumber(data.capacityMax / 1000000, 2);
		var normalMax = max * NORMAL_MAX_PERCENT;
		var warningMax = max * WARNING_MAX_PERCENT;
		var meterLabel = "millions";

		normalRange.start = 0; // Range start point as an angle relative to 0deg (pointing right).
		normalRange.end = normalMax; // Range end point as an angle relative to 0deg (pointing right).
		normalRange.color = "#009900";// Color and alpha (opacity) of the range arc.

		warningRange.start = normalMax; // Range start point as an angle relative to 0deg (pointing right).
		warningRange.end = warningMax; // Range end point as an angle relative to 0deg (pointing right).
		warningRange.color = "#FFA319"; // Color and alpha (opacity) of the range arc.

		criticalRange.start = warningMax; // Range start point as an angle relative to 0deg (pointing right).
		criticalRange.end = max; // Range end point as an angle relative to 0deg (pointing right).
		criticalRange.color = "#FF0000"; // Color and alpha (opacity) of the range arc.

		ranges[0] = normalRange;
		ranges[1] = warningRange;
		ranges[2] = criticalRange;
		var myGauge = new jGauge('gauge1', ranges, meterLabel); // Create a new jGauge.
		myGauge.range.total = max;
		myGauge.range.radius = 65;
		myGauge.init();
		myGauge.setValue(capacityMeter);

		//Performance meter
		meterLabel = "microseconds";
		max = data.performanceMax;
		normalMax = max * NORMAL_MAX_PERCENT;
		warningMax = max * WARNING_MAX_PERCENT;
		ranges = [];
		normalRange = {}, warningRange = {}, criticalRange = {};

		normalRange.start = 0; // Range start point as an angle relative to 0deg (pointing right).
		normalRange.end = normalMax; // Range end point as an angle relative to 0deg (pointing right).
		normalRange.color = "#009900"; // Color and alpha (opacity) of the range arc.

		warningRange.start = normalMax; // Range start point as an angle relative to 0deg (pointing right).
		warningRange.end = warningMax; // Range end point as an angle relative to 0deg (pointing right).
		warningRange.color = "#FFA319";// 'rgba(233,120,0,.9)';//#e97800'; // Color and alpha (opacity) of the range arc.

		criticalRange.start = warningMax; // Range start point as an angle relative to 0deg (pointing right).
		criticalRange.end = max; // Range end point as an angle relative to 0deg (pointing right).
		criticalRange.color = "#FF0000"; // Color and alpha (opacity) of the range arc.

		ranges[0] = normalRange;
		ranges[1] = warningRange;
		ranges[2] = criticalRange;

		myGauge = new jGauge('gauge2', ranges, meterLabel); // Create a new jGauge.
		myGauge.range.total = max;
		myGauge.range.radius = 65;
		myGauge.init();
		myGauge.setValue(performanceMeter);
	}

	function updateReportOptions() {
		if (storageFilterList != null) {
			storageFilterList.populateRequestString();
		}

		report.requestString.copyType = new Array();
		var all = true;
		$(".copyType").each(function() {
			if ($(this).attr("data-state") == "unchecked") {
				all = false;
			}
		});

		if (all) {
			report.requestString.copyType.push("all");
		} else {
			$(".copyType").each(function() {
				if ($(this).attr('data-state') == 'checked')
					report.requestString.copyType.push($(this).attr('id'));
			});
		}
	}

	report.tableDrawCallBack = function(oSettings) {
		var body = $("tbody", document.getElementById(oSettings.sTableId));
		if (oSettings.aoData == undefined || oSettings.aoData == null || oSettings.aoData.length == 0)
			return;

		$("#progressBar").progressbar("enable");
		$("#progressBar").progressbar({
			value : 30
		});
		var rows = $("tr", body);
		$
				.each(rows,
						function(index, row) {
							var r = row;
							var rowData = oSettings.aoData[index]._aData;
							var columns = oSettings.oInit.aoColumns;
							for (var cellIndex = 0; cellIndex < row.cells.length; cellIndex++) {
								var cell = row.cells[cellIndex];
								if (cell.nodeName == "TD" && columns[cellIndex].rendererType == "threshold") {
									var value = 0;
									var actualVal = 0;
									if (columns[cellIndex].mDataProp == "averageQITime") {
										value = rowData["averageQITimeMeter"];
										actualVal = parseInt(rowData["averageQITime"]);
									} else if (columns[cellIndex].mDataProp == "primaryRecords") {
										value = rowData["primaryRecordsMeter"];
										actualVal = parseInt(rowData["primaryRecords"]);
									} else if (columns[cellIndex].mDataProp == "secondaryRecords") {
										value = rowData["secondaryRecordsMeter"];
										actualVal = parseInt(rowData["secondaryRecords"]);
									}

									value = parseInt(value);
									var progressColor = "#009900";
									if (value > WARNING_MAX)
										progressColor = "#FF0000";
									else if (value > NORMAL_MAX)
										progressColor = "#FFA319";

									jQuery(cell).empty();
									jQuery(cell).append("<div style='width%; position:relative;padding:0px'> </div>");
									var outer = $("div", cell);
									outer.progressbar({
										value : parseInt(value)
									});
									var inner = $("div", outer);
									inner.css({
										background : progressColor,
										color : "#000",
										padding : "0px"
									});
									outer
											.append("<div style='position:absolute; top:3px; left:50%; font-weight:bold;font-size:14px; font-family:sans-serif;'> " +
													actualVal + "</div>");
								}
							}
						});
	};
	//	
	//	report.getChartSVGs = function() {
	//		var pieChartDom = $("#piechartcontainer");
	//		$("desc", pieChartDom).empty();
	//		var cHeight = $("svg",pieChartDom).attr("height");
	//		var cWidth = $("svg",pieChartDom).attr("width");
	//		var svg = pieChartDom.html();
	//		var i;
	//		
	//		
	//		
	//		var charts = {};
	//		var detail = {};
	//		detail["html"] = svg;
	//		detail["height"] = cHeight;
	//		detail["width"] = cWidth;
	//		charts["piechartcontainer"] = detail;
	//		report.requestString.invisible.chartsSVGs = charts;
	//		
	//	};
}

//function buildJSON(paper) {
//    var svgdata = [];
//    svgdata.push({
//        width: 390,
//        height: 400
//    });
//
//    $.each(paper,
//    function(i, o) {
//        var node = o;
//
//
//        if (node.type == "image") {
//            var object = {
//                type: node.type,
//                width: node.attrs['width'],
//                height: node.attrs['height'],
//                x: node.attrs['x'],
//                y: node.attrs['y'],
//                src: node.attrs['src'],
//                transform: node.transformations ? node.transformations.join(' ') : ''
//            }
//        }
//
//        if (node.type == "path") {
//            var path = "";
//
//            $.each(node.attrs['path'],
//            function(i, group) {
//                $.each(group,
//                function(index, value) {
//                    if (index < 1) {
//                        path += value;
//                    }
//                    else {
//                        if (index == (group.length - 1)) {
//                            path += value;
//                        }
//                        else {
//                            path += value + ',';
//                        }
//                    }
//                });
//            });
//
//            var object = {
//                type: node.type,
//                fill: node.attrs['fill'],
//                opacity: node.attrs['opacity'],
//                translation: node.attrs['translation'],
//                scale: node.attrs['scale'],
//                path: path,
//                stroke: node.attrs['stroke'] === 0 ? 'none': node.attrs['stroke'],
//                transform: node.transformations ? node.transformations.join(' ') : ''
//            }
//        }
//
//
//        svgdata.push(object);
//    });

//    $('#output').val(JSON.stringify(svgdata));
//};

$(document).ready(function() {
	DedupReport();
});
