function EntitySelection(options) {
	this.listPanelId = options.id;
	this.isAdminUser = options.isAdminUser;
	this.list = options.list;
	var allCheckBox = this.listPanelId + "_AllCheckBox";
	var clearAllButton = this.listPanelId + "_clearAll";
	var selectAllButton = this.listPanelId + "_selectAll";
	var allowIncludeAll = options.isAllowIncludeAll == undefined ? true : options.isAllowIncludeAll;
	var selectedList = [];
	var isSelectedList = false;

	this.buildList = function(listPanelId, list) {
		var id = 0, name = "";
		if (allowIncludeAll) {
			$("#" + listPanelId)
					.html('<li><div id="' + allCheckBox +
							'" class="custom-cb unchecked"  data-state="unchecked"></div><span class="custom-cb-label">All</span></li>');
		} else {
			$("#" + listPanelId).html('<li><input id="' + selectAllButton +
					'" class="selectAllBoxButton"  type="button" value="' + localMsg.selectAll + '" /><input id="' +
					clearAllButton + '" class="clearBoxButton"  type="button" value="' + localMsg.unselectAll +
					'"></label></li>');
		}

		var len = list.length, i = 0;
		for (i; i < len; i++) {
			if (typeof list[i] === "object") {
				id = list[i].id;
				name = list[i].name;
			} else {
				id = 0;
				name = list[i];
			}
			if ('clientFilterList' == listPanelId) {
				if (i == 100 && !isSelectedList) {
					$("#clientsSearch").attr("placeholder", localMsg.jobsummary.SearchLimit);
					break;
				}
			}
			$("#" + listPanelId).append('<li><div id="' + getValidEntity(name) + '" class="' + listPanelId +
					' custom-cb ' + getCheckedStatus(name) + '" data-state="' + getCheckedStatus(name) +
					'"></div><span class="custom-cb-label" data-entityid=' + id + '>' + name + '</span></li>');
		}
	};

	this.updateList = function(list) {
		selectedList = clientFilterPanel.getSelectedList();
		if (selectedList.length > 0) {
			if (selectedList.indexOf('All') > -1) {
				selectedList = [];
			}
			isSelectedList = true;
			var slList = this.mergeSearchList(selectedList, list);
			this.buildList(this.listPanelId, slList);

		} else {
			this.buildList(this.listPanelId, list);
		}
	};

	if (this.list) {
		this.buildList(this.listPanelId, this.list);
	}

	this.getSelectedList = function() {
		var selList = [];
		if ($("#listPanelId").hasClass("checked")) {
			return [ "all" ];
		}
		var list = $("#" + this.listPanelId).children();
		$.each(list, function(key, value) {
			var cb = $(this).find(".custom-cb");
			if (cb.hasClass("checked")) {
				selList.push($(this).find(".custom-cb-label").text());
			}
		});
		return selList;
	};

	this.getSelectedIdNameList = function() {
		var selList = [], item, selection;

		if ($("#listPanelId").hasClass("checked")) {
			return [ "all" ];
		}
		var list = $("#" + this.listPanelId).children();
		$.each(list, function(key, value) {
			var cb = $(this).find(".custom-cb");
			if (cb.hasClass("checked")) {
				selection = {};
				item = $(this).find(".custom-cb-label");
				selection.id = item.attr("data-entityid");
				selection.name = item.html();
				selList.push(selection);
			}
		});
		return selList;
	};

	this.setSelectedList = function(values) {
		var isIdNameList = typeof values[0] === 'object' ? true : false;

		if (values[0] == "all") {
			var list = $("#" + this.listPanelId).children();
			$.each(list, function() {
				checkCb($("div", $(this)));
			});
		} else {
			var ul = $("#" + this.listPanelId);

			if (isIdNameList) {
				$.each(values, function(key, value) {
					checkCb($(ul).find("#" + getValidEntity(value.name)));
				});
			} else {
				$.each(values, function(key, value) {
					checkCb($(ul).find("#" + getValidEntity(value)));
				});
			}
		}
	};

	$("#" + this.listPanelId).on("checkedState", function(e) {
		var el = e.target;
		var all = true;

		if (!allowIncludeAll) {
			checkCb($(el));
			return;
		}

		if ($(el)[0] === $("#" + allCheckBox)[0]) {
			var list = $(el).closest("ul").find(".custom-cb");
			$.each(list, function() {
				checkCb($(this));
			});
		} else {
			var list = $(el).closest("ul").find(".custom-cb");
			$.each(list, function() {
				if ($(this)[0] != $("#" + allCheckBox)[0] && $(this).hasClass("unchecked")) {
					all = false;
					return false;
				}
			});
			if (all == true) {
				if ('clientFilterList' == this.id) {
					//check if it is search flow
					if (!$("#" + allCheckBox).parent().is(':hidden')) {
						checkCb($("#" + allCheckBox));
					}
				} else {
					checkCb($("#" + allCheckBox));
				}
			}
		}
	});
	$("#" + this.listPanelId).on("unCheckedState", function(e) {
		var el = e.target;
		var all = true;

		if (allowIncludeAll) {
			if ($(el)[0] === $("#" + allCheckBox)[0]) {
				var list = $(el).closest("ul").find(".custom-cb");
				$.each(list, function() {
					unCheckCb($(this));
				});
			} else {
				unCheckCb($("#" + allCheckBox));
				unCheckCb($(el));
			}

		} else {
			unCheckCb($(el));
		}
	});

	$("#" + this.listPanelId).on("click", ".clearBoxButton", function(e) {
		var el = e.target;
		var list = $(el).closest("ul").find(".custom-cb");
		$.each(list, function() {
			unCheckCb($(this));
		});
	});
	$("#" + this.listPanelId).on("click", ".selectAllBoxButton", function(e) {
		var el = e.target;
		var list = $(el).closest("ul").find(".custom-cb");
		$.each(list, function() {
			checkCb($(this));
		});
	});

	this.populateRequestString = function(fieldName, isIdNameItem) {
		requestString[fieldName] = [];
		var selection = isIdNameItem ? this.getSelectedIdNameList() : this.getSelectedList();
		if (selection.length > 0) {
			var firstSelection = typeof selection[0] === 'object' ? selection[0].name : selection[0];

			if (firstSelection.toLowerCase() == "all") {
				requestString[fieldName].push('all');
			} else {

				$.each(selection, function(index, value) {
					requestString[fieldName].push(value);
				});
			}
		}
	};

	function getValidEntity(entity) {
		entity = getHtmlEntityEscapedString(entity);
		entity = entity.replace(/[!"#$%&'()*+,.\/:;<=>?@[\\\]^`{|}~]/g, function(match) { //replace all special characters with their ascii
			return match.charCodeAt(0);
		});
		entity = entity.replace(/ /g, '_');
		return entity;
	}

	function getCheckedStatus(name) {
		if (selectedList.length > 0 && selectedList.indexOf(name) > -1) {
			return 'checked';
		} else {
			return 'unchecked';
		}
	}

	this.mergeSearchList = function(selectedList, list) {
		var result_array = [];
		var arr = selectedList.concat(list);
		var len = arr.length;
		var assoc = {};

		while (len--) {
			var item = arr[len];

			if (!assoc[item]) {
				result_array.unshift(item);
				assoc[item] = true;
			}
		}

		return result_array;
	};

	function getHtmlEntityEscapedString(string) { //to decode HTML Entities for older schedules ( eg: &amp; to & )
		var elem = document.createElement('textarea');
		elem.innerHTML = string;
		var decoded = elem.value;
		return decoded;
	}

}