var chartData = null;
var chartOtherDrillIndex = 0;
var MAX_NUM_PIE_SLICE = 5;
var prefCost = 0;
var prefCostUnit = 0;
var currency = '$';

function FileArchiverReport() {

	this.clientPanel = null;
	var clickedPieVolume = false;

	this.report = new Reports.initReport({
		type : 'filearchiver',
		generateButtonId : 'btngenerate',
		idtomask : 'piechartcontainer'
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		//alert("File Archiver - initializeDefaults()");
		report.requestString.type = "FileArchiver";
		report.requestString.isFLA = "false";
		report.requestString.includeAllEntities = "false";
		report.requestString.firstTimeLoading = "true";
		report.requestString.entities = "";
		report.requestString.createdDays = 0;
		report.requestString.modifiedDays = 0;
		report.requestString.accessedDays = 0;
		report.requestString.fileSizeUnit = "";
		report.requestString.fileSize = 0;
		report.requestString.fileExtensions = "";
		report.requestString.sortBy = "FileCount";
		report.requestString.groupBy = "Client";
		report.requestString.distribution = "Client";
		report.requestString.reportFilters = [];
		report.requestString.volume = null;
	};

	report.initComponents = function() {
		$('#createdN').spinner({
			min : 0,
			max : 9999
		});
		$('#accessN').spinner({
			min : 0,
			max : 9999
		});
		$('#modifiedN').spinner({
			min : 0,
			max : 9999
		});
		$('#sizeN').spinner({
			min : 0,
			max : 9999
		});
		$("#filterPanel").accordion({
			fillSpace : true
		});
		chartOtherDrillIndex = 0;

		$(".exportatserver").click(function() {
			report.mask(report.idtomask, true, "Exporting...");
			report.requestString.invisible.exportType = this.id.substring("export".length);
			report.requestString.invisible.exportAll = true;
			cvUtil.loadPageWithGET(getRequestUrlForExport(), "", function(data1) {
				$("#fileNameToDownload").val(data1);
				$("#exportForm").submit();
				report.unmask(report.idtomask);
			});
			report.requestString.invisible.exportType = undefined;
		});
	};

	report.initComponentState = function() {

		$('#createdN').val(requestString.createdDays);
		$('#accessN').val(requestString.accessedDays);
		$('#modifiedN').val(requestString.modifiedDays);
		$('#sizeN').val(requestString.fileSize);
		$('#units').val(requestString.fileSizeUnit);
		$('#extensions').val(requestString.fileExtensions);
		$('#chartView').val(requestString.sortBy);

		$("#btnSaveChanges").bind("click", function() {
			applyCostChanges();
		});

		$("#btnReset").bind("click", function() {
			resetCostChanges();
		});

		collapseFLATable(false);
		$("#flaData h1").click();
		$("#flaData h1").click(function() {
			var arrow = $(this).children(".arrowPlaceholder");
			if (arrow.hasClass("expand")) {
				clickedPieVolume = false;
				sendFLARequest();
			}
		});
		clientPanel = new ClientPanel({
			"treeid" : "#tree",
			"requestString" : report.requestString,
			"callback" : sendInitialRequest
		});
	};

	function applyCostChanges() {

		var unit = $('#costPerSizeUnit option:selected').val();
		var cost = parseInt($('#costTxt').val());

		updateCostChanges(cost, unit);
	}

	function resetCostChanges() {
		updateCostChanges(prefCost, prefCostUnit);
	}

	function updateCostChanges(cost, unit) {
		var dataTable = $('#fileArchiverSummary' + CVTable.table).dataTable();
		for (var i = 0; i < dataTable.fnGetData().length; i++) {
			var data = dataTable.fnGetData(i);
			var size = parseInt(data['totalSize']);
			var newcost = costcalc(size, cost, unit);
			dataTable.fnUpdate(newcost, i, 5);
		}
	}

	function costcalc(size, cost, unit) {

		var divisor = Math.pow(1024, unit);
		if (isNaN(cost)) {
			cost = 0;
		}
		return currency + convert(cost * (size / divisor)); // need to replace '$' with current currency symbol..
	}

	function collapseFLATable(removeData) {
		var arrow = $("#flaData > h1").children(".arrowPlaceholder");
		if (arrow.hasClass("expand")) {
			arrow.removeClass("expand").addClass("collapse");
		}
		if (removeData) {
			var dataTabl = $('#flaData_table').hasClass('initialized');
			if (dataTabl) {
				//$('#flaData_table').dataTable().fnClearTable();
				$('#flaData_table').dataTable().empty();
			}
		}
	}

	function expandFLATable() {
		var arrow = $("#flaData  h1").children(".arrowPlaceholder");
		if (arrow.hasClass("collapse")) {
			arrow.removeClass("collapse").addClass("expand");
		}

	}

	function sendFLARequest() {
		if (this.requestString.isFLA == "true") {
			if (clickedPieVolume == false) {
				return;
			}
		}
		$("#flaData").mask("Loading...");
		this.requestString.isFLA = "true";

		var entities = report.requestString["entities"];

		if (report.requestString.groupBy == "Volume") {
			var entity = report.requestString.reportFilters[report.requestString.reportFilters.length - 1];
			clientPanel.updateSelectedClientPath(entity.entityName);
		}
		//report.requestString["entities"] = path;
		/*
		 * $.each(report.requestString.reportFilters, function(index, entity){ if(entity.){
		 *  } } );
		 */

		cvUtil.loadPageWithGET(getDetailsUrl(), "", function(data) {
			updateDetailsTable(data);
			$("#flaData").unmask();
			//$('#flaData').show();
			expandFLATable();
		});

		report.requestString["entities"] = entities;
	}

	function sendInitialRequest() {
		//alert("File Archiver - sendInitialRequest()");
		clientPanel.updateEntities();
		report.updateHash(false);
		report.mask(report.idtomask);
		if (report.beforeLoadReport) {
			report.beforeLoadReport();
		}
		cvUtil.loadPageWithGET(report.getRequestUrl(), "", function(data1) {
			report.onLoadReport(data1);
			report.unmask();
			report.requestString.firstTimeLoading = "false";
			requestString.firstTimeLoading = "false";
		});

	}
	report.beforeLoadReport = function() {
		$("#piechartcontainer").mask("");
	};
	report.loadReport = function() {

		if (requestString.firstTimeLoading != "true") {
			//alert("FileArchiver - loadReport - sending report request");
			this.mask(this.idtomask);
			if (this.beforeLoadReport) {
				this.beforeLoadReport();
			}
			cvUtil.loadPageWithGET(report.getRequestUrl(), "", function(data1) {
				report.onLoadReport(data1);
				report.unmask();
			});
		}
	};

	report.onLoadReport = function(data1) {
		if (data1 == null || data1["chart"] == null) {
			return;
		}

		chartData = data1["chart"]["points"];
		var currentData = [];
		var i = 0;
		var maxSlice = MAX_NUM_PIE_SLICE - 1;
		if (chartData.length > MAX_NUM_PIE_SLICE) {
			for (i = 0; i < chartData.length && i < maxSlice; i++)
				currentData.push(chartData[i]);

			var total = 0;
			while (i++ < chartData.length - 1)
				total += chartData[i].y;

			currentData.push({
				"name" : "Others",
				"y" : total,
				"id" : -1
			});
		} else {
			currentData = chartData;
		}

		createRaphaelchart(currentData);
		$("#chartTitle").html(data1.chart.chartTitle);

		currency = data1["currency"];
		prefCost = data1["cost"];
		prefCostUnit = data1["costUnit"];

		Reports.configureClientSideTable('fileArchiverSummary', 'Summary', data1.fileArchiverSummary);

		collapseFLATable(true);

		/*
		 * if($.inArray('flaData', report.requestString.jobType)==-1){ $("#flaData").hide(); }else{
		 * Reports.configureTable('flaData', 'FLA Details', data1.flaData, report.requestString,
		 * report.getRequestUrl); }
		 */

		updateBreadCrumb();
		$("#piechartcontainer").unmask();
	};

	report.updateRequestString = function() {
		//		try{
		clientPanel.updateEntities();
		updateReportOptions();
		//		}
		//		catch (e) {
		//			alert(e.toString());
		//		}
	};

	report.init();
	report.customizeTable = function(dataTable) {
	};

	this.breadCrumbClick = function(index) {
		if (index == 0) {
			if (this.requestString.reportFilters == null || report.requestString.reportFilters.length == 0) {
				return;
			}
			report.requestString.reportFilters = [];
			report.requestString.groupBy = report.requestString.distribution;
		} else if (report.requestString.reportFilters != null) {
			if (index == report.requestString.reportFilters.length)
				return;
			else {
				report.requestString.groupBy = report.requestString.reportFilters[index].entityType;
				var i = 0;
				for (i = report.requestString.reportFilters.length - 1; i >= index; i--)
					report.requestString.reportFilters.pop();
			}
		}
		chartOtherDrillIndex = 0;
		report.requestString.isFLA = "false";
		report.requestString.othersLevel = 0;
		//		updateChartData();
		report.processReport();

	};

	$("#groupByPanel").change(function() {
		$("#groupByPanel option:selected").each(function() {
			handleGroupByChange($(this).attr('id'));
		});
	});

	function handleGroupByChange(distribution) {
		chartDrillDown(0, "", "", distribution);
	}

	function chartDrillDown(entityId, entityName, type, distribution) {
		report.requestString.isFLA = "false";
		report.requestString.volume = "";
		clickedPieVolume = false;

		if (distribution != null) {
			report.requestString.reportFilters = [];
			report.requestString.groupBy = distribution;
			report.requestString.distribution = distribution;
			report.requestString.othersLevel = 0;
			chartData = null;
			chartOtherDrillIndex = 0;
			//			updateChartData();
			report.processReport();
		} else if (entityId == -1) {
			chartOtherDrillIndex++;
			var currentData = [];
			var seriesCount = 0;
			var startIndex = chartOtherDrillIndex * MAX_NUM_PIE_SLICE;

			for (; startIndex < chartData.length && seriesCount < MAX_NUM_PIE_SLICE; startIndex++, seriesCount++) {
				currentData.push(chartData[startIndex]);
			}

			if (startIndex < chartData.length - 1) {
				var total = 0;
				while (startIndex++ < chartData.length - 1)
					total += chartData[startIndex].y;

				currentData.push({
					"name" : "Others",
					"y" : total,
					"id" : -1
				});
			}
			createRaphaelchart(currentData);
		} else {
			chartOtherDrillIndex = 0;
			report.requestString.othersLevel = 0;
			if (report.requestString.groupBy == "Volume") {
				report.requestString.volume = entityName;
				clickedPieVolume = true;
				sendFLARequest();
				expandFLATable();
				return;
			}
			var entity = new Object;
			entity.entityId = entityId;
			entity.entityName = entityName;
			entity.entityType = type;
			entity.order = report.requestString.reportFilters.length;
			report.requestString.reportFilters.push(entity);

			//set the new groupBy
			if (report.requestString.distribution == "Client") {
				if (report.requestString.groupBy == "Client") {
					report.requestString.groupBy = "Volume";
				}

			} else if (report.requestString.distribution == "ClientGroup") {
				if (report.requestString.groupBy == "ClientGroup") {
					report.requestString.groupBy = "Client";
				} else if (report.requestString.groupBy == "Client") {
					report.requestString.groupBy = "Volume";
				}
			} else if (report.requestString.distribution == "FileExtension") {
				if (report.requestString.groupBy == "FileExtension") {
					report.requestString.groupBy = "Client";
				} else if (report.requestString.groupBy == "Client") {
					report.requestString.groupBy = "Volume";
				}
			}
			//updateChartData();
			report.processReport();
		}

	}

	function updateBreadCrumb() {
		//clear the breadcrumb
		$("#breadCrumbPanel").empty();

		var counter = 0;
		var id = 'path' + counter;
		$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>All Clients</li>');
		$("#" + id).click(function() {
			breadCrumbClick(this.id.substring('path'.length));
		});
		counter++;
		if (report.requestString.reportFilters != null) {
			$.each(report.requestString.reportFilters, function(index, value) {
				id = 'path' + counter;
				$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>' + value.entityName + '</li>');
				$("#" + id).click(function() {
					breadCrumbClick(this.id.substring('path'.length));
				});
				counter++;
			});

		}
		$('#breadCrumbPanel li').last().css('background-image', 'none');
		$("#breadCrumbPanel").append('<li class="endBreadcrumb"></li>');
	}

	function createRaphaelchart(currentData) {
		$("#piechartcontainer").empty();
		var values = $.map(currentData, function(node) {
			return node["y"];
		});
		currentData.values = values;
		var labels = $.map(currentData, function(node) {
			if (report.requestString.sortBy == "TotalSize") {
				return node["name"] + " - " + autoConvert(node["y"]);
			}
			return node["name"] + " - " + node["y"];
		});
		var events = {};
		events.clickFtn = [];
		//if (report.requestString.groupBy !=  "Volume")
		{
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				events.clickFtn[i] = function() {
					chartDrillDown(this.params.id, this.params.name, this.params.type, null);
				};
			}
		}
		Raphael("piechartcontainer", 700, 400).pieChart(250, 180, 150, currentData, labels, 500, 40, "#fff", events);
		//$("#selectGrpDiv").css('visibility','visible');
	}

	function updateReportOptions() {
		requestString.firstTimeLoading = "false";
		requestString.createdDays = $("#createdN").val();
		requestString.modifiedDays = $("#modifiedN").val();
		requestString.accessedDays = $("#accessN").val();
		requestString.fileSize = $("#sizeN").val();
		requestString.fileSizeUnit = $('#units option:selected').val();
		requestString.fileExtensions = $("#extensions").val();

		requestString.sortBy = $("#chartView option:selected").val();
		requestString.isFLA = "false";
		report.requestString.volume = "";
		//requestString.groupBy = "Client";
		//requestString.distribution = "Client";

		//updateFileSize();
	}

	function updateFileSize() {
		var size = $("#sizeN").val();
		var unit = $('#units option:selected').val();
		if (unit == "KB") {
			size = size * 1024;
		} else if (unit == "MB") {
			size = size * 1024 * 1024;
		} else if (unit == "GB") {
			size = size * 1024 * 1024 * 1024;
		} else if (unit == "TB") {
			size = size * 1024 * 1024 * 1024 * 1024;
		} else if (unit == "PB") {
			size = size * 1024 * 1024 * 1024 * 1024 * 1024;
		}

		requestString.fileSize = size;
	}

	function updateDetailsTable(data) {
		if (data["flaData"] != null && data["flaData"]["aaData"] != null && data["flaData"]["aaData"].length > 0) {
			Reports.configureTable('flaData', 'FLA Details', data.flaData, report.requestString, report.getRequestUrl);
		}
	}

	function getDetailsUrl() {
		return cvUtil.getContextPath() + '/server/report?type=' + report.type + '&json=' +
				window.encodeURIComponent(JSON.stringify(this.requestString));
	}

	function getRequestUrlForExport() {
		this.requestString.exporting = true;
		var url = cvUtil.getContextPath() + '/server/report?type=' + report.type + '&json=' +
				window.encodeURIComponent(JSON.stringify(this.requestString));
		this.requestString.exporting = false;
		return url;
	}

	report.defaultSortColumn = function() {
		return 'volume';
	};

}

$(document).ready(function() {
	FileArchiverReport();
});
