var customerName;
function beforeLoadReportBase() {
	$(".commcell_charts").mask("");
	$(".hideifnodata").hide();
	$(".iconLabel").hide();
};

function onLoadReportBase(data, survey) {
	if (data) {
		if (typeof data === 'string') {
			data = cvUtil.parseJSON(data);
		}
		if (data.error == undefined) {
			//add header
			var header = data["header"];
			var headerTable = $("#growthHeaderTable");
			for (var i = 0; i < header.length; i++) {
				if (survey) {
					var colData = header[i];
					if (colData.label == 'CommCellName') {
						customerName = colData.value;
						if (customerName && customerName.length > 0) {
							$('#custName').text(customerName + ' - ');
						}
					} else if (colData.label == 'CommCellId') {
						$("#metaCCId").html('<span>' + cvUtil.cvLocalize("commcell.info.label.CommCell_ID") + ': ' +
								colData.value + '</span>');
					} else if (colData.label == 'AsOf') {
						$("#metaAsOf").html('<span>' + cvUtil.cvLocalize("commcell.info.label.As_of") + ': ' +
								colData.value + '</span>');
					} else if (colData.label == 'Edition') {
						$("#metaCCEdition").html('<span>' + cvUtil.cvLocalize("commcell.info.label.Edition") + ': ' +
								colData.value + '</span>');
					}
					//$("#surveyList").show();
				} else {
					var colData = header[i++];
					var row = "<tr> <td class='odd'>" + colData.label + "</td>";
					row += "<td class='even'> " + colData.value + "</td>";
					if (i < header.length) {
						colData = header[i++];
						row += "<td class='odd newPair'> " + colData.label + "</td>";
						row += "<td class='even'> " + colData.value + "</td>";
					}
					if (i < header.length) {
						colData = header[i];
						row += "<td class='odd newPair'> " + colData.label + "</td>";
						row += "<td class='even'> " + colData.value + "</td>";
					}
					row += "</tr>";
					headerTable.append(row);

				}
			}

			$("#timeStamp").html(data["timeStamp"]);

			var charts = data["data"];
			var sizeUnit = cvUtil.getParameter("sizeUnit", "TB");

			if (charts != undefined && charts.length > 0) {
				var addedDetailsLink = false;
				for (i = 0; i < charts.length; i++) {
					var chartData = charts[i];
					var gType = chartData.gType;

					/*
					 * if (survey && (!addedDetailsLink)) { report.showDetailsLink(gType); addedDetailsLink =
					 * true; }
					 */

					if (chartData["chartData"] != null && chartData["chartData"]["chart"] != null &&
							chartData["chartData"]["chart"].length != 0) {
						$("#" + gType + "_ContentWrapper > .showifnodata").hide();
						$("#" + gType + "_ContentWrapper > .hideifnodata").show();
						//					$("#" + gType + "_ContentWrapper").hide();
						$("#" + gType + "_ContentWrapper").show();

						createBarChart(chartData["chartData"], gType, "");

					}

					if (chartData["chartData"] != null) {
						var detail = chartData["chartData"]["detail"];
						var percent = parseInt(chartData["chartData"].threshold.percent);
						if (detail) {
							$("#" + gType + "_detailPanel").show();

							if (detail["claMode"] == true) {
								if (percent < 80) {
									$("#" + gType + "_iconLabel.normalIcon").show();
								} else if (percent >= 80 && percent <= 95) {
									$("#" + gType + "_iconLabel.warningIcon").show();
								} else {
									$("#" + gType + "_iconLabel.criticalIcon").show();
								}

								$("#" + gType + "_claLabel").html(detail["usageNote"]);

								if (detail["outOfCapacityDay"] != undefined) {
									$("#" + gType + "_warningValue").html(detail["outOfCapacityDay"]);
								}

								if (detail["predictionExist"]) {
									if (detail["next6Months"]) {
										$("#" + gType + "_pred6MonthsValue").html(detail["next6Months"]);
									} else {
										$("#" + gType + "_pred6MonthsValue").hide();
										$("#" + gType + "_pred6MonthsLabel").hide();
									}

									if (detail["next12Months"]) {
										$("#" + gType + "_pred12MonthsValue").html(detail["next12Months"]);
									} else {
										$("#" + gType + "_pred12MonthsValue").hide();
										$("#" + gType + "_pred12MonthsLabel").hide();
									}

									if (detail["next18Months"]) {
										$("#" + gType + "_pred18MonthsValue").html(detail["next18Months"]);
									} else {
										$("#" + gType + "_pred18MonthsValue").hide();
										$("#" + gType + "_pred18MonthsLabel").hide();
									}
								} else {
									$("#" + gType + "_warningLabel").css("margin-top", "25px");
									$("#" + gType + "_predictionPanel").hide();
								}
								$("#" + gType + "_nonClaPanel").hide();

								if (isCALUsage(gType)) {
									if (gType == 'ci_objects') {
										$("#" + gType + "_currentUsage").html(detail["currentUsage"]);
										$("#" + gType + "_peakUsage").html(detail["peakUsageLastMonth"]);
									} else {
										$("#" + gType + "_currentUsage")
												.html(autoConvertNumber(detail["currentUsage"]));
										$("#" + gType + "_peakUsage")
												.html(autoConvertNumber(detail["peakUsageLastMonth"]));
									}
								} else {
									if (sizeUnit == "TB") {  // Keep old behavior of auto-conversion 
										$("#" + gType + "_currentUsage")
										.html(convertLicenseCapacity(detail["currentUsage"] * 1024 * 1024));
										$("#" + gType + "_peakUsage")
										.html(convertLicenseCapacity(detail["peakUsageLastMonth"] / 1024 / 1024));
									} else { //convert to GB
										var tempCur = detail["currentUsage"] * 1024;
										tempCur = tempCur.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
										var tempPeak = detail["peakUsageLastMonth"] / 1024;
										tempPeak = tempPeak.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ","); 
										$("#" + gType + "_currentUsage").html(tempCur + " " + sizeUnit);
										$("#" + gType + "_peakUsage").html(tempPeak + " " + sizeUnit);
									}
								
								}

								$("#" + gType + "_claPanel .currentCapacity").show();
							} else {
								$("#" + gType + "_claPanel").hide();
								$("#" + gType + "_iconLabel.infoIcon").hide();
								/*
								 * $("#" + gType + "_iconLabel.normalIcon").hide(); $("#" + gType +
								 * "_iconLabel.criticalIcon").hide(); var maxEntityValue =
								 * chartData["chartData"]["maxEntityValue"]; if(maxEntityValue > 0){ if
								 * (percent > 100) { $("#" + gType + "_iconLabel.criticalIcon").show(); }else{
								 * $("#" + gType + "_iconLabel.normalIcon").show(); } }else{ $("#" + gType +
								 * "_iconLabel.infoIcon").show(); }
								 */
								$("#" + gType + "_iconLabel.infoIcon").show();
								if (detail["usageNote"]) {
									$("#" + gType + "_nonClaLabel").html(detail["usageNote"]);
								}
							}

						}

					}
				}
			} else {
				report.showErrorMessage();
			}

			//update help link
			var helpLink = ""
			if (docBaseURL) {
				helpLink = docBaseURL + "?p=6908.htm";
			} else {
				helpLink = "http://documentation.commvault.com/commvault/v11/article?p=6908.htm";
			}

			document.getElementById("helpLink").href = helpLink;
		} else {
			hideAllComponents();
			$("#noDataNotificationPanel").html(data.error);
			$("#noDataNotificationPanel").show();
		}
	}
}

function isCALUsage(type) {
	if (type === 'vmsockets' || type === 'protectedvms' || type === 'users' || type === 'archived_mailboxes' ||
			type === 'ci_objects') {
		return true;
	}

	return false;
}

function createBarChart(data, gType, title) {
	var frameId = gType + "_Chart";
	var exportType = cvUtil.getParameter("exportType","");
	var isExport = exportType !=="";
	var points =  parseInt(cvUtil.getParameter("monthsOfTrend", 12));
	var sizeUnit = cvUtil.getParameter("sizeUnit", "TB");
	var width =  700;

	if (points > 12 ) {
		width = 900;
		if (isExport) {
			width = 800;
		}
	}


	if (data["yMax"] <= 0) {
		$('#' + frameId).empty();
		$('#' + frameId)
				.html("<h4 style='font-weight: bold; margin:100px 325px 0 70px; color: #555555;'>No chartable data</h4>");
		return;
	}

	$("#" + frameId).highcharts({
		chart : {
			plotBackgroundColor : null,
			plotBorderWidth : null,
			plotShadow : false,
			height : 300,
			width: width,
			style: {
				"text-align" : "center"
			},
			className: isExport ? null : "capacityHighChart"
		},
		title : {
			style : {visibility: "hidden"}
		},
		legend: {
			itemStyle: {
	            color: "#000000",
	            "font-weight": "normal",
	            "pointer-events": "none"
	        }
		},
		xAxis: [{
	        categories: data.xAxisLabels,
	        labels: {
	            style: {
	                "font-family": "Helvetica, Arial, sans-serif"
	            }
	        }},
	    ],
	    yAxis: {
	    	title: {
	    		text: data.yAxisTitle,
	    		style: {
		                "font-family": "Helvetica, Arial, sans-serif"
	    		}
	    	}
	    },
		plotOptions : {
			column : {
				pointWidth:20,
				allowPointSelect : false,
				animation : false,
				showInLegend : false
			},
			series: {
				animation: isExport ? false : true
			}
		},
		series : getSeries(data, gType, isExport),
		credits : {
			enabled : false
		}
	});
}

function getSeries(data, gType, isExport) {
	var series = [];
	var chartData = {};
	chartData.barData = [];
	var baseURL = cvUtil.getContextPath() + '/survey/reports/capacityGrowthDetail.jsp?';
	var params = "";
	var drillable =  isDrillable(gType);
	var xLabelDrilldownURLs = null;

	if (commUniId && commUniId > 0) {
		params += 'commUniId=' + commUniId;
	}

	if (ccGroupId && ccGroupId > 0) {
		if (params) {
			params += '&';
		}
		params += 'ccGroupId=' + ccGroupId;
	}
	if (companyId && companyId > 0) {
		if (params) {
			params += '&';
		}
		params += 'companyId=' + companyId;
	}

	if (params) {
		baseURL += params;
	}

	if (drillable) {
		xLabelDrilldownURLs = getDrillDownURLs(data["startDates"], gType, baseURL);
	}
//
	//populate bar points
	$.each(data.chart[0], function(i, val) {
		var yValue = parseFloat(val.toFixed(2));
		var pointData = {
				y: 			yValue,
				tooltip: 	data.popupLabels[0][i],
				startDate:	data.startDates[i],
				barLabel:	yValue > 0 ? yValue : "",
				drillURL:	drillable ? xLabelDrilldownURLs[i] : null

				}
		chartData.barData.push(pointData);
	});

	//populate threshold
	chartData.lineData = [];
	var threshold = data.threshold.value;
	for (var i=0; i< data.xAxisLabels.length; i++) {
		chartData.lineData.push(threshold);
	}


	//bar chart
	series.push({
			name: "PeakUsage",
			type : "column",
			data :  chartData.barData,
			tooltip : {
				headerFormat: '<style="visibility":"hidden"/>',
				pointFormat : "{point.tooltip}"
			},
			cursor: drillable ? "pointer" : "none",
			dataLabels: {
				enabled: isExport? true : false,
				format: 	"{point.barLabel}",
				rotation: -45,
				align: "right",
				y: -20,
				x: 10,
				style: {
					 "font-family": "Helvetica, Arial, sans-serif",
					 "font-weight": "normal"
				}

			},
			pointWidth: 16

	});

	if (drillable) {
		series[0].point = {
				events: {
					click: function() {
						window.open(this.options.drillURL, '_blank');
					}
				}
		}
	}

	//threshold line
	series.push({
		name: data.threshold.label,
		type : "line",
		color: data.threshold.color,
		data : chartData.lineData,
		marker: {
			enabled: false
		},
		lineWidth: 2,
		enableMouseTracking: false
	});

	//loaned capacity
	if (data.otherThresholds && data.otherThresholds.length > 0) {
		var lineData2 = []
		var t2 =  data.otherThresholds[0];
		threshold =t2.value;
		for (var i=0; i< data.xAxisLabels.length; i++) {
			lineData2.push(threshold);
		}
		series.push({
			name: t2.label,
			type : "line",
			color: t2.color || "#FF0000",
			data : lineData2,
			marker: {
				enabled: false
			},
			lineWidth: 2,
			enableMouseTracking: false
		})
	}
	return series;
}


function isDrillable(gType) {
	if (ccGroupId == -1 && companyId <= 0 && commUniId == 0 && isPublicMetrics) {
		return false;
	}

	if (gType === 'protectionEnterprise' || gType === 'archiveEnterprise' || gType === 'replication' ||
			gType === 'snapshot') {
		return true;
	}

	return false;

}

function getDrillDownURLs(dates, gType, baseURL) {
	var urls = [], pointDate, url, aggregate;

	$.each(dates, function(i, d) {
		url = baseURL + "&startDate=" + d;
		url += "&gType=" + gType;
		urls.push(url);
	});

	return urls;
}

function pZ(value) {
	if (value < 10) {
		return "0" + value;
	} else {
		return "" + value;
	}
}