var chartData = null;
var chartOtherDrillIndex = 0;

function AuditTrailReport() {

	this.timeFrame = null;

	this.report = new Reports.initReport({
		type : 'guiAuditTrail',
		generateButtonId : 'btngenerate',
		chartIds : [ 'barChartContainer', 'eventBarChartContainer' ]
	});

	this.requestString = report.requestString;
	report.initializeDefaults = function() {
		report.requestString["type"] = "AuditTrail";
		report.requestString["includeAllEntities"] = "true";
		report.requestString["entities"] = "";
		report.requestString.playBack = [ "all" ];
		report.requestString.searchString = '';
		report.requestString.timeFrameType = "relative";
		report.requestString.frequency = "Hourly";
		report.requestString.lastN = 24;
		report.requestString.groupBy = "PlayBack";
		report.requestString.distribution = "PlayBack";
		report.requestString.reportFilters = [];
		report.requestString.users = [];
		report.requestString.reportType = new Array("audit", "event");
	};

	report.initComponents = function() {
		var genBtn = $('#btngenerate');
		var none = false;
		var reportFilters = $(".reportFilters");
		var error_note_reportType = $('#reportFilter-error');
		var palyback = $('#playBackLevels');

		reportFilters.each(function() {
			$(this).bind('checkedState', function() {
				none = false;
				error_note_reportType.css("display", "none");
				genBtn.attr("disabled", false);
				genBtn.removeClass("btnDisabled");
			});
			$(this).bind('unCheckedState', function() {
				none = true;
				reportFilters.each(function() {
					if ($(this).attr("data-state") == "checked") {
						none = false;
						return false;
					}
				});
				if (none) {
					$('#reportFilter-error').css("display", "block");
					genBtn.attr("disabled", true);
					genBtn.addClass("btnDisabled");
				}
			});
		});

		palyback.bind('selectionChanged', function(e, hasSelection) {
			if (hasSelection) {
				genBtn.removeClass("btnDisabled");
				genBtn.attr("disabled", false);
			} else {
				genBtn.addClass("btnDisabled");
				genBtn.attr("disabled", true);
			}
		});

		$('#userList').bind('selectionChanged', function(e, hasSelection) {
			if (hasSelection) {
				genBtn.removeClass("btnDisabled");
				genBtn.attr("disabled", false);
			} else {
				genBtn.addClass("btnDisabled");
				genBtn.attr("disabled", true);
			}
		});

		report.requestString.searchString = $('#searchstring').val();
		timeFrame = new TimeFrame.frame({
			"requestString" : report.requestString
		});
		chartOtherDrillIndex = 0;
	};

	report.initComponentState = function() {
		usersList = new usersList({
			id : "userList"
		});

		$.each(report.requestString.reportType, function(index, value) {
			if (value == 'audit') {
				checkCb($('#audit'));
			} else if (value == 'event') {
				checkCb($('#event'));
			}
		});

		report.requestString.searchString = $('#searchstring').val();
		timeFrame.initComponentState();
	};

	report.beforeLoadReport = function() {
		$("#chartPanel > .showifnodata").hide();
		$("#chartPanel > .hideifnodata").show();
		$("#groupByPanel").removeAttr("disabled");
		$("#chartPanel").mask(" ");
	};

	report.onLoadReport = function(data1) {
		var treeReqURL = cvUtil.getContextPath() + "/server/report?type=Common&component=Users&reportTyp=" +
				report.requestString.type;
		cvUtil.loadPageWithGET(treeReqURL, "", function(data) {
			if (data["users"] != null) {
				var users = new Array();
				users[0] = "All";
				var j = 1;
				for (var i = 0; i < data["users"].length; i++) {
					if (data["users"][i] == "") {

					} else {
						users[j++] = data["users"][i];
					}
				}
				usersList.updateList(users);
			}
		});

		if (data1 == 'null' || data1 == null) {
			$("#chartPanel > .showifnodata").show();
			$("#chartPanel > .hideifnodata").hide();
			$("#groupByPanel").attr("disabled", "disabled");
			return;
		}

		var showAuditChart = data1.auditChart.chart &&
				data1.auditChart.chart.length > 0 &&
				(data1.auditChart.chart instanceof Array) &&
				(data1.auditChart.chart[0].length > 0) &&
				(data1.auditChart.chart[0][0] != 0 || data1.auditChart.chart[0][1] != 0 ||
						data1.auditChart.chart[0][2] != 0 || data1.auditChart.chart[0][3] != 0);
		var showEventChart = data1.eventChart.chart &&
				data1.eventChart.chart.length > 0 &&
				(data1.eventChart.chart instanceof Array) &&
				(data1.eventChart.chart[0].length > 0) &&
				(data1.eventChart.chart[0][0] != 0 || data1.eventChart.chart[0][1] != 0 ||
						data1.eventChart.chart[0][2] != 0 || data1.eventChart.chart[0][3] != 0);

		$("#auditChartTitle").html(data1.auditChartTitle);
		$("#eventChartTitle").html(data1.eventChartTitle);
		//			$("#auditWrapper > .showifnodata").hide();
		//			$("#auditWrapper > .hideifnodata").hide();
		//			$("#eventWrapper > .showifnodata").hide();
		//			$("#eventWrapper > .hideifnodata").hide();
		//			$("#eventWrapper").removeClass("showingOne");
		//			$("#auditWrapper").removeClass("showingOne");

		if (!showAuditChart && !showEventChart) {
			$("#auditChartTitle").html("");
			$("#eventChartTitle").html("");
			$("#auditWrapper > .hideifnodata").hide();
			$("#eventWrapper > .hideifnodata").hide();
			$("#auditWrapper > .showifnodata").show();
			$("#groupByPanel").attr("disabled", "disabled");
		} else if (showAuditChart && !showEventChart) {
			$("#eventWrapper > .hideifnodata").hide();
			$("#auditWrapper > .hideifnodata").show();
			$("#auditWrapper").addClass("showingOne");
			$("#groupByPanel").removeAttr("disabled");

			$("#eventChartTitle").html("");
			createRaphaelBarchart(data1.auditChart, "barChartContainer", true);
		} else if (showEventChart && !showAuditChart) {
			$("#auditWrapper > .hideifnodata").hide();
			$("#eventWrapper > .hideifnodata").show();
			$("#eventWrapper").addClass("showingOne");
			$("#groupByPanel").removeAttr("disabled");

			$("#auditChartTitle").html("");
			createRaphaelBarchart(data1.eventChart, "eventBarChartContainer", true);
		} else {
			$("#auditWrapper > .showifnodata").hide();
			$("#eventWrapper > .showifnodata").hide();
			$("#auditWrapper > .hideifnodata").show();
			$("#eventWrapper > .hideifnodata").show();
			$("#groupByPanel").removeAttr("disabled");
			$("#eventWrapper").removeClass("showingOne");
			$("#auditWrapper").removeClass("showingOne");
			createRaphaelBarchart(data1.auditChart, "barChartContainer", false);
			createRaphaelBarchart(data1.eventChart, "eventBarChartContainer", true);
		}
		report.requestString.searchString = $('#searchstring').val();

		if ($.inArray('audit', report.requestString.reportType) != 0)
			$("#auditTrail").hide();
		else
			Reports.configureClientSideTable('auditTrail', 'Audit Trail Table', data1.auditTrail);

		if ($.inArray('event', report.requestString.reportType) != 0 &&
				$.inArray('event', report.requestString.reportType) != 1)
			$("#eventDetails").hide();
		else
			Reports.configureClientSideTable('eventDetails', 'Events Table', data1.eventDetails);

		updateBreadCrumb();
	};

	report.updateRequestString = function() {
		updateReportOptions();
		timeFrame.updateTimeRange();
	};

	report.init();
	report.customizeTable = function(dataTable) {
	};

	this.breadCrumbClick = function(index) {
		if (index == 0) {
			if (this.requestString.reportFilters == null || report.requestString.reportFilters.length == 0) {
				return;
			}
			report.requestString.reportFilters = [];
			report.requestString.groupBy = report.requestString.distribution;
		} else if (report.requestString.reportFilters != null) {
			if (index == report.requestString.reportFilters.length)
				return;
			else {
				report.requestString.groupBy = report.requestString.reportFilters[index].entityType;
				var i = 0;
				for (i = report.requestString.reportFilters.length - 1; i >= index; i--)
					report.requestString.reportFilters.pop();
			}
		}
		chartOtherDrillIndex = 0;
		report.requestString.othersLevel = 0;
		report.processReport();

	};

	$("#groupByPanel").change(function() {
		$("#groupByPanel option:selected").each(function() {
			handleGroupByChange($(this).attr('id'));
		});
	});

	function handleGroupByChange(distribution) {
		//			chartDrillDown(0,"","", distribution);
	}

	function chartDrillDown(entityId, entityName, type, distribution) {
		if (distribution != null) {
			report.requestString.reportFilters = [];
			report.requestString.groupBy = distribution;
			report.requestString.distribution = distribution;
			report.requestString.othersLevel = 0;
			chartData = null;
			chartOtherDrillIndex = 0;
			report.processReport();
		} else if (entityId == -1) {
			chartOtherDrillIndex++;
			report.requestString.othersLevel = chartOtherDrillIndex;
			report.updateHash(true);
			var currentData = [];
			var seriesCount = 0;
			var startIndex = chartOtherDrillIndex * MAX_NUM_PIE_SLICE - 1;

			for (; startIndex < chartData.length && seriesCount < MAX_NUM_PIE_SLICE; startIndex++, seriesCount++) {
				currentData.push(chartData[startIndex]);
			}

			if (startIndex < chartData.length - 1) {
				var total = 0;
				while (startIndex++ < chartData.length - 1)
					total += chartData[startIndex].y;

				currentData.push({
					"name" : "Others",
					"y" : total,
					"id" : -1
				});
			}
			createRaphaelchart(currentData);
		} else {
			chartOtherDrillIndex = 0;
			report.requestString.othersLevel = 0;
			if (report.requestString.groupBy == "User")
				return;
			var entity = new Object;
			entity.entityId = entityId;
			entity.entityName = entityName;
			entity.entityType = type;
			entity.order = report.requestString.reportFilters.length;
			report.requestString.reportFilters.push(entity);

			if (report.requestString.groupBy == "PlayBack") {
				if (report.requestString.groupBy == "PlayBack")
					report.requestString.groupBy = "User";
			} else if (report.requestString.distribution == "User") {
				if (report.requestString.groupBy == "User")
					report.requestString.groupBy = "PlayBack";
			}
			report.processReport();
		}

	}

	function updateBreadCrumb() {
		//clear the breadcrumb
		$("#breadCrumbPanel").empty();

		var counter = 0;
		var id = 'path' + counter;
		$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>All</li>');
		$("#" + id).click(function() {
			breadCrumbClick(this.id.substring('path'.length));
		});
		counter++;
		if (report.requestString.reportFilters != null) {
			$.each(report.requestString.reportFilters, function(index, value) {
				id = 'path' + counter;
				$("#breadCrumbPanel").append('<li class="breadcrumb" id=' + id + '>' + value.entityName + '</li>');
				$("#" + id).click(function() {
					breadCrumbClick(this.id.substring('path'.length));
				});
				counter++;
			});

		}
		$('#breadCrumbPanel li').last().css('background-image', 'none');
		$("#breadCrumbPanel").append('<li class="endBreadcrumb"></li>');
	}

	function createRaphaelchart(currentData) {
		$("#piechartcontainer").empty();
		var values = $.map(currentData, function(node) {
			return node["y"];
		});
		currentData.values = values;
		var labels = $.map(currentData, function(node) {
			return node["name"] + " - " + node["y"];
		});
		var events = {};
		events.clickFtn = [];
		if (report.requestString.groupBy != "User") {
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				events.clickFtn[i] = function() {
					//   		chartDrillDown(this.params.id, this.params.name, this.params.type, null);
				};
			}
		} else {
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				if (currentData[i].id == -1) { //Others
					events.clickFtn[i] = function() {
						//    		chartDrillDown(this.params.id, this.params.name, this.params.type, null);
					};
				}
			}
		}
		Raphael("piechartcontainer", 700, 400).pieChart(250, 180, 150, currentData, labels, 500, 40, "#fff", events);
		//$("#selectGrpDiv").css('visibility','visible');
	}

	function createRaphaelBarchart(data, chartDivSelector, flagLegends) {
		$("#" + chartDivSelector).empty();
		var r = Raphael(chartDivSelector);
		var txtattr = {
			font : "12px 'Fontin Sans', Fontin-Sans, sans-serif"
		};

		var xLabels = data["xLabels"];

		var height = 220, g = null;

		var totalPoints = data["chart"][0].length;

		var newData = [];

		for (i = 0; i < totalPoints; i++) {
			newData.push(data["chart"][0][i]);
		}

		var chart;
		if (flagLegends) {
			chart = r.barchart(25, 15, totalPoints * 70, height, newData, {
				nostroke : false,
				stacked : false,
				axis : "0 0 1 1",
				symbol : "circle",
				smooth : true,
				maxy : data["yMax"],
				type : "soft",
				axisxstep : totalPoints,
				axisystep : 3,
				totalpoints : 4,
				serieslabels : data["seriesLabels"],
				labelxpos : 400,
				labelypos : 20,
				notes : data["notes"],
				unitstr : data["unitStr"],
				colors : [ [ "red" ], [ "orange" ], [ "yellow" ], [ "green" ] ],
				xaxiswidth : 350
			}, data["popupLabels"]);
		} else {
			chart = r.barchart(25, 15, totalPoints * 70, height, newData, {
				nostroke : false,
				stacked : false,
				axis : "0 0 1 1",
				symbol : "circle",
				smooth : true,
				maxy : data["yMax"],
				type : "soft",
				axisxstep : totalPoints,
				axisystep : 3,
				totalpoints : 4,
				labelxpos : 400,
				labelypos : 20,
				colors : [ [ "red" ], [ "orange" ], [ "yellow" ], [ "green" ] ],
				notes : data["notes"],
				unitstr : data["unitStr"],
				xaxiswidth : 350
			}, data["popupLabels"]);
		}

		chart.hover(function() {
			g = this.bar.glow();
			hovertxt = r.text(0, 250, this.bar.popupLabel).attr({
				fill : '#555',
				stroke : "none",
				"font-size" : 12,
				"text-anchor" : 'start',
				"font-weight" : 500,
				"font-family" : "Helevetica,Arial,Sans-serif"
			});
			hoverPosX = (400 - hovertxt.getBBox().width) / 2;
			hovertxt.transform('t' + hoverPosX + ',0');
		}, function() {
			if (hovertxt)
				hovertxt.remove();
			if (g)
				g.remove();
		});

		//		    if(flagLegends) {
		//			    var z = 12;
		//			    for(var x=0; x <totalPoints; x++) {
		//			    	var legendLen = xLabels[x].length;
		//			    	var displayLabel=  xLabels[x];
		//					  if (legendLen > z) {
		//			    		displayLabel = displayLabel.substring(0,z-5) + " ... " + displayLabel.substring(legendLen-5,legendLen);
		//					  }
		//	//		    	chart.axis[0].text.items[x].attr({'text': displayLabel});
		//			    }
		//		    }
	}

	function updateReportOptions() {
		report.requestString.playBack = new Array();
		report.requestString.playBack.push($('#playBackLevels').val());

		report.requestString.searchString = $('#searchstring').val();

		if (usersList != null) {
			usersList.populateRequestString();
		}

		requestString.reportType = new Array();
		$(".reportFilters").each(function() {
			if ($(this).attr('data-state') == 'checked')
				report.requestString.reportType.push($(this).attr('id'));
		});
	}

	report.defaultSortColumn = function() {
		return 'ID';
	};
}

$(document).ready(function() {
	AuditTrailReport();
});

function usersList(options) {
	this.policyUl = options.id;
	this.list = options.list;

	this.buildList = function(policyUl, list) {
		$.each(list, function(key, value) {
			if (key == 0) {
				$("#" + policyUl).html('<option value="all">' + value + '</option>');
				return;
			}
			$("#" + policyUl).append('<option value=' + value + '>' + value + '</option>');
		});

	};

	this.updateList = function(list) {
		this.buildList(this.policyUl, list);
		this.list = list;
		$('#userList').multiselect({
			header : false,
			selectedList : 2
		});

		var userArr = report.requestString.users;
		if (userArr.length == 0) {
			$('#userList').multiselect("checkAll");
		}
		$.each(userArr, function(e) {
			var val = this;
			var target = $(":checkbox[value=" + val + "]");
			if (!target.attr("aria-selected")) {
				target.click();
			}
			;
		});

		$('#userList').bind("multiselectclick",
				function(event, ui) {
					if (ui.value == "all") {
						if (ui.checked) {
							$('#userList').multiselect("checkAll");
						} else {
							$('#userList').multiselect("uncheckAll");
						}
					} else {
						if (ui.checked) {
							if ($('#userList').multiselect("getChecked").length == (list.length - 1)) {
								$('#userList').multiselect("checkAll");
							}
						} else {
							$($('#userList').multiselect("widget").find("ul li")[1]).find("input")
									.removeAttr("aria-selected").attr("checked", false);
						}
					}

					var selections = $('#userList').multiselect("getChecked");
					if (selections.length == 0) {
						$('#userList').trigger('selectionChanged', false);
					} else {
						$('#userList').trigger('selectionChanged', true);
					}

				});

	};

	if (this.list)
		this.buildList(this.policyUl, this.list);

	this.getSelectedList = function() {
		return $('#userList').multiselect("getChecked");
	};

	this.setSelectedList = function(arr) {
		$('#userList').multiselect("widget").find(":checkbox").each(function() {
			if ($.inArray(this.value, arr) > -1) {
				this.click();
			}
		});
	};

	this.populateRequestString = function() {
		requestString.users = [];
		var selection = this.getSelectedList();
		if ($(selection[0]).attr('value') == 'all')
			requestString.users = [];
		else {
			$.each(selection, function(key, value) {
				requestString.users.push($(value).attr('value'));
			});

		}

	};

}