var chartData = null;
var chartOtherDrillIndex = 0;
var MAX_NUM_PIE_SLICE = 10;

function JobSummaryReport() {
	var commUniId = cvUtil.getParameter('commUniId');
	var mediaAgentFilterPanel;
	//	this.clientPanel = null;
	this.timeFrame = null;
	initializedComp = false;

	this.report = new Reports.initReport({
		type : 'jobsummary',
		generateButtonId : 'btngenerate',
		reportTitle : 'Job Summary',
		chartIds : [ 'piechartcontainer' ]
	});
	this.requestString = report.requestString;
	report.initializeDefaults = function() {
		report.requestString["type"] = "JobSummary";
		report.requestString["commUniId"] = commUniId;
		report.requestString.backupType = [ "full", "incremental", "differential", "synthetic", "transactionlog" ];
		report.requestString.jobStatus = [ "all" ];
		report.requestString.timeFrameType = "relative";
		report.requestString.frequency = "Hourly";
		report.requestString.lastN = 24;
		report.requestString.groupBy = "JobStatus";
		report.requestString.distribution = "JobStatus";
		report.requestString.reportFilters = [];
		report.requestString.clientFilter = [ "all" ];
		report.requestString.agentFilter = [ "all" ];
		report.requestString.mediaAgentFilter = [ "all" ];
		report.requestString.storagePolicyFilter = [ "all" ];
		report.requestString.groupFilter = [];
		report.requestString.advanced = [];
		report.requestString.retainedJobOption = 'ALL';
		report.requestString.operationType = [ "operationTypeAll" ];
		var today = new Date();
		report.requestString.endTime = "" + today.getFullYear() + pZ((today.getMonth() + 1)) + pZ(today.getDate()) +
				pZ(today.getHours()) + "00";

		if (window.location.search && window.location.search != "?commUniId=" + commUniId) {
			if (window.location.search.indexOf("clientFilter") === -1) {
				report.requestString.clientFilter = [];
			}
		}

	};

	var clientsAll, clientsBoxes, clientsGroupAll, clientsGroupBoxes, error_note, genBtn;
	function minimumSelectionCheck(checkall, boxes, note, errorClass, clientFlag) {
		var clientFilterListId = 'clientFilterList';
		if (isAllowIncludeAll !== 'true' && clientFlag) {
			checkall.parent().hide();
		}

		checkall.bind('checkedState', function() {
			boxes.each(function() {
				checkCb($(this));
			});
			$("." + errorClass).remove();
			error_note.children(":first").css("display", "block");

			if (error_note.is(":empty")) {
				error_note.css("visibility", "hidden");
				genBtn.attr("disabled", false);
				genBtn.removeClass("btnDisabled");
				error_note.append("<span id='removeMe'>&nbsp;</span>");
			}
			if (clientFlag) {
				checkall.is(clientsAll) ? clientsFlag = true : clientGroupsFlag = true;
			}
		});
		checkall.bind('unCheckedState', function() {
			boxes.each(function(index) {
				// 	if(index !=0) {
				unCheckCb($(this));
				// 	}
			});
			if (clientFlag) {
				checkall.is(clientsAll) ? clientsFlag = false : clientGroupsFlag = false;
				if (clientsFlag || clientGroupsFlag) {
					return;
				}
			}
			//	error_note.find("span").text(note);
			error_note.children("*").css("display", "none");
			$("#removeMe").remove();
			error_note.prepend("<span class='paintred " + errorClass + "'>" + note + "</span>");
			error_note.css("visibility", "visible");
			genBtn.attr("disabled", true);
			genBtn.addClass("btnDisabled");
		});
		$('.selectAllBoxButton').on("click", function() {
			$("." + errorClass).remove();
			error_note.children(":first").css("display", "block");
			if (error_note.is(":empty")) {
				error_note.css("visibility", "hidden");
				genBtn.attr("disabled", false);
				genBtn.removeClass("btnDisabled");
				error_note.append("<span id='removeMe'>&nbsp;</span>");
			}
			if (clientFlag) {
				($(this).closest('ul').attr('id') == clientFilterListId) ? clientsFlag = true : clientGroupsFlag = true;
			}
		});
		// check 'all' if all are checked
		boxes.each(function() {
			$(this).bind('checkedState', function() {
				var all = true;
				boxes.each(function() {
					if ($(this).attr("data-state") == "unchecked") {
						all = false;
						return false;
					}
				});
				if (clientFlag && all && checkall.parent().is(':hidden')) {
					all = false;//because selected only all search items
				}
				if (all) {
					if (checkall.attr("data-state") == "unchecked") {
						checkCb(checkall);
					}
				}

				$("." + errorClass).remove();
				error_note.children(":first").css("display", "block");
				if (error_note.is(":empty")) {
					error_note.css("visibility", "hidden");
					genBtn.attr("disabled", false);
					genBtn.removeClass("btnDisabled");
					error_note.append("<span id='removeMe'>&nbsp;</span>");
				}
				if (clientFlag) {
					($(this).closest('ul').attr('id') == clientFilterListId) ? clientsFlag = true : clientGroupsFlag = true;
				}
			});
			$(this).bind('unCheckedState', function() {
				if (checkall.attr("data-state") == "checked") {
					unCheckCb(checkall);
				}
				var all = true;
				boxes.each(function() {
					if ($(this).attr("data-state") == "checked") {
						all = false;
						return false;
					}
				});
				if (clientFlag) {
					if (all) {
						($(this).closest('ul').attr('id') == clientFilterListId) ? clientsFlag = false : clientGroupsFlag = false;
					}
					if (clientsFlag || clientGroupsFlag) {
						return;
					}
				}
				if (all) {
					error_note.children("*").css("display", "none");
					$("#removeMe").remove();
					error_note.prepend("<span class='paintred " + errorClass + "'>" + note + "</span>");
					error_note.css("visibility", "visible");
					genBtn.attr("disabled", true);
					genBtn.addClass("btnDisabled");
					//		checkCb($(boxes[0]));
				}
			});

		});

		$('.clearBoxButton').on("click", function() {
			var all = true;
			boxes.each(function() {
				if ($(this).attr("data-state") == "checked") {
					all = false;
					return false;
				}
			});
			if (clientFlag) {
				if (all) {
					($(this).closest('ul').attr('id') == clientFilterListId) ? clientsFlag = false : clientGroupsFlag = false;
				}
				if (clientsFlag || clientGroupsFlag) {
					return;
				}
			}
			if (all) {
				error_note.children("*").css("display", "none");
				$("#removeMe").remove();
				error_note.prepend("<span class='paintred " + errorClass + "'>" + note + "</span>");
				error_note.css("visibility", "visible");
				genBtn.attr("disabled", true);
				genBtn.addClass("btnDisabled");
				//		checkCb($(boxes[0]));
			}
		});
	}

	report.initComponents = function() {
		$('#settingsLink').hide();
		timeFrame = new TimeFrame.frame({
			"requestString" : report.requestString
		});

		// Job Status "All" checkbox handling:
		error_note = $("#jobstatus-error"), genBtn = $('#btngenerate');
		var jobStatusAll = $("#all"), jobStatusBoxes = $(".jobstatus"), clientsFlag, clientGroupsFlag;
		var operationTypeAll = $("#operationTypeAll"), operationTypeBoxes = $(".operationType");

		minimumSelectionCheck(jobStatusAll, jobStatusBoxes, localMsg.jobsummary.ErrorNoteJobStatus, "jobStatusError");
		minimumSelectionCheck(operationTypeAll,
				operationTypeBoxes,
				localMsg.jobsummary.ErrorNoteOperationType,
				"operationTypeError");

		var backuptypes = $(".backuptype");

		backuptypes.each(function() {
			var cbox = $(this);

			cbox.bind('unCheckedState', function() {
				var all = false;
				backuptypes.each(function() {
					if ($(this).attr("data-state") == "checked") {
						all = true;
					}
				});
				if (all == false) {
					error_note.children("*").css("display", "none");
					$("#removeMe").remove();
					error_note.prepend("<span class='paintred backupTypeError'>" +
							localMsg.jobsummary.ErrorNoteBackupType + "</span>");
					error_note.css("visibility", "visible");
					genBtn.attr("disabled", true);
					genBtn.addClass("btnDisabled");
				} else {
					$(".backupTypeError").remove();
					error_note.children(":first").css("display", "block");
					if (error_note.is(":empty")) {
						error_note.css("visibility", "hidden");
						genBtn.attr("disabled", false);
						genBtn.removeClass("btnDisabled");
						error_note.append("<span id='removeMe'>&nbsp;</span>");
					}
				}
			});
			cbox.bind('checkedState', function() {
				$(".backupTypeError").remove();
				error_note.children(":first").css("display", "block");
				if (error_note.is(":empty")) {
					error_note.css("visibility", "hidden");
					genBtn.attr("disabled", false);
					genBtn.removeClass("btnDisabled");
					error_note.append("<span id='removeMe'>&nbsp;</span>");
				}
			});
		});

		$("#viewButtons>ul>li").click(function() {
			$("#viewButtons>ul>.on").removeClass("on");
			$(this).addClass("on");
			if (initializedComp == true) {
				if (report.requestString.invisible.initializeDefaults == true) {
					return;
				}
				report.REFRESH_REPORT_FILTERS_ONGENERATE = true;

				handleGroupByChange($("#viewButtons").find("li.on").attr('id'));

				report.REFRESH_REPORT_FILTERS_ONGENERATE = false;
			}
		});

		$("#selectionHead").on("click", function() {
			$("#clientDetailPanel").toggle();
			$("#selectionArrow").toggleClass("up");
		});

		$("#groupSelectionHead").on("click", function() {
			$("#groupDetailPanel").toggle();
			$("#groupSelectionArrow").toggleClass("up");
		});

		$("#filterPanel").accordion({
			'collapsible' : true,
			'heightStyle' : "content"
		});

		$("#clearAllClients").click(function(e) {
			$.each($('#clientFilterList .custom-cb.checked'), function(index, value) {
				unCheckCb($(this));
			});

			e.stopPropagation();
		});

		$("#clearAllClientGroups").click(function(e) {
			$.each($('#clientGroupsFilterList .custom-cb.checked'), function(index, value) {
				unCheckCb($(this));
			});

			e.stopPropagation();
		});

		$("#clearAllMAs").click(function(e) {
			$.each($('#mediaAgentFilterList .custom-cb.checked'), function(index, value) {
				unCheckCb($(this));
			});

			e.stopPropagation();
		});
		$('#clientSelectionPanel #clientsSearch').bind("searchKey",
				function(e) {
					var searchResults = $.grep(report.clients, function(elem) {
						return elem.toLowerCase().indexOf(e.target.value.toLowerCase()) > -1;
					});
					if (searchResults.length > 100) {
						//$("#tooManyClientMsg").show().delay(5000).fadeOut();
						searchResults = searchResults.slice(0, 100);
						clientFilterPanel.updateList(searchResults);
					} else if (searchResults.length > 0) {
						clientFilterPanel.updateList(searchResults);
					} else {
						//$("#clientMsg").show().delay(5000).fadeOut();
						clientFilterPanel.updateList(searchResults);
					}
					clientsAll = $("#clientFilterList_AllCheckBox"), clientsBoxes = $(".clientFilterList");
					minimumSelectionCheck(clientsAll,
							clientsBoxes,
							localMsg.jobsummary.ErrorNoteClientorClientGroup,
							"clientOrClientGroupError",
							true);
				});

		$('#clientSelectionPanel #clientsSearch').keyup(function(e) {
			if (report.clients.length > 100) {
				$(this).trigger("searchKey");
			}
		});
		$(".searchBelowULlist").keyup(function(e) {
			if (e.keyCode == 27) {
				$(this).val("");
			}
			searchActionForULList($(this));
		});
		$("#filter-panel-wrapper .search-close-icon").click(function() {
			var searchBelowULlist = $(this).siblings(".searchBelowULlist");
			searchBelowULlist.val("");
			searchActionForULList(searchBelowULlist);
		});

		$("#filter-panel-wrapper .msg-close-icon").click(function() {
			$("#clientMsg").hide();
		});
		chartOtherDrillIndex = 0;

	};

	report.initComponentState = function() {
		initializedComp = false;
		$.each(report.requestString.backupType, function(index, value) {
			checkCb($('#' + value));
		});
		$.each(report.requestString.jobStatus, function(index, value) {
			if (value == 'all') {
				checkCb($('#' + value));
				$('#' + value).trigger('checkedState');
			} else {
				checkCb($('#' + value));
			}
		});

		$.each(report.requestString.operationType, function(index, value) {
			if (value == 'operationTypeAll') {
				checkCb($('#' + value));
				$('#' + value).trigger('checkedState');
			} else {
				checkCb($('#' + value));
			}
		});
		$.each(report.requestString.advanced, function(index, value) {
			checkCb($('#' + value));
			if (value == 'includeRetainedJobs') {
				$('#' + value).trigger('checkedState');
			}
		});

		if (report.requestString.retainedJobOption) {
			$("input[name=includeRetainedJobsOptions][value=" + report.requestString.retainedJobOption + "]")
					.prop('checked', true);
		}

		clientFilterPanel = new EntitySelection({
			id : "clientFilterList",
			isAllowIncludeAll : isAllowIncludeAll === 'true'
		});
		clientGroupsFilterPanel = new EntitySelection({
			id : "clientGroupsFilterList",
			isAllowIncludeAll : isAllowIncludeAll === 'true'
		});
		agentFilterPanel = new EntitySelection({
			id : "agentFilterList",
			isAllowIncludeAll : isAllowIncludeAll === 'true'
		});
		mediaAgentFilterPanel = new EntitySelection({
			id : "mediaAgentFilterList",
			isAllowIncludeAll : isAllowIncludeAll === 'true'
		});
		storagePolicyFilterPanel = new EntitySelection({
			id : "storagePolicyFilterList",
			isAllowIncludeAll : isAllowIncludeAll === 'true'
		});

		var treeReqURL = cvUtil.getContextPath() +
				"/server/report?type=Common&component=CommServTree&entityType=31&reportType=" +
				report.requestString.type;
		cvUtil.loadPageWithPOST(treeReqURL, "", function(data) {
			if (data["clients"] != null) {
				report.clients = data["clients"];
				clientFilterPanel.updateList(data["clients"]);
			}

			if (data["agents"] != null) {
				agentFilterPanel.updateList(data["agents"].sort());
			}

			if (data["groups"] != null) {
				clientGroupsFilterPanel.updateList(data["groups"]);
			}

			if (data["mediaagents"] != null) {
				mediaAgentFilterPanel.updateList(data["mediaagents"]);
			}

			if (data["storagePolicies"] != null) {
				storagePolicyFilterPanel.updateList(data["storagePolicies"]);
			}
			if (report.requestString.clientFilter != null && report.requestString.clientFilter[0] != "all") {
				var clients = report.clients;
				if (report.clients.length > 100) {
					clients = report.clients.slice(0, 100);
				}
				var mergeList = clientFilterPanel.mergeSearchList(report.requestString.clientFilter, clients);
				clientFilterPanel.updateList(mergeList);
				clientFilterPanel.setSelectedList(report.requestString.clientFilter);
			} else {
				clientFilterPanel.setSelectedList(report.requestString.clientFilter);
			}

			if (report.requestString.agentFilter != null) {
				agentFilterPanel.setSelectedList(report.requestString.agentFilter);
			}

			if (report.requestString.mediaAgentFilter != null) {
				if (isAdminUser !== "true" && report.requestString.mediaAgentFilter.length > 0 &&
						report.requestString.mediaAgentFilter[0] === "all") {
					report.requestString.mediaAgentFilter = [];
				}

				mediaAgentFilterPanel.setSelectedList(report.requestString.mediaAgentFilter);
			}
			if (report.requestString.storagePolicyFilter != null) {
				storagePolicyFilterPanel.setSelectedList(report.requestString.storagePolicyFilter);
			}

			if (report.requestString.groupFilter != null && report.requestString.groupFilter.length != 0) {
				clientGroupsFilterPanel.setSelectedList(report.requestString.groupFilter);
			} else {
				$("#groupSelectionHead").click();
			}

			var agentAll = $("#agentFilterList_AllCheckBox"), agentBoxes = $(".agentFilterList");

			minimumSelectionCheck(agentAll, agentBoxes, localMsg.jobsummary.ErrorNoteAgents, "agentsError");

			/*
			 * By default we wont have a case where both of these are unchecked
			 */
			clientsFlag = true, clientGroupsFlag = false;

			clientsAll = $("#clientFilterList_AllCheckBox"),
					clientsBoxes = $(".clientFilterList"),
					clientsGroupAll = $("#clientGroupsFilterList_AllCheckBox"),
					clientsGroupBoxes = $(".clientGroupsFilterList");

			minimumSelectionCheck(clientsAll,
					clientsBoxes,
					localMsg.jobsummary.ErrorNoteClientorClientGroup,
					"clientOrClientGroupError",
					true);
			minimumSelectionCheck(clientsGroupAll,
					clientsGroupBoxes,
					localMsg.jobsummary.ErrorNoteClientorClientGroup,
					"clientOrClientGroupError",
					true);

			if (isAllowIncludeAll !== 'true') {
				clientFilterPanel.populateRequestString("clientFilter");
				clientGroupsFilterPanel.populateRequestString("groupFilter");
				agentFilterPanel.populateRequestString("agentFilter");
				mediaAgentFilterPanel.populateRequestString("mediaAgentFilter");
				storagePolicyFilterPanel.populateRequestString("storagePolicyFilter");
				report.updateHash(false);

			}

		});

		timeFrame.initComponentState({
			"requestString" : this.requestString
		});

		$("#viewButtons").find("li#" + report.requestString.distribution).click();
		initializedComp = true;
	};

	report.beforeLoadReport = function() {
		$("#chartPanel > .showifnodata").hide();
		$("#chartPanel > .hideifnodata").hide();
	};

	report.onLoadReport = function(data1) {
		if (data1 == 'null' || data1 == null) {
			$("#chartPanel > .showifnodata").show();
			$("#chartPanel > .hideifnodata").hide();
			$("#backupJobs").hide();
			$("#jobSummary").hide();
			//report.disableExport();
			return;
		}

		$.each(data1, function(key, value) {
			if (value.viewType == 'exactReplace') {
				$("#" + key).html(value.value);
				if (key == "sectionTitle") {
					$(document).attr('title', value.value);
				}
			}
			if (value.viewType == 'taskSummary') {
				$.each(value.value, function(itemName, itemValue) {
					var li = "";
					if (itemValue[0] == 'truncatedResultsWarning') {
						li = "<li class='col1'>" + itemValue[1] + "</li>";
					} else {
						li = taskSummaryTemplate.replace('{0}', itemValue[0]).replace('{1}', itemValue[1]);
					}
					$('#reportTaskSummary').append(li);
				});
			}
		});

		chartData = data1["chart"]["points"];
		var rows = 0;
		var rowsTotal = 0;
		while (rows < chartData.length) {
			rowsTotal += chartData[rows].y;
			rows++;
		}

		if (rowsTotal <= 0) {
			$("#chartPanel > .showifnodata").show();
			$("#chartPanel > .hideifnodata").hide();
			//report.disableExport();
		} else {
			$("#chartPanel > .showifnodata").hide();
			$("#chartPanel > .hideifnodata").show();
			//report.enableExport();
			var currentData = [];
			var i = 0;
			var maxSlice = MAX_NUM_PIE_SLICE - 1;
			if (chartData.length > MAX_NUM_PIE_SLICE) {
				for (i = 0; i < chartData.length && i < maxSlice; i++) {
					currentData.push(chartData[i]);
				}

				var total = 0;
				while (i < chartData.length) {
					total += chartData[i].y;
					i++;
				}

				currentData.push({
					"name" : "Others",
					"y" : total,
					"id" : -1
				});
			} else {
				currentData = chartData;
			}
			createRaphaelchart(currentData);
		}
		$("#chartTitle").html(data1.chart.chartTitle);
		$("#timeRangeLabel").html(data1.timeRange);

		timeFrame.setTimeZone(data1.timeZone, data1.tzOffset);

		if ($('#backupJobs').length > 0) {
			$("input[id*='_FilterSelected']").val('');
		}

		var dataColumns = data1.backupJobs.aoColumns;
		for (var i = 0; i < dataColumns.length; i++) {
			if (dataColumns[i].mDataProp == 'jobId') {
				dataColumns[i].rendererType = "jobIdColumn";
			} else if (dataColumns[i].mDataProp == 'ParentJobid') {
				dataColumns[i].rendererType = "parentJobIdColumn";
			}
		}

		Reports.configureClientSideTable('jobSummary', localMsg.summary, data1.jobSummary);

		if (typeof data1.jobSummaryQueryGuid != "undefined") {
			data1.backupJobs.jobSummaryQueryGuid = data1.jobSummaryQueryGuid;
		}

		Reports.configureTable('backupJobs',
				localMsg.jobsummary.backupJobs,
				data1.backupJobs,
				report.requestString,
				report.getRequestUrl);
		try {
			var visibleColumns = [];
			var columns = data1.backupJobs.aoColumns;
			for (var i = 0; i < columns.length; i++) {
				if (columns[i].bVisible) {
					visibleColumns.push(columns[i].mDataProp);
				}
			}
			Reports.columnModelForExport = {
				'columnModel' : visibleColumns,
				'totalRows' : data1.backupJobs.iTotalRecords
			};
			var totalCount = data1.backupJobs.iTotalRecords;
			var timeout = 20;
			if (totalCount > 30000) {
				totalCount = totalCount - 30000;
				timeout = 20 + Math.round(totalCount / 1000);
				if (window.reportExportConnectionTimeout < timeout) {
					window.reportExportConnectionTimeout = timeout;
				}
			}
		} catch (e) {
			console
					.log('Failed to generate big export metadata...ignoring error...export of more than 5000 rows may fail');
		}
		report.afterLoadReport();
		report.logReportLoadEvent('sectionTitle');
	};

	report.updateRequestString = function() {
		updateReportOptions();
		timeFrame.updateTimeRange();
		$("#viewButtons>ul>.on").removeClass("on");
		$("#viewButtons").find("li#" + report.requestString.distribution).addClass("on");
	};

	report.init();
	report.customizeTable = function(dataTable) {
	};

	report.breadCrumbClick = function(index) {
		if (report.requestString.reportFilters[index]) {
			if (index == 0) {
				if (this.requestString.reportFilters == null || report.requestString.reportFilters.length == 0) {
					return;
				}
				report.requestString.reportFilters = [];
				report.requestString.groupBy = report.requestString.distribution;
			} else if (report.requestString.reportFilters != null) {
				report.requestString.groupBy = report.requestString.reportFilters[index].entityType;
				var i = 0;
				for (i = report.requestString.reportFilters.length - 1; i >= index; i--) {
					report.requestString.reportFilters.pop();
				}
			}
			chartOtherDrillIndex = 0;
			report.requestString.othersLevel = 0;
			//		updateChartData();
			report.processReport();
		}

	};

	report.updateBreadCrumb = function() {
		$(".dynamicBreadcrumb").remove();

		var template = '<li class="dynamicBreadcrumb smartlinkMain withSeparatorMain"><a id="{2}" class="smartLinkMain" href="{0}">{1}</a></li>';
		var counter = 0;
		var id = 'path' + counter;

		var url = "#";
		var href = cvUtil.getContextPath() + '/reports/jobsummary.jsp?';
		var newRequestString = jQuery.extend(true, {}, report.requestString);
		delete newRequestString['reportFilters'];
		delete newRequestString['groupBy'];
		if (report.requestString.reportFilters == undefined || jQuery.isEmptyObject(report.requestString.reportFilters)) {
			url = window.location.href;
		} else {
			newRequestString['groupBy'] = newRequestString['distribution'];
			url = href + report.getURLFromRequest(newRequestString);
		}

		// The url is not required for breadcrumb as report.breadCrumbClick will take care of the setting the state.
		//$("#breadcrumbMain").append(template.replace('{0}', url).replace('{1}', report.reportTitle).replace('{2}', id));
		$("#breadcrumbMain").append(template.replace('{0}', '#').replace('{1}', report.reportTitle).replace('{2}', id));
		$("#" + id).click(function(e) {
			e.preventDefault();
			report.breadCrumbClick(this.id.substring('path'.length));
		});
		counter++;

		if (report.requestString.reportFilters && report.requestString.reportFilters != null &&
				report.requestString.reportFilters.length > 0) {

			$.each(report.requestString.reportFilters, function(index, value) {
				url = "#";

				if (index == report.requestString.reportFilters.length) {
					return;
				} else if (index == report.requestString.reportFilters.length - 1) {
					url = window.location.href;
				} else {
					newRequestString['groupBy'] = report.requestString.reportFilters[index + 1]['entityType'];
					newRequestString.reportFilters = newRequestString.reportFilters || [];
					newRequestString.reportFilters.push(report.requestString.reportFilters[index]);
					url = href + report.getURLFromRequest(newRequestString);
				}

				id = 'path' + counter;
				var title = decodeURI(value.entityName);
				if (value.display) {
					var args = title.split(";");
					if (args.length == 2) {
						title = cvUtil.cvLocalize(value.display, args[0], args[1]); //declared in ReportsJSMessages.properties
					}
					if (args.length == 1) {
						title = cvUtil.cvLocalize(value.display, args[0]);
					}
				}
				// The url is not required for breadcrumb as report.breadCrumbClick will take care of the setting the state.
				//$("#breadcrumbMain").append(template.replace('{0}', url).replace('{1}', title).replace('{2}', id));
				$("#breadcrumbMain").append(template.replace('{0}', '#').replace('{1}', title).replace('{2}', id));
				$("#" + id).click(function(e) {
					e.preventDefault();
					report.breadCrumbClick(this.id.substring('path'.length));
				});
				counter++;
			});
		}
	};

	report.updateFilters = function() {
		report.requestString.reportFilters = [];
		report.requestString.groupBy = report.requestString.distribution;
	};

	function handleGroupByChange(distribution) {
		chartDrillDown(0, "", "", distribution);
	}

	function chartDrillDown(entityId, entityName, type, distribution) {
		Reports.clearTableParams();
		if (distribution != null) {
			report.requestString.reportFilters = [];
			report.requestString.groupBy = distribution;
			report.requestString.distribution = distribution;
			report.requestString.othersLevel = 0;
			chartData = null;
			chartOtherDrillIndex = 0;
			//			updateChartData();
			report.processReport();
		} else if (entityId == -1) {
			chartOtherDrillIndex++;
			report.requestString.othersLevel = chartOtherDrillIndex;
			report.updateHash(true);
			var currentData = [];
			var seriesCount = 0;
			var startIndex = chartOtherDrillIndex * MAX_NUM_PIE_SLICE - 1;

			for (; startIndex < chartData.length && seriesCount < MAX_NUM_PIE_SLICE; startIndex++, seriesCount++) {
				currentData.push(chartData[startIndex]);
			}

			if (startIndex < chartData.length - 1) {
				var total = 0;
				while (startIndex++ < chartData.length - 1) {
					total += chartData[startIndex].y;
				}

				currentData.push({
					"name" : "Others",
					"y" : total,
					"id" : -1
				});
			}
			createRaphaelchart(currentData);
		} else {
			chartOtherDrillIndex = 0;
			report.requestString.othersLevel = 0;
			if (report.requestString.groupBy == "Client") {
				return;
			}

			var entity = {};
			entity.entityId = entityId;
			entity.entityName = entityName;
			entity.entityType = type;
			entity.order = report.requestString.reportFilters.length;
			//entity.URL = window.location.href;
			report.requestString.reportFilters.push(entity);

			//set the new groupBy
			if (report.requestString.distribution == "JobStatus") {
				if (report.requestString.groupBy == "JobStatus") {
					report.requestString.groupBy = "Agent";
				} else if (report.requestString.groupBy == "Agent") {
					report.requestString.groupBy = "Client";
				}
			} else if (report.requestString.distribution == "Agent") {
				if (report.requestString.groupBy == "Agent") {
					report.requestString.groupBy = "JobStatus";
				} else if (report.requestString.groupBy == "JobStatus") {
					report.requestString.groupBy = "Client";
				}
			} else if (report.requestString.distribution == "CommCell") {
				if (report.requestString.groupBy == "CommCell") {
					report.requestString.groupBy = "JobStatus";
				} else if (report.requestString.groupBy == "JobStatus") {
					report.requestString.groupBy = "Agent";
				} else if (report.requestString.groupBy == "Agent") {
					report.requestString.groupBy = "Client";
				}
			} else if (report.requestString.distribution == "ClientGroup") {
				if (report.requestString.groupBy == "ClientGroup") {
					report.requestString.groupBy = "JobStatus";
				} else if (report.requestString.groupBy == "JobStatus") {
					report.requestString.groupBy = "Agent";
				} else if (report.requestString.groupBy == "Agent") {
					report.requestString.groupBy = "Client";
				}
			}
			//			updateChartData();
			report.processReport();
		}

	}

	function createRaphaelchart(currentData) {
		$("#piechartcontainer").empty();
		var values = $.map(currentData, function(node) {
			return node["y"];
		});
		currentData.values = values;
		var labels = $.map(currentData, function(node) {
			return node["name"] + " - " + node["y"];
		});
		var events = {};
		events.clickFtn = [];
		if (report.requestString.groupBy != "Client") {
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				events.clickFtn[i] = function() {
					chartDrillDown(this.params.id, this.params.name, this.params.type, null);
				};
			}
		} else {
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				if (currentData[i].id == -1) { //Others
					events.clickFtn[i] = function() {
						chartDrillDown(this.params.id, this.params.name, this.params.type, null);
					};
				}
			}
		}

		this.colorFailed = "#ff3030";//"#FF3030"; //Red
		this.colorFailed3d = "#B22222";
		this.colorCompleted = "#15b822";//"#71C42B"; //Green
		this.colorCompleted3d = "#4E891E";
		this.colorCompletedError = "#ff9121";//"#EE6363";  //Amber
		this.colorCompletedError3d = "#995714";//"#A64646";
		this.colorCompletedWarning = "#f2f101";//"#FDD023"; //Yellow
		this.colorCompletedWarning3d = "#B19319";
		this.colorActive = "#0068fc";//"#1278B7"; //blue
		this.colorActive3d = "#0D5480";
		this.colorDelayed = "#8d38bc";//"#7250A5";  //purple
		this.colorDelayed3d = "#4F3773";
		this.colorKilled = "#530020";//"#53004B";  //Magenta
		this.colorKilled3d = "#3A0034";
		this.colorNoRun = "#84807c";//"#8B8682";	//Gray
		this.colorNoRun3d = "#615E5B";
		this.colorCommitted = "#00e6e6" //cyan
		this.colorCommitted3d = "#00b3b3" //cyan

		colors = [
				"#1278B7",
				"#4DB8DB",
				"#E8CF39",
				"#E1832C",
				"#A55B49",
				"#A58AA5",
				"#7250A5",
				"#2635A5",
				"#92A574",
				"#6AA923",
				"#8F7F49" ];
		colors3d = [
				"#0D5887",
				"#2AA3CB",
				"#D7BA19",
				"#C06B1B",
				"#83483A",
				"#8D6D8D",
				"#5A3F83",
				"#1C287D",
				"#788B5B",
				"#507F1A",
				"#6C5F37" ];

		if (report.requestString.groupBy == "JobStatus") {
			var i = 0;
			for (i = 0; i < currentData.length; i++) {
				var value = currentData[i].id;
				var name = currentData[i].name.toLowerCase();
				switch (value) {
				case 1://ReportJobStatus.COMPLETED
					colors[i] = colorCompleted;
					colors3d[i] = colorCompleted3d;
					break;
				case 2://ReportJobStatus.COMPLETED_WITH_ERRORS
					colors[i] = colorCompletedError;
					colors3d[i] = colorCompletedError3d;
					break;
				case 3://ReportJobStatus.COMPLETED_WITH_WARNINGS
					colors[i] = colorCompletedWarning;
					colors3d[i] = colorCompletedWarning3d;
					break;
				case 4://ReportJobStatus.FAILED
					colors[i] = colorFailed;
					colors3d[i] = colorFailed3d;
					break;
				case 5://ReportJobStatus.KILLED
					colors[i] = colorKilled;
					colors3d[i] = colorKilled3d;
					break;
				case 6://ReportJobStatus.DELAYED
					colors[i] = colorDelayed;
					colors3d[i] = colorDelayed3d;
					break;
				case 7://ReportJobStatus.ACTIVE
					colors[i] = colorActive;
					colors3d[i] = colorActive3d;
					break;
				case 8://ReportJobStatus.NO_RUN
					colors[i] = colorNoRun;
					colors3d[i] = colorNoRun3d;
					break;
				case 9://COMMITTED
					colors[i] = colorCommitted;
					colors3d[i] = colorCommitted3d;
					break;
				}
			}
			;

		}

		Raphael("piechartcontainer", 700, 300).pieChart(250,
				160,
				180,
				currentData,
				labels,
				500,
				40,
				"#fff",
				events,
				null,
				colors,
				colors3d);
		//$("#selectGrpDiv").css('visibility','visible');
	}

	function updateReportOptions() {
		report.requestString.backupType = [];
		$.each($(".backuptype"), function() {
			if ($(this).hasClass('checked')) {
				report.requestString.backupType.push($(this).attr('id'));
			}
		});
		report.requestString.jobStatus = [];

		var jobStatusAll = $("#all");
		if (jobStatusAll.hasClass("checked")) {
			report.requestString.jobStatus.push(jobStatusAll.attr('id'));
		} else {
			$.each($(".jobstatus"), function() {
				if ($(this).hasClass('checked')) {
					report.requestString.jobStatus.push($(this).attr('id'));
				}
			});
		}
		report.requestString.operationType = [];
		var operationTypeAll = $("#operationTypeAll");
		if (operationTypeAll.hasClass("checked")) {
			report.requestString.operationType.push(operationTypeAll.attr('id'));
		} else {
			$.each($(".operationType"), function() {
				if ($(this).hasClass('checked')) {
					report.requestString.operationType.push($(this).attr('id'));
				}
			});
		}

		report.requestString.advanced = [];
		$.each($(".advanced"), function() {
			if ($(this).hasClass('checked')) {
				report.requestString.advanced.push($(this).attr('id'));
			}
		});

		if ($('#includeRetainedJobs').hasClass('checked')) {
			var retainedJobOption = $("input[name='includeRetainedJobsOptions']:checked").val();
			report.requestString.retainedJobOption = retainedJobOption;
		}

		clientFilterPanel.populateRequestString("clientFilter");
		clientGroupsFilterPanel.populateRequestString("groupFilter");
		agentFilterPanel.populateRequestString("agentFilter");
		mediaAgentFilterPanel.populateRequestString("mediaAgentFilter");
		storagePolicyFilterPanel.populateRequestString("storagePolicyFilter");

		//		clientFilterPanelNew.populateRequestString("clientFilter");
		//		clientGroupsFilterPanelNew.populateRequestString("groupFilter");

	}

	function searchActionForULList(searchField) {
		var searchText = $(searchField).val().toLowerCase().trim();
		var targetUlListId = $(searchField).attr("data-target-ul");
		var targetUlList = $("#filter-panel-wrapper #" + targetUlListId);
		if ('clientFilterList' == targetUlListId) {
			if (searchText == "") {
				var clients = report.clients;
				if (report.clients.length > 100) {
					clients = report.clients.slice(0, 100);
				}
				clientFilterPanel.updateList(clients);

			}
			clientsAll = $("#clientFilterList_AllCheckBox"), clientsBoxes = $(".clientFilterList");
			minimumSelectionCheck(clientsAll,
					clientsBoxes,
					localMsg.jobsummary.ErrorNoteClientorClientGroup,
					"clientOrClientGroupError",
					true);
		}

		$(targetUlList).children("li").each(function() {
			if (searchText == "") {
				$(this).show();
			} else if ($(this).text().toLowerCase().indexOf(searchText) > -1) {
				$(this).show();
			} else {
				$(this).hide();
			}
		});
	}

	report.defaultSortColumn = function() {
		return 'jobId';
	};
	report.defaultSortOrder = function() {
		return 'desc';
	};
	report.getExportFilePrefix = function() {
		return "Job Summary";
	};

	function pZ(value) {
		if (value < 10) {
			return "0" + value;
		} else {
			return "" + value;
		}
	}
	window.bigExportSupported = true;

}

$(document).on("checkedState", "#includeRetainedJobs", function() {
	$('.include-retained-jobs-container').removeClass('disabled');
}).on("unCheckedState", "#includeRetainedJobs", function() {
	$('.include-retained-jobs-container').addClass('disabled');
});

$(document).ready(function() {
	JobSummaryReport();
	cvUtil.GUIAuditReportLog("Job Summary Report", "CommCell");

});
