var manageSchedules = {};
manageSchedules.performOperation = function(operation) {
	$("#schedulesList").mask();
	var params = {};
	params.operation = operation;
	var taskIds = $('.scheduleCB.checked').map(function() {
		return $(this).data('taskid');
	}).get();
	var subtaskIds = $('.scheduleCB.checked').map(function() {
		return $(this).data('subtaskid');
	}).get();
	params.taskIds = taskIds;
	params.subtaskIds = subtaskIds;
	cvUtil.loadPageWithPOST("reportBatchSchedules.do", params, function(response) {
		//		alert('Schedules ' + verbalize(operation) + ' successfully');
		$("#schedulesList").unmask("");
		if (response.data && response.data.isErrorResponse) {
			if (response.data.errorMessage) {
				cvUtil.errorToast(cvUtil.cvLocalize('Schedule_Op_Failed') + " :" + response.data.errorMessage);
			} else {
				cvUtil.errorToast(cvUtil.cvLocalize('Schedule_Op_Failed'));
			}
		} else {
			manageSchedules.refreshSchedulesTable();
			if (response && operation == "RUN") {
				if (response.data && response.data.output) {
					cvUtil.toast(response.data.output);
				}
			}
		}

	}, function() {
		$("#schedulesList").unmask("");
		cvUtil.errorToast(cvUtil.cvLocalize('Schedule_Op_Failed'));
	});
};

function getRowData(rows, taskid) {
	for (var i = 0; i < rows.length; i++) {
		if (rows[i]._aData.taskId === taskid) {
			return rows[i]._aData;
		}
	}

}

manageSchedules.selectionChanged = function() {
	var numSelected = $(".scheduleCB.checked").length;
	console.debug(numSelected + " schedules selected");
	if ($(".scheduleCB.unchecked").length < 1) {
		checkCb($("#selectAll", manageSchedules.oTable), false);
	} else {
		unCheckCb($("#selectAll", manageSchedules.oTable), false);
	}

	if ($(".scheduleCB.checked").length == 0) {
		$(".actionBtns", $(".actnBtnsDiv.manageSchedules")).addClass("disabled");
	} else {
		$(".actionBtns", $(".actnBtnsDiv.manageSchedules")).removeClass("disabled");
		var rows = manageSchedules.oTable.fnSettings().aoData;
		var allEnabled = true;
		var allDisabled = true;
		$.each($(".scheduleCB.checked"), function(index, row) {
			var rowData = getRowData(rows, $(this).data("taskid"));
			if (rowData && rowData.enabled === true) {
				allDisabled = false;
			}
		});

		$.each($(".scheduleCB.checked"), function(index, row) {
			var rowData = getRowData(rows, $(this).data("taskid"));
			if (rowData && rowData.enabled === false) {
				allEnabled = false;
			}
		});

		//		if (!allEnabled && !allDisabled) {
		//			$("#enableBtn").removeClass("disabled");
		//			$("#disableBtn").removeClass("disabled");
		//		} {
		if (allEnabled) {
			$("#enableScheduleBtn").addClass("disabled");
		}

		if (allDisabled) {
			$("#disableScheduleBtn").addClass("disabled");

		}
		//		}

	}

	//	if (allEnabled)
	//		$(".actnBtnsDiv.manageSchedules").addClass("disabled");
	//	else
	//		$(".actnBtnsDiv.manageSchedules").removeClass("disabled");
	//
	//
	//	if($(".scheduleCB.checked").length>0){
	//		$(".actnBtnsDiv.manageSchedules").removeClass("disabled");
	//	}
	//	else
	//		$(".actnBtnsDiv.manageSchedules").addClass("disabled");
};
manageSchedules.refreshSchedulesTable = function() {
	$("#schedulesList").mask();
	manageSchedules.oTable.fnReloadAjax(null, function() {
		$("#schedulesList").unmask("Loading");
	}, true);
	$(".actionBtns", $(".actnBtnsDiv.manageSchedules")).addClass("disabled");
};

manageSchedules.showEditScheduleModal = function(target, schedule) {
	var height = 640;
	if (!window.networkShareEnabled) {
		height = 640;
	}

	if (schedule.savedUrl.indexOf('reportsplus') !== -1) {
		height = 670;
	}
	cvUtil.showModal({
		width : 440,
		height : height,
		title : cvUtil.cvLocalize('editSchedule.title.page'),
		href : target,
		iframe : true
	}, null, function(returnData) {
		if (returnData) {
			if (returnData.cancel) {
				return;
			}
			manageSchedules.refreshSchedulesTable();
			if (returnData.isError && returnData.message) {
				cvUtil.errorToast(returnData.message, null, null, false);
			}
		} else {
			cvUtil.errorToast(cvUtil.cvLocalize('schedule.Operation_Failed'), null, null, false);
		}
	}, schedule);
	$('.ui-dialog-content').mask("");
}

manageSchedules.edit = function(taskId, schedule) {
	var target = cvUtil.getContextPath() + "/reports/editReportSchedule.do?";
	if (schedule.exportType == "EXECUTIVESUMMARY") {
		target = target + "showPPT=true&noAutofillExecSummary=true&";
	} else if (schedule.documentGUID) {//for customppt or customdoc
		var key = schedule.filePrefix;
		if (!key) {
			console.error('Error finding the document for the guid');
			cvUtil.errorToast(cvUtil.cvLocalize('Schedule_Loading_Failed'), null, null, false);
			return;
		}
		target = target + 'customDocumentName=' + key + '&clearDefaultExportTypes=true&';
		if (schedule.customDocumentInputs) {
			var inputList = [];
			schedule.customDocumentInputs.forEach(function(input) {
				inputList.push(input.key);
				target += 'customDocumentInput.' + input.key + '=' + input.value + '&';
			});
			if (inputList.length > 0) {
				target += 'customDocumentInputsList=' + inputList.join(',') + '&';
			}
		}

		target += cvUtil.createParamString('scheduleSettingsPage', "true");

	}

	if (schedule.filePrefix == "HealthReport") {
		target = target + cvUtil.createParamString("hideHTMLExport", "true");
	}
	
	var reportId = schedule.savedUrl ? cvUtil.getParameterByName("reportId",decodeURIComponent(schedule.savedUrl)) : undefined;		
	if(reportId) {
		var params = {
			reportId : reportId
		};
		$("#schedulesList").mask("");
		var api = cvUtil.getContextPath()+"/api/dcube/getReportHandlers";
		cvUtil.loadPageWithGET(api, params, function(data) {
			//if handlers are present then it's data cube data source. For data cube show only PDF and HTML formats
			$("#schedulesList").unmask("");
			if (data && data.data && data.data.length > 0) {
				target += cvUtil.createParamString('format', 'PDF,HTML');
			}
			manageSchedules.showEditScheduleModal(target,schedule);
		}, function() {
			$("#schedulesList").unmask("");
			//even if get handler call is failing show the default formats
			manageSchedules.showEditScheduleModal(target,schedule);
		});
	} else {
		manageSchedules.showEditScheduleModal(target, schedule);
	}	
};
manageSchedules.daysToRun = [ "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun" ];
$(document)
		.ready(function() {
			var config = {
				'bUseRendered' : false,
				"aoColumns" : [
						{
							"sTitle" : '<div id="selectAll" class="custom-cb unchecked" data-state="unchecked"></div>',
							"sWidth" : "25px",
							"mDataProp" : "actionEdit",
							"sWidth" : "25px",
							"bSortable" : false,
							"fnRender" : function(o, val) {
								return '<div data-taskid="' + o.aData.taskId + '"data-subtaskid="' + o.aData.subtaskId +
										'" class="custom-cb unchecked scheduleCB" data-state="unchecked"></div>';
							}
						},
						{
							"sTitle" : 'Name',
							"mDataProp" : "description",
							"sDefaultValue" : "1",
							"sWidth" : "200px",
							'bUseRendered' : false,
							'bFilterRendered' : false,
							"fnRender" : function(o, val) {
								var val = o.aData.disabled;
								var status;
								if (val) {
									status = '<span class="sprite icon-dot-gray" alt="Disabled" style="vertical-align: middle" title="Disabled"></span>';
								} else {
									status = '<span class="sprite icon-dot-green" alt="Enabled" style="vertical-align: middle" title="Enabled"></span>';
								}
								var sp = $('<span class="someLink editSchedule"></span>');
								sp.text(o.aData.description);
								sp.attr('data-taskid', o.aData.taskId);
								sp.css("padding-left", " 8px");
								return status + $('<div></div>').append(sp).html();
							}
						},
						{
							"sTitle" : 'Report Name',
							"mDataProp" : "filePrefix",
							"sDefaultValue" : "1",
							"sWidth" : "200px"
						},
						{
							"sTitle" : 'Format',
							"mDataProp" : "exportType",
							"sDefaultValue" : "PDF",
							"sWidth" : "90px",
							'fnRender' : function(o, val) {
								var returnVal = val;
								if (o && !!o.aData && !!o.aData.emailType && o.aData.emailType === 'EMBEDDED') {
									returnVal = cvUtil.cvLocalize('schedule.output_format_inline');
								}
								if (val == 'Custom Ppt') {
									returnVal = 'PPT';
								} else if (val == 'Custom Doc') {
									returnVal = 'DOC';
								}else if (val == 'ZIP') {
									returnVal = 'CSV';
								}
								return returnVal;
							}
						},
						{
							"sTitle" : 'Frequency',
							"mDataProp" : "freqType1",
							"sDefaultValue" : "Daily",
							'bFilterRendered' : false,
							"sWidth" : "90px",
							'fnRender' : function(o, val) {
								if (o.aData.freqType == 'WEEKLY') {
									var returnVal = "";
									var daysToRun = o.aData.daysToRun;
									for (var i = 0; i < daysToRun.length; i++) {
										if (daysToRun[i]) {
											returnVal += "," + manageSchedules.daysToRun[i];
										}
									}
									if (returnVal) {
										returnVal = returnVal.substring(1);
									}
									return returnVal;
								} else if (o.aData.freqType == 'MONTHLY') {
									var returnVal = "Monthly - ";
									if (o.aData.repeatNFrequencey > 1) {
										returnVal = "Repeat every " + o.aData.repeatNFrequencey + " Months - ";
									}
									if (o.aData.dateOfMonth) {
										var dateOfMonth = o.aData.dateOfMonth;
										returnVal += "Day " + dateOfMonth;
									} else if (o.aData.weekOfMonth) {
										var dayOfWeek = o.aData.dayOfWeek;
										dayOfWeek = dayOfWeek.replace("_", " ");
										returnVal += o.aData.weekOfMonth + " " + dayOfWeek;
									}
									return returnVal;
								} else {
									return 'Daily';
								}
							}
						},
						{
							"sTitle" : 'Time',
							"mDataProp" : "actionDelete",
							"sDefaultValue" : "9:00 am",
							"sWidth" : "90px",
							'fnRender' : function(o, v) {
								var val = o.aData.activeStartTime;
								var hours = Math.floor(val / 3600);
								var minutes = Math.floor((val - hours * 3600) / 60);
								var am = 'am';
								if (hours == 0) {
									hours = 12;
								} else if (hours == 12) {
									hours = 24; //appear as 12 pm
								}

								if (hours > 12) {
									hours = hours - 12;
									am = 'pm';
								}
								if (minutes < 10) {
									minutes = '0' + minutes;
								}
								return hours + ":" + minutes + ' ' + am;
							}
						},
						{
							"sTitle" : 'Created By',
							"mDataProp" : "owner",
							"sDefaultValue" : "false",
							"sWidth" : "100px",
							'bUseRendered' : false,
							'bFilterRendered' : false,
							'fnRender' : function(o, v) {
								var val = o.aData.owner;
								return val;
							}
						},
						{
							"sTitle" : 'Email Recipient(s)',
							"mDataProp" : "emails",
							"sDefaultValue" : "false",
							'bUseRendered' : false,
							"sWidth" : "200px"
						},
						{
							"sTitle" : 'Recipient Users and Groups',
							"mDataProp" : "emailCommcellUsersList",
							'bUseRendered' : false,
							"sWidth" : "150px",
							"sDefaultValue" : "false",
							'fnRender' : function(o, v) {
								var valUsers = o.aData.emailCommcellUsersList.concat(o.aData.emailExternalUsersList);
								var valUserGroups = o.aData.emailUserGroupsList
										.concat(o.aData.emailExternalUsersGroupsList);
								var recipientHTML = '<span id="recipientUser' + o.iDataRow +
										'" class="recipientUserClass">';
								var valUsersName = [];
								valUsers.forEach(function(recipientUser, index) {
									if (recipientUser.userName) {
										valUsersName.push(recipientUser.userName)
									}
								});
								if (valUsersName.length > 1) {
									valUsersName.sort();
								}
								valUsersName.forEach(function(recipientUserName, index) {
									if (index == 0 && recipientUserName.length > 0) {
										recipientHTML += '<span hidden>Users : </span>';
									}
									if (recipientUserName.length > 0) {
										recipientHTML += recipientUserName;
									}
									if (index != valUsers.length - 1 && recipientUserName.length > 0) {
										recipientHTML += ', ';
									}
								});
								var valUsersGroupName = [];
								valUserGroups.forEach(function(recipientUserGroup, index) {
									if (recipientUserGroup.userGroupName) {
										valUsersGroupName.push(recipientUserGroup.userGroupName);
									}
								});
								if (valUsersGroupName.length > 0) {
									valUsersGroupName.sort();
								}
								valUsersGroupName.forEach(function(recipientUserGroupName, index) {
									if (index == 0 && recipientUserGroupName.length > 0) {
										if (valUsersName.length > 0) {
											recipientHTML += ", <span hidden>; </span>";
											recipientHTML += String.fromCharCode(13, 10);
										}
										recipientHTML += '<span hidden>User Groups : </span>';
									}
									if (recipientUserGroupName.length > 0) {
										recipientHTML += "<b>" + recipientUserGroupName + "</b>";
									}
									if (index != valUserGroups.length - 1 && recipientUserGroupName.length > 0) {
										recipientHTML += ', ';
									}
								});
								recipientHTML += "</span>";
								return recipientHTML;

							}
						} ],
				"sAjaxSource" : "reportSchedules.do",
				"fnServerParams" : function(aoData) {

				},
				"sDom" : "Rrt",
				"oColReorder" : {
					"iFixedColumns" : 1
				}
			};

			if (window.networkShareEnabled) {
				var networkPath = {
					"sTitle" : 'Network Path',
					"mDataProp" : "networkShare",
					"sDefaultValue" : "false",
					"sWidth" : "200px",
					'fnRender' : function(o) {
						if (o.aData.networkShare) {
							return o.aData.networkPath;
						} else {
							return "";
						}
					}
				}
				config.aoColumns.push(networkPath);
			}

			Table.tableDrawCallBack = function(oSettings) {
				$('#schedulesList' + CVTable.table + ' thead th').each(function(index, value) {
					$(value).attr('title', $(value).text());
				});
				$('#schedulesList' + CVTable.table + ' tbody td').each(function(index) {
					$this = $(this);
					var titleVal = $this.text();
					if (titleVal != '') {
						$this.attr('title', titleVal);
					}
				});
				$('#schedulesList' + CVTable.table + '>tbody>tr>td').each(function(index, value) {
					$(value).attr('data-label',
							$('#schedulesList' + ' thead th')[index %
									($('#schedulesList' + CVTable.table + ' thead th').length)].innerText);
				});
				$(".recipientUserClass").each(function(index, value) {
					var titleStr = value.parentElement.title;
					if (titleStr != " " && titleStr.lastIndexOf(" ; ") != -1) {
						var unrequired = titleStr.lastIndexOf(" ; ") - 1;
						value.parentElement.title = titleStr.substr(0, unrequired) + titleStr.substr(unrequired + 4);
					}
				});

			};

			manageSchedules.oTable = Table.configureAjaxTable('schedulesList', cvUtil
					.cvLocalize('schedule.label.existing'), cvUtil.cvLocalize('schedule.No_schedules'), config, cvUtil
					.cvLocalize('schedule.loading_error'));

			$(".schedulesFilter").click(function(event) {
				var gridId = $(this).attr('id');
				gridId = gridId.substring(0, gridId.lastIndexOf("_"));
				Table.tableFilterColumns(gridId);
				$(this).toggleClass("filterOn");
			});
			$("#schedulesList tbody").on("click", ".editSchedule", function() {
				var aaData = manageSchedules.oTable.fnSettings().aoData;
				for (var i = 0; i < aaData.length; i++) {
					if (aaData[i]._aData.taskId == $(this).data('taskid')) {
						manageSchedules.edit($(this).data('taskid'), aaData[i]._aData);
						return;
					}
				}
				console.error('TaskId of the click row not found in aaData of table.');
			});
			$("#schedulesList tbody")
					.on("checkedState unCheckedState", ".scheduleCB", manageSchedules.selectionChanged);
			$("#selectAll", manageSchedules.oTable).on("checkedState",
					function() {
						$(".scheduleCB").removeClass("unchecked").removeClass("indeterminate").addClass("checked")
								.attr("data-state", "checked");
						manageSchedules.selectionChanged();
					}).on("unCheckedState",
					function() {
						$(".scheduleCB").removeClass("checked").removeClass("indeterminate").addClass("unchecked")
								.attr("data-state", "unchecked");
						manageSchedules.selectionChanged();
					});
			$(".actnBtnsDiv.manageSchedules button").on('click', '', function(data) {
				if ($(this).hasClass("disabledActions")) {
					return;
				}
				manageSchedules.performOperation($(this).data('action'));
			});
		});
