var jobStatus = cvUtil.getParameter('jobStatus', -1);

function MSScorecardReport() {
	var NO_OF_MONTHS = 24;

	var type = cvUtil.getParameter('type', 'backup');
	var dcId = cvUtil.getParameter('dcId', 0);
	var startDate = cvUtil.getParameter('startDate');
	var endDate = cvUtil.getParameter('endDate');
	var jobStatus = cvUtil.getParameter('jobStatus');

	var dcName = cvUtil.getParameter('dcName');
	var repTitle = type.substr(0, 1).toUpperCase() + type.substr(1);

	this.report = new Reports.initReport({
		type : type,
		reportTitle : 'Scorecard - ' + repTitle
	});
	this.requestString = report.requestString;
	report.initializeDefaults = function() {
		report.requestString.type = type;
		if (dcId > 0) {
			report.requestString.dcId = dcId;
		}

		if (dcName) {
			report.requestString.dcName = dcName;
		}
		if (startDate) {
			report.requestString.startDate = startDate;
		}
		if (jobStatus) {
			report.requestString.jobStatus = jobStatus;
		}
	};

	report.initComponents = function() {
		var r = "<span id='rep_link' class='breadcrumbMain'><a class='withSeparatorMain' href='index.jsp#0'>Reports</a></span>";
		$(r).prependTo($('#headerLinks'));

		$('#actionsButton').hide();
		$('#buildYourOwnReport').hide();
		$('#settingsLink').hide();
		$('#sectionTitle').html('Scorecard - ' + repTitle);
		$(document).attr("title", 'Scorecard - ' + repTitle);

		var options = [];
		var dt = new Date();
		options.push("<option value='-1'>All</option>");
		for (var i = 0; i < NO_OF_MONTHS; i++) {
			var mm = moment(dt);
			var val = mm.startOf('month').format('MM/DD/YYYY');
			var dispStr = mm.startOf('month').format('MMM YYYY');
			var selected = '';
			if (jobStatus == '' && startDate == '' && i == 0) {
				selected = 'selected';
			}
			options.push("<option value='" + val + "' " + selected + ">" + dispStr + "</option>");
			dt.setMonth(dt.getMonth() - 1);
		}
		$('#month_list').html(options.join(''));
		if (startDate == '') {
			startDate = $("#month_list").val();
			report.requestString.startDate = startDate;
		}
	};

	report.initComponentState = function() {
		var selDate = startDate;
		if (endDate) {
			var mm = moment(startDate);
			selDate = mm.startOf('month').format('MM/DD/YYYY');
		}

		$("#month_list option[value='" + selDate + "']").attr('selected', 'selected');

		$(".msGenerate").click(function(el) {
			delete requestString["startDate"];
			delete requestString["endDate"];
			delete requestString["dcId"];
			delete requestString["jobStatus"];
			delete requestString["dcName"];

			startDate = $("#month_list").val();
			var sd = "";
			//if(startDate != '-1'){
			requestString["startDate"] = startDate;
			sd = '&startDate=' + startDate;
			//}
			if (jobStatus) {
				location.href = 'msbackupscorecard.jsp?type=' + type + sd;
			}
			report.mask("");

			updateTableData();
		});

		updateFilters();
	};

	report.getExportFilePrefix = function() {
		var filePre = "Scorecard-" + repTitle;
		return filePre;
	};

	report.beforeLoadReport = function() {

	};
	report.getRequestUrl = function() {
		return cvUtil.getContextPath() + '/server/msbackup.do?type=' + type + '&action=msscorecard&json=' +
				window.encodeURIComponent(JSON.stringify(this.requestString));
	};

	report.onLoadReport = function(data) {
		processResponse(data, true);
	};

	report.init();

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(data, initialLoad) {
		report.updateHash(true);
		if (data == undefined || data == null) {
			$("#ContentWrapper").hide();
			$("#noDataNotificationPanel").html(cvUtil.cvLocalize('Something_went_wrong_please_try_again'));
			$("#noDataNotificationPanel").show();
		} else if (data && data.error) {
			$("#ContentWrapper").hide();
			$("#noDataNotificationPanel").html(data.error);
			$("#noDataNotificationPanel").show();
			addSummarySection();
			//report.updateHash(true);
		} else {
			$("#ContentWrapper").show();
			$("#noDataNotificationPanel").hide();
			if (data && typeof data === 'object') {
				$("#filterDiv").show();
				if (data.totalScorecard) {
					var view = {};
					view.members = data.totalScorecard;
					//view.members.iDisplayLength = 10;
					view.collapsible = false;
					//view.filters=true;
					//view.exportExcel=true;
					view.alarm = true;
					view.title = 'Summary';

					var tableDiv = 'summaryTable';

					if ($("#" + tableDiv).length == 0) {
						$('#ContentWrapper').append(SurveyTemplates.makeReportTable(tableDiv, view));
					}
					var configTable = true;
					if ((!data.totalScorecard.aoColumns || data.totalScorecard.aoColumns.length == 0) &&
							(!data.totalScorecard.aoColumnDefs || data.totalScorecard.aoColumnDefs.length == 0)) {
						configTable = false;
					}
					if (configTable) {
						setFilterRendered(view.members.aoColumns);
						Reports.configureClientSideTable(tableDiv, view.title, view.members);
					}
					//$("#"+tableDiv+" .rptTblBtnEncDiv").append($("#"+tableDiv+"_table_length"));
					$("#" + tableDiv + " .dataTables_filter").hide();
					/*
					 * $("#"+tableDiv+" .rptTblBtnEncDiv").find('.dataTables_length').remove(); var
					 * pageLengthDiv = $("#"+tableDiv+"_table_wrapper .dataTables_length").detach();
					 * pageLengthDiv.appendTo($("#"+tableDiv+" .rptTblBtnEncDiv"));
					 */

					//addSummarySection(tableDiv);
				}
				if (data.tableModel) {
					var view = {};
					view.members = data.tableModel;
					view.members.iDisplayLength = 100;
					view.collapsible = false;
					view.filters = true;
					view.exportExcel = true;
					view.alarm = true;
					if (dcId > 0 || jobStatus > 0) {
						view.title = repTitle + ' Job Details By Job Status';
					} else {
						view.title = repTitle + ' Summary By Data Center';
					}
					var tableDiv = 'detailsTable';

					if ($("#" + tableDiv).length == 0) {
						$('#ContentWrapper').append(SurveyTemplates.makeReportTable(tableDiv, view));
					}
					var configTable = true;
					if ((!data.tableModel.aoColumns || data.tableModel.aoColumns.length == 0) &&
							(!data.tableModel.aoColumnDefs || data.tableModel.aoColumnDefs.length == 0)) {
						configTable = false;
					}
					if (configTable) {
						setFilterRendered(view.members.aoColumns);
						Reports.configureClientSideTableWithPaging(tableDiv, view.title, view.members);
					}
					$("#" + tableDiv + " .dataTables_filter").hide();
					$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
					var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
					pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));

					addSummarySection('summaryTable');
				}
				var dailyTableDiv = 'dailySummaryTable';
				if (data.dailyTableModel) {
					var view = {};
					view.members = data.dailyTableModel;
					view.members.iDisplayLength = 100;
					view.collapsible = false;
					view.filters = true;
					view.exportExcel = true;
					view.alarm = true;
					view.title = repTitle + ' Jobs By Day';

					if ($("#" + dailyTableDiv).length == 0) {
						$('#ContentWrapper').append(SurveyTemplates.makeReportTable(dailyTableDiv, view));
					}
					var configTable = true;
					if ((!data.dailyTableModel.aoColumns || data.dailyTableModel.aoColumns.length == 0) &&
							(!data.dailyTableModel.aoColumnDefs || data.dailyTableModel.aoColumnDefs.length == 0)) {
						configTable = false;
					}
					if (configTable) {
						setFilterRendered(view.members.aoColumns);
						Reports.configureClientSideTable(dailyTableDiv, view.title, view.members);
					}
					$("#" + dailyTableDiv + " .dataTables_filter").hide();
					$("#" + dailyTableDiv).show();
				} else {
					$("#" + dailyTableDiv).hide();
				}

			}
			report.afterLoadReport();
		}
	}//end of processResponse

	function updateTableData() {
		//delete requestString["drillFrom"];
		Reports.clearTableParams();
		var configURL = cvUtil.getContextPath() + '/server/msbackup.do?type=' + type + '&action=msscorecard&json=' +
				window.encodeURIComponent(JSON.stringify(report.requestString));
		report.mask("");
		cvUtil.loadPageWithPOST(configURL, "", function(data) {
			processResponse(data, false);
			report.afterLoadReport();
			var filterOn = $("#detailsTable_FilterButton").hasClass("filterOn");
			if (filterOn) {
				$("#detailsTable_FilterButton").toggleClass("filterOn");
			}
			updateFilters();
			report.unmask();
		});
	}//end of updateTableData

	function updateFilters() {
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
						}
					});
				}
				report.unmask();
			}, 100);
			report.unmask();
		});
	}//end of updateFilters
	function addSummarySection(tableDiv) {
		var showSummary = false;
		var summary = "<table id=\"reportSummary\">";
		summary += "<tr><td>Summary::&nbsp;</td><td></td>";
		if (jobStatus || exportRequest) {
			showSummary = true;
			if (dcName) {
				summary += "<td class='summaryCol'>" + cvUtil.cvLocalize('ms.stats.Data_Center') + ": </td><td>&nbsp;" +
						dcName + "</td>";
			}
			if (endDate) {
				summary += "<td class='summaryCol'>" + cvUtil.cvLocalize('Date') + ": </td><td>&nbsp;" + startDate +
						"</td>";
			} else {
				summary += "<td class='summaryCol'>" + cvUtil.cvLocalize('ms.card.Fiscal_Month') + ": </td><td>&nbsp;" +
						$('#month_list').find(':selected').text() + "</td>";
			}
			if (jobStatus > 0) {
				summary += "<td class='summaryCol'>" + cvUtil.cvLocalize('Job_Status') + ": </td><td>&nbsp;" +
						getJobStatusStr() + "</td>";
			}
		}
		summary += "</tr></table>";
		if (showSummary) {
			$("#msSummaryDiv").append(summary);
			$("#msSummaryDiv").show();
		} else {
			$("#msSummaryDiv").hide();
		}
	}
}

function getJobStatusStr() {
	var jstatus = cvUtil.cvLocalize('NA');
	if (jobStatus == 1) {
		jstatus = cvUtil.cvLocalize('Successful');
	} else if (jobStatus == 2) {
		jstatus = cvUtil.cvLocalize('Failed');
	} else if (jobStatus == 3) {
		jstatus = cvUtil.cvLocalize('Others');
	}
	return jstatus;
}

function convertMapToList(map) {
	var list = [];
	if (map) {
		$.each(map, function(key, val) {
			var temp = {};
			temp.id = key;
			temp.name = val;
			list.push(temp);
		});
		sortList(list);
	}
	return list;
}

function sortList(list) {
	if (list) {
		list.sort(function(a, b) {
			var nameA = a.name.toLowerCase();
			var nameB = b.name.toLowerCase();
			return (nameA < nameB) ? -1 : (nameA > nameB) ? 1 : 0;
		});
	}
}

function setFilterRendered(aoColumns) {
	var renderersResultingURLs = [ "MSSuccessJobs", "MSFailedJobs", "MSJobsRate" ];
	for (var i = 0; i < aoColumns.length; i++) {
		var renderer = aoColumns[i].rendererType;
		if (typeof renderer != 'undefined') {
			if ($.inArray(renderer, renderersResultingURLs) > -1) {
				aoColumns[i].bFilterRendered = false;
			}
		}
	}
}

$(document).ready(function() {
	MSScorecardReport();
});
