var msstats = {};

function MSStatisticsReport() {
	var SHOW_ENTITY_NAME_SIZE = 25;

	var type = cvUtil.getParameter('type', 'backup');
	var custId = cvUtil.getParameter('custId', 0);
	var dcId = cvUtil.getParameter('dcId', 0);
	var serverId = cvUtil.getParameter('serverId', 0);
	var dateType = cvUtil.getParameter('dateType', 1);
	var lastNdays = cvUtil.getParameter('lastNdays', 1);
	var startDate = cvUtil.getParameter('startDate');
	var endDate = cvUtil.getParameter('endDate');
	var serverName = cvUtil.getParameter('serverName');
	var showJobs = cvUtil.getParameter('showJobs');
	var showServersJobs = cvUtil.getParameter('showServersJobs');
	var repTitle = type.substr(0, 1).toUpperCase() + type.substr(1);

	this.report = new Reports.initReport({
		type : type,
		reportTitle : repTitle + ' Statistics'
	});
	this.requestString = report.requestString;
	report.initializeDefaults = function() {
		report.requestString.type = type;
		if (custId > 0) {
			report.requestString.custId = custId;
		}
		if (dcId > 0) {
			report.requestString.dcId = dcId;
		}
		if (serverId > 0) {
			report.requestString.serverId = serverId;
		}

		report.requestString.dateType = dateType;
		if (dateType == 1) {
			report.requestString.lastNdays = lastNdays;
		} else {
			lastNdays = -1;
		}
		if (startDate) {
			report.requestString.startDate = startDate;
		}
		if (endDate) {
			report.requestString.endDate = endDate;
		}
		if (serverName) {
			report.requestString.serverName = serverName;
		}
		if (showJobs) {
			report.requestString.showJobs = showJobs;
		}
		if (showServersJobs) {
			report.requestString.showServersJobs = showServersJobs;
			var serversCnt = cvUtil.getParameter('serversCnt', 0);

			report.requestString.serverList = [];
			for (var i = 0; i < serversCnt; i++) {
				var dId = cvUtil.getParameter('dId-' + i, 0);
				var sId = cvUtil.getParameter('sId-' + i, 0);
				var sName = cvUtil.getParameter('sName-' + i);

				if (sId > 0) {
					var serverInfo = {};
					serverInfo.dataCenterId = dId + '';
					serverInfo.serverId = sId + '';
					//serverInfo.customerId=custId+'';
					report.requestString.serverList.push(serverInfo);
				}
			}
		}
	};

	report.initComponents = function() {
		var r = "<span id='rep_link' class='breadcrumbMain'><a class='withSeparatorMain' href='index.jsp#0'>Reports</a></span>";
		$(r).prependTo($('#headerLinks'));

		$('#actionsButton').hide();
		$('#buildYourOwnReport').hide();
		$('#settingsLink').hide();
		$('#sectionTitle').html(repTitle + ' Statistics');
		$(document).attr("title", repTitle + ' Statistics');

		$("#from").datepicker({
			onClose : function(selectedDate) {
				$("#to").datepicker("option", "minDate", selectedDate);
			}
		});
		$("#to").datepicker({
			onClose : function(selectedDate) {
				$("#from").datepicker("option", "maxDate", selectedDate);
			}
		});

		setDefaultDates();
	};

	report.initComponentState = function() {

		$("input[name='dateType'][value='" + dateType + "']").prop('checked', true);
		if (dateType == 1) {
			$("#interval_list option[value='" + lastNdays + "']").attr('selected', 'selected');
		} else {
			$("#from").datepicker('setDate', startDate);
			$("#to").datepicker('setDate', endDate);
		}
		enableComponents(dateType);
		$("input[name=dateType]:radio").change(function(ele) {
			enableComponents($("input[name='dateType']:checked").val());
		});

		$(".msGenerate").click(function(el) {

			report.mask("");

			var customer = $("#customers").val();
			var dc = $("#datacenters").val();
			var repType = 1;
			if ($("input[name='dateType']:radio").length > 0) {
				repType = $("input[name='dateType']:checked").val();
			}
			if (repType == 2) {
				var result = validateDates();
				if (result == false) {
					report.unmask();
					return;
				}
			}
			serverId = 0;
			delete requestString["lastNdays"];
			delete requestString["startDate"];
			delete requestString["endDate"];
			delete requestString["serverId"];
			delete requestString["showJobs"];
			delete requestString["serverName"];
			showJobs = false;
			showServersJobs = false;
			if (requestString["showServersJobs"]) {
				delete requestString["showServersJobs"];
				delete requestString["serversCnt"];
				delete requestString["serverList"];
				delete requestString["sId"];
				delete requestString["sName"];
				delete requestString["dId"];
			}

			if (repType == 2) {
				startDate = $.datepicker.formatDate('mm/dd/yy', $('#from').datepicker('getDate'));
				requestString["startDate"] = startDate;

				endDate = $.datepicker.formatDate('mm/dd/yy', $('#to').datepicker('getDate'));
				requestString["endDate"] = endDate;
			} else {
				lastNdays = $("#interval_list").val();
				requestString["lastNdays"] = lastNdays;
			}
			requestString["custId"] = customer;
			requestString["dcId"] = dc;
			requestString["dateType"] = repType;
			updateTableData();
		});

		updateFilters();
	};

	report.beforeLoadReport = function() {

	};
	report.getRequestUrl = function() {
		//return cvUtil.getContextPath() + '/server/msbackup.do?type='+type+'&action=msstats&json='+window.encodeURIComponent(JSON.stringify(this.requestString));
		return cvUtil.getContextPath() + '/server/msbackup.do?type=' + type + '&action=msstats';
	};

	report.getExportFilePrefix = function() {
		var filePre = repTitle + " Statistics";
		return filePre;
	};

	report.onLoadReport = function(data) {
		processResponse(data, true);
	};

	report.loadReport = function() {
		$("#ErrorPanel").hide();

		report.requestString.invisible.initializeDefaults = false;

		if (report.beforeLoadReport) {
			if (report.beforeLoadReport() === false) {
				return;
			}
		}

		if (window.cvCustomMask) {
			if (window.tempCvIdtoMask) {
				report.idtomask = window.tempCvIdtoMask;
				$("#" + report.idtomask).mask("");
			} else {
				$("#content").mask("");
			}
		} else {
			report.mask(this.idtomask);
		}

		if (report.getRequestUrl() != '') {

			var data = {
				'json' : JSON.stringify(report.requestString)
			};

			cvUtil.loadPageWithPOST(report.getRequestUrl(), data, function(data1) {
				try {
					report.onLoadReport(data1);

					$(".reportContent").show();
					report.unmask();
					if (report.getExportType() == Reports.PRINT) {
						window.print();
					}

				} catch (e) {
					report.unmask();
					$(".reportContent").hide();
					$("#error_message_default").show();
					$("#error_message").hide();
					$("#ErrorPanel").show();
					console.debug("Error occured while processing request " + e.message + "\n" + e.stack);
				}
			}, function(xhr, ajaxOptions, thrownError) {
				report.unmask();
				if (thrownError && thrownError == 'Unauthorized') {
					window.location = cvUtil.getContextPath() + "/login/index.jsp";
					return;
				}
				if (xhr.responseText && xhr.responseText != "") {
					$("#error_message").html(xhr.responseText).show();
					$("#error_message_default").hide();
				} else {
					$("#error_message_default").show();
					$("#error_message").hide();
				}
				$("#ErrorPanel").show();
				$(".reportContent").hide();
			});

		}
	};

	report.init();

	Reports.Renderers = Reports.Renderers || {};
	Reports.Renderers.serverSelectionRenderer = function(o, val) {
		var custId = o.aData['CustomerId<DONOTSHOW>'];
		var dcId = o.aData['DataCenterId<DONOTSHOW>'];
		var serverId = o.aData['ServerId<DONOTSHOW>'];
		var serverName = o.aData['Server<MSServer>'];

		serverName = $("<div/>").html(serverName).text();

		var html = $('<div name="serverSelectionChk" class="serverSelection custom-cb unchecked" data-state="unchecked"></div>');
		html.attr('data-custid', custId);
		html.attr('data-dcid', dcId);
		html.attr('data-serverid', serverId);
		html.attr('data-servername', serverName);
		var c = $('<div />').append(html);
		return c.html();
	};

	//------------------------------------------functions----------------------------------------------------------

	function processResponse(data, initialLoad) {
		if (data == undefined || data == null) {
			$("#ContentWrapper").hide();
			$("#noDataNotificationPanel").html(cvUtil.cvLocalize('Something_went_wrong_please_try_again'));
			$("#noDataNotificationPanel").show();
		} else {
			$("#ContentWrapper").show();
			$("#noDataNotificationPanel").hide();
			if (data && typeof data === 'object') {
				$("#filterDiv").show();
				if (data.propertyDimension) {
					customersList = convertMapToList(data.propertyDimension);
					var options = [];
					options.push("<option value='0'>All</option>");
					$.each(customersList, function(index, cust) {
						var cName = cust.name;
						if (cName.length > SHOW_ENTITY_NAME_SIZE + 3) {
							cName = cName.substr(0, SHOW_ENTITY_NAME_SIZE) + '...';
						}
						options
								.push("<option value='" + cust.id + "' title='" + cust.name + "'>" + cName +
										"</option>");
					});
					$('#customers').html(options.join(''));
					$("#customers option[value='" + report.requestString.custId + "']").attr('selected', 'selected');
				}
				if (data.dataCenters) {
					dataCenters = convertMapToList(data.dataCenters);
					var options = [];
					options.push("<option value='0'>All</option>");
					$.each(dataCenters, function(index, dc) {
						var cName = dc.name;
						if (cName.length > SHOW_ENTITY_NAME_SIZE + 3) {
							cName = cName.substr(0, SHOW_ENTITY_NAME_SIZE) + '...';
						}
						options.push("<option value='" + dc.id + "' title='" + dc.name + "'>" + cName + "</option>");
					});
					$('#datacenters').html(options.join(''));
					$("#datacenters option[value='" + dcId + "']").attr('selected', 'selected');
				}
				if (data.error) {
					$("#ContentWrapper").hide();
					$("#noDataNotificationPanel").html(data.error);
					$("#noDataNotificationPanel").show();
					//addSummarySection();
					report.updateHash(false);
				} else {
					if (data.summaryTable) {
						var view = {};
						view.members = data.summaryTable;
						//view.members.iDisplayLength = 100;
						view.collapsible = false;
						view.filters = false;
						//view.exportExcel=true;
						view.alarm = true;
						view.title = 'Summary';
						setFilterRendered(view.members.aoColumns);
						var tableDiv = 'summaryTable';
						if (initialLoad || $('#summaryTable').length == 0) {
							$('#ContentWrapper').append(SurveyTemplates.makeReportTable(tableDiv, view));
							if (initialLoad == false) {
								var st = $('#summaryTable').detach();
								st.prependTo($('#ContentWrapper'));
							}
						}

						var configTable = true;
						if ((!data.summaryTable.aoColumns || data.summaryTable.aoColumns.length == 0) &&
								(!data.summaryTable.aoColumnDefs || data.summaryTable.aoColumnDefs.length == 0)) {
							configTable = false;
						}
						if (configTable) {
							Reports.configureClientSideTable(tableDiv, view.title, view.members);
						}
						$('.dataTables_filter').hide();
						$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
						var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
						pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));

					}
					if (data.detailsTable) {
						var view = {};
						view.members = data.detailsTable;
						view.members.iDisplayLength = 100;
						view.collapsible = false;
						view.filters = true;
						view.exportExcel = true;
						view.alarm = true;

						var showServerSelection = false;
						if (serverId > 0 || showJobs || showServersJobs) {
							view.title = repTitle + ' Job Details';
						} else if (report.requestString.custId > 0) {
							view.title = 'Property Dimension Details';
							view.members.iDisplayLength = -1;
							showServerSelection = true;
						} else {
							view.title = 'Details';
						}
						if (exportRequest) {
							showServerSelection = false;
						}
						if (showServerSelection) {
							view.members.aoColumns
									.splice(0,
											0,
											{
												'sTitle' : '<div id="allServersChk" class="allServers custom-cb unchecked" data-state="unchecked"></div>',
												'sWidth' : '20px',
												'mDataProp' : 'selected',
												"bSortable" : false,
												'bUseRendered' : false,
												'bFilterRendered' : false,
												'rendererType' : 'serverSelectionRenderer'
											});

							$.each(view.members.aaData, function(i, row) {
								row.selected = false;
							});
						}
						setFilterRendered(view.members.aoColumns);
						var tableDiv = 'detailsTable';
						if ($('#' + tableDiv).length <= 0) {
							$('#ContentWrapper').append(SurveyTemplates.makeReportTable(tableDiv, view));
						} else {
							$("input[id*='_FilterSelected']").val('');
						}
						var configTable = true;
						if ((!data.detailsTable.aoColumns || data.detailsTable.aoColumns.length == 0) &&
								(!data.detailsTable.aoColumnDefs || data.detailsTable.aoColumnDefs.length == 0)) {
							configTable = false;
						}
						if (configTable) {
							Reports.configureClientSideTableWithPaging(tableDiv, view.title, view.members);
						}
						$('.dataTables_filter').hide();
						$("#" + tableDiv + " .rptTblBtnEncDiv").find('.dataTables_length').remove();
						var pageLengthDiv = $("#" + tableDiv + "_table_wrapper .dataTables_length").detach();
						pageLengthDiv.appendTo($("#" + tableDiv + " .rptTblBtnEncDiv"));
						$("#" + tableDiv + "_title").html(view.title);
						addSummarySection(tableDiv);
						/*
						 * if(data.totalRows > data.maxRows){ var title = 'This table is showing only
						 * '+data.maxRows+' of ' + data.totalRows + ' entries. Filters and Sorting will work
						 * on loaded data only. To view full data, please use CSV export.'; var note = "<span
						 * id='"+tableDiv+"_rows_note' class='tableRowsNote' title='"+title+"'>This table is
						 * showing partial data.</span>"; $("#"+tableDiv+" .rptTblBtnEncDiv").append(note); }
						 */
						if (showServerSelection) {
							$('#' + tableDiv + "_title_holder")
									.append("<span id='showJobs_button' class='actionButtons clearfix hideOnExportFriendly disabled msDisabled-events' title='View jobs for selected servers'>View Jobs</span>");
							$("#showJobs_button").click(function() {
								if (isChecked($('#allServersChk')) || $('.serverSelection.checked').length > 0) {
									var type = cvUtil.getParameter('type', 'backup');
									var custId = cvUtil.getParameter('custId', 0);
									var dcId = cvUtil.getParameter('dcId', 0);
									var dateType = cvUtil.getParameter('dateType', 1);
									var lastNdays = cvUtil.getParameter('lastNdays', -1);
									var startDate = cvUtil.getParameter('startDate');
									var endDate = cvUtil.getParameter('endDate');
									if (dateType == 2) {
										lastNdays = -1;
									}
									var params = "type=" + type + "&custId=" + custId + "&dateType=" + dateType +
											"&lastNdays=" + lastNdays + '&dcId=' + dcId;
									if (startDate) {
										params += "&startDate=" + startDate;
									}
									if (endDate) {
										params += "&endDate=" + endDate;
									}

									if (isChecked($('#allServersChk'))) {//All means property dimention
										params += '&showJobs=true';

									} else {//multiple servers
										if ($('.serverSelection.checked').length > 25) {
											cvUtil.errorToast('Maximum 25 servers can be selected.');
											return;
										}
										params += "&showServersJobs=true";

										var selected = $('.serverSelection.checked');
										var serversCnt = 0;
										$.each(selected, function(i, ele) {
											var dcid = $(ele).data("dcid");
											var serverid = $(ele).data("serverid");
											var servername = $(ele).data("servername");
											params += '&dId-' + i + '=' + dcid + '&sId-' + i + '=' + serverid +
													'&sName-' + i + '=' + servername;
											serversCnt++;
										});
										params += '&serversCnt=' + serversCnt;
									}
									var urlval = cvUtil.getContextPath() + "/reports/msbackupstats.jsp?" + params;
									window.location.href = urlval;
								} else {
									if (!$("#showJobs_button").hasClass('disabled')) {
										cvUtil.errorToast(cvUtil.cvLocalize('ms.stats.select_server'));
									}
								}
							});

							$('#' + tableDiv).on("checkedState", '.allServers', function() {
								checkCb($('.serverSelection'));
								$("#showJobs_button").removeClass('disabled');
							}).on("unCheckedState", function() {
								unCheckCb($('.serverSelection'));
								$("#showJobs_button").addClass('disabled');
							});
							var totalDetailRows = view.members.iTotalRecords;
							$('#' + tableDiv + ' tbody').on("checkedState", '.serverSelection', function(e) {
								var allSelected = (totalDetailRows === $('.serverSelection.checked').length);
								e.stopPropagation();
								if (allSelected) {
									checkCb($('#allServersChk'));
								} else {
									unCheckCb($('#allServersChk'));
									var selectedCb = $(this);
									if ($('.serverSelection.checked').length > 25) {
										cvUtil.toast(cvUtil.cvLocalize('ms.stats.Maximum_25_servers_error'));
										window.setTimeout(function() {
											unCheckCb(selectedCb, false);
										}, 5);
										return;
									}
								}
								if ($('.serverSelection.checked').length > 0) {
									$("#showJobs_button").removeClass('disabled');
								} else {
									$("#showJobs_button").addClass('disabled');
								}
							}).on("unCheckedState", '.serverSelection', function(e) {
								var allSelected = (totalDetailRows === $('.serverSelection.checked').length);
								e.stopPropagation();

								if (allSelected) {
									checkCb($('#allServersChk'));
								} else {
									unCheckCb($('#allServersChk'));
									var selectedCb = $(this);
									if ($('.serverSelection.checked').length > 25) {
										cvUtil.toast(cvUtil.cvLocalize('ms.stats.Maximum_25_servers_error'));
										window.setTimeout(function() {
											unCheckCb(selectedCb, false);
										}, 5);
										return;
									}
								}
								if ($('.serverSelection.checked').length > 0) {
									$("#showJobs_button").removeClass('disabled');
								} else {
									$("#showJobs_button").addClass('disabled');
								}
							});
						} else {
							$('#showJobs_button').remove();
						}
					}
				}//else - error
			}
		}
	}//end of processResponse

	function updateTableData() {
		Reports.clearTableParams();
		var configURL = cvUtil.getContextPath() + '/server/msbackup.do?type=' + type + '&action=entitytable&json=' +
				window.encodeURIComponent(JSON.stringify(report.requestString));
		report.mask("");
		cvUtil.loadPageWithPOST(configURL, "", function(data) {
			report.updateHash(false);
			processResponse(data, false);
			report.afterLoadReport();
			var filterOn = $("#detailsTable_FilterButton").hasClass("filterOn");
			if (filterOn) {
				$("#detailsTable_FilterButton").toggleClass("filterOn");
			}
			updateFilters();
			report.unmask();
		});
	}//end of updateTableData

	function updateFilters() {
		$(document).ajaxStart(function() {
			//report.mask("");
		}).ajaxStop(function() {
			// If the ajax completes but tables are not rendered attacheTableActions may fail.
			// This is not observed but just be sure, waiting for 100ms.
			setTimeout(function() {
				report.attachTableActions();
				if (!cvUtil.getParameter('exportType') && !$("body").hasClass("exportfriendly")) {
					$('.tableFilter').each(function(idx, elem) {
						if (!$(this).hasClass("filterOn") &&
								$(this).closest(".reportTable").find("table").hasClass("initialized")) {
							$(elem).click();
							if ($('#allServersChk').length > 0) {
								$('input#detailsTable_filterText-0').remove();
							}
						}
					});
				}
				report.unmask();
			}, 100);
			report.unmask();
		});
	}//end of updateFilters

	function addSummarySection(tableDiv) {
		var showSummary = false;
		var summary = "<table id=\"reportSummary\">";
		summary += "<tr><td><u>Summary</u></td><td></td></tr>";
		if (exportRequest) {
			showSummary = true;
			summary += "<tr><td>Property Dimension:</td><td> " + $('#customers').find(':selected').text() +
					"</td></tr>";
			summary += "<tr><td>Data Center:</td><td> " + $('#datacenters').find(':selected').text() + "</td></tr>";
			if (serverName) {
				summary += "<tr><td>Server:</td><td> " + serverName + "</td></tr>";
			}
			if (dateType == 1) {
				summary += "<tr><td>Interval:</td><td> " + $('#interval_list').find(':selected').text() + "</td></tr>";
			} else {
				sDate = $.datepicker.formatDate('mm/dd/yy', $('#from').datepicker('getDate'));
				eDate = $.datepicker.formatDate('mm/dd/yy', $('#to').datepicker('getDate'));
				summary += "<tr><td>Time Range:</td><td> " + sDate + " - " + eDate + "</td></tr>";
			}

		}
		if (showServersJobs) {
			showSummary = true;
			var serversCnt = cvUtil.getParameter('serversCnt', 0);
			var sName = '';
			for (var i = 0; i < serversCnt; i++) {
				sName += cvUtil.getParameter('sName-' + i) + '; ';
			}
			if (sName.length > 1) {
				sName = sName.substr(0, sName.length - 2);
			}
			summary += "<tr><td>Servers:</td><td> " + sName + "</td></tr>";
		}
		summary += "</table>";
		if (showSummary) {
			$("#msSummaryDiv").append(summary);
			$("#msSummaryDiv").show();
		} else {
			$("#msSummaryDiv").hide();
		}
	}
}
function setFilterRendered(aoColumns) {
	var renderersResultingURLs = [ "MSCustomer", "MSCustomerJobs", "MSServer" ];
	for (var i = 0; i < aoColumns.length; i++) {
		var renderer = aoColumns[i].rendererType;
		if (typeof renderer != 'undefined') {
			if ($.inArray(renderer, renderersResultingURLs) > -1) {
				aoColumns[i].bFilterRendered = false;
				aoColumns[i].bUseRendered = false;
			}
		}
	}
}
function convertMapToList(map) {
	var list = [];
	if (map) {
		$.each(map, function(key, val) {
			var temp = {};
			temp.id = key;
			temp.name = val;
			list.push(temp);
		});
		sortList(list);
	}
	return list;
}

function sortList(list) {
	if (list) {
		list.sort(function(a, b) {
			var nameA = a.name.toLowerCase();
			var nameB = b.name.toLowerCase();
			return (nameA < nameB) ? -1 : (nameA > nameB) ? 1 : 0;
		});
	}
}

function enableComponents(dateType) {
	if (dateType == '1') {
		$("#from").attr('disabled', 'disabled');
		$("#to").attr('disabled', 'disabled');
		$("#interval_list").removeAttr('disabled');
	} else {
		$("#from").removeAttr('disabled');
		$("#to").removeAttr('disabled');
		$("#interval_list").attr('disabled', 'disabled');
	}
}
function isDate(txtDate) {
	var currVal = txtDate;
	if (currVal == '') {
		return false;
	}
	//Declare Regex
	var rxDatePattern = /^(\d{1,2})(\/|-)(\d{1,2})(\/|-)(\d{4})$/;
	var dtArray = currVal.match(rxDatePattern); // is format OK?
	if (dtArray == null) {
		return false;
	}
	//Checks for mm/dd/yyyy format.
	dtMonth = dtArray[1];
	dtDay = dtArray[3];
	dtYear = dtArray[5];
	if (dtMonth < 1 || dtMonth > 12) {
		return false;
	} else if (dtDay < 1 || dtDay > 31) {
		return false;
	} else if ((dtMonth == 4 || dtMonth == 6 || dtMonth == 9 || dtMonth == 11) && dtDay == 31) {
		return false;
	} else if (dtMonth == 2) {
		var isleap = (dtYear % 4 == 0 && (dtYear % 100 != 0 || dtYear % 400 == 0));
		if (dtDay > 29 || (dtDay == 29 && !isleap)) {
			return false;
		}
	}
	return true;
}

function validateDates() {
	var result1 = validateDate($('#from'));
	var result2 = validateDate($('#to'));
	if (result1 == false || result2 == false) {
		return false;
	}
	return true;
}
function validateDate(ele) {
	var f = ele.val();
	var result = true;
	if (isDate(f) == false) {
		ele.addClass('dateError');
		result = false;
	} else {
		ele.removeClass('dateError');
	}
	return result;
}

function setDefaultDates() {
	var today = new Date();
	var fromday = new Date();
	fromday.setDate(today.getDate() - 1);
	$("#from").datepicker('setDate', fromday);
	$("#to").datepicker('setDate', today);
}

$(document).ready(function() {
	MSStatisticsReport();
});
