var reportSchedule = reportSchedule || {};

var GET_REPORT_HANDLERS = "/api/dcube/ReportHandlers";
var API_SCHEDULE_ADD = "/reports/addReportSchedule.do";
var API_SCHEDULE_MODIFY = "/reports/modifyReportSchedule.do";
var API_SCHEDULE_DELETE = "/reports/deleteReportSchedule.do";
var PARAM_TASK_ID = "taskId";
var PARAM_SUBTASK_ID = "subtaskId";
var PARAM_MODE = "mode";
var PARAM_POLICY = "policy";
var PARAM_REPORT_ENUM = "reportEnum";
var PARAM_REPORT_UNIQID = "reportUniqId";
var PARAM_URL = "reportUrl";
var tpicker;
var tEUntilpicker;
var isLMApp = false;
var isWAApp = false;
var validatePPTX=false;

var usersList=[];
var userTypes={
		USER : "USER",
		EXTERNALUSER :"EXTERNALUSER",
		USERGROUP:"USERGROUP",
		EXTERNALUSERGROUP:"EXTERNALUSERGROUP"
}

function isLMApplication() {

	var lmAppTypes = [ "logMonitoring.do", "sysMonitoring.do" ];
	var path = parent.window.location.pathname;
	if (path != undefined && path != "") {
		path = path.substring(path.lastIndexOf("/") + 1);
		if (lmAppTypes.indexOf(path) != -1) {
			return true;
		}
	}
	return false;
}
function isAnalyticsReports() {
	var path = parent.window.location.pathname;
	if (path != undefined && path != "" && path.indexOf("cireports") != -1) {
		return true;
	}
	return false;
}
function isAnalyticsReports(url) {
	var isAnalytics = false;
	var path = parent.window.location.pathname;
	if (url != undefined && url != "" ) {
		var type = cvUtil.getParameterByName("type", url, false);
		isAnalytics = (type=="fileanalytics" || type=="duplicates");		
	}else{
		if (path != undefined && path != "" && path.indexOf("cireports") != -1) {
			isAnalytics= true;
		}
	}
	return isAnalytics;
}
function isAnalyticsSummaryReport() {
	var path = parent.window.location.search;
	if (path != undefined) {
		var type = cvUtil.getParameterByName('type', path);
		if (type == "summary") {
			return true;
		}
	}
	return false;
}
function isReportsPlus() {
	var path = parent.window.location.pathname;
	if (path != undefined && path != "" && path.indexOf("reportsplus") != -1) {
		return true;
	}
	return false;
}
function isNullOrEmpty(value) {
	if (!value || value == '' || value == undefined || value == null) {
		return true;
	}
}
function updateScheduleObj(taskId) {

	var scheduleInfo = parent.scheduleMap[taskId];

	var form = $("#schForm");

	scheduleInfo.description = form.find("#description").val();
	scheduleInfo.reportCustomName = form.find("#reportCustomName").val();
	scheduleInfo.emails = form.find("#emails").val();

	var cbEnabledState = form.find("div[name=schedEnabled]").attr("data-state");

	scheduleInfo.disabled = cbEnabledState == "checked" ? false : true;
	scheduleInfo.freqType = form.find("input[name=freqType]:checked").val();

	if (scheduleInfo.freqType == "WEEKLY") {
		scheduleInfo.daysToRun = [];
		for (var i = 0; i < 7; i++) {
			if (form.find("div[name=daysToRun" + i + "]").attr("data-state") == "checked") {
				scheduleInfo.daysToRun[i] = true;
			} else {
				scheduleInfo.daysToRun[i] = false;
			}
		}
	}

	scheduleInfo.activeStartTime = form.find("#activeStartTime").val();

}

function isWebAnalytics() {

	var path = parent.window.location.pathname;
	if (path != undefined && path != "" && path.indexOf("webanalytics") != -1) {
		return true;
	}
	return false;
}

// Show/hide fields according to the currently selected frequency
function setFieldVisibility() {
	var freq = $('input[name=freqType]:checked').val();
	$("#repeatNHoursElements").addClass('dontshow vw-start-hidden');
	$("#monthlyElements").addClass('dontshow vw-start-hidden');
	$("#weeklyElements").addClass('dontshow vw-start-hidden');
	if (freq === "WEEKLY") {
		$("#weeklyElements").removeClass('dontshow vw-start-hidden');
	} else if (freq === "MONTHLY") {
		$("#monthlyElements").removeClass('dontshow vw-start-hidden');
	} else if (freq === "DAILY") {
		$("#repeatNHoursElements").removeClass('dontshow vw-start-hidden');
	}
	console.debug("Frequency value: " + $('input[name=freqType]:checked').val());

	var monthSelection = $("input[name=monthSelection]:checked").val();
	$("#daySelectorInput select").prop('disabled', monthSelection == 'dateSelector');
	$("#dateSpinner").prop("disabled", monthSelection != 'dateSelector');
	if ( monthSelection == 'dateSelector' ) {
		$("#daySelectorInput").addClass("disabled");
		$("#dateSpinner").removeClass("disabled");
	} else {
		$("#daySelectorInput").removeClass("disabled");
		$("#dateSpinner").addClass("disabled");
	}
}
function setEmailTypeVisibiity() {
	var format = $(".exportType").val();
	var emailEnabled = true;//$('input[name=emailEnabled]:checked').val();

	if (format == "MHTML" && emailEnabled && $("input[name=emailType]").length > 1) {
		$("#emailTypeOptions").show();
	} else {
		$("#emailTypeOptions").hide();
	}
}
//Show/hide buttons appropriately
function setButtonVisibility() {
	if (adding) {
		$("#deleteButton").hide();
	} else {
		$("#deleteButton").show();
	}
}

function ok() {
	if (isChecked($("div[name=endUserSecurity]"))) {
		$("#emails").val('');
		$("#reportCustomName").val('');
	}

	if (!validate()) {
		return;
	}
	var lmSearchId = 0;
	if (isLMApplication()) {
		lmSearchId = parseInt($("#searchInfo").attr("data-searchId"));
		if ($("#searchName").val() == "") {
			highlightField("#searchName", "searchName should be entered");
			return;
		}
	}

	var hour = tpicker.cvTimepicker('getHour');
	var min = tpicker.cvTimepicker('getMinute');
	console.debug("Parsed time: hours=" + hour + ", minutes=" + min);
	$("#activeStartTime").val("" + (hour * 3600 + min * 60)); // Convert to seconds-from-midnight:
	var paramString = window.location.search;

	var endTimeHour = tEUntilpicker.cvTimepicker('getHour');
	var endTimeMin = tEUntilpicker.cvTimepicker('getMinute');
	$("#activeEndTime").val("" + (endTimeHour * 3600 + endTimeMin * 60)); // Convert to seconds-from-midnight:

	var scheduleName = $("input[name=description]").val();

	var action = "";
	var message = "";
	if (adding) {
		message = addSchedule();
		action = "addSchedule";
	} else {
		message = modifySchedule();
		action = "modifySchedule";
	}

	if (!isLMApplication()) {
		var exportType = $(".exportType").val().toLowerCase();
		cvUtil.logUserAction(cvUtil.getParameterByName("filePrefix", paramString),
				action,
				exportType,
				"scheduleName=[" + scheduleName + "] Message=[" + message + "]");
	} else {
		if (lmSearchId == 0) {
			return;
		}
	}

	if (window.refreshSchedulesTable) {
		window.refreshSchedulesTable();
	}
	if (window.closeOnSave) {
		exitSchedulePage();
	}
}
function validate() {
	var emails = $("#emails").val();
	var usersNotiList = getSelectedUsers();
	var name = $("#schedDescription  #description").val();
	var exportType = $(".exportType").find('option:selected').attr('title');
	var msg = "";
	markField("#schedDescription  #description", msg);
	markField("#emails", msg);
	markField(".networkPanel", msg);
	if (name.trim().length == 0) {
		msg = localMsg.enterScheduleName;
		return markField("#schedDescription  #description", msg);
	} else if (name.trim()) {
		if (name.length > 255) { // schedulename can have max length of 255 character, as backend table column character size is 255
			msg = localMsg.nameLengthErrorMessage;
			return markField("#schedDescription  #description", msg);
		} else {
			markField("#schedDescription  #description", msg);
		}
	}
	if ((isChecked($("div[name=endUserSecurity]")) || (!isChecked($("div[name=endUserSecurity]")) && !emails)) && usersNotiList.length < 1) {
		if (!window.networkShareEnabled || (cv.isTenantUser || cv.isTenantAdmin)) {
			msg = cvUtil.cvLocalize('schedule.Email_required');
			return markField("#emails", msg);
		} else {
			var e = isChecked($("div[name=networkShare]"));
			if (!e) {
				msg = cvUtil.cvLocalize('schedule.one_email_requied');
				markField(".networkPanel", msg);
				return markField("#emails", msg);
			}
		}
	}
	if (exportType == "ESP Quarterly PPT" || exportType == "EMEA QBR" || exportType == "ESP Monthly PPT"){
		if ($("#samDescription #sam").val().trim().length == 0) {
			return markField("#samDescription #sam", "Please enter SAM name");
		}
		if (exportType != "ESP Monthly PPT"){
			if ($("#tamDescription #tam").val().trim().length == 0) {
				return markField("#tamDescription #tam", "Please enter TAM name");
			}
		}
	}
	markField(".networkPanel", msg); //clear highlight if no error
	markField("#emails", msg);
	return validateEmail(true) && validateTime(true, "#activeStartTimeDisplay") && validateDateSpinner(true) &&
			validateNetworkPath() && validateRepeatNmonths(true) &&
			reportsUtil.validateRepeatNHours("input[name=freqType]:checked", true) && validatePPTXdata();
}
function validatePPTXdata(){
	if(validatePPTX==false) {
		return true;
	}
	var name = $("#name");
	var designation = $("#designation");
	var validateTips = $("#validateTips");
	var ccglist = $("#ccglist");
	var excutiveSummary = cvUtil.getTopWindow().excutiveSummary;

	if(excutiveSummary.checkLength(name, "name", 1, 50, validateTips) &&
	excutiveSummary.checkLength(designation, "designation", 1, 100, validateTips) &&
	excutiveSummary.checkLengthCheckBox(ccglist, 1, validateTips)){
		$('#ccgListFinal').val(excutiveSummary.prepareCCGListParam(ccglist));
		return true;
	} else {
		return false;
	}
}
function validateTime(onSaveClick, fieldId) {
	if (!fieldId) {
		return false;
	}
	var isValid = tpicker.cvTimepicker('isValid');
	if (!isValid) {
		return markField(fieldId, cvUtil.cvLocalize('schedule.Invalid_Time'));
	}
	return markField(fieldId, "");
}

function processLMScheduleCreationForRecentSearch(paramString, params) {

	cvUtil.loadPage(cvUtil.getContextPath() + API_SCHEDULE_ADD + paramString + $('form').serialize(), params, function(
			data) {

		var searchCreated = false;
		var isError = true;

		if (data.entityResp == undefined) {
			searchCreated = true;
			isError = false;
			message = parent.lmOptionsMsg.savedSearchSuccess;
		} else if (data.entityResp != undefined) {

			if (data.searchResp != undefined) {
				searchCreated = true;
				message = parent.lmOptionsMsg.savedSearchSuccessScheduleFailure + " " + data.entityResp.errorString;
			} else {
				message = parent.lmOptionsMsg.savedSearchScheduleFailure + " " + data.entityResp.errorString;
			}
		}

		if (searchCreated) {
			API_SCHEDULE_ADD = "/logMonitoring/addLMSchedule.do";
			parent.processAddSavedSearchResponse(data.searchResp);
			$("#searchName").addClass("disabledActions");
			$("#searchInfo").attr("data-searchName", data.searchResp.Name);
			$("#searchInfo").attr("data-searchId", data.searchResp.Id);

			if (!isError) {
				if (window.refreshSchedulesTable) {
					window.refreshSchedulesTable();
				}
				setModel();
			}
		}

		showMessage(message, isError);
		return message;

	}, function(xhr, ajaxOptions, thrownError) {
		//schedule failed;
		//console.error("Add schedule failed: " + data);
		message = cvUtil.cvLocalize('schedule.Add_schedule_failed2');
		showMessage(message, true);
		return message;
	});

}

function validateEndUserSecurity() {
	var form = $("#schForm");
	var reportCustomName = form.find("#reportCustomName").val();
	if ( reportCustomName === '' || reportCustomName === null ) {
		$("#endUserSecurityCheckBox").removeClass("disabled");
		$("#endUserSecurityText").removeClass("disabled");
		$("#endUserSecurity").removeClass("disabled");
	}
	else {
		$("#endUserSecurityCheckBox").addClass("disabled");
		$("#endUserSecurityText").addClass("disabled");
		$("#endUserSecurity").addClass("disabled");
	}
}

function validateDateSpinner(onSaveClick) {
	var freqOption = $("input[name=freqType]:checked").val();
	if (freqOption != 'MONTHLY') {
		return true;
	}
	var fieldId = "#dateSpinner";
	var monthSelection = $("input[name=monthSelection]:checked").val();
	if (monthSelection != 'dateSelector') {
		return markField(fieldId, "");
	}
	var dayOfMonth = $(fieldId).val();
	if (isNullOrEmpty(dayOfMonth)) {
		if (onSaveClick) {
			return markField(fieldId, cvUtil.cvLocalize('schedule.Day_of_month_is_required'));
		} else {
			return markField(fieldId, "");
		}
	}
	if (isNaN(dayOfMonth) || dayOfMonth > 31 || dayOfMonth < 1) {
		return markField(fieldId, cvUtil.cvLocalize('schedule.Invalid_day_of_month'));
	}
	return markField(fieldId, "");
}
function validateRepeatNmonths(onSaveClick) {
	var freqOption = $("input[name=freqType]:checked").val();
	if (freqOption != 'MONTHLY') {
		return true;
	}
	var fieldId = "#repeatNmonths";

	var nMonths = $(fieldId).val();
	if (isNullOrEmpty(nMonths)) {
		if (onSaveClick) {
			return markField(fieldId, cvUtil.cvLocalize('schedule.monthly.required_month'));
		} else {
			return markField(fieldId, "");
		}
	}
	if (isNaN(nMonths) || nMonths > 24 || nMonths < 1) {
		return markField(fieldId, cvUtil.cvLocalize('schedule.monthly.invalid_month'));
	}
	return markField(fieldId, "");
}
function validateNetworkPath() {
	if (isLMApplication()) {
		return true;
	}
	var e = isChecked($("div[name=networkShare]"));
	if (!e) {
		return true;
	}
	var field = $("#networkPath");
	var valu = field.val();
	if (!valu) {
		return markField(field, cvUtil.cvLocalize('schedule.Path_is_required'));
	}
	if (valu.indexOf('\\\\') != 0) {
		return markField(field, cvUtil.cvLocalize('schedule.Invalid_network_path'));
	} else {
		markField(field, '');
	}
	field = $("#networkUser");
	var valu = field.val();
	if (!valu) {
		return markField(field, cvUtil.cvLocalize('schedule.Username_to_access_network_path_is_required'));
	} else {
		markField(field, '');
	}
	field = $("#networkPassword");
	var valu = field.val();
	if (!valu) {
		return markField(field, cvUtil.cvLocalize('schedule.Password_is_required'));
	} else {
		markField(field, '');
	}
	return true;
}
function addSchedule() {
	var params = {};
	var searchId = 0;
	var $exportTypeElement = $(".exportType");
	var exportType = "";
	if (cvUtil.getTopWindow().convertToExportUrl) {
		exportType = $exportTypeElement.val().toLowerCase();
		currentUrl = window.parent.report && window.parent.report.getExportUrl ? window.parent.report
				.getExportUrl(exportType) : window.parent.document.URL;
		currentUrl = cvUtil.getTopWindow().convertToExportUrl(currentUrl, exportType); //currenturl is initialized in jsp
	}
	console.debug("Adding schedule: " + params[PARAM_URL]);
	var paramString = window.location.search + '&'; //retain the paramaters that were passed to this page

	if(exportType == 'custom_ppt' || exportType == 'custom_doc'){
		paramString =   replaceUrlParam(window.location.search, "filePrefix", window
				.encodeURIComponent($exportTypeElement.find('option:selected').attr('title')));
		paramString +='&customDocumentName='+$exportTypeElement.find('option:selected').attr('title');
		var commUniIdValue = cvUtil.getTopWindow().cvUtil.getParameter('commUniId');
		var ccGroupIdValue = cvUtil.getTopWindow().cvUtil.getParameter('ccGroupId');
		var companyIdValue = cvUtil.getTopWindow().cvUtil.getParameter('companyId');
		paramString += '&customDocumentInput.commUniId='+encodeURIComponent(commUniIdValue == "" ? 0 : commUniIdValue);
		paramString += '&customDocumentInput.ccGroupId='+encodeURIComponent(ccGroupIdValue == "" ? -1 : ccGroupIdValue);
		paramString += '&customDocumentInput.companyId='+encodeURIComponent(companyIdValue == "" ? 0 : companyIdValue);
		paramString += '&customDocumentInput.sam='+$('#sam').val();

		if($exportTypeElement.find('option:selected').attr('title') == "ESP Monthly PPT"){
			paramString += '&customDocumentInput.fromMonth=1';
			paramString += '&customDocumentInput.tam=none';
		}else{
			paramString += '&customDocumentInput.fromMonth='+$('#from-time').val();
			paramString += '&customDocumentInput.tam='+$('#tam').val();
		}
		paramString += '&customDocumentInput.toMonth=1';
	}
	var urlParams = cvUtil.getUrlParams(window.location.search);

	var expType;
	if ($exportTypeElement.length > 0) {
		expType = $exportTypeElement.val();
	}

	var newFilePrefix;
	if (expType) {
		if (expType.toLowerCase() === "executivesummary" ) {
			if ( urlParams != undefined && urlParams.showPPT === "true" ) {
				newFilePrefix = "Executive Summary";
			}
		}
	}

	if (newFilePrefix) {
		paramString = replaceUrlParam(window.location.search, "filePrefix", window
				.encodeURIComponent(newFilePrefix));
	}
	if (isLMApp) {
		//$("#timezoneid").val(timezoneid);
		var searchInfo = $("#searchInfo");
		searchId = parseInt(searchInfo.attr("data-searchId"));
		var lmSearchParams = [];
		lmSearchParams.push(cvUtil.createParamString("searchName", $("#searchName").val()));
		lmSearchParams.push(cvUtil.createParamString("searchId", searchId));
		var lmSearchParamsStr = cvUtil.createParamsString(lmSearchParams);
		lmSearchParamsStr = parent.addAppTypeParamToRequest(lmSearchParamsStr);
		paramString = "?" + lmSearchParamsStr + "&";
		currentUrl=parent.History.getState().cleanUrl;
	}
	if (isWAApp) {
		if (currentUrl.indexOf("scheduled=false") > -1) {
			currentUrl = currentUrl.replace("scheduled=false", "scheduled=true");
		} else {
			currentUrl = currentUrl + "&scheduled=true";
		}
	}
	if (isReportsPlus()) {
		currentUrl = currentUrl + "&viewportWidth=1600";
		var selectedComponentString = getSelectedComponents();
		if (selectedComponentString) {
			currentUrl = currentUrl +"&showComponents=" + selectedComponentString;
		}

		// hide report Summary will be saved as url option and the inputs summary will be hidden based on this url parameters.
		if($('.hideReportSummary').hasClass('checked')){
		    currentUrl = currentUrl +"&hideReportSummary=true";
		}

	}
	params[PARAM_URL] = currentUrl;
	var isError = false;
	var message = "";
	if (isLMApp && searchId == 0) {
		//This means it is a recent Search.. so show the searchName textbox
		API_SCHEDULE_ADD = "/logMonitoring/addLMScheduleForRecentSearch.do";
		processLMScheduleCreationForRecentSearch(paramString, params);
	} else {
		var formFields = $('form').serializeArray();
		jQuery.each(formFields, function(i, field) {
			if (field.name == 'networkPassword') {
				params[field.name] = Base64.encode(field.value);
			} else if (field.name == 'usersListToNotify'){
				params[field.name] = JSON.stringify($("#users-list-to-notify").data("usersToNotify")) ;
			} else {
				params[field.name] = field.value;
			}
		});
		if (isAnalyticsReports() && !isAnalyticsSummaryReport()) {
			paramString = cvUtil.getTopWindow().getParamString(exportType);
			var parmObj = cvUtil.getParameterByName('format', paramString);
			if (parmObj == "ZIP") {
				params["exportType"] = "ZIP";
			}
		}

		removeNotApplicableParams(params);

		var result = cvUtil.loadSynchronously(cvUtil.getContextPath() + API_SCHEDULE_ADD + paramString,
				params,
				function(data) {
					isError = true;
					console.error("Add schedule failed: " + data);
					if (data.responseText) {
						message = cvUtil.cvLocalize('schedule.Add_schedule_failed', data.responseText.trim());
					} else {
						message = cvUtil.cvLocalize('schedule.Add_schedule_failed2');
					}
					showMessage(message, true);
					window.returnData = {
							'isError' : isError,
							'response' : data.responseText,
							'message' : message
					}
				});
		if (!isError) {
			console.debug("Add schedule result: " + result);
			if(isLMApp && (result.msg != undefined && result.msg != "")){
				message = cvUtil.cvLocalize('schedule.Add_schedule_failed', result.msg.trim());
				showMessage(message);
			}
			else
			{
				message = cvUtil.cvLocalize('schedule.Schedule_added');
				showMessage(message);
				window.returnData = {
						'isError' : false,
						'message' : message
				}
				setModel();
			}
		}
	}
	return message;
}

function removeNotApplicableParams(params) {
	if (params && params.exportType == 'EMAIL_BODY') {
		delete params.compressFile;
		delete params.networkShare;
		delete params.networkPassword;
		delete params.networkPath;
		delete params.networkUser;
		delete params.passwordChanged;
	}
}

function replaceUrlParam(url, paramName, paramValue) {
	var pattern = new RegExp('\\b(' + paramName + '=).*?(&|$)')
	if (url.search(pattern) >= 0) {
		return url.replace(pattern, '$1' + paramValue + '$2');
	}
	return url + (url.indexOf('?') > 0 ? '&' : '?') + paramName + '=' + paramValue
}

function modifySchedule() {
	var params = {};
	params[PARAM_URL] = model.url; //retain existing url of the schedule being modified
	params[PARAM_TASK_ID] = model.taskId;
	console.debug("Modifying schedule: " + params[PARAM_URL]);
	var paramString = window.location.search;
	if (!paramString) {
		paramString = '?';
	} else if (paramString != '?') {
		paramString = paramString + '&';
	}
	var isError = false;
	var urlParams = cvUtil.getUrlParams(window.location.search);

	var expType;
	var $exportTypeElement = $(".exportType");

	if($exportTypeElement.length > 0){
		expType = $exportTypeElement.val();
	}
	var customDocumentExport;
	var newFilePrefix;
	if(expType){
		if (expType.toLowerCase() === "executivesummary" ) {
			if ( urlParams != undefined && urlParams.showPPT === "true" ) {
				newFilePrefix = window.encodeURIComponent("Executive Summary")+"&";
			}
		} else if (expType.toLowerCase().indexOf('custom_ppt') == 0) {

			customDocumentExport = {
					type : 'CUSTOM_PPT',
					customDocumentName : $exportTypeElement.find('option:selected').attr('title')
			}
			newFilePrefix = $exportTypeElement.find('option:selected').attr('title')+'&';
		} else if (expType.toLowerCase().indexOf('custom_doc') == 0) {
			customDocumentExport = {
					type : 'CUSTOM_DOC',
					customDocumentName : $exportTypeElement.find('option:selected').attr('title')
			}
			newFilePrefix = $exportTypeElement.find('option:selected').attr('title')+'&';
		}
	}
	if (newFilePrefix) {
		paramString = replaceUrlParam(window.location.search, "filePrefix", window
				.encodeURIComponent(newFilePrefix));
		paramString = replaceUrlParam(paramString, "customDocumentInput.sam", window.encodeURIComponent($('#sam').val()));
		paramString = replaceUrlParam(paramString, "customDocumentInput.tam", window.encodeURIComponent($('#tam').val()));
		paramString = replaceUrlParam(paramString, "customDocumentInput.fromMonth", window.encodeURIComponent($('#from-time').val()));
	}
	if (isLMApp) {
		if (!parent.isScheduleTab()) {
			if (cvUtil.getTopWindow().convertToExportUrl) {
				var exportType = $(".exportType").val().toLowerCase();
				currentUrl = cvUtil.getTopWindow().convertToExportUrl(currentUrl, exportType, -1); //currenturl is initialized in jsp
			}
			params[PARAM_URL] = currentUrl;
		} else {
			params[PARAM_URL] = cvUtil.getContextPath() + params[PARAM_URL];
		}

		var lmSearchParams = [];
		var exportSchedule = $("#searchInfo");
		var searchId = exportSchedule.attr("data-searchId");
		var searchName = exportSchedule.attr("data-searchName");
		//$("#timezoneid").val(timezoneid);
		if (searchId != undefined && searchId != "" && searchName != undefined && searchName != "") {
			lmSearchParams.push(cvUtil.createParamString("searchId", searchId));
			lmSearchParams.push(cvUtil.createParamString("searchName", searchName));
			var lmSearchParamsStr = cvUtil.createParamsString(lmSearchParams);
			lmSearchParamsStr = parent.addAppTypeParamToRequest(lmSearchParamsStr);
			paramString = "?" + lmSearchParamsStr + "&";
		}
	}

	var savedUrl = decodeURIComponent(model.savedUrl);
	if(savedUrl.indexOf("reportsplus") !== -1){
		var selectedComponentsString = getSelectedComponents();
		var paramsMap =  cvUtil.getUrlParams(savedUrl);
		delete paramsMap['showComponents'];
		delete paramsMap['hideReportSummary'];
		if(selectedComponentsString){
			paramsMap['showComponents'] = selectedComponentsString;
		}
		if($('.hideReportSummary').hasClass('checked')){
			paramsMap['hideReportSummary']=true;
		}
		savedUrl = requestToUrl(paramsMap);
		savedUrl = window.location.origin+cvUtil.getContextPath()+savedUrl;
		params['reportUrl'] = savedUrl;
		params['updateUrl'] = true;
	}

	var message;
	//var formParams = $('form').serialize();
	var formFields = $('form').serializeArray();
	var formData = {};

	$(formFields).each(function(index, obj){
		if(obj.name!="usersListToNotify"){
			formData[obj.name] = obj.value;
		}else{
			formData[obj.name] = JSON.stringify($("#users-list-to-notify").data("usersToNotify")) ;
		}
	});

//	jQuery.each(formFields, function(i, field) {
//		if (field.name == 'networkPassword') {
//			//var nwp = field.name + '=' + window.encodeURIComponent(field.value);
//			formFields.networkPassword = Base64.encode(field.value);
////			var nwpencoded = field.name + '=' + Base64.encode(field.value);
////			formParams = formParams.replace(nwp, nwpencoded);
//			// break loop.
//			return false;
//		}
//	});

	if (!!formData['networkPassword']) {
		formData.networkPassword = Base64.encode(formData.networkPassword);
	}

	var url = decodeURIComponent(model.url);
	var isAnalytics = isAnalyticsReports(url);
	if (isAnalytics) {
		// params[PARAM_URL] = undefined;
		// if (cvUtil.getTopWindow().convertToExportUrl) {
		// 	var exportType = $(".exportType").val().toLowerCase();
		// 	currentUrl = cvUtil.getTopWindow().convertToExportUrl(currentUrl, exportType, -1); //currenturl is initialized in jsp
		// }
		//params[PARAM_URL] = currentUrl;		

		params[PARAM_URL] =  window.location.origin+ cvUtil.getContextPath() + url;
		var filePrefix = model.filePrefix;
		var isStatsView = false;
		var exportType = $(".exportType").val().toLowerCase();
		var json = cvUtil.getParameterByName("json", url, false);
		if (json != false) {
			data = jQuery.parseJSON(json);
			isStatsView = data.statsTable;
		}
		
		if (isStatsView == true || exportType == "csv") {
			formData.exportType = 'ZIP';
			formData.emails = decodeURIComponent(formData.emails);
			formData.networkPath = decodeURIComponent(formData.networkPath);
			params["exportType"] = "ZIP";
		}
		
	}

	if (customDocumentExport) {
		if (customDocumentExport.type) {
			formData.exportType = customDocumentExport.type;
		}
		if (customDocumentExport.customDocumentName) {
			formData.customDocumentName = customDocumentExport.customDocumentName;
		}
	}

	var allParams = $.extend({}, params, formData);

	if (paramString == '?') {
		paramString = '';
	}

	removeNotApplicableParams(allParams);

	var result = cvUtil.loadSynchronously(cvUtil.getContextPath() + API_SCHEDULE_MODIFY + paramString,
			allParams,
			function(data) {
				isError = true;
				console.error("Modify schedule failed: " + data);
				message = cvUtil.cvLocalize('schedule.Modify_schedule_failed', data.responseText);
				showMessage(message, true);
				window.returnData = {
					'isError' : isError,
					'response' : data.responseText,
					'message' : message
				}
			});
	if (!isError) {
		console.debug("Modify schedule result: " + result);
		if(isLMApp && (result.msg != undefined && result.msg != "")){message = cvUtil.cvLocalize('schedule.Modify_schedule_failed', result.msg.trim());} else {message = cvUtil.cvLocalize('schedule.Schedule_updated');}

		showMessage(message);
		window.returnData = {
			'isError' : false,
			'message' : message
		}

		if (isLMApplication()) {
			if (parent.isScheduleTab()) {
				updateScheduleObj(model.taskId);
				return;
			}
		}
		setModel();
	}
	if (window.refreshSchedulesTable) {
		window.refreshSchedulesTable();
	}
	return message;
}

function deleteSchedule(sched, name, exportType) {
	if (confirm(confirmDeleteVar)) {
		console.debug("Deleting schedule: " + sched);
		var isError = false;
		var message = "";
		var result = cvUtil.loadSynchronously(cvUtil.getContextPath() + API_SCHEDULE_DELETE, {
			"taskId" : sched
		}, function(data) {
			isError = true;
			console.error("Delete schedule failed: " + data.responseText);
			message = cvUtil.cvLocalize('schedule.Delete_schedule_failed', data.responseText);
			showMessage(message, true);
		});
		if (!isError) {
			console.debug("Delete schedule result: " + result);
			message = cvUtil.cvLocalize('schedule.Schedule_deleted');
			showMessage(message);
			if (sched == model.taskId) {
				setModel();
			}
		}

		if (!isLMApplication() && !isAnalyticsReports()) {
			cvUtil.logUserAction(cvUtil.getParameterByName("filePrefix", window.location.search),
					'deleteSchedule',
					exportType,
					"scheduleName=[" + name + "] Message=[" + message + "]");
		}

		if (isLMApplication() && !isError && $("#schedulesList_table tbody tr").length === 1) {
			var isSearchReset = parent.lmUtils.functions.resetImplicitSearch();
			if (isSearchReset) {
				$("#searchName").removeClass("disabledActions disabled");
				$("#searchInfo").attr("data-searchName", parent.$("#keyword").val());
				$("#searchInfo").attr("data-searchId", 0);
			}
		}

		if (window.refreshSchedulesTable) {
			window.refreshSchedulesTable();
		}
	}
}

function exitSchedulePage(forceReload) {
	console.debug("Location: " + parent.window.location); // !!! test

	cvUtil.closeModal();
}

function containsParam(href, paramString) {
	return href.indexOf("?" + paramString) !== -1 || href.indexOf("&" + paramString) !== -1;
}

function insertParam(href, paramString) {
	var hashLoc = href.indexOf("#");
	if (hashLoc === -1) {
		return href + "&" + paramString;
	}
	var beforeHash = href.slice(0, hashLoc);
	var hashStr = href.slice(hashLoc);
	return beforeHash + "&" + paramString + hashStr;
}
function showMessage(message, isError) {
	if (isError) {
		cvUtil.errorToast(message, null, null, true);
	} else {
		cvUtil.toast(message, null, null, true);
	}
}
//has to be at window level - closeModal parent will access return data from here
function getData() {
	return window.returnData;
}
function enableDisableOk() {
	var freq = $('input[name=freqType]:checked').val();
	var ok = false;
	if (freq === "WEEKLY") {
		$("#daysToRunList").find(".dayToRun.custom-cb").each(function() {
			var cv = $(this);
			if (isChecked(cv)) {
				ok = true;
				return false;
			}
		});
	} else {
		ok = true; // no validations needed for daily/auto
	}

	if (ok) {
		$("#okButton").removeClass("disabledActions");
		$("#okButton").removeAttr("disabled");
	} else {
		$("#okButton").addClass("disabledActions");
		$("#okButton").attr("disabled", "disabled");
	}
}

function setModel(t) {
	if (!t) {
		t = defaultModel; //initialized in jsp with default values of ReportSchedule
		var userEmail = window.sessionStorage.getItem('userEmail');
		if(userEmail){
			t.emails = userEmail+",";
		}
		$("#schedulesList tr").removeClass("selected");
		$("#schMask").removeClass("editOn").addClass("addOn").find("#schedulesList").parents(".vw-panel").removeClass("vw-start-hidden");
		$(".editMessage").addClass("vw-start-hidden").siblings(".addMessage").removeClass("vw-start-hidden");
	} else {
		$("#schMask").removeClass("addOn").addClass("editOn").find("#schedulesList").parents(".vw-panel").addClass("vw-start-hidden");
		$(".editMessage").removeClass("vw-start-hidden").siblings(".addMessage").addClass("vw-start-hidden");
	}
	window.model = t;
	reset();
}
function getValue(inputArray, key) {
	var itr;
	if (!!inputArray && !!key){
	for (itr = 0; itr < inputArray.length; itr++) {
		  if (inputArray[itr].key == key){
			  return inputArray[itr].value;
		  }
		}
	}
	return "";
}
function reset() {
	var t = window.model;
	var form = $("#schForm");
	var selectedDocument = t.filePrefix;
	if (selectedDocument == "QBR PPT"){
		selectedDocument = "ESP Quarterly PPT";
	}else if (selectedDocument == "QBR Monthly PPT"){
		selectedDocument = "ESP Monthly PPT";
	}
	if(t.taskId){
		sessionStorage.setItem("taskId"+t.taskId,JSON.stringify(t));
	}
	form.find("#description").val(t.description);
	form.find("#reportCustomName").val(t.reportCustomName);
	if (isAnalyticsReports() && t.exportType == "ZIP") {
		t.exportType = "CSV";
	}
	if (t.exportType == "CUSTOM_PPT" || t.exportType == "CUSTOM_DOC"){
		form.find(".exportType").find('option[title="'+selectedDocument+'"]').attr('selected','selected');
	}else{
		form.find(".exportType").find('option[title="'+t.exportType+'"]').attr('selected','selected');
	}
	var hideMonthlyCustomDocuments = $(".monthlyCustomDocumentHides");
	var hideCustomDocuments = $(".customDocumentHides");

	if(selectedDocument == "ESP Quarterly PPT" || selectedDocument == "EMEA QBR" || selectedDocument == "ESP Monthly PPT" || selectedDocument == "RMS PPT"){
		var samObject = getValue(t.customDocumentInputs, 'sam');
		var tamObject = getValue(t.customDocumentInputs, 'tam');
		var fromMonthObject = getValue(t.customDocumentInputs, 'fromMonth');;
	}

	if (selectedDocument == "ESP Monthly PPT"){
		hideCustomDocuments.removeClass("hidden");
		hideMonthlyCustomDocuments.addClass("hidden");
		form.find("input[name=sam]").val(samObject);
		form.find("#updateScheduleParams").hide();
		$("#manageSchedulesLinkContainer").hide();
		$('#manageSchedulesLink').hide();
		form.find(".exportType").addClass('disabled');
	}else if (selectedDocument == "RMS PPT" || selectedDocument == "OSOS PPT" || selectedDocument == "Charter"){
		hideMonthlyCustomDocuments.removeClass("hidden");
		hideCustomDocuments.addClass("hidden");
		form.find("#updateScheduleParams").hide();
		$('#manageSchedulesLink').hide();
		form.find(".exportType").addClass('disabled');
	}else if (selectedDocument == "ESP Quarterly PPT" || selectedDocument == "EMEA QBR"){
		hideMonthlyCustomDocuments.removeClass("hidden");
		hideCustomDocuments.removeClass("hidden");
		form.find("input[name=sam]").val(samObject);
		form.find("input[name=tam]").val(tamObject);
		form.find("select[id=from-time]").find('option[value='+fromMonthObject+']').attr('selected','selected');
		form.find("#updateScheduleParams").hide();
		$('#manageSchedulesLink').hide();
		form.find(".exportType").addClass('disabled');
	}else {
		hideMonthlyCustomDocuments.removeClass("hidden");
		hideCustomDocuments.addClass("hidden");
		form.find("#updateScheduleParams").show();
		form.find(".exportType").removeClass('disabled');
		$('#manageSchedulesLink').show();
	}
	form.find("input[name=emailType][value=" + t.emailType + "]").attr('checked', 'checked');
	form.find("#emails").val(t.emails);
	if(t.emailType=="EMBEDDED"){
		checkCb($("div[name=includereportSummary]"), false);
	}else{
		unCheckCb($("div[name=includereportSummary]"), false);
	}

	if (t.isCompressed) {
		checkCb($('div[name=compressFile]'), false);
	} else {
		unCheckCb($('div[name=compressFile]'), false);
	}

	var reportName = cvUtil.getParameterByName("filePrefix", document.URL, false);
	var reportType = window.reportEnum;
	if (reportType === null || reportType === "") {
		reportType = t.reportType;
	}

	var checkEndUserSecurityVisible = function (value, index, array) {
	  return value !== reportName;
	}
	var filteredReportNames = ["File Search", "Cleanup Report", "Software_Report"];
	var isNotInFilteredReports = filteredReportNames.every(checkEndUserSecurityVisible);

	if ( reportType !== "CustomReports" ) {
		$("div[id=endUserSec]").hide();
	}
	else if ( isNotInFilteredReports === false ) {
		$("div[id=endUserSec]").hide();
	}
	else {
		$("div[id=endUserSec]").show();

		if (t.isEndUserSecurity) {
			checkCb($('div[name=endUserSecurity]'), false);
			form.find("#reportCustomName").prop('disabled', true);
		} else {
			unCheckCb($('div[name=endUserSecurity]'), false);
		}
	}

	if (t.reportCustomName !== '' && t.reportCustomName !== null && t.reportCustomName !== undefined) {
		$("#endUserSecurityCheckBox").addClass("disabled");
		$("#endUserSecurityText").addClass("disabled");
		$("#endUserSecurity").addClass("disabled");
	}

	if (! isLMApplication()){
		if(t.exportType != "CUSTOM_PPT" && t.exportType != "CUSTOM_DOC"){
			if(t.savedUrl){ //On loading a saved schedule
				form.find("#updateScheduleParameters").attr("data-target-url",t.savedUrl);
				form.find("#updateScheduleParameters").attr("data-task-id",t.taskId);
				form.find("#updateScheduleParams").show();
				$("#manageSchedulesLinkContainer").hide();
			}else{
				form.find("#updateScheduleParams").hide();
				$("#manageSchedulesLinkContainer").show();
			}
		}

		var usersToNotify=getUsersToNotifyText(t);
		form.find("#users-list-to-notify").data("usersToNotify",usersToNotify);
		updateUsersToNotifyField();

	}

	form.find("input[name=freqType][value=" + t.freqType + "]").attr('checked', 'checked');
	$("#daySelector").prop('checked', true);

	resetExecutiveSummarySection(t);

	for (var i = 0; i < 7; i++) {
		if (t.daysToRun && t.daysToRun[i]) {
			checkCb($("div[name=daysToRun" + i + "]"), false);
		} else {
			unCheckCb($("div[name=daysToRun" + i + "]"), false);
		}
	}

	var localeVal = "en-us"; //all schedules created without locale information should be loaded with en_US
	if(t.locale){
		if(t.locale.locale){
			localeVal = t.locale.locale;
		}
	}
	form.find("#locales").val(localeVal);

	if (t.weekOfMonth) {
		form.find("#weekOfMonth").val(t.weekOfMonth);
	} else {
		form.find('#weekOfMonth').prop('selectedIndex', 0);
	}
	if (t.dayOfWeek) {
		form.find("#dayOfWeek").val(t.dayOfWeek);
	} else {
		form.find('#dayOfWeek').prop('selectedIndex', 0);
	}
	if (t.dateOfMonth) {
		form.find("#dateSpinner").val(t.dateOfMonth);
		$("#dateSelector").prop('checked', true);
	} else {
		form.find("#dateSpinner").val('1');
	}
	if (t.repeatNFrequencey) {
		form.find("#repeatNmonths").val(t.repeatNFrequencey);
	} else {
		form.find("#repeatNmonths").val('1');
	}
	if (!t.disabled) {
		checkCb($("div[name=schedEnabled]"), false);
	} else {
		unCheckCb($("div[name=schedEnabled]"), false);
	}
	if (t.networkShare) {
		checkCb($("div[name=networkShare]"), false);
		form.find("#networkPath").val(t.networkPath);
		form.find("#networkUser").val(t.networkUser);
		form.find("#networkPassword").val('XXXXXXXXXX');
	} else {
		unCheckCb($("div[name=networkShare]"), false);
		form.find("#networkPath").val('');
		form.find("#networkUser").val('');
		form.find("#networkPassword").val('');
	}
	if (t.timezone) {
		$("#timezone option[value='" + t.timezone + "']").prop('selected', 'selected');
	} else {
		$("#timezone option[value='" + defaultTimeZoneId + "']").prop('selected', 'selected');
	}

	$("#activeStartTime").val(t.activeStartTime);
	if (!isLMApplication()) {
		var enableRepeatEverySection = false;
		if (t.activeEndTimeNHours && t.activeEndTimeNHours > 0) {
			$("#activeEndTime").val(t.activeEndTimeNHours);
			enableRepeatEverySection = true;
		} else {
			$("#activeEndTime").val(t.activeEndTime);
		}

		if (t.repeatNHoursInterval && t.repeatNHoursInterval > 0) {
			$("#everyNHoursSpinner").val(Math.floor(t.repeatNHoursInterval / 3600));
			$("#everyNMinsSpinner").val((t.repeatNHoursInterval / 60) % 60);
		} else {
			enableRepeatEverySection = false;
			$("#everyNHoursSpinner").val(8);//default value as 8 hours
			$("#everyNMinsSpinner").val(0);///default value as 0 mins
		}
		if (enableRepeatEverySection) {
			form.find("div[name=repeatEveryNHours]").removeClass('unchecked').addClass('checked').attr("data-state",
					"checked");
		} else {
			form.find("div[name=repeatEveryNHours]").removeClass('checked').addClass('unchecked').attr("data-state",
					"unchecked");

		}

	}

	$("#passwordChanged").val(false);
	setTime();
	adding = !t.taskId;
	clearHighlight("input");
	setFieldVisibility();
	setEmailTypeVisibiity();
	if (isAnalyticsReports()) {
		if (t.url != undefined) {
			checkAnalyticsReport(t.url);
		} else {
			checkAnalyticsReport(parent.window.location.href);
		}
	}
	enableDisableOk();
	setButtonVisibility();
	enableDisableNetworkPath();
	enableEmails();
	if (!isLMApplication()) {
		reportsUtil.enableDisableRepeatEveryElements("#schForm");
	}
	form.find("#description").focus();

	if (isLMApplication()) {
		$("#searchName").val($("#searchInfo").attr("data-searchName"));
	}

	if(cv && cv.additionalSettings && cv.additionalSettings.Console && cv.additionalSettings.Console.showReportComponentSelection){
		var url = decodeURIComponent(t.savedUrl);
		if(url.indexOf("reportsplus") !== -1){
			$("#hideReportSummaryOption").show();
			var reportId = cvUtil.getParameterByName('reportId',url);
			var pageName = cvUtil.getParameterByName('pageName',url);
			var selectedComponents = cvUtil.getParameterByName('showComponents',url);
			loadComponentsFromReport(reportId,pageName,selectedComponents);
			if(url.indexOf("hideReportSummary=true") !== -1){
				checkCb($("div[name=hideReportSummary]"), true);
			}
		}
	}

	if(t.emailType=="EMBEDDED") {
		setDialogStateForSelectedFormat('EMAIL_BODY');
	}
}

function getSelectedComponents(){
	var selectedComponentsString = "";
	if($("#components").val() != null){
		// if there are more than one option and user select one or more of then we need to add it to the url.
		if($("#components option").length > 1 && $("#components option").length !== $("#components").val().length){
			selectedComponentsString = $("#components").val().join(",");
		}

	}
	return selectedComponentsString;
}

function getSelectedUsers(){
	var list = $("#users-list-to-notify").data("usersToNotify");
	if(!list){
		list=[];
	}
	result=[]
	list.forEach(function(userObj){
		result.push( userObj.userId + "-" + userObj.userType );
	});
	return result;
}

function getUsersToNotifyText(t){
	var usersToNotifyArray= new Array();
	if(t.emailCommcellUsersList && t.emailCommcellUsersList.length > 0){
		for(var i=0;i<t.emailCommcellUsersList.length;i++ ){
			userObj={};
			userObj["userId"]=t.emailCommcellUsersList[i].userId;
			userObj["userType"]=userTypes.USER;
			userObj["userName"]=t.emailCommcellUsersList[i].userName;
			usersToNotifyArray.push(userObj);
		}
	}
	if(t.emailExternalUsersList && t.emailExternalUsersList.length > 0){
		for(var i=0;i<t.emailExternalUsersList.length;i++ ){
			userObj={};
			userObj["userId"]=t.emailExternalUsersList[i].userId;
			userObj["userType"]=userTypes.EXTERNALUSER;
			userObj["userName"]=t.emailExternalUsersList[i].userName;
			usersToNotifyArray.push(userObj);
		}
	}
	if(t.emailUserGroupsList && t.emailUserGroupsList.length > 0){
		for(var i=0;i<t.emailUserGroupsList.length;i++ ){
			userGroupObj={};
			userGroupObj["userId"]=t.emailUserGroupsList[i].userGroupId;
			userGroupObj["userType"]=userTypes.USERGROUP;
			userGroupObj["userName"]=t.emailUserGroupsList[i].userGroupName;
			usersToNotifyArray.push(userGroupObj);
		}
	}
	if(t.emailExternalUsersGroupsList && t.emailExternalUsersGroupsList.length > 0){
		for(var i=0;i<t.emailExternalUsersGroupsList.length;i++ ){
			userGroupObj={};
			userGroupObj["userId"]=t.emailExternalUsersGroupsList[i].userGroupId;
			userGroupObj["userType"]=userTypes.EXTERNALUSERGROUP;
			userGroupObj["userName"]=t.emailExternalUsersGroupsList[i].userGroupName;
			usersToNotifyArray.push(userGroupObj);
		}
	}
	return usersToNotifyArray;
}

function resetExecutiveSummarySection(t){
	var executiveSummaryDialog = $("#executive-summary-export-dialog");

	if(t.exportType!="EXECUTIVESUMMARY"){
		hideExecutiveSummaryDetails();
		return;
	}else{
		showExecutiveSummaryDetails();
	}

	var nameField = $(executiveSummaryDialog.find("input#name"));
	var designationField = $(executiveSummaryDialog.find("input#designation"));
	nameField.val(t.headName);
	designationField.val(t.designation);
	if(t.ccgList=="" || t.ccgList==" "){
		executiveSummaryDialog.find("#SelectAllCCG").prop('checked',true);
		executiveSummaryDialog.find("input:checkbox[name=commcellgroup]").prop('checked',true);
	}else{
		var ccgListArray = t.ccgList.trim().split(" ");
		var isSelectAllCheckBox = true;
		var collCellGroupList = executiveSummaryDialog.find("input:checkbox[name=commcellgroup]");
		collCellGroupList.each(function(index){
			var ccgValue = $(this).val();
			if(ccgListArray.indexOf(ccgValue)>-1){
				$(this).prop('checked',true);
			}else{
				$(this).prop('checked',false);
				isSelectAllCheckBox = false;
			}
		});
		if(isSelectAllCheckBox){
			executiveSummaryDialog.find("#SelectAllCCG").prop('checked',true);
		}else{
			executiveSummaryDialog.find("#SelectAllCCG").prop('checked',false);
		}
	}
}

function checkAnalyticsReport(url) {
	var isAnalytics = isAnalyticsReports(url);
	if (isAnalytics) {
		var url = decodeURIComponent(url);
		var type = cvUtil.getParameterByName("type", url);
		var isTableView = false;
		var isStatsView = false;
		if (type == "duplicates") {
			var json = cvUtil.getParameterByName("json", url, false);
			if (json != false) {
				data = jQuery.parseJSON(json);
				isStatsView = data.statsTable;
				isTableView = data.showDataTable;
			} else {
				isTableView = cvUtil.getParameterByName("showDataTable", url, false);
				isStatsView = cvUtil.getParameterByName("statsTable", url, true);
			}
		} else {
			isTableView = cvUtil.getParameterByName("showDataTable", url, false);
			isStatsView = cvUtil.getParameterByName("statsTable", url, false);
		}
		var form = $("#schForm");
		form.find('input[id=PDF]').removeAttr('disabled');
		form.find('input[id=HTML]').removeAttr('disabled');
		form.find('input[id=CSV]').removeAttr('disabled');
		if (type == "duplicates" && isStatsView.toString() == "true") {
			form.find('input[id=PDF]').attr('disabled', 'disabled');
			form.find('input[id=HTML]').attr('disabled', 'disabled');
			form.find('input[id=CSV]').attr('checked', 'checked');
		} else if (isStatsView.toString() == "false" && isTableView.toString() == "false") {
			form.find('input[id=CSV]').attr('disabled', 'disabled');
		}

	}
}

function enableCustomName() {
		var form = $("#schForm");
		var e = isChecked($("div[name=endUserSecurity]"));
		document.getElementById("reportCustomName").disabled = e;
}

function enableEmails() {
		var form = $("#schForm");
		var e = isChecked($("div[name=endUserSecurity]"));
		form.find("#emails").prop('disabled', e);
}

function enableDisableNetworkPath() {
	if (!isLMApplication()) {
		var form = $("#schForm");
		var e = !isChecked($("div[name=networkShare]"));
		form.find("#networkPath").prop('disabled', e);
		form.find("#networkUser").prop('disabled', e);
		form.find("#networkPassword").prop('disabled', e);
		if(e){
			form.find(".networkPanelDetails").addClass("disabled");
		}else{
			form.find(".networkPanelDetails").removeClass("disabled");
		}
	}
}

function addComponentsToList(components,defaultList){
	if (components) {
		$("#components").empty();
		$.each(components,function(key, component) {
			$("#components").append('<option value="' + component.id + '">' + component.label + '</option>');
		});
		$("#componentOptions").removeClass('hidden');
		$("#components").multiselect({
					includeSelectAllOption : true,
					selectAllValue : 'all',
					nonSelectedText: 'All selected',
					allSelectedText: 'All selected',
					includeSelectAllIfMoreThan:2
		});

		if(defaultList){
			$("#components").val(defaultList.split(','));
			$("#components").multiselect("refresh");
		}

		//$("#components").bind("blur", updateComponentSelectionInTheUrl);

		$('.schedule-field').show();

	}
}



//function updateComponentSelectionInTheUrl(){
//	var currentUrl = "";
//	if ($("#components option").length > $("#components").val().length) {
//		  currentUrl = "&showComponents=" + $("#components").val().join(",");
//	}
//}

function setTime() {
	var ast = $("#activeStartTime").val(); // internal numeric value
	window.tpicker.cvTimepicker('setTime', Math.floor(ast / 3600), ((ast / 60) % 60));
	var aet = $("#activeEndTime").val(); // internal numeric value
	window.tEUntilpicker.cvTimepicker('setTime', Math.floor(aet / 3600), ((aet / 60) % 60));
}

reportSchedule.fillDropdowns = function(last12monthsDropdown) {
	for (var i = 0; i < 12; i++) {
		last12monthsDropdown.append("<option value=\"" + (i + 1) + "\">" + (i + 1) + "</option>");
	}
	$('.last12months').val(12); // To make the default selection of from-time to the last option.
};

$(document).ready(function() {
	reportSchedule.fillDropdowns($(".last12months"));
	cvUtil.getTopWindow().$('.ui-dialog-content').unmask();

	$("select.exportType").change(function(){
		var selectedDocument = $(this).children("option:selected").attr("title");
		var selectedExportType = $(this).val();

		setDialogStateForSelectedFormat(selectedExportType);

		$(".exportType").removeClass('disabled');
		var hideMonthlyCustomDocuments = $(".monthlyCustomDocumentHides");
		var hideCustomDocuments = $(".customDocumentHides");
		if(selectedDocument != "ESP Quarterly PPT" && selectedDocument != "EMEA QBR" && selectedDocument != "ESP Monthly PPT"){
			hideMonthlyCustomDocuments.removeClass("hidden");
			hideCustomDocuments.addClass("hidden");
		}else if (selectedDocument == "ESP Monthly PPT"){
			hideCustomDocuments.removeClass("hidden");
			hideMonthlyCustomDocuments.addClass("hidden");
		}
		else{
			hideMonthlyCustomDocuments.removeClass("hidden");
			hideCustomDocuments.removeClass("hidden");
		}
	});

	//$("#componentSelection").hide();
	if (isLMApplication()) {
		API_SCHEDULE_ADD = "/logMonitoring/addLMSchedule.do";
		API_SCHEDULE_MODIFY = "/logMonitoring/modifyLMSchedule.do";
		API_SCHEDULE_DELETE = "/logMonitoring/deleteReportSchedule.do";
		PARAM_URL = "searchUrl";
		isLMApp = true;
		if (parent.searchObj != undefined && parent.searchObj.Id > 0) {
			$("#searchInfo").attr("data-searchName", parent.searchObj.Id);
			$("#searchInfo").attr("data-searchName", parent.searchObj.Name);
		} else {
			$("#searchName").removeClass("disabledActions disabled");
			$("#searchInfo").attr("data-searchName", parent.$("#keyword").val());
		}
	}

	else if (isWebAnalytics()) {
		API_SCHEDULE_ADD = "/webanalytics/addReportSchedule.do";
		API_SCHEDULE_MODIFY = "/webanalytics/modifyReportSchedule.do";
		API_SCHEDULE_DELETE = "/webanalytics/deleteReportSchedule.do";
		isWAApp = true;
	} else if (isAnalyticsReports()) {
		API_SCHEDULE_ADD = "/cireports/addReportSchedule.do";
		API_SCHEDULE_MODIFY = "/cireports/modifyReportSchedule.do";
		API_SCHEDULE_DELETE = "/cireports/deleteReportSchedule.do";
	}

	window.reportEnum = decodeURIComponent ( cvUtil.getParameterByName(PARAM_REPORT_ENUM) );
	window.reportUniqId = decodeURIComponent ( cvUtil.getParameterByName(PARAM_REPORT_UNIQID) );
	if (isWAApp) {
		window.reportEnum = "WebAnalytics";
	}

	if(cv && cv.additionalSettings && cv.additionalSettings.Console && cv.additionalSettings.Console.showReportComponentSelection){
		if (window.reportEnum === "CustomReports") {
			var components = cvUtil.getParameterByName("components");
			if(components){
				components = JSON.parse(components);
				addComponentsToList(components);
			}
			$("#hideReportSummaryOption").show();
		}
	}

	if (window.reportEnum != "CustomReports") {
		$("div[id=endUserSec]").hide();
	}

	$('input[id="PPTX"]').before('<br/>');

	$(".dayToRun").bind('checkedState unCheckedState', function() {
		enableDisableOk();
	});

	$("input[name=freqType]").click(function() {
		setFieldVisibility();
		enableDisableOk();
	});
	$("select[name=exportType]").click(function() {
		setEmailTypeVisibiity();
	});

	$(".networkShare").bind('checkedState unCheckedState', function() {
		enableDisableNetworkPath();
	});

	$(".endUserSecurity").bind('checkedState unCheckedState', function() {
		enableEmails();
		enableCustomName();
	});

	$(".repeatEveryNHours").bind('checkedState unCheckedState', function() {
		reportsUtil.enableDisableRepeatEveryElements("#schForm");
	});
	$("input#networkPassword").on("focus", function() {
		if (!$("#passwordChanged").val() || $("#passwordChanged").val() == "false") {
			$("#networkPassword").val("");
		}
		$("#passwordChanged").val("true");
	});
	$("#reportCustomName").bind('keyup input', function(event) {
		validateEndUserSecurity();
	});
	$("#dateSpinner").bind('keyup input', function(event) {
		validateDateSpinner();
	});
	$("#repeatNmonths").bind('keyup input', function(event) {
		validateRepeatNmonths();
	});

	$("#everyNHoursSpinner, #everyNMinsSpinner").bind('keyup input', function(event) {
		reportsUtil.validateRepeatNHours("input[name=freqType]:checked");
	});

	$("#dateSpinner").bind('keydown', function(evt) {
		var arrayExceptions = [ 8, 13, 16, 17, 18, 20, 27, 35, 36, 37, 38, 39, 40, 45, 46, 144 ];
		if ((evt.which < 48 || evt.which > 57) && (evt.which < 96 || evt.which > 106) && // NUMPAD
		$.inArray(evt.which, arrayExceptions) === -1) {
			return false;
		}
	});
	$("input[name=monthSelection]").click(function() {
		var monthSelection = $("input[name=monthSelection]:checked").val();
		$("#daySelectorInput select").prop('disabled', monthSelection == 'dateSelector');
		$("#dateSpinner").prop("disabled", monthSelection != 'dateSelector');
		if (!isNullOrEmpty($("#dateSpinner").val())) {
			validateDateSpinner();
		}
		if ( monthSelection == 'dateSelector' ) {
			$("#daySelectorInput").addClass("disabled");
			$("#dateSpinner").removeClass("disabled");
		} else {
			$("#daySelectorInput").removeClass("disabled");
			$("#dateSpinner").addClass("disabled");
		}
	});

	window.tpicker = $("#activeStartTimeDisplay").cvTimepicker({
		change : function(event, data) {
			validateTime(false, "#activeStartTimeDisplay");
		}
	});
	window.tEUntilpicker = $("#activeEndTimeDisplay").cvTimepicker({
		change : function(event, data) {
			validateTime(false, "#activeEndTimeDisplay");
		}
	});

	if (isLMApplication()) {

		if (parent.isScheduleTab()) {
			var taskId = cvUtil.getParameter("taskId", "");
			if (taskId != "") {
				var scheduleInfo = parent.scheduleMap[parseInt(taskId)];
				var lmSearchInfo = scheduleInfo.lmSearchInfo;
				$("#cancelButton").css("display", "none");
				$("#closeButton").css("display", "none");

				$("#searchInfo").attr("data-searchId", lmSearchInfo.searchId);
				$("#searchInfo").attr("data-searchName", lmSearchInfo.searchName);

				setModel(scheduleInfo);
			}
		} else {
			setModel();
			$("#description").val(parent.$("#keyword").val());
		}
	} else {
		var initialModel = cvUtil.getInitModalData();
		setModel(initialModel);
	}

	if (!window.networkShareEnabled || (cv.isTenantUser || cv.isTenantAdmin)) {
		$("#content").addClass("networkShareDisabled");
		var form = $("#schForm");
		unCheckCb($("div[name=networkShare]"), false);
		form.find("#networkPath").val('');
		form.find("#networkUser").val('');
		form.find("#networkPassword").val('');
	}


	console.debug("Check if report contains data cube");
	var reportId = cvUtil.getParameterByName('reportId',decodeURIComponent(model.savedUrl));
	var containDataCube = false;
	cvUtil.loadPageWithGET(cvUtil.getContextPath() + GET_REPORT_HANDLERS, {
		"reportId" : reportId
	}, function(data) {
		if (data && data.data && data.data.length>0) {
			containDataCube = true;
		}

		if (containDataCube) {
			$("div[id=endUserSec]").hide();
		}
	}, function(data) {
	});

	$("#schForm #formOptions input:radio").change(function(){
		if($("#schForm #formOptions #PPTX").prop("checked")==true && $("#schForm #formOptions #PPTX").val()=="EXECUTIVESUMMARY"){
			showExecutiveSummaryDetails();
		}
		else {
			hideExecutiveSummaryDetails();
		}
	});

	$("#updateScheduleParameters").click(function(e){
		var savedUrl = decodeURIComponent( $(this).attr("data-target-url") );
		savedUrl = cvUtil.getTopWindow().removeParamFromUrl("exportType",savedUrl);
		savedUrl = cvUtil.getTopWindow().removeParamFromUrl("pageSize",savedUrl);
		var link = cvUtil.getContextPath() + savedUrl;
		window.sessionStorage.setItem("editSchedule", $(this).attr("data-task-id") );
		cvUtil.getTopWindow().window.location=link;
		e.preventDefault();
	});

	$("#users-to-notify-input-field-container").click(function(e){
		startUsersLoading();
		e.stopPropagation();

	});

	$("#users-to-notify-input-field-container").focusin(function(e) {
		startUsersLoading();
		e.stopPropagation();
	});

	function startUsersLoading(){
		if ( ! $("#user-notify-list-hold").is(":visible") ){
			$("#user-notify-list-hold").show();
			$("#users-to-notify-input-field").focus();

			$("#users-notify-loading").show();
			$("#selected-users-section").hide();
			$("#available-users-section").hide();

			$("#available-users-search").val("");
			$("#selected-users-list").html("");
			$("#available-users-list").html("");

			loadUsers();
		}
	}

	$("#available-users-search").keyup(function(){
		var value = $(this).val();
		loadAvailableUsers(value);
	});


	$("#user-notify-list-hold").click(function(e){
		e.stopPropagation();
	});

	$("#user-notify-list-hold").on("click",".user-selection-change",function(e){
		var operation = $(this).attr("data-action");
		var idWithType = $(this).attr("id");
		$(this).closest(".user-hold").remove();
		var userObject = window.usersList.filter(function(el){
			return el.idWithType == idWithType;
		});
		if(userObject && userObject.length ==1 ){
			if(operation == "ADD"){
				addToSelectedUsers(userObject[0]);
			}else if(operation == "REMOVE"){
				deleteFromSelectedUsers(userObject[0]);
			}
		}

		var totalLen = parseInt($('#available-user-groups').attr("data-original-val"));
		if(!isNaN(totalLen)){
			$('#available-user-groups').html( totalLen - getSelectedUsers().length );
		}


		function addToSelectedUsers(obj){
			var list = $("#users-list-to-notify").data("usersToNotify");
			if(!list){
				list=[];
			}
			var userType;
			if(obj.type == 1 ){ //Type = 1 means user
				if(obj.name.indexOf("\\")==-1){
					userType = userTypes.USER;
				}else{
					userType = userTypes.EXTERNALUSER;
				}
			}else if (obj.type == 2 ){ //Type = 2 means user group
				if(obj.name.indexOf("\\")==-1){
					userType = userTypes.USERGROUP;
				}else{
					userType = userTypes.EXTERNALUSERGROUP;
				}
			}
			list.push({
				"userId": obj.id,
				"userType": userType,
				"userName": obj.name			
			});
			$("#users-list-to-notify").data("usersToNotify",list);
			$("#selected-users-list").append(generateSelectedUserHtml(obj));

			var value = $("#available-users-search").val();
			if(typeof value !="undefined"){
				loadAvailableUsers(value);
			}

			updateUsersToNotifyField();
		}

		function deleteFromSelectedUsers(obj){
			var list = $("#users-list-to-notify").data("usersToNotify");
			if(!list){
				list ="";
			}
			var result=[];
			list.forEach(function(userObj){
				generatedIdType = userObj.userId + "-" + userObj.userType;
				if( generatedIdType !=  obj.idWithType){
					result.push(userObj)
				}
			});
			$("#users-list-to-notify").data("usersToNotify",result);
			$("#available-users-list").append(generateAvailableUserHtml(obj));

			var len = parseInt($("#available-user-limit").text());
			if(!isNaN(len)){
				$('#available-user-limit').html( len+1 );
			}

			updateUsersToNotifyField();

		}

	});

	$("#okButton").click(function(e) {
		ok();
		e.preventDefault();
	});
	//	$("#deleteButton").click(function() {
	//		deleteSchedule(model.taskId);
	//	});
	$("#cancelButton").click(function(e) {
		setModel();
		e.preventDefault();
	});
	$("#closeButton").click(function() {
		window.returnData = {
			'isError' : false,
			'cancel' : true
		};
		exitSchedulePage();
	});
	$(document).click(function(){
		$("#user-notify-list-hold").hide();
	});

});

function setDialogStateForSelectedFormat(selectedExportType) {
	if (selectedExportType && selectedExportType.toUpperCase() == 'EMAIL_BODY') {
		// disable compress and network options.
		$(".notEmailBodyFriendly").addClass('disabled');
	} else {
		$(".notEmailBodyFriendly").removeClass('disabled');
	}
}

function normalizeSecurityAPIResult(data){
	var jsonData = JSON.parse(data)["records"];
	var finalData = new Array();

	for (var i = 0; i < jsonData.length; i++) {
		var indData = {
				id :jsonData[i][2],
				name: jsonData[i][3],
				type:jsonData[i][4],
				email: jsonData[i][5]
		};
		if(jsonData[i][4] == 1 ){ //Type = 1 means user
			if(jsonData[i][3].indexOf("\\")==-1){
				indData.idWithType = jsonData[i][2]+"-"+userTypes.USER;
			}else{
				indData.idWithType = jsonData[i][2]+"-"+userTypes.EXTERNALUSER;
			}
		}else if (jsonData[i][4] == 2 ){ //Type = 2 means user group
			if(jsonData[i][3].indexOf("\\")==-1){
				indData.idWithType = jsonData[i][2]+"-"+userTypes.USERGROUP;
			}else{
				indData.idWithType = jsonData[i][2]+"-"+userTypes.EXTERNALUSERGROUP;
			}
		}
		finalData.push(indData);
	}
	return finalData;
}

function loadUsers(){
	var additionalParams='';
	if(getSelectedUsers().length > 0){ // Load selected users first
		list= getSelectedUsers();
		var searchText=new Array();
		list.forEach(function(element){
			var el = element.split("-");
			if(el[0]){
				searchText.push(el[0]);
			}
		});
		additionalParams='&where=%5Bid%5D%20%3D%20_exprInt(%22'+encodeURI( searchText.join(" OR ") )+'%22)';
		reportsUtil.getSecurityAPIInfo(null,additionalParams,function(data){
			var convertedData = normalizeSecurityAPIResult(data);
			saveUsersInfo(convertedData);
			var finalHtml="";
			var selectedUsersListObj = window.usersList.filter(function(el){
				return jQuery.inArray(el.idWithType,list)>-1;
			});
			selectedUsersListObj.forEach(function(el){
				finalHtml+=generateSelectedUserHtml(el);
			});
			$("#selected-users-list").html(finalHtml);
			loadAvailableUsers();
		});
	}else{
		loadAvailableUsers();
	}


}

function loadComponentsFromReport(reportId,pageName,selectedComponents){
	reportsUtil.getCustomReport(reportId,function(data){
		var report = JSON.parse(data);
		var page = null;
		if(pageName && report.pages.length > 1){
			for (var i = 0; i < report.pages.length; i++) {
                if(report.pages[i].pageName === pageName){
                	page = report.pages[i];
                	break;
                }
			}
		}else{
			page = report.pages[0];
		}

		var reportComps = JSON.parse(page.body).reportComponents;
		var exportComponents=[];
		for(var i in reportComps){
			var component = reportComps[i];
			var label = component.title && component.title.text ? component.title.text : component.id;
	        exportComponents.push({id:component.id,label:label});
		}
		addComponentsToList(exportComponents,selectedComponents);
	});
}

function loadAvailableUsers(searchText){
	var additionalParam = "";
	var limit = 100;
	if(searchText){
		additionalParam = '&where=%5Bnameemail%5D%20%3D%20_exprString (%22' + encodeURIComponent(searchText) +'%22%2C%22contains%22)'
	}else{
		searchText="";
	}

	var availableUsersListObj = window.usersList.filter(function(el){
		return $('#selected-users-list').find("#"+el.idWithType).length == 0 && el.name.toLowerCase().indexOf(searchText.toLowerCase())>-1;
	});
	if(availableUsersListObj.length<limit){
		if(availableUsersListObj.length > 0){
			updateHtml(availableUsersListObj);
		}
		$("#available-users-loading").show();
		reportsUtil.getSecurityAPIInfo(200,additionalParam,function(data){
			if(!searchText && !$('#available-user-groups').text() && JSON.parse(data).totalRecordCount){
				$('#users-available-meta').show();
				$('#available-user-groups').html(JSON.parse(data).totalRecordCount);
				$('#available-user-groups').attr("data-original-val",JSON.parse(data).totalRecordCount);

			}
			var convertedData = normalizeSecurityAPIResult(data);
			saveUsersInfo(convertedData);
			var availableUsersListObj = window.usersList.filter(function(el){
				return $('#selected-users-list').find("#"+el.idWithType).length == 0 && el.name.toLowerCase().indexOf(searchText.toLowerCase())>-1;
			});
			updateHtml(availableUsersListObj);
		});
	}else{
		updateHtml(availableUsersListObj);
	}

	function updateHtml(availableUsersListObj){
		availableUsersListObj = availableUsersListObj.slice(0,limit);
		var finalHtml="";
		availableUsersListObj.forEach(function(el){
			finalHtml+=generateAvailableUserHtml(el);
		});
		$("#available-user-limit").html(availableUsersListObj.length);

		$("#available-users-loading").hide();
		$("#available-users-list").html(finalHtml);

		$("#users-notify-loading").hide();
		$("#selected-users-section").show();
		$("#available-users-section").show();
	}

}

function updateUsersToNotifyField(){
	if(getSelectedUsers().length>0){
		$("#users-to-notify-input-field").val(getSelectedUsers().length+" "+cvUtil.cvLocalize('schedule.selected'));
	}else{
		$("#users-to-notify-input-field").val(cvUtil.cvLocalize('schedule.none_selected'));
	}
}

function saveUsersInfo(finalData){
	//Adding non duplicate objects to emailSuggestion.usersWithEmail
    var mergedArray = window.usersList;
    for (var i = 0; i < finalData.length; i++) {
      var alreadyExists = false;
      for (var j = 0; j < window.usersList.length; j++) {
        if (window.usersList[j].id == finalData[i].id && window.usersList[j].type == finalData[i].type ) {
          alreadyExists = true;
          break;
        }
      }
      if (!alreadyExists) {
        mergedArray.push(finalData[i]);
      }
    }
    mergedArray = mergedArray.sort(function(a,b){
    	if(a.type > b.type) {//Sort by type, larger type first
			return -1;
		}
    	if(a.type <b.type ) {
			return 1;
		}

    	if(a.name > b.name) {
			return 1;
		}
    	if(a.name < b.name) {
			return -1;
		}
    });
    window.usersList=mergedArray;
}

function generateSelectedUserHtml(data){ //Users to notidy section, generate html for a single Selected User
	var name = '<span title="'+data.name+'">'+data.name+'</span>';
	if(data.type == 2){
		name = '<strong>'+name+'</strong>';
	}
	return '<div class="user-hold"> <input type="checkbox" class="user-selection-change" title="Remove" data-action="REMOVE" id="'+data.idWithType+'" checked/>  <span class="username-hold">'+name+' </span> </div>';
}

function generateAvailableUserHtml(data){ //For available users
	var name = '<span title="'+data.name+'">'+data.name+'</span>';
	if(data.type == 2){
		name = '<strong>'+name+'</strong>';
	}
	return '<div class="user-hold"> <input type="checkbox" class="user-selection-change" title="Add" data-action="ADD" id="'+data.idWithType+'"/>  <span class="username-hold">'+name+' </span> </div>';
}

function showExecutiveSummaryDetails(){
	//	$("#executiveSummaryHide").show();
	//	validatePPTX=true;
}
function hideExecutiveSummaryDetails(){
	$("#executiveSummaryHide").hide();
	validatePPTX=false;
}
