var oTable;
$(document).ready(function() {
	$("#schedulesList").hide().parents(".vw-panel").addClass("vw-start-hidden");
	if (isLMApplication() && parent.isScheduleTab()) {
		$(".scheduleTitle").css("display", "none").parent(".panel-heading").addClass("vw-start-hidden");
		return;
	}

	var config = {
		"aoColumns" : [ {
			"sTitle" : '',
			"mDataProp" : "descriptionDummyProperty",
			"sDefaultValue" : "1",
			"fnRender" : function(o, val) {
				var sp = $('<span></span>');
				var obj = o.aData;
				if (obj.disabled)
					sp.addClass("grayedOut disabled");
				sp.text(obj.description);
				return $('<div></div>').append(sp).html();
			}
		}, {
			"sTitle" : '',
			"mDataProp" : "actionEdit",
			"sDefaultValue" : "1",
			"fnRender" : function(o, val) {
				return '<span class="glyphicon glyphicon-pencil vw-cursor-pointer" title="Edit"></span>';
			}
		}, {
			"sTitle" : '',
			"sClass" : "deleteTd",
			"mDataProp" : "actionDelete",
			"sDefaultValue" : "1",
			"fnRender" : function(o, val) {
				return '<span class="glyphicon glyphicon-remove vw-cursor-pointer" title="Delete"></span>';
			}
		} ],
		"sAjaxSource" : isLMApplication() ? "lmSchedules.do" : "reportSchedules.do",
		"fnServerParams" : function(aoData) {
			aoData.push({
				"name" : "reportType",
				"value" : window.reportEnum
			}, {
				"name" : "reportUniqId",
				"value" : window.reportUniqId || ''
			}, {
				"name" : "searchId",
				"value" : isLMApplication() ? parseInt($("#searchInfo").attr("data-searchId")) == 0 ? -1
						: $("#searchInfo").attr("data-searchId") : ""
			}, {
				"name" : "currentMonitoringApplication",
				"value" : isLMApplication() ? parent.getCurrentMonitoringApp() : ""
			});
		},
		"sDom" : ""
	};
	oTable = Table.configureAjaxTable('schedulesList',
			"Existing Schedules",
			"No schedules",
			config,
			'Error occured while loading schedules.');
	$("#schedulesList").on("click", "tbody td:not(.deleteTd)", function() {
		var tr = $(this).closest('tr');
		$(".selected").removeClass("selected");
		$(tr).addClass("selected");
		var task = oTable.fnGetData(tr[0]);
		if (window.setModel) {
			setModel(task);
			$("#schedulesList").show().parents(".vw-panel").removeClass("vw-start-hidden");
		}
	});
	$("#schedulesList").on("click", "tbody td.deleteTd", function() {
		var task = oTable.fnGetData($(this).closest('tr')[0]);
		deleteSchedule(task.taskId, task.description, task.exportType.toLowerCase());
		//setmodel
	});
	window.refreshSchedulesTable = function() {
		$("#schedulesList").mask();
		oTable.fnReloadAjax(null, function() {
			$("#schedulesList").unmask("Loading");
		}, true);
	};
});
