var reportsSearch = false;
var page = "";

var reportAdvanceSearch = (function() {
	var contentSearch = {
		TYPE_DESCRIPTION : 0,
		TYPE_CONTENT : 1,
		TYPE_COLUMNNAME : 2,
	};

	var SOLRMETADATA = [ //for the headers
			"cvseaid",
			"data_source_type",
			"data_source",
			"_version_",
			"timestamp",
			"score",
			"data_source_name",
			"contentid",
			"Description",
			"Name" ];

	var SOLRMETADATA2 = [
			"cvseaid",
			"data_source_type",
			"data_source",
			"_version_",
			"timestamp",
			"score",
			"data_source_name",
			"contentid" ];
	contentSearch.init = function() {
		var params = {};
		params.URL = isReportSearchConfiguredURL();
		if (params.URL) {
			submitRequest(params, enableAdvanceSearch);
		}
		/*
		 * params.URL = getDataSourceReportMapUpdateRequestURL(); submitRequest(params,populateDataSourceMap);
		 */
	}

	function enableAdvanceSearch(isEnabled) {
		if (isEnabled === "1") {
			contentSearch.hideShowContentSearchbox("advanceSearch");
			var params = {};
			params.URL = getDataSourceReportMapUpdateRequestURL();
			submitRequest(params, populateDataSourceMap);

		} else {
			contentSearch.hideShowContentSearchbox("reportFilter");
		}

	}
	function isReportSearchConfiguredURL() {
		page = getUrlParameter('page');
		if (page == 'Reports') {
			return cvUtil.getContextPath() + '/server/isReportSearchConfigured.do?';
		}
	}
	;

	function getAdvanceSearchRequestUrl() {
		return cvUtil.getContextPath() + '/server/reportContentSearch.do?';
	}
	;

	function getDataSourceReportMapUpdateRequestURL() {
		return cvUtil.getContextPath() + '/server/dataSourceMap.do?';
	}
	;

	function submitRequest(paramObj, callback) {
		var url = paramObj.URL;
		var select = paramObj.select;
		var searchContent = paramObj.searchContent;
		$("#searchBox").addClass("disabled");
		cvUtil.loadPage(url, paramObj, function(data1) {
			$("#searchBox").removeClass("disabled");
			if (!!callback && typeof callback == 'function') {
				callback(data1, select, searchContent);
			}
		}, function(xhr, ajaxOptions, thrownError, action) {
			$("#searchBox").removeClass("disabled");
			var message = null; //decide based on action 
			errFun(xhr, ajaxOptions, thrownError, message);
		}

		);
	}

	function errFun(xhr, ajaxOptions, thrownError, message) {
		if (xhr.status == 0 && xhr.statusText != "userAborted") {
			cvUtil.errorToast(cvUtil.cvLocalize("generic_error"), "");
		} else {
			cvUtil.errorToast(message + " " + thrownError);
		}
	}
	;
	function populateDataSourceMap(data) {
		contentSearch.dataSourceReportMap = JSON.parse(data);
	}

	function showAdvanceSearchResult(searchResp, select, searchContent) {

		searchResp = $.parseJSON(searchResp);
		cvUtil.unmask('#advanceSearchDiv');
		cvUtil.unmask("#reportSearchDiv");
		showMatchedReports(contentSearch.dataSourceReportMap, searchResp, select, searchContent);
		console.log("searchResp" + searchResp);
	}
	function showMatchedReports(dataSourceReportMap, searchResp, select, searchContent) {
		var reportList = {};
		var tagList = [];
		if (searchResp == null) {
			if (select == 1) {
				$("#contentText").empty();
				$("#contentText").append(searchContent.replace(":*", " ").toUpperCase());
				$("#searchByContent").show();
				$("#searchByColumn").hide();
				$("#noContentDataNotificationPanel").show();
			} else if (select == 2) {
				$("#columnText").empty();
				$("#columnText").append(searchContent.replace(":*", " ").toUpperCase());
				$("#searchByColumn").show();
				$("#searchByContent").hide();
				$("#noContentDataNotificationPanel").show();
			} else {
				$("#noContentDataNotificationPanel").hide();
				$("#noDataNotificationPanel").show();
			}
			return;
		}
		var customReport = $.parseJSON(searchResp.CustomReport);
		var metricsReport = $.parseJSON(searchResp.MetricReport);
		var hasCustomReports = processMatchedReport('custom',
				customReport,
				dataSourceReportMap,
				reportList,
				tagList,
				select);
		var hasMetricsReports = processMatchedReport('metrics',
				metricsReport,
				dataSourceReportMap,
				reportList,
				tagList,
				select);

		if (typeof dataSourceReportMap !== 'undefined' && (hasCustomReports || hasMetricsReports)) {
			$.each(tagList, function(index, associatedTagList) {
				//check if it already exists, else create one					
				var tagValue = associatedTagList[0];
				if ($("#advanceSearchDiv #" + tagValue.tagId).length > 0) {
					return;
				}
				if ($("#advanceSearchDiv #" + tagValue.tagId).length == 0) {
					createTag(tagValue.tagId, tagValue.tagName, true, "#advanceSearchDiv");
				}
				$.each(reportList, function(key, report) {
					var values = $(report).data("tag");
					if ((values instanceof Array) == true && values.length > 0) {
						for (var i = 0; i < values.length; i++) {
							var reportTag = values[i].tagId;
							if (tagValue.tagId === reportTag) {
								$(report).appendTo("#advanceSearchDiv #" + reportTag + "list").css("display", "block");
							}
						}
					}

				});
			});
		} else {
			//default advance search is by content (select ==0)
			if (select == 1 || select == 0) {
				$("#contentText").empty();
				$("#contentText").append(searchContent.replace(":*", " ").toUpperCase());
				$("#searchByContent").show();
				$("#searchByColumn").hide();
				$("#noContentDataNotificationPanel").show();
				$("#noDataNotificationPanel").hide();
			} else if (select == 2) {
				$("#columnText").empty();
				$("#columnText").append(searchContent.replace(":*", " ").toUpperCase());
				$("#searchByColumn").show();
				$("#searchByContent").hide();
				$("#noContentDataNotificationPanel").show();
				$("#noDataNotificationPanel").hide();
			} else if (select != 0) {
				$("#noContentDataNotificationPanel").hide();
				$("#noDataNotificationPanel").show();
			}
		}
		console.log(tagList);
	}

	function processMatchedReport(reportType, reports, dataSourceReportMap, reportList, tagList, select) {
		var hasReports = false;
		var untagged = {};
		untagged.tagName = "Untagged";
		untagged.tagId = -1;

		if (!!reports && reports.grouped !== 'undefined' && reports.grouped.data_source &&
				(reports.grouped.data_source.groups instanceof Array) &&
				(reports.grouped.data_source.groups.length > 0)) {
			hasReports = true;

			var resultGroups = reports.grouped.data_source.groups;
			var groups = [];
			var group, tableObj, sourceName;
			//filter data
			//Column search should consider only rows with Dummy data source name

			for (var index = 0; index < resultGroups.length; index++) {
				group = resultGroups[index];
				tableObj = group.doclist.docs;
				sourceName = "";

				if ((tableObj instanceof Array) == true && tableObj.length > 0) {
					var row = tableObj[0];

					if (select == 2) {
						if (row.data_source_name && (row.data_source_name.toLowerCase().indexOf("dummy") != -1)) {
							groups.push(group);
						}
					} else {
						if (row.data_source_name && (row.data_source_name.toLowerCase().indexOf("dummy") == -1)) {
							groups.push(group);
						}
					}
				}
			}

			$.each(groups, function(index, value) {
				if (dataSourceReportMap[value.groupValue]) {
					var reportId = dataSourceReportMap[value.groupValue]['ReportId'];
					var matchedTableMetaData = dataSourceReportMap[value.groupValue];
					var report = reportList[reportType + "-" + reportId];
					var matchedTable, tableName = "";
					if (report !== undefined) {
						matchedTable = createMatchedDataTable(matchedTableMetaData["TableName"], value.doclist.docs);
						$(report).children("#matchedDivtemplate").append(matchedTable);
					} else {
						report = $(".tagSections #reportItem[data-unique='" + reportType + "_" + reportId + "']")
								.clone(true, true);
						if (report.length == 0) {
							report = createDummyReport(matchedTableMetaData);
						}

						if (select == 2) { //for column search
							if (value.doclist && value.doclist.docs && value.doclist.docs.length > 0) {
								tableName = value.doclist.docs[0].Name || "";
							}
						} else {
							tableName = matchedTableMetaData["TableName"];
						}
						matchedTable = createMatchedSection(matchedTableMetaData['Description'],
								tableName,
								value.doclist.docs,
								value.groupValue);
						$(report).append(matchedTable);
					}

					var tag = $(report).data('tag');
					if (tag === undefined && tagList.indexOf(untagged) === -1) {
						$(report).data('tag', [ untagged ]);
						tagList.push([ untagged ]);
					} else if (tag != undefined && tagList.indexOf(tag)) {
						tagList.push(tag);
					}
					reportList[reportType + "-" + reportId] = report;
				}
			});
		}

		return hasReports;
	}

	function createMatchedSection(description, tableName, tableObj, groupValue) {
		var matchedSection = $("#matchedDivtemplate").clone().show();
		var matchedDataTable = createMatchedDataTable(tableName, tableObj, groupValue);
		$(matchedSection).children("#reportDescription")
				.append("<span class='matchedLabel'>Description :</span><span>" + description + "</span");

		$(matchedSection).children("#dataMatchedDiv").html($(matchedDataTable).html());
		return matchedSection;
	}

	function createMatchedDataTable(tableName, tableObj, groupValue) {
		var dataMatchedDiv = $("#matchedDivtemplate #dataMatchedDiv").clone();
		$(dataMatchedDiv).find("#dataTableName").append("<span class='matchedLabel'>Table Name :</span><span>" +
				tableName + "</span");
		$(dataMatchedDiv).find("#dataTableName").attr("data-groupValue", groupValue);
		var dataTableHeaderRow = $(dataMatchedDiv).children("#dataTableHeaderRow").empty();
		var dataTableContent = $(dataMatchedDiv).children("#dataTableContent");
		createMatchedDataTableHeader(tableObj, dataTableHeaderRow);
		createMatchedDataTableRow(tableObj, dataTableContent);
		return dataMatchedDiv;
	}
	function createMatchedDataTableHeader(tableObj, dataTableHeaderRow) {
		var tableHeaderRowTemp = $(dataTableHeaderRow);
		var inputText = getSearchString(contentSearch.TYPE_COLUMNNAME);
		var tableRowTemp = "";
		var tableCellTemp = "";
		var regExp, wordMatch, matchCtr, resultCell, substrHolder;
		if ((tableObj instanceof Array) == true && tableObj.length > 0) {
			var row = tableObj[0];
			var colList = Object.keys(row);
			if ((colList instanceof Array) == true && colList.length > 0) {
				for (var j = 0; j < colList.length; j++) {
					if ($.inArray(colList[j], SOLRMETADATA) !== -1) {
						continue;
					}
					tableCellTemp = colList[j];
					inputText = inputText.toLowerCase();
					if (tableCellTemp.toLowerCase().indexOf(inputText.toLowerCase()) > -1 && inputText != '*') {
						regExp = new RegExp(inputText, "gi");
						wordMatch = tableCellTemp.match(regExp);
						substrHolder = "", resultCell = "";
						for (matchCtr = 0; matchCtr < wordMatch.length; matchCtr++) {
							substrHolder = tableCellTemp.substring(0, tableCellTemp.toLowerCase().indexOf(inputText));
							resultCell += substrHolder + "<b>" + wordMatch[matchCtr] + "</b>";
							tableCellTemp = tableCellTemp.substring(tableCellTemp.toLowerCase().indexOf(inputText) +
									inputText.length);
						}
						if (tableCellTemp.trim().length > 0) {
							resultCell += tableCellTemp;
						}
					} else {
						resultCell = tableCellTemp;
					}
					tableRowTemp += (" " + resultCell);
				}

			}
			$(tableHeaderRowTemp).append(tableRowTemp + '<p>');
		}

		return tableHeaderRowTemp;
	}
	function createMatchedDataTableRow(tableObj, dataTableContent) {
		var inputText = getSearchString(contentSearch.TYPE_CONTENT);
		var tableRowTemp = "";
		var tableCellTemp = "";
		var regExp, regExp2, resultCell, substrHolder, noHightLight = false;
		//SOLR * is ".*, SOLR ? is ".."
		if (inputText.trim() === "*") {
			noHightLight = true;
		}
		inputText = inputText.replace(/\?/g, ".");
		inputText = inputText.replace(/\*/g, ".*");
		if ((tableObj instanceof Array) == true && tableObj.length > 0) {
			for (var i = 0; i < tableObj.length; i++) {
				var row = tableObj[i];
				var colList = Object.keys(row);
				tableRowTemp = $(dataTableContent).children("#dataTableContentRow").clone().empty();
				if ((colList instanceof Array) == true && colList.length > 0) {
					for (var j = 0; j < colList.length; j++) {
						if ($.inArray(colList[j], SOLRMETADATA2) !== -1) {
							continue;
						}
						tableCellTemp = row[colList[j]].toString();
						regExp = new RegExp(inputText, "gi");
						if (!noHightLight && regExp.test(tableCellTemp)) {
							var words = tableCellTemp.split(" ");
							var newStr = [];
							$.each(words, function(mIndex, mValue) {
								regExp2 = new RegExp(inputText, "gi");
								var matches = mValue.match(regExp2);
								if (matches != null && matches.length > 0) {
									var tempStr = "", formattedStr = "";
									$.each(matches, function(idx, m) {
										tempStr = mValue.substring(0, mValue.toLowerCase().indexOf(m.toLowerCase()));
										formattedStr += tempStr + "<b>" + m + "</b>";
										tempStr = mValue.substring(mValue.toLowerCase().indexOf(m.toLowerCase()) +
												m.length);
									});
									if (tempStr.trim().length > 0) {
										formattedStr += tempStr;
									}
									newStr.push(formattedStr);
								} else {
									newStr.push(mValue);
								}
								resultCell = newStr.join(" ");
							});

						} else {
							resultCell = tableCellTemp;
						}

						$(tableRowTemp).append(" " + resultCell);
					}
					$(dataTableContent).append(tableRowTemp);
				}
			}
		}
		return dataTableContent;
	}
	function createDummyReport(reportMetadata) {
		var report = $("#reportEntity #reportItem").clone(true, true);
		$(report).data("unique", "metrics_" + reportMetadata.ReportId);
		$(report).find("img").attr("src", "img/customIcon/data-table.png").attr("alt", reportMetadata.ReportName);
		$(report).find("a").attr("href", ".." + reportMetadata.HyperLink).text(reportMetadata.ReportName);
		$(report).find("a").attr("title", reportMetadata.ReportName);
		return report;
	}
	function getSearchString(searchOn) {
		var inputText = $("input#reportFilterSearch").val().trim();
		inputText = inputText.indexOf(':') > -1 ? inputText.split(':') : inputText;
		if ((inputText instanceof Array) == true && searchOn === contentSearch.TYPE_CONTENT) {
			inputText = inputText[1];
		} else if ((inputText instanceof Array) == true && searchOn === contentSearch.TYPE_COLUMNNAME) {
			inputText = inputText[0];
		}
		return inputText;
	}
	contentSearch.hideShowContentSearchbox = function(selected) {
		$("#searchBox").children("#reportFilterSearch").show();
		switch (selected) {

		case "reportFilter":
			$("#searchBoxImg").removeClass("advanceSearch").addClass("filterSearch");
			$("#reportAdvanceSearch_section").remove();
			break;

		case "advanceSearch":
			$("#searchBoxImg").removeClass("filterSearch").addClass("advanceSearch");
			break;
		}
	};
	contentSearch.showHideAdvanceSearchSection = function(filterString, event) {
		var searchSection = $("#reportAdvanceSearch_section");
		var noContentDataNotificationPanel = $("#noContentDataNotificationPanel");
		var reportAdvanceSearchString = filterString + " ";
		if (noContentDataNotificationPanel.is(":visible")) {
			noContentDataNotificationPanel.hide();
		}
		if (searchSection.is(":visible")) {
			var selection = searchSection.find("li.selected");
			if (event.which == 13) { // enter key
				var selectedOpt;
				if (selection.length > 0) {
					selectedOpt = $(selection[0]).val();
				} else {
					reportAdvanceSearch.searchAcrossReports(filterString, selection.length);
				}

				reportAdvanceSearch.searchAcrossReports(filterString, selectedOpt);

				searchSection.hide();
			} else if (event.which == 27) { // escape key
				$("#reportFilterSearch").val("").keyup();
			} else {
				if (event.which == 38) { // up arrow
					if (selection.length > 0) {
						searchSection.find("li").removeClass("selected ui-state-hover");
						var prevLi = $(selection[0]).prev();
						if (prevLi.length > 0) {
							prevLi.addClass("selected ui-state-hover");
						} else {
							searchSection.find("#reportColumn").addClass("selected ui-state-hover");
						}
					} else {
						searchSection.find("#reportColumn").addClass("selected ui-state-hover");
					}
				} else if (event.which == 40) { // down arrow
					if (selection.length > 0) {
						searchSection.find("li").removeClass("selected ui-state-hover");
						var nextLi = $(selection[0]).next();
						if (nextLi.length > 0) {
							nextLi.addClass("selected ui-state-hover");
						} else {
							searchSection.find("#reportContent").addClass("selected ui-state-hover");
						}
					} else {
						searchSection.find("#reportContent").addClass("selected ui-state-hover");
					}
				} else {
					contentSearch.reset(filterString);
				}
			}
		} else {
			contentSearch.reset(filterString);
		}
		event.stopPropagation();
		event.preventDefault();

	};

	contentSearch.reset = function(filterString) {
		var reportAdvanceSearchString = filterString + " ";
		var searchSection = $("#reportAdvanceSearch_section");
		if (filterString.trim().length === 0) {
			$("#reportSearchDiv").show();
			$("#advanceSearchDiv").hide();
			searchSection.hide();
			$("#noDataNotificationPanel").hide();
			return;
		}
		$("#reportAdvanceSearch_section #reportContent #reportContentSpan").text(reportAdvanceSearchString);
		$("#reportAdvanceSearch_section #reportColumn #reportColumnSpan").text(reportAdvanceSearchString);
		searchSection.find("li").removeClass("selected ui-state-hover");
		searchSection.show();
	};

	function getSelectedIndex() {
		var searchSection = $("#reportAdvanceSearch_section");
		if (searchSection.is(":visible")) {
			var selection = $(".adv-srch-opt").find(".selected");
			if (!!selection && selection.length > 0) {
				return selection[0].val();
			}
		} else {
			return 0;
		}
	}

	contentSearch.searchAcrossReports = function(filterString, select) {
		$("#noDataNotificationPanel").hide();
		$("#reportSearchDiv").hide();
		$("#advanceSearchDiv").show();
		$("#advanceSearchDiv").empty();
		cvUtil.mask('#advanceSearchDiv', cvUtil.cvLocalize("FetchingMatchedReport"));
		var params = {};
		params['searchContent'] = filterString;
		params['pageOffset'] = 0;
		params.URL = getAdvanceSearchRequestUrl();
		params.select = select;
		submitRequest(params, showAdvanceSearchResult);
	};
	return contentSearch;

}).call(this);

$(document).on("ready", function() {
	;
	reportAdvanceSearch.init();

	$("body").on("click", ".navHeaderLi", function(e) {
		page = getUrlParameter('page');
		if (reportsSearch == false && page == 'Reports') {
			reportAdvanceSearch.init();
			reportsSearch = true;
		}
	});
});