function InitReport(options) {
	window.urlParamDelimiter = "-";
	cvUtil.DEFAULT_TIMEOUT = 10 * 60 * 1000; //export can take long times as it processes all pages so increasing it to 10 min.
	this.fireHistoryChange = true;
	this.requestString = {};
	this.requestString.invisible = {
		"initial" : true
	};
	this.isExport = false;

	this.type = options.type;
	this.reportTitle = options.reportTitle || 'Default';
	this.idtomask = options.idtomask;
	this.chartIds = options.chartIds;
	this.directPrint = options.directPrint || false;

	var report = this;
	report.REFRESH_REPORT_FILTERS_ONGENERATE = false;// flag to reset drilldown level on change of a filter e.g. timeframe
	if (debug != undefined) {
		debug.setLevel(1);
	}

	this.tableActionsAttached = false;

	this.init = function() {

		if (this.type != 'storageinformation' && this.type != 'filearchiver') {
			//			$(".exportatserver").click(function(){
			//				report.mask(this.idtomask, true, "Exporting...");
			//				requestString.invisible.exportType=this.id.substring("export".length);
			//				requestString.invisible.exportAll=true;
			//				report.isExport = true;
			//				cvUtil.loadPageWithGET(report.getRequestUrl(), "", function(data1) {
			//					$("#fileNameToDownload").val(data1);
			//					$("#exportForm").submit();
			//					report.unmask(this.idtomask);
			//				});
			//				requestString.invisible.exportType=undefined;
			//				isExport = false;
			//				requestString.invisible.exportAll=false;
			//			});
			var scheduleEmailOptions;
			if (window.location.pathname.indexOf('survey/reports/dashboard.jsp') > -1 ||
					window.location.pathname.indexOf('survey/profile/profilecustdashboard.jsp') > -1 ||
					window.location.pathname.indexOf('survey/reports/growthDashboard.jsp') > -1 ||
					window.location.href.indexOf('reports/index.jsp?page=Dashboard') > -1) {
				scheduleEmailOptions = {};
				scheduleEmailOptions.format = 'PDF,HTML,EMAIL_BODY';
			}
			reportsUtil.scheduleReport(scheduleEmailOptions);
			attachEmailHandler(scheduleEmailOptions);
			reportsUtil.attachTaskHandler();
			report.getExportUrl = function(exportType) {
				var url = document.URL;
				if (report.scaleReport && exportType == 'csv') {
					//					url = report.getRequestUrl();
					//					if(!url)
					//						url = document.URL;
					var gridparams = 'gridParams=' + window.encodeURIComponent(JSON.stringify(Reports.reportTableMap));
					url = url + "&" + gridparams;
				}
				return url;
			}
			report.getExportParams = function(exportType) {
				var url = report.getExportUrl(exportType);
				var custname = $('ul.nav .nav-customer-title').attr('title');
				custname = custname ? custname + ' - ' : '';
				var reportName = custname + $("#surveyName").text();
				url = window.convertToExportUrl(url, exportType);
				return {
					url : url,
					reportEnum : window.reportEnum,
					reportName : reportName
				};
			};
			$(".exportatserver").click(function() {
				report.exportReport(this);
			});

			$("#buildReportLink").click(function() {
				window.location.href = cvUtil.getContextPath() + "/reportsplus/";
			});
		}
		if (options.generateButtonId) {
			$("#" + options.generateButtonId).click(function() {
				// Commenting this as the table columns are not preserved on clicking Generate button - hravula
				//report.REFRESH_REPORT_FILTERS_ONGENERATE=true; //normally the reports that have a generate button will require this
				report.generateReport();
			});
		}

		report.initComponents();
		//resetting filter's value property as while refreshing page, it is holding old value.
		$("input[id*='_FilterSelected']").val('');
		// Respond to changes in the URL with appropriate ajax call
		History.Adapter.bind(window, 'statechange', function() {
			if (report.fireHistoryChange) {
				report.historychanged();
			}
			report.fireHistoryChange = true;
		});

		report.historychanged();
		if (requestString.exportType) {
			$("body").addClass('exportfriendly');
		}
	};
	this.exportReport = function(element) {

		if (window.cvCustomMask) {
			$("#content").mask(cvUtil.cvLocalize('WaitMsg'), 0, function() {
				report.exportajaxRequest.abort('userAborted');
			});
		} else {
			report.mask(report.idtomask, true, "Exporting...");
		}
		//		requestString.invisible.exportType=this.id.substring("export".length);
		//		requestString.invisible.exportAll=true;
		report.isExport = true;
		//		if (report.getChartSVGs)
		//			report.getChartSVGs(report.chartIds);
		var exportType = element.id.substring("export".length).toLowerCase();
		if (exportType === "healthppt" || exportType == "word" || exportType == "valassessppt") {
			report.unmask(element.idtomask);
			if (report.exportX) {
				report.exportX(exportType);
			}
			return;
		}

		var temptimeOut = cvUtil.DEFAULT_TIMEOUT;
		try {
			var timeout = parseInt(window.reportExportConnectionTimeout) * 60 * 1000;
			if (!isNaN(timeout)) {
				cvUtil.DEFAULT_TIMEOUT = timeout;
			}
		} catch (e) {
			console.log("Error occured while setting timeout " + e.message + "\n" + e.stack);
		}

		var exParams = report.getExportParams(exportType);
		exParams.filePrefix = report.getExportFilePrefix();

		if (report.isPushDownload(exportType)) { //Using push service
			exParams.subscriptionID = window.sessionStorage.getItem('export_subscriptionID');
			report.unmask(element.idtomask);
		}
		var exportOptions = report.getExportPageOptions(exportType);

		var urlParams = '/reports/exp.do?directDownload=false&exportType=' + exportType;
		if (exportOptions) {
			urlParams += '&' + exportOptions;
		}
		downloadUnclaimedExportFiles();
		report.exportajaxRequest = cvUtil.loadPage(cvUtil.getContextPath() + urlParams, exParams, function(data1) {
			if (!report.isPushDownload(exportType)) { //Using push elements in pushEnabledDownloads
				downloadReportFile(data1);
				report.unmask(element.idtomask);
			}
		}, function(xhr, ajaxOptions, thrownError) {
			if (thrownError && thrownError == 'Unauthorized') {
				window.location = cvUtil.getContextPath() + "/login/index.jsp";
				return;
			}
			if (thrownError != 'userAborted') {
				cvUtil.handleError(xhr, ajaxOptions, thrownError);
			}
		});
		cvUtil.DEFAULT_TIMEOUT = temptimeOut;
		requestString.invisible.exportType = undefined;
		isExport = false;
		requestString.invisible.exportAll = false;
		requestString.invisible.chartsSVGs = null;
	};

	this.isPushDownload = function(exportType) {
		var pushEnabledDownloads = [ "pdf", "html", "csv" ];
		if (pushEnabledDownloads.indexOf(exportType) > -1 && typeof pushService !== "undefined") {
			return true;
		} else {
			return false;
		}
	};

	this.getExportFilePrefix = function() {
		return report.type;
	};

	this.getExportPageOptions = function(exportType) {
		return null;
	}
	this.attachTableActions = function() {
		if (!report.tableActionsAttached) {
			var arrowAction = function(arrow, event) {
				arrow.parent().siblings().slideToggle("fast");
				if (arrow.hasClass("expand")) {
					arrow.removeClass("expand").addClass("collapse");
				} else {
					arrow.removeClass("collapse").addClass("expand");
				}
				event.stopPropagation();
				event.preventDefault();
			};
			$("body").on("click", ".reportTable .arrowPlaceholder", function(event) {
				arrowAction($(this), event);
			});
			$("body").on("click", ".reportChart .arrowPlaceholder", function(event) {
				arrowAction($(this), event);
			});
			$("body").on("click", ".reportCView .arrowPlaceholder", function(event) {
				arrowAction($(this), event);
			});
			$("body").on("click", ".AddorRemoveCols", function(event) {
				var gridId = $(this).attr('id');
				gridId = gridId.substring(0, gridId.lastIndexOf("_"));
				Reports.addOrRemoveColumns(gridId);
				event.stopPropagation();
				event.preventDefault();
			});

			$("body").on("click", ".tableFilter", function(event) {
				var gridId = $(this).attr('id');
				gridId = gridId.substring(0, gridId.lastIndexOf("_"));
				Reports.filterClick(gridId, 'toggle');
			});

			$("body").on("click", ".tableExportExcel", function(event) {
				var gridId = $(this).attr('id');
				gridId = gridId.substring(0, gridId.lastIndexOf("_"));
				report.mask(gridId, true, " ");
				var filePrefix = report.getExportFilePrefix();
				var title = (filePrefix ? filePrefix + "_" : "") + $("#" + gridId + "_title").text();
				title = title.replace(/[\\\/;:\\"*?<>|]+/g, "_");
				Reports.exportToExcel(gridId, title);
				report.unmask(gridId);
			});
			$("body").on("click",
					".tableAlarm",
					function(event) {
						var gridId = $(this).attr('id');
						gridId = gridId.substring(0, gridId.lastIndexOf("_"));
						report.mask(gridId, true, " ");
						var welcomeMsg = $("#welcomeMsg"); // some metrics reports
						var sName = $("#surveyName"); // most of the metrics reports
						var secTitle = $("#sectionTitle"); // custom reports and others
						var reportName = welcomeMsg.text().trim().length > 0 ? welcomeMsg.text().trim()
								: (sName.length > 0 ? sName.text() : (secTitle.length > 0 ? secTitle.text()
										: "Uncategorized"));
						Reports.configureAlarm({
							"gridId" : gridId,
							"type" : 1,
							"manageLink" : true,
							"reportName" : reportName
						});
						report.unmask(gridId);
					});
			$("body").on("click",
					".tableApi",
					function(event) {
						var gridId = $(this).attr('id');
						gridId = gridId.substring(0, gridId.lastIndexOf("_"));
						report.mask(gridId, true, " ");
						reportsUtil.displayDataURL(gridId);
						report.unmask(gridId);
					});
			report.tableActionsAttached = true;
		}
		$.each($('.dataTable.initialized:visible'), function(index, value) { //init filter from url
			var grid = $(value).closest('.reportTable');
			Reports.initFilter($(grid).attr('id'));
			report.requestString.invisible[$(grid).attr('id')] = report.requestString.invisible[$(grid).attr('id')] ||
					{};
			report.requestString.invisible[$(grid).attr('id')].notFirstDrawCallBack = true;
		});
	};

	this.historychanged = function() {
		var url = window.location.href;
		var params = cvUtil.getParameterByName("type", url);
		var query = window.location.search;
		if (!window.location.search || query.length < 2) {
			window.urlInitializationNotRequired = false;
		}
		if (!window.urlInitializationNotRequired && (params == null || params == "" || params == "?")) {
			this.reinit();
			updateHash(true);
		} else {
			this.reinit();
			var tokens = url.substring(url.indexOf("?") + 1);
			var tempReq = {};
			urlToRequest(tokens, tempReq);
			for (x in tempReq)
				report.requestString[x] = tempReq[x]; //since requestString is initialized with defaults, lets merge the properties exclusively without merging arrays
		}
		report.loadReport();
		report.initComponentState();
	};

	this.reinit = function() {
		$("input[id*='_FilterSelected']").val('');
		report.requestString = {};
		report.requestString.invisible = {
			"initial" : true
		};
		window.requestString = report.requestString;
		report.requestString.invisible.initializeDefaults = true;
		report.initializeDefaults();
	};

	this.processReport = function() {
		this.loadReport();
		this.updateHash(false);
	};

	this.getRequestUrl = function() {
		var surveyTypes = [ "operations", "general", "reports", "health", "manage" ];
		if ($.inArray(report.type, surveyTypes) != -1) {
			return cvUtil.getContextPath() + '/server/cloudsurvey.do?type=' + report.type + '&json=' +
					window.encodeURIComponent(JSON.stringify(this.requestString));
		} else if (report.type === 'survey') {
			return "";
		}

		return cvUtil.getContextPath() + '/server/report?type=' + report.type + '&json=' +
				window.encodeURIComponent(JSON.stringify(this.requestString));
	};

	this.getExportParams = function() {
		return {
			type : report.type,
			json : JSON.stringify(this.requestString)
		};
	};

	//	this.getChartSVGs = function(chartIds) {
	//		if (chartIds == null)
	//			return;
	//
	//		var charts = {};
	//		for (var i=0; i< chartIds.length; i++)
	//		{
	//			var pieChartDom = $("#" + chartIds[i]);
	//			$("desc", pieChartDom).empty();
	//			var cHeight = $("svg",pieChartDom).attr("height");
	//			var cWidth = $("svg",pieChartDom).attr("width");
	//			var svgText = pieChartDom.html();
	//			var i;
	//
	//			if (svgText.indexOf("svg") == -1)
	//				continue;
	//
	//			var detail = {};
	//			detail["html"] = svgText;
	//			detail["height"] = cHeight;
	//			detail["width"] = cWidth;
	//			charts[chartIds[i]] = detail;
	//		}
	//
	//		report.requestString.invisible.chartsSVGs = charts;
	//
	//	};

	this.updateHash = function(isReplace) {
		updateHash(isReplace);
	};

	this.mask = function(id, maskContent, message) {
		if (message && message != null) {
			loading = message;
		} else {
			message = "";
		}
		if (id && id != null) {
			$("#" + id).mask(message);
		} else {
			$("#content").mask(message);
		}
		if (id && !(maskContent && maskContent === false)) {
			$("#content").mask();
		}
	};
	this.unmask = function(id) {
		$("#content").unmask();
		if (id) {
			$("#" + id).unmask();
		}
	};

	this.disableExport = function() {
		$("#exportpdf").addClass("btnDisabled");
		$("#exportpdf").off("click");
		$("#exportcsv").addClass("btnDisabled");
		$("#exportcsv").off("click");
		$("#exportexcel").addClass("btnDisabled");
		$("#exportexcel").off("click");
		$("#exportmhtml").addClass("btnDisabled");
		$("#exportmhtml").off("click");
	};

	this.enableExport = function() {
		$("#exportpdf").removeClass("btnDisabled");
		$("#exportpdf").on("click");
		$("#exportcsv").removeClass("btnDisabled");
		$("#exportcsv").on("click");
		$("#exportexcel").removeClass("btnDisabled");
		$("#exportexcel").on("click");
		$("#exportmhtml").removeClass("btnDisabled");
		$("#exportmhtml").on("click");
	};

	this.loadReport = function() {
		$("#ErrorPanel").hide();

		this.requestString.invisible.initializeDefaults = false;

		if (this.beforeLoadReport) {
			if (this.beforeLoadReport() === false) {
				return;
			}
		}

		if (window.cvCustomMask) {
			if (window.tempCvIdtoMask) {
				this.idtomask = window.tempCvIdtoMask;
				$("#" + this.idtomask).mask("");
			} else {
				$("#content").mask("");
			}
		} else {
			this.mask(this.idtomask);
		}

		if (report.getRequestUrl() != '') {
			cvUtil.loadPageWithPOST(report.getRequestUrl(), "", function(data1) {
				try {
					report.onLoadReport(data1);

					$(".reportContent").show();
					report.unmask();
					/*
					 * if($.active<=1) { report.unmask(); }
					 */

				} catch (e) {
					report.unmask();
					$(".reportContent").hide();
					$("#error_message_default").show();
					$("#error_message").hide();
					$("#ErrorPanel").show();
					console.debug("Error occured while processing request " + e.message + "\n" + e.stack);
				}
			}, function(xhr, ajaxOptions, thrownError) {
				report.unmask();
				if (thrownError && thrownError == 'Unauthorized') {
					window.location = cvUtil.getContextPath() + "/login/index.jsp";
					return;
				}
				if (xhr.responseText && xhr.responseText != "") {
					$("#error_message").html(xhr.responseText).show();
					$("#error_message_default").hide();
				} else {
					$("#error_message_default").show();
					$("#error_message").hide();
				}
				$("#ErrorPanel").show();
				$(".reportContent").hide();
				//if (!cvUtil.handleIfFwkErr(xhr, ajaxOptions, thrownError)) {
				//					var exText = cvUtil.getString("Exception_Text", function() {
				//					});
				//					if (exText == "")
				//						exText = "We're sorry, something went wrong. Please try again.";
				//					alert(exText);
			});

		}

	};

	function updateHash(isReplace) {
		report.fireHistoryChange = false;
		var url = requestToUrl(report.requestString);
		if (url.length != 0) {
			if (isReplace === true) {
				History.replaceState(null, document.title, "?" + url);
			} else {
				History.pushState(null, document.title, "?" + url);
			}
		}
		report.fireHistoryChange = true;
	}
	;

	this.generateReport = function() {
		$.each($(".tableFilter"), function(index, value) {
			var gridId = $(this).attr('id');
			gridId = gridId.substring(0, gridId.lastIndexOf("_"));
			var isFilterOn = $("#" + gridId + "_FilterSelected").attr('value');
			if (isFilterOn != null && isFilterOn != 'undefined' && isFilterOn == 'true') {
				Reports.tableFilterColumns(gridId);
				$(this).toggleClass("filterOn");
			}
		});
		if (report.saveFilters) {
			report.saveFilters();
		}
		if (report.REFRESH_REPORT_FILTERS_ONGENERATE) {
			report.reinit();
		}
		if (report.updateFilters) {
			report.updateFilters();
		}
		report.updateRequestString();
		report.processReport();
	};

	report.onLoadReport = function(data1) {
		$(".reportView").hide();
		if (!data1 || data1 == 'null' || data1.error) {
			$(".errorPanel").show();
			$(".reportContent").hide();
			if (data1 && data1.error) {
				$("#error_message").html(data1.error);
				$("#error_message").show();
			} else {
				$("#error_message_default").show();
			}
			report.disableExport();
			return;
		}
		if (data1.noData == true) {
			$(".noDataPanel").show();
			$(".reportContent").hide();
			return;
		}
		$.each(data1, function(key, value) {
			$("." + key).show();
			if (value.cssClassToAdd) {
				$("#" + key).addClass(value.cssClassToAdd);
			}
			if (value.cssClassToRemove) {
				$("#" + key).removeClass(value.cssClassToRemove);
			}
			if (value.noData) {
				$("." + key + "_showifnodata").show();
				$("." + key + "_hideifnodata").hide();
				return;
			} else {
				$("." + key + "_showifnodata").hide();
				$("." + key + "_hideifnodata").show();
			}
			if (value.viewType == 'chart') {
				if (value.value.type == 'PIE') {
					report.createRaphaelPieChart(value.value, key);
				}
				if (value.value.type == 'LINE') {
					report.createRaphaelLineChart(value.value, key);
				}
			}
			if (value.viewType == 'clientTable') {
				Reports.configureClientSideTable(key, "Protected Clients", value.value);
				if (value.value && value.value.tableTitle) {
					$("#" + key + "_title").html(value.value.tableTitle);
				}
			}
			if (value.viewType == 'serverTable') {
				report.configureServerTable(key, value);
			}
			if (value.viewType == 'exactReplace') {
				$("#" + key).html(value.value);
				if (key == "sectionTitle") {
					$(document).attr('title', value.value);
				}
			}
			if (value.viewType == 'taskSummary') {
				$.each(value.value, function(itemName, itemValue) {
					var li = taskSummaryTemplate.replace('{0}', itemValue[0]).replace('{1}', itemValue[1]);
					$('#reportTaskSummary').append(li);
				});
			}
			if (value.viewType == 'custom') {
				report.customRender(key, value, data1);
			}
		});
		report.afterLoadReport();
		report.logReportLoadEvent();
	};

	report.configureServerTable = function(key, value) {
		Reports.configureTable(key, "Protected Clients", value.value, report.requestString, report.getRequestUrl);
		if (value.value && value.value.tableTitle) {
			$("#" + key + "_title").html(value.value.tableTitle);
		}
	};

	report.afterLoadReport = function() {
		report.attachTableActions();
		report.updateBreadCrumb();
		window.setTimeout(function() {
			if ($(".dataTable").filter(":visible").length > 0) {
				$("#exportcsv").show();
			} else {
				$("#exportcsv").hide();
			}
		}, 20);
		// resetting table filters
		//$("input[id*='_FilterSelected']").val('');

	};

	report.logReportLoadEvent = function(reportId, reportName) {
		if (!reportName) {
			var idToRead = "#surveyName";
			if (reportId) {
				idToRead = '#' + reportId;
			}
			reportName = $.trim($(idToRead).text());
		}
		if (reportName) {
			cvUtil.logToReportsUsage(reportName);
		}
	};

	report.getExportType = function() {
		if (report.requestString.exportType) {
			return report.requestString.exportType.toUpperCase();
		}
	};
	report.updateBreadCrumb = function() {
		$(".dynamicBreadcrumb").remove();
		var template = '<li class="dynamicBreadcrumb smartlinkMain withSeparatorMain"><a id="{2}" class="smartLinkMain" href="{0}">{1}</a></li>';
		var counter = 0;
		var id = 'path' + counter;
		//		var reportsLink = $(template.replace('{1}', "Reports").replace('{0}', "../reports").replace('{2}', "reportshomelink"));
		//		reportsLink.addClass("secTitleClickable");
		//		$("#breadcrumbMain").append(reportsLink);

		if (report.requestString.reportFilters && report.requestString.reportFilters != null &&
				report.requestString.reportFilters.length > 0) {
			var url = '#';
			if (report.requestString.reportFilters[0].URL && report.requestString.reportFilters[0].URL != null) {
				url = report.requestString.reportFilters[0].URL;
			}
			$("#breadcrumbMain").append(template.replace('{0}', url).replace('{1}', report.reportTitle).replace('{2}',
					id));
			$("#" + id).click(function(e) {
				e.preventDefault();
				report.breadCrumbClick(this.id.substring('path'.length));
			});
			counter++;
			$.each(report.requestString.reportFilters, function(index, value) {
				if (index == report.requestString.reportFilters.length - 1) {
					return;
				}
				id = 'path' + counter;
				var title = decodeURI(value.entityName);
				if (value.display) {
					var args = title.split(";");
					if (args.length == 2) {
						title = cvUtil.cvLocalize(value.display, args[0], args[1]); //declared in ReportsJSMessages.properties
					}
					if (args.length == 1) {
						title = cvUtil.cvLocalize(value.display, args[0]);
					}
				}
				url = "#";
				if (report.requestString.reportFilters[index + 1].URL &&
						report.requestString.reportFilters[index + 1].URL != null) {
					url = report.requestString.reportFilters[index + 1].URL;
				}
				$("#breadcrumbMain").append(template.replace('{0}', url).replace('{1}', title).replace('{2}', id));
				$("#" + id).click(function(e) {
					e.preventDefault();
					report.breadCrumbClick(this.id.substring('path'.length));
				});
				counter++;
			});
		}
	};
	report.breadCrumbClick = function(index) {
		if (index == 0) {
			if (this.requestString.reportFilters == null || report.requestString.reportFilters.length == 0) {
				return;
			}
			report.requestString.reportFilters = [];
		} else if (report.requestString.reportFilters != null) {
			var i = 0;
			for (i = report.requestString.reportFilters.length - 1; i >= index; i--) {
				report.requestString.reportFilters.pop();
			}
		}
		report.processReport();
	};
	report.drillDown = function(pointdata) {
		pointdata.URL = window.location.href;
		report.requestString.reportFilters.push(pointdata);
		Reports.clearTableParams();
		report.processReport();
	};

	report.getURLFromRequest = function(params) {
		return requestToUrl(params);
	}

	function requestToUrl(a1) {
		return objectToUrl(a1).join("&");
	}

	function objectToUrl(a1, prefix) {
		var u = [];
		var x;
		if (prefix) {
			prefix = prefix + urlParamDelimiter;
		} else {
			prefix = "";
		}
		for (x in a1) {
			if (x == 'invisible') {
				continue;
			}
			var curr = a1[x];
			if (curr === undefined || curr === '') {
				continue;
			}
			if (curr instanceof Array) {
				u = u.concat(arrayToUrl(curr, prefix + x));
			} else if (curr instanceof Object) {
				u = u.concat(objectToUrl(curr, prefix + x));
			} else {
				u.push(prefix + x + "=" + encodeURIComponent(curr));
			}
		}
		return u;
	}
	function arrayToUrl(curr, prefix) {
		var u = [];
		var index = 0;
		if (prefix) {
			prefix = prefix + urlParamDelimiter;
		}
		for (index = 0; index < curr.length; index++) {
			if (curr[index] instanceof Object) {
				u = u.concat(objectToUrl(curr[index], prefix + index));
			} else if (curr[index] instanceof Array) {
				u = u.concat(arrayToUrl(curr[index], prefix + index));
			} else {
				u.push(prefix + index + "=" + encodeURIComponent(curr[index]));
			}
		}
		return u;
	}
	function urlToRequest(hash, requestString) {
		var u = hash.split('&');

		$.each(u, function(index, token) {
			var nameValue = token.split('=');
			var name = nameValue[0];
			var hierarchy = name.split(urlParamDelimiter);
			var current = requestString;
			var value = decodeURIComponent(nameValue[1]);
			for (index = 0; index < hierarchy.length; index++) {
				var step = hierarchy[index];
				if (index == hierarchy.length - 1) {
					current[step] = value;
				} else {
					if (isNaN(hierarchy[index + 1])) {
						if (!(current[step] instanceof Object)) {
							current[step] = {};
						}
					} else if (!(current[step] instanceof Array)) {
						current[step] = [];
					}
					current = current[step];
				}
			}
		});
	}

}

var mandatoryColList = []; //key:table_id, val:mandatory col list

function updateMandatoryList(gridid, aoColumns) {
	var columns = [];
	$.each(aoColumns, function(intIndex, objValue) {
		var column = {};
		column.title = objValue["sTitle"];
		column.mDataProp = objValue["mDataProp"];
		var mandatory = objValue["bMandatoryCol"];
		if (mandatory == true) {
			columns.push(column);
		}
	});
	mandatoryColList.push({
		id : gridid,
		val : columns
	});
}

var Reports = {
	tableid : '_table',
	initReport : InitReport,
	MAXROWS_TOPRINT_WITHOUT_DIALOG : 20000,
	PDF : 'PDF',
	PRINT : 'PRINT',
	CSV : 'CSV',
	MHTML : 'MHTML',
	reportTableMap : {},

	filterClick : function(gridId, action) { //'expand', 'collapse', 'toggle' - default is toggle
		if ($("#" + gridId + "_table").hasClass("initialized")) {
			var button = $("#" + gridId).find(".tableFilter");
			var expanded = $(button).hasClass("filterOn");
			if (!action) {
				action = 'toggle';
			}
			if ((!expanded && action == 'collapse') || (expanded && action == 'expand')) {
				return;
			}
			Reports.tableFilterColumns(gridId);
			$(button).toggleClass("filterOn");
		}
	},

	pushFilteredTable : function(gridid) {//need to handle multplie tables if required - avoid using filteredTable variable directly
		report.requestString.filteredTable = report.requestString.filteredTable || new Array();
		var array = report.requestString["filteredTable"];
		var index = array.indexOf(gridid);
		if (index == -1) {
			report.requestString.filteredTable.push(gridid);
		}
	},
	removeTableParams : function(gridid) {//need to handle multplie tables if required - avoid using filteredTable variable directly
		// remove - important for backup job summary
		var array = report.requestString["filteredTable"];
		var index = array.indexOf(gridid);
		if (index != -1) {
			array.splice(index, 1);
		}
		delete report.requestString[gridid];
	},
	clearTableParams : function() {
		var array = report.requestString["filteredTable"];
		if (array) {
			$.each(array, function(index, value) {
				delete report.requestString[value];
			});
			delete report.requestString["filteredTable"];
		}
	},
	isFilteredTable : function(gridid) { //need to handle multplie tables if required - avoid using filteredTable variable directly
		if (!report.requestString["filteredTable"]) {
			return false;
		}
		var array = report.requestString["filteredTable"];
		if (!gridid) {
			return array.length > 0;
		}
		return report.requestString["filteredTable"].indexOf(gridid) != -1;
	},

	initFilter : function(gridid, aoColumns) {
		var filterClause = '';
		if (!aoColumns) {
			var oTable = $("#" + gridid + CVTable.table).dataTable();
			var oSettings = oTable.fnSettings();
			aoColumns = oSettings.aoColumns;
		}
		if (requestString[gridid] && requestString[gridid].filterClause) {
			filterClause = requestString[gridid]['filterClause'];
		}
		if (filterClause != "") {
			Reports.filterClick(gridid, 'expand');
		}

		// Begin - new filters

		filterClause = filterClause.slice(0, -1); // removing the last semi-colon.

		var filters = filterClause.split(/;?([^;-]+)-(LIKE)-/).slice(1); // removing the empty sting that is matched
		var i = 0;
		for (i = 0; i < filters.length; i += 3) {
			var filteredColumn = filters[i];
			var op = filters[i + 1];
			var v = filters[i + 2];

			if (op == 'LIKE') {
				op = "";
			}

			for (var j = 0; j < aoColumns.length; j++) {
				if (aoColumns[j].mDataProp == filteredColumn) {
					$("input#" + gridid + "_filterText-" + j).attr("value", op + v);
					aoColumns[j].sSearch = op + v;
					Reports.pushFilteredTable(gridid);
					break;
				}
			}
		}

		// End - new filters

		/*
		 * This code fails when the URL has ';' or '-' in filter value var filtersClauses =
		 * filterClause.split(';'); $.each(filtersClauses,function(i,val){ console.log(val); if(val != null &&
		 * val != ""){ var filters = val.split("-"); var op = filters[1]; if(op=='LIKE') op=""; var
		 * filteredColumn =filters[0]; var v = val.substr((filters[0]+'-'+filters[1]+'-').length); //in case
		 * value has a - filters[2] won't have complete value for(i=0; i<aoColumns.length;i++)
		 * if(aoColumns[i].mDataProp==filteredColumn){ $("input#"+gridid+"_filterText-"+i).attr("value", op +
		 * v); aoColumns[i].sSearch = op + v; Reports.pushFilteredTable(gridid); } } });
		 */
	},
	getTableCols : function(gridid, getHidden) {
		var tableColumns = [];
		var el = $('#' + gridid + '_table');
		var dataTabl = el.hasClass('initialized');
		if (dataTabl) {
			var oTable = el.dataTable();
			var oSettings = oTable.fnSettings();
			if (oSettings != null) {
				for (var j = 0; j < oSettings.aoColumns.length; j++) {
					if (!!getHidden) {
						if (!oSettings.aoColumns[j].bVisible) {
							tableColumns.push(oSettings.aoColumns[j].mDataProp);
						}
					} else if (oSettings.aoColumns[j].bVisible &&
							(oSettings.aoColumns[j].sTitle != "" && $("<p>").html(oSettings.aoColumns[j].sTitle).text() != "")) {
						tableColumns.push(oSettings.aoColumns[j].mDataProp);
					}
				}
			}
		}
		return tableColumns;
	},
	columnVisibilityFromUrl : function(gridid, aoColumns) {
		if (report.requestString[gridid] && report.requestString[gridid]["tableColumns"]) {
			var visibleColumns = report.requestString[gridid]["tableColumns"];
			var updateTableColumns = false; //update from url
			for (k in visibleColumns) {
				updateTableColumns = true; //if atleast one columns is in url then override else we'll show default columns
				break;
			}
			if (updateTableColumns) {
				for (var j = 0; j < aoColumns.length; j++) {
					aoColumns[j].bVisible = $.inArray(aoColumns[j].mDataProp, visibleColumns) > -1;
				}
			}
		}
	},
	sortColumnFromUrl : function(gridid, aoColumns) {
		var aaSorting = []; //use the sort parameter from url
		var sortCol = null;
		if (report.defaultSortColumn) {
			sortCol = report.defaultSortColumn(gridid, aoColumns);
		}
		var sortDir = 'asc';
		if (report.defaultSortOrder) {
			sortDir = report.defaultSortOrder(gridid, aoColumns);
		}
		if (typeof requestString[gridid] != 'undefined' && requestString[gridid] != null) {
			if (requestString[gridid].iSort_Col) {
				sortCol = requestString[gridid]['iSort_Col'];
			}
			if (requestString[gridid].sortDir) {
				sortDir = requestString[gridid]['sortDir'];
			}
		}
		$.each(aoColumns, function(index, value) {
			if (value.mDataProp == sortCol) {
				aaSorting.push([ index, sortDir ]);
				return false;
			}
		});
		return aaSorting;
	},
	configureTable : function(gridid, title, data, requestString, getRequestUrl) {
		$.each(data.aoColumns, function(intIndex, objValue) {
			objValue.fnRender = Reports.Renderers[objValue["rendererType"]];
		});

		updateMandatoryList(gridid, data.aoColumns);

		report.temp = {
			"data" : data
		};
		if (requestString.invisible.initial == false) {
			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			dataTable.fnClearTable();
		} else {
			var dataTabl = $('#' + gridid + CVTable.table).hasClass('initialized');
			if (dataTabl) {
				//				dataTabl.removeClass('initialized').fnDestroy();
				$('#' + gridid + CVTable.table).removeClass('initialized');
				$('#' + gridid + CVTable.table).dataTable().fnDestroy();
				$('#' + gridid + CVTable.table).empty();
				$("#" + gridid + "_FilterButton").removeClass("filterOn");
			}
			var firstLoad = true;
			var aaSorting = Reports.sortColumnFromUrl(gridid, data.aoColumns);
			Reports.columnVisibilityFromUrl(gridid, data.aoColumns);

			if (isExportRequestTwoStep(data, gridid)) { //For nonCustom Reports Export
				data.aaData.length = 2;
				initializeForExport(gridid, data);
			}
			$('#' + gridid + CVTable.table)
					.addClass('initialized')
					.dataTable({
						"bProcessing" : true,
						"bServerSide" : true,
						"iDisplayLength" : data.aaData.length,
						"aaData" : data.aaData,
						"bFilter" : false,
						"aoColumns" : data.aoColumns,
						"aoColumnDefs" : data.aoColumnDefs,
						"sAjaxSource" : '/vaultcxWeb/server/report', //dummy url just to confuse datatables
						"iTotalRecords" : data.iTotalRecords,
						"sPaginationType" : 'input',
						"bRetrieve" : true,
						"bAutoWidth" : false,
						"sDom" : "Rlfrtip",
						"aaSorting" : aaSorting,
						"bLengthChange" : false,
						"oLanguage" : {
							"oPaginate" : {
								"sFirst" : '&nbsp;',
								"sNext" : '&nbsp;',
								"sPrevious" : '&nbsp;',
								"sLast" : '&nbsp;'
							}
						},
						"fnDrawCallback" : function(oSettings) {
							$('#' + gridid + CVTable.table).addClass('drawn');
						},
						"fnServerData" : function(sSource, aoData, fnCallback) {
							//			alert(JSON.stringify(aoData));
							if (firstLoad == true) {
								report.temp.data.sEcho = Reports.fnGetKey(aoData, 'sEcho');
								fnCallback(report.temp.data);
								firstLoad = false;
								return;
							}

							requestString[gridid] = {};
							var pageSize = Reports.fnGetKey(aoData, 'iDisplayLength');
							var pageNo = 1;
							if (pageSize != 0) {
								pageNo = (Reports.fnGetKey(aoData, 'iDisplayStart') / pageSize) + 1;
							}
							requestString[gridid] = {
								'sortColumn' : report.defaultSortColumn(),
								'filterClause' : Reports.fnGetSearchString(this.fnSettings()),
								'iSort_Col' : this.fnSettings().aoColumns[Reports.fnGetKey(aoData, 'iSortCol_0')].mDataProp,
								'sortDir' : Reports.fnGetKey(aoData, 'sSortDir_0'),
								'tableColumns' : Reports.getTableCols(gridid)
							};
							report.updateHash(true);
							requestString[gridid].pageNo = pageNo; //we don't want pageno in url so after updatehash
							$('#' + gridid).mask();
							cvUtil
									.loadPageWithPOST(getRequestUrl(),
											'',
											function(data1) {
												delete requestString[gridid];
												var okToSetLength = $('#' + gridid + CVTable.table).dataTable()
														.fnSettings().aLengthMenu
														.indexOf(data1[gridid].iDisplayLength || 0) > -1;
												if (data1[gridid].viewType == 'serverTable') {
													data1[gridid].value.sEcho = Reports.fnGetKey(aoData, 'sEcho');
													if (okToSetLength) {
														$('#' + gridid + CVTable.table).dataTable().fnSettings()._iDisplayLength = data1[gridid].value.iDisplayLength;
													}
													fnCallback(data1[gridid].value);
												} else {
													data1[gridid].sEcho = Reports.fnGetKey(aoData, 'sEcho');
													if (okToSetLength) {
														$('#' + gridid + CVTable.table).dataTable().fnSettings()._iDisplayLength = data1[gridid].iDisplayLength;
													}
													fnCallback(data1[gridid]);
													$('#' + gridid + CVTable.table + '>tbody>tr>td')
															.each(function(index, value) {
																$(value)
																		.attr('data-label',
																				$('#' + gridid + CVTable.table +
																						' thead th')[index %
																						($('#' + gridid +
																								CVTable.table +
																								' thead th').length)].innerText);
															});

												}

												$('#' + gridid).unmask();
											},
											function(xhr, ajaxOptions, thrownError) {
												report.unmask();
												if (thrownError && thrownError == 'Unauthorized') {
													window.location = cvUtil.getContextPath() + "/login/index.jsp";
													return;
												}
											});
						}
					});
		}

		$('#' + gridid + CVTable.table + '>tbody>tr>td').each(function(index, value) {
			$(value).attr('data-label',
					$('#' + gridid + CVTable.table + ' thead th')[index %
							($('#' + gridid + CVTable.table + ' thead th').length)].innerText);
		});

		$("#" + gridid).show();
		$(".dataTables_paginate input").click(function(e) {
			$(this).css("background", "url('../common/img/pging_bg_edit.png') repeat-x 0 0 transparent").css("width",
					"25px");
			e.stopPropagation();
		});
		$('html').click(function() {
			$(".dataTables_paginate input").css("background",
					"url('../common/img/pging_bg.png') repeat-x 0 0 transparent").css("width", "15px")
					.keypress(function(event) {
						var keycode = (event.keyCode ? event.keyCode : event.which);
						if (keycode == '13') {
							$(".dataTables_paginate input").css("background",
									"url('../common/img/pging_bg.png') repeat-x 0 0 transparent").css("width", "15px")
									.blur();
						}
					});
		});
		if (report.requestString[gridid + "addOrRemoveColumns"] != undefined) {
			Reports.showUiSelectColumns(gridid, report.requestString[gridid + "addOrRemoveColumns"]);
		}
		if (isExportRequestTwoStep(data, gridid)) { //For nonCustom Reports Export
			initializeForExport(gridid, data);
		}
	},
	configureClientSideTable : function(gridid, title, data, nodata, opt) {
		nodata = nodata || "No data available";
		var options = opt || {};
		if ((!data.aoColumns || data.aoColumns.length == 0) && (!data.aoColumnDefs || data.aoColumnDefs.length == 0)) {
			console.error('No columns defined for the table, skipping datatables initialization');
			return;
		}

		if (data.dataURL) {
			reportsUtil.setDataURLForGrid(gridid, data.dataURL);
		}

		$.each(data.aoColumns, function(intIndex, objValue) {
			objValue.fnRender = Reports.Renderers[objValue["rendererType"]];
		});

		updateMandatoryList(gridid, data.aoColumns);

		if (requestString.invisible.initial == false && $('#' + gridid + CVTable.table).hasClass('initialized')) {
			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			dataTable.fnUpdate(data.aaData);
		} else {
			var dataTabl = $('#' + gridid + CVTable.table).hasClass('initialized');
			if (dataTabl) {
				$('#' + gridid + CVTable.table).removeClass('initialized');
				$('#' + gridid + CVTable.table).dataTable().fnClearTable();
				$('#' + gridid + CVTable.table).dataTable().fnDestroy();
				$('#' + gridid + CVTable.table).empty();
				$("#" + gridid + "_FilterButton").removeClass("filterOn");
			}

			var originalColumns = data.aoColumns;
			var aaSorting = Reports.sortColumnFromUrl(gridid, data.aoColumns);
			if (data.aaSorting && (aaSorting && aaSorting.length == 0)) {
				aaSorting = data.aaSorting;
			}
			Reports.columnVisibilityFromUrl(gridid, data.aoColumns);
			$('#' + gridid + CVTable.table).addClass('initialized')
					.dataTable({
						"aaData" : data.aaData,
						"bFilter" : true,
						"aoColumns" : data.aoColumns,
						"aoColumnDefs" : data.aoColumnDefs,
						"bRetrieve" : true,
						"bInfo" : false,
						"bAutoWidth" : false,
						"sDom" : "Rlrti",
						"bLengthChange" : false,
						"iDisplayLength" : data.aaData.length,
						"bUseRendered" : false,
						"aaSorting" : aaSorting,
						"oColReorder" : options.oColReorder || {},
						"fnDrawCallback" : function(oSettings) {
							$('#' + gridid + CVTable.table).addClass('drawn');
							if (!report.requestString.invisible[gridid]) {
								report.requestString.invisible[gridid] = {};
							}
							if (report.requestString.invisible[gridid].notFirstDrawCallBack) {
								var aoData = oSettings.aoData;
								requestString[gridid] = requestString[gridid] || {};
								var filter = Reports.fnGetSearchString(oSettings);
								requestString[gridid]['filterClause'] = filter;
								if (oSettings.aaSorting && oSettings.aaSorting.length > 0 &&
										oSettings.aaSorting[0].length > 0) {
									var sortColumn = oSettings.aoColumns[oSettings.aaSorting[0][0]];
									requestString[gridid]['iSort_Col'] = sortColumn.mDataProp;
									requestString[gridid]['sortDir'] = oSettings.aaSorting[0][1] || 'asc';
								} else {
									delete requestString[gridid].iSort_Col;
									delete requestString[gridid].sortDir;
								}
								report.updateHash(true);
							} else {
								report.requestString.invisible[gridid].notFirstDrawCallBack = true;
								Reports.initFilter(gridid);
								if (Reports.isFilteredTable(gridid)) {
									var oTable = $("#" + gridid + CVTable.table).dataTable();
									oTable.fnDraw();
								}
							}

							if (report.tableDrawCallBack) {
								report.tableDrawCallBack(oSettings);
							}
						},
						"oLanguage" : {
							"sEmptyTable" : nodata
						}
					});

			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			dataTable.fnSettings().originalColumns = originalColumns;
			dataTable.fnSettings().query = data.query;
			$('#' + gridid + CVTable.table + ' thead th').each(function(index, value) {
				$(value).attr('title', $(value).text());
			});

			$('#' + gridid + CVTable.table + '>tbody>tr>td').each(function(index, value) {
				$(value).attr('data-label',
						$('#' + gridid + CVTable.table + ' thead th')[index %
								($('#' + gridid + CVTable.table + ' thead th').length)].innerText);
			});

			$('.dataTable tbody td').each(function(index) {
				$this = $(this);
				var titleVal = $this.text();
				if (titleVal != '') {
					$this.attr('title', titleVal);
				}
			});
			$.each(dataTable.fnGetNodes(), function(index, value) {

				$.each($('dataTable tbody tr > td', $(this)), function(childIndex, childValue) {

					if (data.aoColumns[childIndex]["rendererType"] != undefined) {
						var frRender = data.aoColumns[childIndex]["rendererType"];
						if (frRender.indexOf("editable") == 0) {
							var input = $(this).find('input');
							$(this).find('input').bind('keyup blur', function(event) {
								if (!event.keyCode || event.keyCode == 13) {
									var growth = input.val();
									$.each(capacity.units, function(index, unit) {
										if (endsWith(growth, index)) {
											if (!isNaN(growth.substr(0, growth.length - index.length))) //convert only if it is a number
											{
												growth = parseFloat(growth) * unit;
											}
											return false;
										}
									});
									if (isNaN(growth)) {
										return;
									} else {
										growth = Math.round(parseFloat(growth) * 100) / 100;
									}
									report.editTableCallBack(dataTable, growth, {
										"colIndex" : childIndex,
										"rowIndex" : index,
										"rowData" : data.aaData[index]
									});
								}
							});
							//							$(this).find('input').bind('keydown', function(event){
							//								if(isNaN(input.val()))
							//									event.preventDefault();
							//							});
							//							$(this).editable(function(value, settings) {
							//								return value;
							//								}, {
							//								"tooltip" : "Click to edit",
							//								"height": "14px",
							//								"width": "100px",
							//								"colIndex" : childIndex,
							//								"rowIndex" : index,
							//								"rowData"  : data.aaData[index],
							//								"callback" : function(value, settings) {
							//									report.editTableCallBack(dataTable, value, settings);
							//								}}
							//							);
						}
					}

				});
			});

			if (report.customizeTable) {
				report.customizeTable(dataTable);
			}
		}

		$("#" + gridid).show();
		if (report.requestString[gridid + "addOrRemoveColumns"] != undefined) {
			Reports.showUiSelectColumns(gridid, report.requestString[gridid + "addOrRemoveColumns"]);
		}

		Reports.showHideAddRemoveColumsIcon(gridid);
	},
	configureClientSideTableWithPaging : function(gridid, title, data, nodata, opt) {
		nodata = nodata || "No data available";
		var options = opt || {};
		if ((!data.aoColumns || data.aoColumns.length == 0) && (!data.aoColumnDefs || data.aoColumnDefs.length == 0)) {
			console.error('No columns defined for the table, skipping datatables initialization');
			return;
		}

		if (data.dataURL) {
			reportsUtil.setDataURLForGrid(gridid, data.dataURL);
		}

		$.each(data.aoColumns, function(intIndex, objValue) {
			objValue.fnRender = Reports.Renderers[objValue["rendererType"]];
		});

		updateMandatoryList(gridid, data.aoColumns);

		if (requestString.invisible.initial == false && $('#' + gridid + CVTable.table).hasClass('initialized'))

		{
			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			dataTable.fnUpdate(data.aaData);
		} else {
			var dataTabl = $('#' + gridid + CVTable.table).hasClass('initialized');
			if (dataTabl) {
				$('#' + gridid + CVTable.table).removeClass('initialized');
				$('#' + gridid + CVTable.table).dataTable().fnClearTable();
				$('#' + gridid + CVTable.table).dataTable().fnDestroy();
				$('#' + gridid + CVTable.table).empty();

			}
			var ps = parseInt(cvUtil.getParameter("pageSize", 0));
			var lengthMenu = [ [ 10, 50, 100, 200, 500, -1 ], [ 10, 50, 100, 200, 500, "All" ] ];
			if (ps != 0) {
				if (lengthMenu[0].indexOf(ps) == -1) {
					lengthMenu[0].push(ps);
					lengthMenu[1].push(ps);
				}
			} else {
				ps = data.iDisplayLength;
			}
			if (isExportRequestTwoStep(data, gridid)) { //For nonCustom Reports Export
				ps = 2;
				initializeForExport(gridid, data);
			}
			var originalColumns = data.aoColumns;
			var aaSorting = Reports.sortColumnFromUrl(gridid, data.aoColumns);
			if (data.aaSorting && (aaSorting && aaSorting.length == 0)) {
				aaSorting = data.aaSorting;
			}
			Reports.columnVisibilityFromUrl(gridid, data.aoColumns);
			if ((options.growthAndTrendTable && options.growthAndTrendTable === true) ||
					(options.alarmTable && options.alarmTable === true)) {
				data.aoColumns[0].bVisible = true;
			}
			$('#' + gridid + CVTable.table).addClass('initialized')
					.dataTable({
						"aaData" : data.aaData,
						"aoColumns" : data.aoColumns,
						"aoColumnDefs" : data.aoColumnDefs,
						"iTotalRecords" : data.iTotalRecords,
						"iDisplayLength" : ps,
						"bUseRendered" : false,
						"bRetrieve" : true,
						"bServerSide" : false,
						"bDeferRender" : true,
						"bFilter" : true,
						"bAutoWidth" : false,
						"sDom" : options.sDom || "Rlfrtip",
						"bLengthChange" : true,
						"aLengthMenu" : lengthMenu,
						"bInfo" : true,
						"sPaginationType" : "input",
						"aaSorting" : aaSorting,
						"oColReorder" : options.oColReorder || {},
						"oLanguage" : {
							"oPaginate" : {
								"sFirst" : '&nbsp;',
								"sNext" : '&nbsp;',
								"sPrevious" : '&nbsp;',
								"sLast" : '&nbsp;'
							},
							"sLengthMenu" : "Show _MENU_"
						},
						"fnDrawCallback" : function(oSettings) {
							if (isExportRequestTwoStep(data, gridid)) { //For NonCustom Reports Export
								initializeForExport(gridid, data);
							}
							$('.dataTable tbody td').each(function(index) {
								$this = $(this);
								var titleVal = $this.text();
								if (titleVal != '') {
									$this.attr('title', titleVal);
								}
							});

							$('#' + gridid + CVTable.table + '>tbody>tr>td').each(function(index, value) {
								$(value).attr('data-label',
										$('#' + gridid + CVTable.table + ' thead th')[index %
												($('#' + gridid + CVTable.table + ' thead th').length)].innerText);
							});

							$('#' + gridid + CVTable.table).addClass('drawn');
							if (!report.requestString.invisible[gridid]) {
								report.requestString.invisible[gridid] = {};
							}
							if (report.requestString.invisible[gridid].notFirstDrawCallBack) { //subsequent requests
								var aoData = oSettings.aoData;
								requestString[gridid] = requestString[gridid] || {};
								var filter = Reports.fnGetSearchString(oSettings);
								requestString[gridid]['filterClause'] = filter;
								if (oSettings.aaSorting && oSettings.aaSorting.length > 0 &&
										oSettings.aaSorting[0].length > 0) {
									var sortColumn = oSettings.aoColumns[oSettings.aaSorting[0][0]];
									requestString[gridid]['iSort_Col'] = sortColumn.mDataProp;
									requestString[gridid]['sortDir'] = oSettings.aaSorting[0][1] || 'asc';
								} else {
									delete requestString[gridid].iSort_Col;
									delete requestString[gridid].sortDir;
								}
								report.updateHash(true);
							} else { //first request
								report.requestString.invisible[gridid].notFirstDrawCallBack = true;
								Reports.initFilter(gridid);
								if (Reports.isFilteredTable(gridid)) {
									var oTable = $("#" + gridid + CVTable.table).dataTable();
									oTable.fnDraw();
								}
							}

							if (report.tableDrawCallBack) {
								report.tableDrawCallBack(oSettings);
							}
						}

					});

			var dataTable = $('#' + gridid + CVTable.table).dataTable();
			if (!!dataTable.fnSettings()) {
				dataTable.fnSettings().originalColumns = originalColumns;
				dataTable.fnSettings().query = data.query;
			}
			$('#' + gridid + CVTable.table + ' thead th').each(function(index, value) {
				$(value).attr('title', $(value).text());
			});

			$.each(dataTable.fnGetNodes(), function(index, value) {
				$.each($('td', $(this)), function(childIndex, childValue) {

					if (data.aoColumns[childIndex]["rendererType"] != undefined) {
						var frRender = data.aoColumns[childIndex]["rendererType"];
						if (frRender.indexOf("editable") == 0) {
							var input = $(this).find('input');
							$(this).find('input').bind('keyup blur', function(event) {
								if (!event.keyCode || event.keyCode == 13) {
									var growth = input.val();
									$.each(capacity.units, function(index, unit) {
										if (endsWith(growth, index)) {
											if (!isNaN(growth.substr(0, growth.length - index.length))) //convert only if it is a number
											{
												growth = parseFloat(growth) * unit;
											}
											return false;
										}
									});
									if (isNaN(growth)) {
										return;
									} else {
										growth = Math.round(parseFloat(growth) * 100) / 100;
									}
									report.editTableCallBack(dataTable, growth, {
										"colIndex" : childIndex,
										"rowIndex" : index,
										"rowData" : data.aaData[index]
									});
								}
							});
						}
					}

				});
			});
			if (report.customizeTable) {
				report.customizeTable(dataTable);
			}
		}
		$("#" + gridid + '_table_length').addClass('hideOnExportFriendly');
		$("#" + gridid).show();
		if (report.requestString[gridid + "addOrRemoveColumns"] != undefined) {
			Reports.showUiSelectColumns(gridid, report.requestString[gridid + "addOrRemoveColumns"]);
		}

		if (isExportRequestTwoStep(data, gridid)) { //For NonCustom Reports Export
			initializeForExport(gridid, data);
		}

		Reports.showHideAddRemoveColumsIcon(gridid);
	},
	fnGetKey : function(aoData, sKey) {
		for (var i = 0, iLen = aoData.length; i < iLen; i++) {
			if (aoData[i].name == sKey) {
				return aoData[i].value;
			}
		}
		return null;
	},
	fnGetSearchString : function(oSettings) {
		var searchString = "";
		for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
			if (oSettings.aoColumns[iColumn].bVisible) {
				var operator = 'LIKE';
				var search = oSettings.aoColumns[iColumn].sSearch;
				if (typeof search == 'undefined' || search == "") {
					search = 'undefined';
				} else if (oSettings.aoColumns[iColumn].dataType == 'Integer' ||
						oSettings.aoColumns[iColumn].dataType == 'Float' ||
						oSettings.aoColumns[iColumn].dataType == 'CapacityMB' ||
						oSettings.aoColumns[iColumn].dataType == 'DateTime') {
					var tokens = search.toString().toUpperCase().split('AND');
					$.each(tokens, function(index, condition) {
						search = condition.trim();
						if (search == "") {
							return true;
						}
						if (search.indexOf('>=') == 0 || search.indexOf('<=') == 0) {
							operator = search.substr(0, 2);
							search = search.substring(2);
						} else if (search.indexOf('>') == 0 || search.indexOf('<') == 0 || search.indexOf('=') == 0) {
							operator = search.substr(0, 1);
							search = search.substring(1);
						}
						search = search.trim();
						if (oSettings.aoColumns[iColumn].dataType == 'Integer' ||
								oSettings.aoColumns[iColumn].dataType == 'Float' ||
								oSettings.aoColumns[iColumn].dataType == 'CapacityMB') {
							if (oSettings.aoColumns[iColumn].dataType != 'Float') {
								var isSearchWithUnits = false;
								$.each(capacity.units, function(index, unit) {
									if (endsWith(search, index)) {
										if (!isNaN(search.substr(0, search.length - index.length))) //convert only if it is a number
										{
											search = parseFloat(search) * unit;
											isSearchWithUnits = true;
										}
										return false;
									}
								});
								if (oSettings.aoColumns[iColumn].dataType == 'CapacityMB') {
									if (isSearchWithUnits == true) {
										search = search / capacity.units.MB;
									}
								}
								if (isNaN(search)) {
									search = 'undefined';
								} else {
									search = parseInt(search);
								}
							} else if (isNaN(search)) {
								search = 'undefined';
							} else {
								search = parseFloat(search);
							}
						}
						searchString = searchString + oSettings.aoColumns[iColumn].mDataProp + '-' + operator + '-' +
								search + ';';
					});
				} else {
					searchString = searchString + oSettings.aoColumns[iColumn].mDataProp + '-' + operator + '-' +
							search + ';';
				}
			}
		}
		return searchString;
	},
	fnGetFilteredData : function(oSettings) {
		var a = [];
		for (var i = 0, iLen = oSettings.aiDisplay.length; i < iLen; i++) {
			a.push(oSettings.aoData[oSettings.aiDisplay[i]]._aData);
		}
		return a;
	},
	showUiSelectColumns : function(gridid, columnString) {
		columnString = columnString.substring(0, columnString.lastIndexOf(":"));
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var items = columnString.split(':');
		$.each(items, function(index) {
			var current = items[index];
			var colNo = current.split("-")[0];
			var bVis = current.split("-")[1];
			var showCol = bVis == "true" ? true : false;
			if (colNo < oTable.fnSettings().aoColumns.length) {
				oTable.fnSetColumnVis(colNo, showCol, false);
			}
		});
	},
	addOrRemoveColumns : function(gridid) {
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var container = $("#" + gridid + '_Colums');

		var oSettings = oTable.fnSettings();
		var id = 0;
		container.empty();

		var mandatoryColumns = [];
		$.each(mandatoryColList, function(intIndex, objValue) {
			if (objValue.id == gridid) {
				mandatoryColumns = objValue.val;
				return;
			}
		});
		var p = 0;
		for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
			var name = oSettings.aoColumns[iColumn].sTitle;
			var mDataProp = oSettings.aoColumns[iColumn].mDataProp;

			var mandatoryCol = '';
			if (mandatoryColumns.length > 0) {
				$.each(mandatoryColumns, function(colIndex, column) {
					if (mDataProp == column.mDataProp) {
						//Mandatory columns will be disabled in addOrRemove list.
						mandatoryCol = 'disabled';
						return;
					}
				});
			}/*
				 * else{ //If mandatory columns are not there, first 1 visible column will be treated as
				 * mandatory column if(oSettings.aoColumns[iColumn].bVisible==true) { if(p < 1){ mandatoryCol =
				 * 'disabled'; } p++; } }
				 *
				 * if(mandatoryCol == 'disabled'){ continue; }
				 */

			if (name == "" || $("<p>").html(name).text() == "") {
				continue;
			}

			var html = "";
			id = iColumn;
			var visible = (oSettings.aoColumns[iColumn].bVisible == true) ? 'checked' : 'unchecked';
			html = '<li class="col1"><div id="' + gridid + ':cb_' + id + '" class="custom-cb addOrRemoveCheckBox ' +
					visible + '" data-state="' + visible + '"></div><span class="custom-cb-label">' + name +
					'</span></li>';

			//var spanId = gridid+'_cbName_'+id;
			//html ='<li class="col1"><div id="'+gridid+':cb_'+id+'" class="custom-cb addOrRemoveCheckBox '+mandatoryCol+' '+visible+'" data-state="'+visible+'"></div><span id="'+spanId+'" class="custom-cb-label">'+name+'</span></li>';

			if (!(oSettings.aoColumns[iColumn].doNotShow == true)) {
				container.append($(html));
			}

			/*
			 * if(mandatoryCol == 'disabled'){ $('#'+spanId).unbind().undelegate().die(); }
			 */
		}

		container.slideToggle('fast');
		$("#" + gridid + '_Button').toggleClass('activeNow');
		$(".reportColums_container").off("click");
		$(".reportColums_container").on("click",
				function(event) {
					var el = $(event.target).children(".addOrRemoveCheckBox");
					if (el.length == 0) {
						el = $(event.target);
						if ($(el).hasClass("addOrRemoveCheckBox")) {
							//do nothing
						} else {
							return;
						}
					}

					toggleCb($(el));
					event.stopPropagation();
					var checkedLength = $("#" + gridid + "_Colums .checked").length;
					if (checkedLength == 0) {
						//Atleast one column should visible in the table.
						toggleCb($(el));
						return;
					}

					var id = $(el).attr('id');
					var columnNum = id.substring(id.lastIndexOf("_") + 1, id.length);
					var bVis = oSettings.aoColumns[columnNum].bVisible;
					bVis = bVis ? false : true;

					var visColNum = oSettings.oApi._fnColumnIndexToVisible(oSettings, columnNum);
					if (!bVis) {
						$("#filterRow_" + gridid + " td:eq(" + visColNum + ")").remove();
					}
					oTable.fnSetColumnVis(columnNum, bVis, false);
					if (!bVis) {
						var serverCall = false;
						for (var i = 0; i < oSettings.aoColumns.length; i++) {
							if (oSettings.aoColumns[i].bVisible) {
								var val1 = $("#filterRow_" + gridid + " td:eq(" +
										oSettings.oApi._fnColumnIndexToVisible(oSettings, i) + ") input").val();
								oSettings.aoColumns[i].sSearch = val1;
								serverCall = true;
							} else {
								oSettings.aoColumns[i].sSearch = "";
							}
						}
						if (serverCall) {
							Reports.pushFilteredTable(gridid);
							oTable.fnDraw();
						}
					} else {
						visColNum = oSettings.oApi._fnColumnIndexToVisible(oSettings, columnNum);
						// code to create filter field and append it at the required position.
						if (visColNum) {
							$("#filterRow_" + gridid + " td:eq(" + (visColNum - 1) + ")").after(Reports
									.inlineFilterTd(oSettings, gridid, columnNum));
						} else {
							$(Reports.inlineFilterTd(oSettings, gridid, columnNum)).insertBefore("#filterRow_" +
									gridid + " td:eq(0)");
						}
					}
					// add title attr for values in this column, to get tooltip..
					var columnArray = Reports.getTableCols(gridid);
					report.requestString[gridid] = report.requestString[gridid] || {};
					report.requestString[gridid]["tableColumns"] = columnArray;
					report.requestString[gridid]['filterClause'] = Reports.fnGetSearchString(oSettings);

					report.updateHash(true);

					if (bVis) {
						var aoData = oSettings.aoData;
						var nTd, i, iLen;

						for (i = 0, iLen = aoData.length; i < iLen; i++) {
							if (aoData[i].nTr !== null) {
								nTd = oTable.oApi._fnGetTdNodes(oSettings, i)[columnNum];
								$(nTd).attr("title", $(nTd).html());
							}
						}

						$('#' + gridid + CVTable.table + ' thead th').each(function(index, value) {
							$(value).attr('title', $(value).text());
						});

						$('#' + gridid + CVTable.table + '>tbody>tr>td').each(function(index, value) {
							$(value).attr('data-label',
									$('#' + gridid + CVTable.table + ' thead th')[index %
											($('#' + gridid + CVTable.table + ' thead th').length)].innerText);
						});
					}

					var filterSelected = $("#" + gridid + "_FilterSelected");
					var value = filterSelected.attr('value');
					/*
					 * if(value == 'true') { //filterSelected.val('undefined');
					 * //$("#filterRow_"+gridid).remove(); //container.hide();
					 * //filterButton.trigger('click'); //filterButton.addClass("filterOn");
					 * //container.show(); $("#"+gridid+"_filterText-"+columnNum + "-td").toggle(); }
					 */

					//adjustWidth(gridid);
				});
		$(".custom-cb-label").click(function(e) {
			$(this).prev(".custom-cb").trigger('click');
			e.stopPropagation();
		});
		$('html').click(function() {
			container.slideUp('fast');
			$("#" + gridid + '_Button').removeClass('activeNow');
		});

	},
	showHideAddRemoveColumsIcon : function(gridid) {
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var oSettings = oTable.fnSettings();

		var mandatoryColumns = [];
		$.each(mandatoryColList, function(intIndex, objValue) {
			if (objValue.id == gridid) {
				mandatoryColumns = objValue.val;
				return;
			}
		});
		var showIcon = true;

		if (mandatoryColumns.length == oSettings.aoColumns.length || oSettings.aoColumns.length <= 2) {
			showIcon = false;
		}

		if (showIcon) {
			$("#" + gridid + '_holder').show();
		} else {
			$("#" + gridid + '_holder').hide();
		}

	},//end of showHideAddRemoveColumsIcon()

	inlineFilterTd : function(oSettings, gridid, iColumn) {
		var width = oSettings.aoColumns[iColumn].sWidth;
		return '<td><input type="text" class="inLineFilter" value="" width="' + width + '"/></td>';
	},

	tableFilterColumns : function(gridid) {
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var readonly = "readonly ";
		var oSettings = oTable.fnSettings();
		var value = $("#" + gridid + "_FilterSelected").attr('value');
		if (value.trim() == '' || value.trim() == 'undefined') {
			$("#" + gridid + "_FilterSelected").val('true');
			var appendTxt = '<tr id="filterRow_' + gridid + '">';
			for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
				if (oSettings.aoColumns[iColumn].bVisible) {
					var width = oSettings.aoColumns[iColumn].sWidth;
					appendTxt = appendTxt + '<td id="' + gridid + '_filterText-' + iColumn + '-td' +
							'"><input type="text" id="' + gridid + '_filterText-' + iColumn +
							'" class="inLineFilter" value="" width="' + width + '"';
					if (oSettings.aoColumns[iColumn].sClass.toLowerCase().indexOf("selectioncb") > -1) {
						appendTxt += readonly;
					}
					appendTxt += '/></td>';
				}
			}
			appendTxt = appendTxt + '</tr>';
			$("tr:first", oTable).after(appendTxt);
			showHideFilterComps();
		} else if (value == 'false') {
			$("#" + gridid + "_FilterSelected").val('true');
			$('#filterRow_' + gridid).show();
			showHideFilterComps();
		} else if (value == 'true') {
			$("#" + gridid + "_FilterSelected").val('false');
			$('#filterRow_' + gridid).hide();
		}
		/*
		 * $("input").focusout(function () { var oTable = $("#"+gridid+CVTable.table).dataTable(); var
		 * oSettings = oTable.fnSettings(); var id = $(this).attr('id'); var value = $(this).attr('value');
		 * var colNum = id.substring(id.lastIndexOf("-")+1,id.length); if(oSettings.aoColumns[colNum]) {
		 * oSettings.aoColumns[colNum].sSearch = value; } if(value.trim() != "") {
		 * requestString["filteredTable"]=gridid; oTable.fnDraw(); } });
		 */

		(function(oSettings, gridid) {
			$(document)
					.on("keyup",
							"#" + gridid + " .inLineFilter",
							function(event) {
								var serverCall = false;
								if (event.keyCode == 13) {
									for (var i = 0; i < oSettings.aoColumns.length; i++) {
										if (oSettings.aoColumns[i].bVisible) {
											var value = $("#filterRow_" + gridid + " td:eq(" +
													oSettings.oApi._fnColumnIndexToVisible(oSettings, i) + ") input")
													.val();
											if (value != undefined && value.trim() != "") {
												oSettings.aoColumns[i].sSearch = value;
												serverCall = true;
											}
										}
									}
								}

								if (event.keyCode == 46 || event.keyCode == 8) {
									var value = $(this).attr('value');
									if (value.trim() == "") {
										for (var i = 0; i < oSettings.aoColumns.length; i++) {
											if (oSettings.aoColumns[i].bVisible) {
												var value = $("#filterRow_" + gridid + " td:eq(" +
														oSettings.oApi._fnColumnIndexToVisible(oSettings, i) +
														") input").val();
												oSettings.aoColumns[i].sSearch = value;
												serverCall = true;

											}
										}
									}
								}
								if (serverCall) {
									Reports.pushFilteredTable(gridid);
									$('#' + gridid + CVTable.table).dataTable().fnDraw();
								}
							});
		})(oSettings, gridid);

		/*
		 * $("input").focusin(function () { $(this).val(""); }); ;
		 */

		function showHideFilterComps() {
			for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
				var id = '#' + gridid + '_filterText-' + iColumn + '-td';
				if (oSettings.aoColumns[iColumn].bVisible) {
					$(id).show();
				}
				/*
				 * else { $(id).hide(); }
				 */
			}
		}

		//adjustWidth(gridid);
	},
	exportToExcelScale : function(gridId, title) {
		var exportType = 'csv';
		var url = document.URL;
		var reportName = $("#custName").text() + $("#surveyName").text();
		url = window.convertToExportUrl(url, exportType);
		//		var gridparams = cvUtil.requestToUrl(Reports.reportTableMap);
		//var queryId = Reports.reportTableMap[gridId].queryId;
		cvUtil.loadPageWithGET(cvUtil.getContextPath() +
				'/reports/csvExportTableLevel.do?directDownload=false&filePrefix=' + report.getExportFilePrefix() +
				'&exportType=csv', {
			url : url,
			reportEnum : window.reportEnum,
			reportName : reportName,
			queryId : gridId
		}, function(data1) {
			downloadReportFile(data1);
			report.unmask(this.idtomask);
		}, function(xhr, ajaxOptions, thrownError) {
			if (thrownError && thrownError == 'Unauthorized') {
				window.location = cvUtil.getContextPath() + "/login/index.jsp";
				return;
			}
			if (thrownError != 'userAborted') {
				cvUtil.handleError(xhr, ajaxOptions, thrownError);
			}
		});

		var gridparams = 'gridParams=' + window.encodeURIComponent(JSON.stringify(Reports.reportTableMap));
		url = url + "&" + gridparams;
	},
	exportToExcel : function(gridId, title) {
		reportsUtil.exportToExcel(gridId, title);
	}
/*
 * , Renderers : { "capacity" : function(o, val, id ) { return
 * autoConvert(o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp]); }, "capacityMB" : function(o, val, id ) {
 * return autoConvertFromMB(o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp]); }, "capacityMB_Neg" :
 * function(o, val, id ) { return autoConvertFromMB(o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp],
 * true); }, "capacityMBPercent" : function(o, val, id ) { return
 * autoConvertFromMB(o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp]); }, "percentNA" :
 * function(o,val) { return getPercentValue(o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp]); },
 * "editable" : function(o,val) { return '<input style="width: 100px; height: 14px; " autocomplete="off"
 * value="'+ val +'">'; }, "editableCapacity" : function(o,val) { val =
 * autoConvert(o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp]); return '<input style="width: 100px;
 * height: 14px; " autocomplete="off" value="'+ val +'">'; }, "formattedInteger" : function(o,val, id) { var
 * x1=""+o.aData[o.oSettings.aoColumns[o.iDataColumn].mDataProp]; var rgx = /(\d+)(\d{3})/; while
 * (rgx.test(x1)) { x1 = x1.replace(rgx, '$1' + ',' + '$2'); } return x1; } }
 */

};

var pageLoaded = false;

$("document")
		.ready(function() {

			if (pageLoaded) {
				return;
			}
			pageLoaded = true;
			if (cvUtil.getParameter('commUniId', 0) > 0) {
				$(".collapsible-page-tabs").addClass("commcellLevelReportResponsive");
				$("#settingsLink").addClass("commcellLevelReportResponsive");
			} else {

				$(".collapsible-page-tabs").addClass("wwReportResponsive");
				$("#settingsLink").addClass("wwReportResponsive");
			}

			$("#importReportButton").on("click", function(evt) {
				$(".actionMenu").hide();
				$("#importReport #sourcePage").val($(this).attr("data-sourcepage"));
				$("#browseImportFile").click();
			});

			$("#importDataSet").on("click", function(evt) {
				$(".actionMenu").hide();
				$("#importDataSet #sourcePage").val($(this).attr("data-sourcepage"));
				$("#browseImportDSFile").click();
			});

			$("#browseImportDSFile").on("change", function() {
				$("#content").mask("Installing the report...");
				var url = cvUtil.getContextPath() + '/server/uploadAndInstallDataSet.do';
				if ($("#importDataSet #sourceDSPage").val()) {
					url += "?sourceDSPage=" + $("#importDataSet #sourceDSPage").val();
				}
				var options = {
					url : url,
					beforeSubmit : validateForm, // pre-submit callback
					success : handleDataSetSuccess, // post-submit callback,
					contentType : 'multipart/form-data',
					error : handleErrorImportError,
					beforeSend : cvUtil.addCsrf,
					addCsrf : true
				};
				$(this).parent().ajaxSubmit(options);
			});

			$("#browseImportFile").on("change", function() {
				$("#content").mask("Installing the report...");
				var url = cvUtil.getContextPath() + '/server/uploadAndInstallCustomReport.do';
				if ($("#importReport #sourcePage").val()) {
					url += "?sourcePage=" + $("#importReport #sourcePage").val();
				}
				var options = {
					url : url,
					beforeSubmit : validateForm, // pre-submit callback
					success : handleSubmit, // post-submit callback,
					contentType : 'multipart/form-data',
					error : handleErrorImportError,
					addCsrf : true
				};
				$(this).parent().ajaxSubmit(options);
			});

			/*
			 * $(".exportScript").on("click", function(evt) {
			 * $("#exportCRReportId1").val(cvUtil.getParameter("reportId", 0)); $(".actionMenu").hide();
			 * $("#exportCustomReportForm").submit(); cvUtil.logUserAction("CustomReport-" +
			 * $("#sectionTitle").text(), "exportCustomReport", "", ""); });
			 */

			if ($("#pageTabs-collapse li").length == 0) {
				$(".collapsible-page-tabs").hide();
			}

			var editSchedule = window.sessionStorage.getItem('editSchedule');
			if (editSchedule != undefined) {
				$(".vw-content").prepend($("#scheduleNavPanelTemplate").html());
				$("#scheduleNavPanelTemplate").html("");
				window.sessionStorage.removeItem('editSchedule');
				window.editSchedule = editSchedule;
			}
			$(document).on("click",
					"#saveScheduleEdit",
					function(e) {
						var sKey = "taskId" + window.editSchedule;
						var taskId = window.editSchedule;
						var modelObject = JSON.parse(sessionStorage.getItem(sKey));

						$(".reportSettingsButtons").hide();
						var updatedUrl = convertToExportUrl(window.location.href,
								modelObject.exportType.toLowerCase(),
								-1); // Get updated Url after cleaning Url from schedule edit params

						var params = {
							"taskId" : taskId,
							"updatedUrl" : updatedUrl
						};

						$('body').mask(cvUtil.cvLocalize('Updating_Schedule') + ' "' + modelObject.description + '"');
						cvUtil.loadPageWithPOST(cvUtil.getContextPath() + "/reports/updateReportScheduleUrl.do",
								params,
								function(data) {
									$('body').unmask();
									cvUtil.toast(cvUtil.cvLocalize('Schedule_Url_Update_Successful') + ' "' + data +
											'"');
								},
								function() {
									$('body').unmask();
									cvUtil.errorToast(cvUtil.cvLocalize('Schedule_Url_Update_Error'));
								});

						e.preventDefault;
					});

			$(document).on("click", "#cancelScheduleEdit", function(e) {
				$(".reportSettingsButtons").hide();
				e.preventDefault;
			});

			cvUtil.origNotify = cvUtil.notify;
			cvUtil.notify = function(messageTemplate, messageData, delay, addToHistory, historyType, historyMessage,
					closeOnClick) {
				cvUtil.origNotify(messageTemplate,
						messageData,
						delay,
						addToHistory,
						historyType,
						historyMessage,
						closeOnClick);
				if (historyType == nh.NOTIFICATION_ERROR && !Reports.nonFatal) {
					Reports.fatalError = true;
					Reports.fatalErrorMessage = historyMessage;
				}
			};
			cvUtil.origErrorToast = cvUtil.errorToast;
			cvUtil.origErrorToastWithDetails = cvUtil.errorWithDetailsToast;
			cvUtil.errorToast = function(message, delay, persist, addToHistory, notFatal) {
				Reports.nonFatal = notFatal; //remember js is single threaded, we can achieve it with minimal changes
				cvUtil.origErrorToast(message, delay, persist, addToHistory);
				delete Reports.nonFatal;
			};
			cvUtil.errorWithDetailsToast = function(message, delay, persist, addToHistory, notFatal) {
				Reports.nonFatal = notFatal; //remember js is single threaded, we can achieve it with minimal changes
				cvUtil.origErrorToastWithDetails(message, delay, persist, addToHistory);
				delete Reports.nonFatal;
			};
			window.alert = function(data, notFatal) {
				Reports.nonFatal = notFatal;
				cvUtil.origErrorToast(data);
				delete Reports.nonFatal;
			};
			window.reportMetaData = {
				"tableMetaData" : {}
			};
			$('body').on("click", "#minimizeExportBox", function(e) {
				toggleMinimizeExportBox();
				e.stopPropagation();
			});
			$('body').on("click", "#exportStatusBox #headContent", function() {
				toggleMinimizeExportBox();
			});
			$('body').on("click", "#removeExportBox", function() {
				hideExportBox();
			});
			$('body').on("click", ".exportContentCloseButton", function() {
				var fileGuid = $(this).attr("data-guid");
				$("#content-" + fileGuid).fadeOut("fast");
				cancelExport(fileGuid);
			});
			setTimeout(function() {
				registerExportRequest();
			}, 1000);
			if (cvUtil.getParameterByName("exportType") == "" && !inIframe() && !window.startedExportTracking) {
				startExportTracking();
			}
			saveUserEmailToSessionStorage();
		});

function validateForm(formData, jqForm, options) {
	var fileName = formData[0].value.name;
	var ext = fileName.substring(fileName.lastIndexOf('.') + 1, fileName.length);
	if (ext.toLowerCase() !== "xml") {
		$("#content").unmask();
		-alert('Invalid file uploaded, only XML files which are exported as part of custom reports are accepted');
		return false;
	}
	return true;
}

function handleDataSetSuccess(data, statusText, xhr, $form) {
	var input = $("#browseImportDSFile");
	input.replaceWith(input.val('').clone(true));
	cvUtil.toast(data.succesMessage);
	$("#content").unmask();
	rpt.reload('dataSetManagerTable');
}

function handleSubmit(data, statusText, xhr, $form) {
	var input = $("#browseImportFile");
	input.replaceWith(input.val('').clone(true));
	var reportData = data;
	if (data.data) {//import of v1 report returns different data format
		reportData = data.data;
	}
	$("#content").unmask();

	if (reportData.errorMessage) {
		if (reportData.errorMessage) {
			cvUtil.errorToast(reportData.errorMessage);
		} else {
			cvUtil.errorToast(cvUtil.cvLocalize("errors.error"));
		}
	}

	if (reportData.successMessage) {
		cvUtil.toast(reportData.successMessage);
		setTimeout(function() {
			if (window.location.href.indexOf("reports.jsp") != -1) {
				if (rpt) { // this will check for the rpt object and reload call the reload function. that will reload the report manager page with cache reset.
					rpt.reload();
					rpt.reload("dashboardManagerTable");// dashboardmanager refresh;
				}
			} else if (data.sourcePage && data.sourcePage == 'report_home_page') {
				window.location.reload();
			} else {
				if (!!reportData && !!reportData.imported && $.isArray(reportData.imported) && reportData.imported.length > 0) {
					window.location.href = cvUtil.getContextPath() + "/reportsplus/index.jsp?reportId=" +
					reportData.imported[reportData.imported.length - 1].id;
				}
			}
		}, 3000);
	}

}

function handleErrorImportError(data) {
	var input = $("#browseImportFile");
	input.replaceWith(input.val('').clone(true));
	handleError(data);
}

function handleError(data) {
	$("#content").unmask();
	-alert($.trim(data.responseText));
}

function localSaveTableSettings() {
	if (report.isExport != undefined && report.isExport == true) {
		return;
	}

	if (tablePrefs.length == 0) {
		var len = 0;
		$(".reportTable").each(function() {
			var tableId = $(this).attr("id");
			var display = $(this).css("display");
			if (display != "none") {
				tablePrefs = [];
				tablePrefs[len] = {};
				tablePrefs[len].tableid = tableId;
				addOrUpdateTableSettings(len, tableId);
				len++;
			}
		});
	} else {
		$(".reportTable").each(function() {
			var tableId = $(this).attr("id");
			var display = $(this).css("display");
			if (display != "none") {
				for (var i = 0; i < tablePrefs.length; i++) {
					if (tablePrefs[i].tableid == tableId) {
						addOrUpdateTableSettings(i, tableId);
					} else {
						if (i == (tablePrefs.length - 1)) {
							i = i + 1;
							tablePrefs[i] = {};
							tablePrefs[i].tableid = tableId;
							addOrUpdateTableSettings(i, tableId);
						}
					}
				}
			}
		});
	}
}
function addOrUpdateTableSettings(len, tableId) {
	if ($("#" + tableId + CVTable.table).html() != '') {
		var oTable = $("#" + tableId + CVTable.table).dataTable();
		var oSettings = oTable.fnSettings();
		if (oSettings != null) {
			for (var j = 0; j < oSettings.aoColumns.length; j++) {

				tablePrefs[len].columns = tablePrefs[len].columns || [];
				tablePrefs[len].columns[j] = tablePrefs[len].columns[j] || {};
				tablePrefs[len].columns[j].order = j;
				tablePrefs[len].columns[j].fieldname = oSettings.aoColumns[j].mDataProp;
			}
		}
	}
}
function isExportRequestTwoStep(data, gridid) { //NOT used for custom reports
	var url = document.URL;
	var exportType = cvUtil.getParameterByName("exportType").toLowerCase();

	if (exportType == 'email_body' &&
			(typeof data.dbQuery != "undefined" || typeof data.jobSummaryQueryGuid != "undefined")) {
		return true;
	} else {
		if (url.indexOf("CommCellSurvey.jsp") != -1) {
			if (cvUtil.getParameterByName(gridid + "-filterClause")) {
				return false;
			}
		}
		if (url.indexOf("jobsummary.jsp") == -1) {
			return false;
		}
		if (cvUtil.getParameterByName("dashboardExport")) {
			return false;
		}
		if ((exportType == "pdf" || exportType == "html") &&
				(typeof data.dbQuery != "undefined" || typeof data.jobSummaryQueryGuid != "undefined")) {
			return true;
		}
	}

	return false;
}

function initializeForExport(gridid, data) { //NOT used for custom reports
	if (window.reportMetaData == null || window.reportMetaData == undefined) {
		window.reportMetaData = {
			"tableMetaData" : {}
		};
	}
	var aoColumns = data.aoColumns;
	var columnsProcessed;
	var dbQuery = "";
	var jobSummaryQueryGuid = "";
	if (typeof data.dbQuery != "undefined") {
		dbQuery = data.dbQuery;
	}
	if (typeof data.jobSummaryQueryGuid != "undefined") {
		jobSummaryQueryGuid = data.jobSummaryQueryGuid;
	}

	$("#" + gridid + "_table_info").html("Total of " + data.iTotalRecords + " Entries");

	columnsProcessed = getExportColumnInfo(aoColumns);

	window.reportMetaData.tableMetaData[gridid] = {
		"class" : {
			"odd" : "odd",
			"even" : "even",
			"generic" : ""
		},
		"columns" : columnsProcessed,
		"dataURL" : "", //NO USE RIGHT NOW
		"jsFilesList" : [
				"reports/js/reportsExportUtil.js",
				"common/js/cvutil.js",
				"reports/js/reportsUtil.js",
				"reports/js/reportsRenderers.js",
				"common/js/moment.js" ],
		"rowSelector" : "tbody tr",
		"currentURL" : window.location.href,
		"tableWrapperDivID" : gridid + "_table_wrapper"
	};

	if (dbQuery != "") {
		window.reportMetaData.tableMetaData[gridid].dbQueryForMetrics = dbQuery;
	} else if (jobSummaryQueryGuid != "") {
		window.reportMetaData.tableMetaData[gridid].jobSummaryQueryGuid = jobSummaryQueryGuid;
	}

}

function getExportColumnInfo(aoColumns) {
	var columnsProcessed = [];
	var indObject;
	var columnObj;
	for (var i = 0; i < aoColumns.length; i++) {
		columnObj = aoColumns[i];
		indObject = {
			"dataField" : columnObj.mDataProp,
			"displayName" : columnObj.mDataProp,
			"origName" : columnObj.mDataProp,
			"visible" : columnObj.bVisible,
			"hidden" : !columnObj.bVisible,
			"metricsColumn" : true
		};

		//"id"
		if (columnObj.sOriginalName) { // For Metrics Reports
			indObject.id = columnObj.sOriginalName;
			if (columnObj.rendererType) {
				indObject.rendererType = columnObj.rendererType;
			}
		} else if (columnObj.sTitle) { // For Web Job Summary Report
			indObject.displayName = columnObj.sTitle;
			indObject.id = columnObj.sTitle;
			if (columnObj.rendererType) {
				indObject.id = indObject.id + "<" + columnObj.rendererType + ">";
			}
		}

		//"type"
		if (columnObj.sqlType) {
			indObject.type = columnObj.sqlType;
		} else if (columnObj.dataType) {
			indObject.type = columnObj.dataType;
		}

		columnsProcessed.push(indObject);
	}
	return columnsProcessed;
}

function adjustWidth(gridid) {
	var dataTable = $('#' + gridid + CVTable.table).dataTable();
	dataTable.fnAdjustColumnSizing();
}
function convertToExportUrl(url, exportType, pageSize) {
	var p = pageSize || -1;
	var params = {};

	var positionToInsert = url.indexOf("?") + 1;
	if (cvUtil.isInternetExplorer() && cvUtil.getInternetExplorerMajorVersion() <= 9) {
		url = extractExportUrlForIe9(url);
	}

	if (positionToInsert > 0) {
		urlToRequest(url.slice(positionToInsert), params);

		var cleanExportParams = function(iObj) {
			for ( var m in iObj) {
				if (typeof iObj[m] == 'object') {
					// remove the pageSize of table objects recursively.
					cleanExportParams(iObj[m]);
				} else if (m == 'pageSize' || m == 'exportType') {
					delete iObj[m];
				}
			}
		};

		// remove existing exportType & pageSize
		cleanExportParams(params);
	}

	// add the current export settings params.
	if (window.bigExportSupported && exportType && exportType.toUpperCase() == 'CSV') {
		p = pageSize || Reports.pagesize || window.pageSizeForBigExport || 5000;
		params.bigExportSupport = true;
	}
	params.pageSize = p;
	params.exportType = exportType;

	var paramsString = requestToUrl(params);

	if (positionToInsert < 1) {
		url = url + '?' + paramsString;
	} else {
		url = [ url.slice(0, positionToInsert), paramsString ].join(''); //we can't just append at the end because of IE9
	}
	return url;
};

function removeParamFromUrl(key, sourceURL) { // Modifies the passed in URL, by removing the URLParam with "key" as the key
	var rtn = sourceURL.split("?")[0], param, params_arr = [], queryString = (sourceURL.indexOf("?") !== -1) ? sourceURL
			.split("?")[1]
			: "";
	if (queryString !== "") {
		params_arr = queryString.split("&");
		for (var i = params_arr.length - 1; i >= 0; i -= 1) {
			param = params_arr[i].split("=")[0];
			if (param === key) {
				params_arr.splice(i, 1);
			}
		}
		rtn = rtn + "?" + params_arr.join("&");
	}
	return rtn;
}

function getParamInsertedDocumentSearch(key, value) { //Takes current page window.document.search and adds the parameter to it and return
	key = encodeURI(key);
	value = encodeURI(value);
	var kvp = document.location.search.substr(1).split('&');
	var i = kvp.length;
	var x;
	while (i--) {
		x = kvp[i].split('=');

		if (x[0] == key) {
			x[1] = value;
			kvp[i] = x.join('=');
			break;
		}
	}

	if (i < 0) {
		kvp[kvp.length] = [ key, value ].join('=');
	}
	return kvp.join('&');
}

function extractExportUrlForIe9(url) {
	var begin = url.indexOf("?");
	var end = url.lastIndexOf("?");
	var mid = url.indexOf("#");
	if (mid > 0 && end != begin) {
		url = url.substring(0, begin) + url.substring(end); // e.g. http://joker/webconsole/reports/jobsummary.jsp?communid=1#jobsummary.jsp?communid=1&type=JobSummary&backupType-0=full
	} else if (mid > 0 && end == begin) {
		url = url.substring(0, mid) + url.substring(end); // e.g. http://joker/webconsole/reports/jobsummary.jsp#jobsummary.jsp?type=JobSummary&backupType-0=full
	}
	return url;
}

function uniqueIDGenerator() {
	return 'xxxxxxx'.replace(/[x]/g, function(c) {
		var r = Math.random() * 16 | 0;
		return r.toString(10);
	});
}

function inIframe() {
	try {
		return window.self !== window.top;
	} catch (e) {
		return true;
	}
}

function downloadReportFile(fileName) {
	if (!fileName || fileName == "" || fileName == 'null') {
		cvUtil.errorToast(localMsg['ExportError']);
	} else {
		var finalLink = cvUtil.getContextPath() + "/server/doDownload?type=report&fileName=" +
				window.encodeURIComponent(fileName);
		var iframeId = "iframe" + Date.now();
		var iframeDOM = document.createElement("iframe");
		iframeDOM.setAttribute("style", "display:none;");
		iframeDOM.id = iframeId;
		document.body.appendChild(iframeDOM);
		iframeDOM.src = finalLink;
	}
}

//function generateUUID() { //Generate Cache ID for  Export_ Can be used if Cache ID can be used for Metrics
//	var d = new Date().getTime();
//	var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
//		var r = (d + Math.random() * 16) % 16 | 0;
//		d = Math.floor(d / 16);
//		return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
//	});
//	return uuid;
//}

function addBreadCrumbs(crumbs) {
	var template = '<li class="dynamicBreadcrumb smartlinkMain withSeparatorMain"><a class="smartLinkMain" href="{0}">{1}</a></li>';
	crumbs.forEach(function(crumb) {
		$("#breadcrumbMain").append(template.replace('{0}', crumb.link).replace('{1}', crumb.title));
	});
}

function registerExportRequest() {
	var subscriptionID = window.sessionStorage.getItem('export_subscriptionID');
	if (typeof isPhantomJs !== "undefined" && typeof pushService !== "undefined") {
		subscriptionID = subscriptionID == undefined ? this.uniqueIDGenerator() : subscriptionID;
		window.sessionStorage.setItem('export_subscriptionID', subscriptionID);
		pushService.subscribe({
			'msg' : 'subscribe',
			'type' : 'EXPORT_MESSAGE',
			'additionalData' : subscriptionID
		}, function(data) {
			if (data.subscriptionID != subscriptionID) {
				return;
			}
			if (data["fileToDownload"]) {
				downloadPushExportFile(data);
			} else {

				//Handle the incoming Data
				var trackingInfo = JSON.parse(window.sessionStorage.getItem("trackingInfo"));
				var stopDownload = false;
				if (trackingInfo && trackingInfo[data["trackingId"]] != undefined) {
					if (trackingInfo[data["trackingId"]]["stopDownload"] != undefined) {
						stopDownload = trackingInfo[data["trackingId"]]["stopDownload"];
					}
				}
				if (stopDownload == false) {
					trackingInfo[data["trackingId"]] = {
						"reportName" : data["reportName"],
						"exportType" : data["exportType"],
						"processingPercent" : data["percent"],
						"exportFailed" : data["exportFailed"],
						"errorMsg" : data["errorMessage"],
						"stopDownload" : stopDownload
					}
				}
				window.sessionStorage.setItem("trackingInfo", JSON.stringify(trackingInfo));
				updateExportInfo();
			}

		}, function(data) {
			console.log("Something went wrong");
		});
	}

	return subscriptionID;
}

function isExportCancelled(exportKey) {
	var isCancelled = true;
	var notFound = true;
	var trackingInfo = JSON.parse(window.sessionStorage.getItem("trackingInfo"));
	for ( var key in trackingInfo) {
		if (key == exportKey) {
			if (trackingInfo[key]["stopDownload"] == false) {
				isCancelled = false;
				break;
			}
		}
	}
	return isCancelled;
}

function cancelExport(guid) {
	var trackingInfo = JSON.parse(window.sessionStorage.getItem("trackingInfo"));
	var countOfExports = 0;
	if (trackingInfo[guid] != undefined) {
		trackingInfo[guid]["stopDownload"] = true;
	}
	for ( var key in trackingInfo) {
		if (trackingInfo[key]["stopDownload"] == false && trackingInfo[key]["processingPercent"] != 100) {
			countOfExports++;
		}
	}
	if (countOfExports < 1) {
		hideExportBox();
	}
	window.sessionStorage.setItem("trackingInfo", JSON.stringify(trackingInfo));
}

function hideExportBox() {
	$("#exportStatusBox").hide();
	$("#exportStatusBox").addClass("alwaysHide");
	window.sessionStorage.setItem("closedExportBox", "true");
}
function showExportBox() {
	$("#exportStatusBox").show();
	$("#exportStatusBox").removeClass("alwaysHide");
	window.sessionStorage.setItem("closedExportBox", "false");
}

function toggleMinimizeExportBox() {
	if (window.sessionStorage.getItem("minimizedExportBox") == "false") {
		minimizeExportBox();
	} else {
		unmimimizeExportBox();
	}
}

function unmimimizeExportBox() {
	$("#exportContentHold").fadeIn("fast");
	$("#minimizeExportBox").removeClass("glyphicon-plus");
	$("#minimizeExportBox").addClass("glyphicon-minus");
	window.sessionStorage.setItem("minimizedExportBox", "false");
}

function minimizeExportBox() {
	$("#exportContentHold").fadeOut("fast");
	$("#minimizeExportBox").addClass("glyphicon-plus");
	$("#minimizeExportBox").removeClass("glyphicon-minus");
	window.sessionStorage.setItem("minimizedExportBox", "true");
}

function startExportTracking() {
	window.startedExportTracking = true;
	if (!window.sessionStorage.getItem("trackingInfo")) {
		window.sessionStorage.setItem("trackingInfo", "{}");
	}
	if (!window.sessionStorage.getItem("minimizedExportBox")) {
		window.sessionStorage.setItem("minimizedExportBox", false);
	}
	if (!window.sessionStorage.getItem("closedExportBox")) {
		window.sessionStorage.setItem("closedExportBox", false);
	}

	$('body').append('<div id="exportStatusBox" class="hideOnExportFriendly"></div>');

	$("#exportStatusBox").append("<div id='headContent'> <h5>" + cvUtil.cvLocalize('Recent_Exports') + "</h5> " +
			"<span id='exportRightFloat'> <span class='glyphicon glyphicon-minus' id='minimizeExportBox'></span>  " +
			"<span id='removeExportBox'>X</span> </span>" + "</div><div id='exportContentHold'></div>");

	var currentIsClosedExportBox = window.sessionStorage.getItem("closedExportBox");
	var currentIsMinimizedExportBox = window.sessionStorage.getItem("minimizedExportBox");

	updateExportInfo(); //Will add the Export box with expanded, Non Mimized Form

	if (currentIsClosedExportBox == "true") {
		hideExportBox();
	}
	if (currentIsMinimizedExportBox == "true") {
		toggleMinimizeExportBox();
	}
	downloadUnclaimedExportFiles();
}

function downloadUnclaimedExportFiles() {
	subscriptionId = window.sessionStorage.getItem("export_subscriptionID");

	if (subscriptionId != "") {
		cvUtil.loadPageWithGET(cvUtil.getContextPath() + "/reports/getUnclaimedExportFiles.do", {
			"subscriptionID" : subscriptionId
		}, function(data) {
			setTimeout(function() { //Temporary fix. Needs to get functionality from push service
				registerExportRequest();
			}, 6000);
			if (data != "") {
				data = JSON.parse(data);
				for (i = 0; i < data.length; i++) {
					var fileToDownload = data[i];
					downloadPushExportFile(fileToDownload);
				}
			}
		});
	}
}

function downloadPushExportFile(data) {
	if (!isExportCancelled(data["trackingId"])) {
		downloadReportFile(data["fileToDownload"]);

		clearPushExportData(data["trackingId"]);
		if (isAllExportsSuccessfull()) {
			hideExportBox();
		}
	}
}

function clearPushExportData(key) {
	if (key) {
		$("#content-" + key).fadeOut("fast");
		var trackingInfo = JSON.parse(window.sessionStorage.getItem("trackingInfo"));
		delete trackingInfo[key];
		window.sessionStorage.setItem("trackingInfo", JSON.stringify(trackingInfo));
	}
}

function isAllExportsSuccessfull() {
	var countOfSuccessExports = 0;
	var trackingInfo = JSON.parse(window.sessionStorage.getItem("trackingInfo"));
	for ( var key in trackingInfo) {
		if (trackingInfo[key]["stopDownload"] == false && trackingInfo[key]["processingPercent"] != 100) {
			countOfSuccessExports++;
		}
	}
	if (countOfSuccessExports == 0) {
		return true;
	}
	return false;
}

function updateExportInfo() {
	var trackingInfo = JSON.parse(window.sessionStorage.getItem("trackingInfo"));
	for ( var key in trackingInfo) {
		var domHead = $('#content-' + key);
		var fileType = trackingInfo[key]["exportType"];
		var fullFileName = trackingInfo[key]["reportName"];
		var fileName = fullFileName;
		if (fullFileName.length > 15) {
			fileName = fullFileName.substring(0, 15) + "...";
		}
		var currentStatus = "";
		if (trackingInfo[key]["exportFailed"] == true) {
			currentStatus = cvUtil.cvLocalize('Exports_Failed');

			if (trackingInfo[key]["errorMsg"]) {
				var errorInfoIcon = '<span data-toggle="tooltip" data-placement="top" title="" data-original-title="' +
						trackingInfo[key]["errorMsg"] +
						'" class="export-box-error-info"><svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16" class="vw-notification-svg" fill="#b32828"><path d="M8,0a8,8,0,1,0,8,8A8,8,0,0,0,8,0ZM9,12H7V10H9v2ZM9,9H7V3H9V9Z"></path></svg></span>';

				currentStatus = "(" + currentStatus + ")" + errorInfoIcon;
				setTimeout(function() {
					$('[data-toggle="tooltip"]').tooltip();
				}, 200);
			} else {
				currentStatus = "(" + currentStatus + ")";
			}
		} else if (trackingInfo[key]["processingPercent"] == 100) {
			currentStatus = "(" + cvUtil.cvLocalize('Exports_Success') + ")";
		} else {
			currentStatus = "(" + trackingInfo[key]["processingPercent"] + "%" + ")";
		}

		if (trackingInfo[key]["stopDownload"] == false) {
			if (domHead.length <= 0 && trackingInfo[key]["processingPercent"] != 100) { //New DOM addition
				showExportBox();//opening the export box even if it's closed
				unmimimizeExportBox();//uminimising for new download
				var spriteIcon = "icon-leaf";
				switch (fileType) {
				case 'pdf':
					spriteIcon = "icon-export-pdf";
					break;
				case 'html':
					spriteIcon = "icon-export-html";
					break;
				case 'csv':
					spriteIcon = "icon-export-csv";
					break;
				case 'pptx':
					spriteIcon = "icon-export-ppt-small";
					break;
				case 'docx':
					spriteIcon = "icon-export-word";
					break;
				}
				$("#exportContentHold").append("<div class='exportStatusContent' id='content-" + key + "'>" +
						"<div class='exportContentDetails'>" + "<span class='imageSpan sprite " + spriteIcon +
						"'></span><span class='downloadType'>" + fileType + "</span> " + "<span title='" +
						fullFileName + "'>" + fileName + "</span> <span class='currentStatus'> " + currentStatus +
						" </span> </div> " + "<div class='exportContentCloseButton' data-guid='" + key +
						"'><span class='sprite icon-delete-tag'></span></div> </div>");
			} else {
				domHead.find(".currentStatus").html(currentStatus);
			}
		}
	}
	window.sessionStorage.setItem("trackingInfo", JSON.stringify(trackingInfo));
}

function saveUserEmailToSessionStorage() {
	var userEmail = window.sessionStorage.getItem('userEmail');
	if (userEmail == undefined) {
		cvUtil.loadPageWithGET(cvUtil.getContextPath() + "/reports/getUserSmtpAddress.do", "", function(data) {
			window.sessionStorage.setItem('userEmail', data);
		});
	}

}

Reports.hasFatalError = function() { //intended to be used by automation tools/export code, so after each page load this function will be called
	var page = "retrieveReportsError.do";
	var msg = $.trim(cvUtil.loadSynchronously(page)); //important to make server call even if there is a js error, so as to clear error from session
	if (Reports.fatalError) {
		return true;
	}
	if (msg) {
		Reports.fatalError = true;
		Reports.fatalErrorMessage = msg;
		return true;
	}
	return false;
	//	var error = $.cookie("ReportsError");
	//	Reports.fatalErrorMessage = error;
	//	if(error){
	//		return true;
	//	}
};
Reports.getFatalError = function() {
	if (Reports.hasFatalError()) {
		return Reports.fatalErrorMessage;
	} else {
		return null;
		//	var error = $.cookie("ReportsError");
		//	Reports.fatalErrorMessage = error;
		//	if(error){
		//		return true;
		//	}
	}
};
