function SLAReport() {
	sla = {};
	sla.initialized = false;
	sla.slaDaysLoaded = false;
	var commUniId = cvUtil.getParameter('commUniId');

	var MAX_ENTITIES_SELECTION = 10;
	var SLA_MAX_DAYS = 30;

	this.report = new Reports.initReport({
		type : 'sla',
		reportTitle : 'SLA'
	});
	this.requestString = report.requestString;

	report.initializeDefaults = function() {
		report.requestString.type = 'sla';
		report.requestString["commUniId"] = commUniId;
		report.requestString.days = 0;
		report.requestString.viewBy = 'ByClient';
		report.requestString.countFullJobsOnly = 'All';
		report.requestString.includeScheduledJobs = 0;
		report.requestString.reportFilters = [];
	};

	report.initComponents = function() {
		$('#settingsLink').hide();
		$("#from").datepicker({
			onClose : function(selectedDate) {
				$("#to").datepicker("option", "minDate", selectedDate);
				if (sla.initialized === true) {
					var startDate = $('#from').datepicker('getDate').getTime() / 1000;
					var endDate = $('#to').datepicker('getDate').getTime() / 1000;
					var minDate = new Date();
					minDate.setDate(minDate.getDate() - SLA_MAX_DAYS);
					minDate.setHours(0, 0, 0, 0);
					if ((minDate.getTime() > startDate * 1000) || (endDate < startDate)) {
						cvUtil.errorToast(cvUtil.cvLocalize('sla.Select_valid_start_date'));
						return;
					}
					report.generateReport();
				}
			}
		});
		$("#to").datepicker({
			onClose : function(selectedDate) {
				$("#from").datepicker("option", "maxDate", selectedDate);
				var startDate = $('#from').datepicker('getDate').getTime() / 1000;
				var endDate = $('#to').datepicker('getDate').getTime() / 1000;
				var minDate = new Date();
				minDate.setDate(minDate.getDate() - SLA_MAX_DAYS);
				minDate.setHours(0, 0, 0, 0);
				if ((minDate.getTime() > endDate * 1000) || (endDate < startDate)) {
					cvUtil.errorToast(cvUtil.cvLocalize('sla.Select_valid_end_date'));
					return;
				}
				if (sla.initialized === true) {
					report.generateReport();
				}
			}
		});

		var today = new Date();
		var todayStr = today.format('MM/dd/yyyy');
		$("#to").val(todayStr);

		var fromday = new Date();
		fromday.setDate(fromday.getDate() - SLA_MAX_DAYS);
		var fromdayStr = fromday.format('MM/dd/yyyy');
		$("#from").val(fromdayStr);

		$("#from").datepicker("option", "minDate", fromdayStr);
		$("#from").datepicker("option", "maxDate", todayStr);
		$("#to").datepicker("option", "minDate", fromdayStr);
		$("#to").datepicker("option", "maxDate", todayStr);

		var treeReqURL = cvUtil.getContextPath() +
				"/server/report?type=Common&component=CommServTree&entityType=1&reportType=" +
				report.requestString.type;
		report.clientGroupsLoaded = false;
		cvUtil
				.loadPageWithPOST(treeReqURL,
						"",
						function(data) {
							$("li#loadingDummyGroup").remove();
							if (data["groups"] != null) {
								$
										.each(data["groups"],
												function(index, val) {
													var checkBoxTemplate = '<div class="custom-cb unchecked" data-state="unchecked"></div><span class="custom-cb-label" >' +
															val + '</span>';
													$("#clientGroup").append('<li data-name="' + escape(val) +
															'" id="group_' + index + '">' + checkBoxTemplate + '</li>');
												});
								report.clientGroupsLoaded = true;
								$('.custom-cb').click(function(e) {
									customCheckBoxClicked(e, this); //defined in custom-cb.js
									report.updateClientGroupText();
								});

								if (report.requestString.clientGroup) {
									$.each(report.requestString.clientGroup, function(index, value) {
										checkCb($("#clientGroup").find('li[data-name="' + escape(value) +
												'"] .custom-cb'));
									});
									report.updateClientGroupText();
								}

								$('#clientGroup #searchClientGroup').click(function(e) {
									report.isSearching = true;
									e.stopPropagation();
								});

								$('#clientGroup #searchClientGroup').keyup(function(e) {
									var searchText = $(this).val().toLowerCase().trim();
									$(this).closest("ul#clientGroup").children("li").each(function() {
										if (!$(this).hasClass("excludeFromSearch")) {
											if ($(this).text().toLowerCase().indexOf(searchText) > -1) {
												$(this).show();
											} else {
												$(this).hide();
											}
										}
									});
								});

								$('#clientGroup #searchClientGroup').focusout(function() {
									report.isSearching = false;
									setTimeout(function() {
										$('#clientGroup #searchClientGroup').closest("ul#clientGroup").children("li")
												.show();
										$('#clientGroup #searchClientGroup').val("");
									}, 500);
								});

								$('#clientGroup li').click(function(e) {
									if ($(this).attr("id") == 'clearAll') {
										return;
									}
									if ($(this).attr("id") == "All") {
										$.each($('#clientGroup .custom-cb.checked'), function(index, value) {
											unCheckCb($(this));
										});
										report.updateClientGroupText();
										report.allClientGroupsSelected = true;
									}
									if (!$(this).find(".custom-cb").hasClass("checked")) {
										$(this).find(".custom-cb").click();
									}
									$('#clientGroup').hide();
									$('#clientGroup #searchClientGroup').val(""); //empty search area
									$(this).closest("ul#clientGroup").children("li").show();
									e.stopPropagation();
								});
								report.clientGroupChanged = false;
								$('#clientGroup-selection').removeClass("disabledActions");

								if (isAllowIncludeAll !== 'true') {
									//if not admin and there is no client group in URL then check all groups
									var clientGroup = [];
									$.each($('#clientGroup .custom-cb'), function(index, value) {
										clientGroup.push($(value).next().text());
										checkCb($(this));

									});

									report.requestString.clientGroup = clientGroup;
									report.updateClientGroupText();
									report.generateReport();
									report.updateHash(false);
								}
							}
						});

		$("#clientGroup").customSelect(0);
		$("#clientGroup").on("hide", function(e, el) {
			if (sla.initialized == true && report.clientGroupChanged == true && report.isSearching == false) {
				report.generateReport();
				report.clientGroupChanged = false;
			}
		});
		$('#clientGroup-selection').addClass("disabledActions");

		//$("#timeframe").customSelect(0);
		$("#timeframe").on("customSelectionChanged", function(e, el) {
			var daysSelected = parseInt($("#timeframe").find("li.selectedOption").attr('id'));
			enableSLAOptions(daysSelected);
			if (sla.initialized == true) {
				report.generateReport();
			}
		});
		$("#countScheduledJobs").on("checkedState", function(e) {
			setChecked($("#countScheduledJobs"), true);
			e.stopPropagation();
			if (sla.initialized == true) {
				report.generateReport();
			}
		}).on("unCheckedState", function(e) {
			setChecked($("#countScheduledJobs"), false);
			e.stopPropagation();
			if (sla.initialized == true) {
				report.generateReport();
			}
		});

		$("input[name=daysType]:radio").change(function() {
			var days = $("input[name='daysType']:checked").val();
			enableSLAOptions(days);
			if (sla.initialized == true) {
				report.generateReport();
			}
		});

		$("#jobType").customSelect(0);
		$("#jobType").on("customSelectionChanged", function(e, el) {
			if (sla.initialized == true) {
				report.generateReport();
			}
		});
		/*
		 * $("#timeframe>li").click(function(){ $("#timeframe>.on").removeClass("on"); $(this).addClass("on");
		 * if(sla.initialized==true) report.generateReport(); });
		 */
		$("#viewButtons>ul>li").click(function(e) {
			if (e && e.target && e.target.classList.contains("disabled")) {
				return;
			}
			$("#viewButtons>ul>.on").removeClass("on");
			$(this).addClass("on");
			if (sla.initialized == true) {
				report.REFRESH_REPORT_FILTERS_ONGENERATE = true;
				report.generateReport();
				report.REFRESH_REPORT_FILTERS_ONGENERATE = false;
			}
		});
		$("#slaNote,#agent_slaNote").click(function() {
			report.drillDown({
				entityType : "status",
				entityName : "Excluded"
			});
		});

		$("#clearAll").click(function(e) {
			$.each($('#clientGroup .custom-cb.checked'), function(index, value) {
				unCheckCb($(this));
			});

			report.updateClientGroupText();
			e.stopPropagation();
		});

		if (isAllowIncludeAll !== 'true') {
			$("#clientGroup .selectedOption").hide();
		}

	};
	report.initComponentState = function() {
		sla.initialized = false;
		if (report.clientGroupsLoaded == true) {
			$('#clientGroup li[id="All"]').click();
			if (report.requestString.clientGroup) {
				$.each(report.requestString.clientGroup, function(index, value) {
					$("#clientGroup").find('li[data-name="' + escape(value) + '"] .custom-cb').click();
				});
			}
			report.updateClientGroupText();
		}
		report.updateClientGroupText();
		report.clientGroupChanged = false;
		report.isSearching = false;
		if (report.requestString.countFullJobsOnly) {
			$("#jobType").find("li[data-value=" + report.requestString.countFullJobsOnly + "]").click();
		}
		//$("#timeframe").find("li#" + report.requestString.days + "_days").click();
		$("#viewButtons").find("li#" + report.requestString.viewBy).click();
		if (report.requestString.days === '-1') {
			$("#from").val(new Date(report.requestString.startDate * 1000).format('MM/dd/yyyy'));
			$("#to").val(new Date(report.requestString.endDate * 1000).format('MM/dd/yyyy'));
		}
		if (report.requestString.includeScheduledJobs === '1') {
			checkCb($("#countScheduledJobs"));
		}
		enableSLAOptions(report.requestString.days);
		sla.initialized = true;
	};
	report.updateRequestString = function() {
		var selectedClientGroup = $("#clientGroup").find("li.selectedOption");
		if (!report.allClientGroupsSelected) {
			report.requestString.clientGroup = report.getSelectedClientGroup();
		} else {
			delete report.requestString.clientGroup;
		}
		var daysLi = $("#timeframe").find("li.selectedOption").attr('id');
		var daysSelected = report.requestString.days;
		if (daysLi) {
			daysSelected = parseInt(daysLi);
		}
		report.requestString.days = daysSelected;
		report.requestString.viewBy = $("#viewButtons").find("li.on").attr('id');
		report.requestString.countFullJobsOnly = $("#jobType").find("li.selectedOption").data("value");
		if (report.requestString.days === -1) {
			report.requestString.startDate = $('#from').datepicker('getDate').getTime() / 1000;
			report.requestString.endDate = $('#to').datepicker('getDate').getTime() / 1000;
		}
		report.requestString.includeScheduledJobs = isChecked($("#countScheduledJobs")) ? 1 : 0;
	};
	report.getSelectedClientGroup = function() {
		var clientGroup = [];
		$.each($("#clientGroup .custom-cb.checked"), function(index, value) {
			clientGroup.push($(value).next().text());
		});
		return clientGroup;
	};
	report.defaultSortColumn = function() {
		return 'client';
	};
	report.updateClientGroupText = function() {
		var text = '';
		$.each($("#clientGroup .custom-cb.checked"), function(index, value) {
			text = $(value).next().text();
		});
		if (text == '') {

			if (isAllowIncludeAll === 'true') {
				text = 'All';
			} else {
				text = localMsg.selectClientGroup;
			}

			report.allClientGroupsSelected = true;
		} else {
			if ($("#clientGroup .custom-cb.checked").length > 1) {
				text = $("#clientGroup .custom-cb.checked").length + ' Selected';
			}
			report.allClientGroupsSelected = false;
		}
		$('#clientGroup-selection').text(text);
		report.clientGroupChanged = true;
		if (!report.clientGroupsLoaded) {
			if (report.requestString.clientGroup && report.requestString.clientGroup.length > 0) {
				if (report.requestString.clientGroup.length > 1) {
					$("#clientGroup-selection").text(report.requestString.clientGroup.length + " selected");
				} else {
					$("#clientGroup-selection").text(report.requestString.clientGroup[0]);
				}
			}
			report.clientGroupChanged = !report.requestString.clientGroup;
		}
	};

	report.init();

	report.customRender = function(key, model, data1) {
		if (key == 'agentSLABars') {
			if (report.slaTable) {
				report.slaTable.fnClearTable();
				report.slaTable.fnAddData(model.value);
			} else {
				report.slaTable = $("#agentSLABars").dataTable({
					"bProcessing" : false,
					"bRetrieve" : true,
					"aaData" : model.value,
					"aoColumns" : [
							{
								"mDataProp" : "agentType",
								"sClass" : "textcol column1",
								"sWidth" : "270px"
							},
							{
								"mDataProp" : "sla",
								"bUseRendered" : false,
								"sWidth" : "210px",
								"sClass" : "barcol",
								"fnRender" : function(o, val) {
									var clazz = "progress";
									if (o.aData.sla < data1.threshold.value) {
										clazz = "progress threshold";
									}
									var html = '<div class="' + clazz + '" id="progress-agent' + o.aData.index +
											'"><div class="progressPercent"></div></div>';
									return html;
								}
							},
							{
								"mDataProp" : "protectedClients",
								"bUseRendered" : false,
								"sDefaultContent" : "0",
								"sClass" : "textcol",
								"sWidth" : "180px",
								"fnRender" : function(o, val) {
									var html = "";
									html = '<span href="#" class="agentdrilldown" data-agent="' + o.aData.agentType +
											'" data-isprotected="Protected">' + o.aData.protectedClients + '</span>';
									return html;
								}
							},
							{
								"mDataProp" : "unprotectedClients",
								"bUseRendered" : false,
								"sDefaultContent" : "0",
								"sClass" : "textcol",
								"sWidth" : "270px",
								"fnRender" : function(o, val) {
									var html = "";
									html = '<span href="#" class="agentdrilldown" data-agent="' + o.aData.agentType +
											'" data-isprotected="Unprotected">' + o.aData.unprotectedClients +
											'</span>';
									return html;
								}
							} ],
					"aaSorting" : [ [ 1, 'desc' ] ],
					"bPaginate" : false,
					"bFilter" : false,
					"bSort" : true,
					"bLengthChange" : false, //don't show the drop down to select no. of displayed rows
					"bUseRendered" : false
				//use actual value for sorting, not the rendered one
				});
			}
			$.each(model.value, function(index, agent) {
				var el = $("#progress-agent" + agent.index);
				el.progressbar({
					value : parseFloat(agent.sla)
				});
				if (parseFloat(agent.sla) < 5) {
					el.addClass("lowPercent");
				}
				if (parseFloat(agent.sla) == 0) {
					el.addClass("zeroPercent");
				}
				$("#progress-agent" + agent.index + ">.progressPercent").html(agent.formattedSla);
			});
			$(".agentdrilldown").click(function(e) {
				e.preventDefault();
				var status = $(this).data('isprotected');
				var agentType = $(this).data('agent');
				report.requestString.reportFilters.push({
					entityType : 'agentTypeAndStatus',
					entityName : agentType + ';' + status,
					display : 'Agent' + status,
					URL : window.location.href
				}); //display is same as the key in localization bundle
				report.processReport();
			});
		} else if (key == 'asofspan') {
			$("#" + key).html(model.value.value);
			$("#" + key).attr("title", model.value.title);
		} else if (key == 'slaDays') {
			if (!sla.slaDaysLoaded) {
				var list = '<li id="0_days">' + cvUtil.cvLocalize('sla_days_default') + '</li>';
				var selectedIndex = 0;
				var tempMaxDays = SLA_MAX_DAYS;
				if (model.value) {
					$.each(model.value, function(i, val) {
						var dayStr = '';
						if (val > 1) {
							dayStr = cvUtil.cvLocalize('sla_days_n', val);
						} else {
							dayStr = cvUtil.cvLocalize('sla_days_one');
						}
						if (report.requestString.days == val) {
							selectedIndex = i + 1;
						}
						list = list + '<li id="' + val + '_days" >' + dayStr + '</li>';
						if (val > tempMaxDays) {
							tempMaxDays = val;
						}
					});
				}
				if (tempMaxDays > SLA_MAX_DAYS) {
					SLA_MAX_DAYS = tempMaxDays;
					var fromday = new Date();
					fromday.setDate(fromday.getDate() - SLA_MAX_DAYS);
					var fromdayStr = fromday.format('MM/dd/yyyy');
					if (report.requestString.days !== '-1') {
						$("#from").val(fromdayStr);
					}
					$("#from").datepicker("option", "minDate", fromdayStr);
					$("#to").datepicker("option", "minDate", fromdayStr);
				}
				list = list + '<li id="-1_days">' + cvUtil.cvLocalize('sla_days_custom') + '</li>';
				if (report.requestString.days == -1) {
					selectedIndex = (model.value) ? model.value.length + 1 : 1;
				}
				$('#timeframe').append(list);
				$("#timeframe").customSelect(selectedIndex);
				sla.slaDaysLoaded = true;
			}
		}

		var entitiesList = [
				'failedClients',
				'noJobFound',
				'noSchedule',
				'snapNoBackupCopy',
				'filteredVM',
				'unprotectedClients',
				'protectedClients',
				'excludedClients' ];
		for (var k = 0; k < entitiesList.length; k++) {
			var entityData = data1[entitiesList[k]];
			if (entityData) {
				var dataColumns = entityData.value.aoColumns;
				for (var i = 0; i < dataColumns.length; i++) {
					if (dataColumns[i].mDataProp == 'client') {
						dataColumns[i].rendererType = "clientColumn";
						//} else if (dataColumns[i].mDataProp == 'subclient') {
						//	dataColumns[i].rendererType = "subclientColumnRenderer";
					} else if (dataColumns[i].mDataProp == 'lastFailedJobId') {
						dataColumns[i].rendererType = "lastFailedJobIdColumn";
					}
				}
			}
		}

	};

	report.createRaphaelPieChart = function(chartModel, frameid) {
		if ($("#" + frameid).parent().hasClass("boxedChart")) {
			cvcharts.createPieChart(chartModel, frameid, 300, 160, 160, 550, 40, "#fff", null, null, false);
		} else {
			cvcharts.createPieChart(chartModel, frameid, 200, 130, 160, 550, 10, "#fff", null, null, false);
		}
	};
	report.createRaphaelLineChart = function(chartData, frameId) {
		localMsg.raphael.threshold = cvUtil.cvLocalize('sla.threshold', chartData["yAxis"]["thresholdValue"]);
		$("#" + frameId).empty();
		var r = Raphael(frameId);
		var chart = cvcharts.createRaphaelLinechart(r, chartData, {
			axis : "0 1 1 1",
			legend : -1,
			chartWidth : 600,
			chartHeight : 240,
			topMargin : 30,
			legendX : 500,
			legendY : 85,
			shade : true,
			radius : 0,
			showLegend : false
		});
		if (chartData["yAxis"]["thresholdValue"] || chartData["yAxis"]["thresholdValue"] == 0) {
			cvcharts.wrapText(r, localMsg.raphael.threshold, chart.cvcharts.x2 + 10, chart.cvcharts.thresholdY, 70);
		}
	};
	report.getExportFilePrefix = function() {
		return "SLA";
	};

	report.configureServerTable = function(key, value) {
		var enabledEntitySelection = false;
		//if (key != 'excludedClients') {
		if (value.value.aoColumns && value.value.aoColumns.length > 0) {
			var firstColumn = value.value.aoColumns[0];
			firstColumn['bUseRendered'] = false;
			firstColumn['bFilterRendered'] = false;
			value.value.aoColumns.splice(0, 0, {
				"sTitle" : '',
				"sWidth" : "20px",
				"mDataProp" : firstColumn["mDataProp"],
				"bSortable" : false,
				'bUseRendered' : false,
				'bFilterRendered' : false,
				'rendererType' : 'slaEntityRenderer'
			});
			enabledEntitySelection = true;
		}
		//}
		Reports.configureTable(key, "Protected Clients", value.value, report.requestString, report.getRequestUrl);
		if (value.value && value.value.tableTitle) {
			$("#" + key + "_title").html(value.value.tableTitle);
		}
		if (enabledEntitySelection) {
			var ButtonText;
			var ButtonTitle;
			var isExcludedClientsPage = key == 'excludedClients'
			if (isExcludedClientsPage) {
				ButtonText = cvUtil.cvLocalize('SLA.IncludeInSLA');
				ButtonTitle = cvUtil.cvLocalize('SLA.IncludeInSLAText');
			} else {
				ButtonText = cvUtil.cvLocalize('SLA.ExcludeFromSLA');
				ButtonTitle = cvUtil.cvLocalize('SLA.ExcludeFromSLAText');
			}
			$("#" + key + "_table_wrapper")
					.prepend("<div class='excludeBtnContainer'><span class='excludeSLAOption hide' title='" +
							ButtonTitle + "'>" + ButtonText + "</span></div>");
			var tablebodyId = "#" + key + " tbody";
			$(tablebodyId).on("checkedState", '.slaEntitySelection', function() {
				var selectedCb = $(this);
				if ($(tablebodyId + " .slaEntitySelection.checked").length > MAX_ENTITIES_SELECTION) {
					cvUtil.errorToast(cvUtil.cvLocalize('SLA.EntitiesSelectionError'));
					window.setTimeout(function() {
						unCheckCb(selectedCb, false);
					}, 5);
					return;
				}
				enableExcludeSLAButton(tablebodyId);

			}).on("unCheckedState", '.slaEntitySelection', function() {
				enableExcludeSLAButton(tablebodyId);
			});
			$(".excludeSLAOption").on("click", function() {
				submitExcludeSLAEntities(tablebodyId, isExcludedClientsPage);
			});
		}
	};

	report.logReportLoadEvent = function() {
		cvUtil.logToReportsUsage(cvUtil.cvLocalize('SLA'));
	};

	Reports.Renderers.slaEntityRenderer = function(o, val) {

		if (exportRequest) {
			return "";
		}

		//if the page is "Excluded SLA" AND the Category of the client is not "Exclude From SLA Property"
		if (o.oSettings.sTableId === "excludedClients_table" && o.aData.category !== "Exclude From SLA Property") {
			//there should be no checkbox, so return empty string
			return "";
		}

		var client = o.aData['client'];
		var agenttype = o.aData['agentType'];
		var instance = o.aData['instance'];
		var backupset = o.aData['backupset'];
		var subclient = o.aData['subclient'];
		var clientId = o.aData['clientId'];
		var subClientId = o.aData['appId'];

		var data = "data-client='" + client + "'";
		if (agenttype) {
			data += " data-agenttype='" + agenttype + "'";
		}
		if (instance) {
			data += " data-instance='" + instance + "'";
		}
		if (backupset) {
			data += " data-backupset='" + backupset + "'";
		}
		if (subclient) {
			data += " data-subclient='" + subclient + "'";
		}
		if (clientId) {
			data += " data-clientid='" + clientId + "'";
		}
		if (subClientId) {
			data += " data-subclientid='" + subClientId + "'";
		}
		return "<span class='custom-cb slaEntitySelection' data-state='unchecked' " + data + " title='" +
				cvUtil.cvLocalize('SLA.ExcludeFromSLA') + "'></span>";
	};

	function enableExcludeSLAButton(tablebodyId) {
		var selected = $(tablebodyId + ' .slaEntitySelection.checked').length;
		if (selected > 0 && selected <= MAX_ENTITIES_SELECTION) {
			//show
			$('.excludeSLAOption').removeClass('hide');
			$('.excludeBtnContainer').addClass('excludeBtnContainerCls');

		} else {
			//hide
			$('.excludeSLAOption').addClass('hide');
			$('.excludeBtnContainer').removeClass('excludeBtnContainerCls');
		}
	}

	function submitExcludeSLAEntities(tablebodyId, isExcludedClientsPage) {
		var selected = $(tablebodyId + ' .slaEntitySelection.checked').length;
		if (selected > 0 && selected <= MAX_ENTITIES_SELECTION) {
			if(!isExcludedClientsPage){
				$('#slaReason').val('');
				$("#exclude-sla-dialog-wrapper").removeClass('hide');
				$("#exclude-sla-dialog").dialog({
					title : cvUtil.cvLocalize("SLA.ExcludeFromSLA"),
					width : 500,
					height : 200,
					modal : true,
					resizable : false,
					buttons : [ {
						text : cvUtil.cvLocalize("Cancel"),
						class : "ui-close-button",
						click : function() {
							$(tablebodyId).unmask();
							$(this).dialog("close");
						}
					}, {
						text : cvUtil.cvLocalize("ok"),
						class : "add-user-btn ui-close-button ui-save-csv-button",
						click : function() {
							$(this).dialog("close");
							var reason = $('#slaReason').val();
							submitExcludeIncludeSLAEntities(tablebodyId, isExcludedClientsPage, reason);
						}
					} ]
				});
			}else{
				submitExcludeIncludeSLAEntities(tablebodyId, isExcludedClientsPage);
			}
		} else {
			cvUtil.errorToast(cvUtil.cvLocalize('SLA.InvalidSelection'));
		}

	}

	function submitExcludeIncludeSLAEntities(tablebodyId, isExcludedClientsPage, reason) {
		$(tablebodyId).mask("");
		var selected = $(tablebodyId + ' .slaEntitySelection.checked').length;
		if (selected > 0 && selected <= MAX_ENTITIES_SELECTION) {
			var selectedEntities = $(tablebodyId + ' .slaEntitySelection.checked');
			var entities = [];
			$.each(selectedEntities, function(i, chk) {
				var data = $(chk).data();
				data.excludeFromSLA = !isExcludedClientsPage;
				entities.push(data);
			});

			if (entities.length > 0) {
				var request = {};
				request.entities = JSON.stringify(entities);
				if(!isExcludedClientsPage){
					request.reason = reason;
				}
				cvUtil.loadPageWithPOST(cvUtil.getContextPath() + '/reports/excludeEntitiesFromSLA.do',
						request,
						function(resp) {
							$(tablebodyId).unmask();
							if (resp.errorCode > 0) {
								if (resp.errorMessage) {
									cvUtil.errorToast(resp.errorMessage);
								} else {
									cvUtil.errorToast("");
								}
							} else {
								cvUtil.toast(resp.message);
								unCheckCb($(tablebodyId + ' .slaEntitySelection'));
								enableExcludeSLAButton(tablebodyId);
							}
						},
						function(err) {
							$(tablebodyId).unmask();
							cvUtil.errorToast(err);
						});
			}
		} else {
			cvUtil.errorToast(cvUtil.cvLocalize('SLA.InvalidSelection'));
		}
	}
	function enableSLAOptions(days) {
		days = parseInt(days);
		if (days > 0) {
			$('.time-range').addClass('hide');
			$("#ByAgentType").removeClass('disabled');
			$("#ByAgentType").removeClass('agentDisable');
			$("#ByAgentType").attr("title", cvUtil.cvLocalize('By_Agent'));

		} else if (days === -1) {
			$('.time-range').removeClass('hide');
			$("#ByAgentType").removeClass('disabled');
			$("#ByAgentType").removeClass('agentDisable');
			$("#ByAgentType").attr("title", cvUtil.cvLocalize('By_Agent'));

		} else {
			$('.time-range').addClass('hide');
			$("#ByAgentType").attr("title", cvUtil.cvLocalize('Agent_Disable_Message'));
			$("#ByAgentType").addClass('disabled');
			$("#ByAgentType").addClass('agentDisable');
			$("#viewButtons>ul>.on").removeClass("on");
			$("#viewButtons").find("li#ByClient").click();
		}
	}
}
Reports.Renderers.clientColumn = function(o, val) {
	var clientname = o.aData.client;
	var clientId = o.aData.clientId;
	var serverDetailsUrl = '/adminconsole/#/clientDetails/' + clientId;
	return "<a href='" + serverDetailsUrl + "' target='_blank'>" + clientname + "</a>";
};

Reports.Renderers.subclientColumnRenderer = function(o, val) {
	var subclientName = o.aData.subclient;
	var subclientId = o.aData.appId;
	var subclientDetailsUrl = '/adminconsole/#/subclientDetails/' + subclientId;
	return "<a href='" + subclientDetailsUrl + "' target='_blank'>" + subclientName + "</a>";
};

Reports.Renderers.lastFailedJobIdColumn = function(o, val) {
	if (exportRequest) {
		return val;
	}
	var lastFailedJobId = val;
	if (lastFailedJobId <= 0) {
		return lastFailedJobId;
	} else {
		return lastFailedJobId + '<div class="failed-jobs-actions-container"> <div class="dropdown">' +
				'<button class="btn btn-default btn-sm dropdown-toggle" type="button" data-toggle="dropdown">' +
				'<span class="caret"></span></button><ul class="dropdown-menu">' +
				'<li><a href="#" class="last-failed-resubmit-job" data-job-id="' + lastFailedJobId +
				'">Resubmit Job</a></li><li><a href="#" class="last-failed-send-logs" data-job-id="' + lastFailedJobId +
				'">Send Logs</a></li></ul></div></div>';
	}
};

$(document).ready(function() {
	SLAReport();
	cvUtil.GUIAuditReportLog("SLA", "CommCell");

	$(document.body).on('click', '.last-failed-resubmit-job', function() {
		$("#content").mask("");
		var jobId = $(this).attr("data-job-id");
		params = {
			'jobId' : jobId
		}
		cvUtil.loadPageWithPOST(cvUtil.getContextPath() + '/reports/resubmitJob.do', params, function(resp) {
			$("#content").unmask();
			if (resp.errorCode > 0) {
				if (resp.errorMessage) {
					cvUtil.errorToast(resp.errorMessage);
				} else {
					cvUtil.errorToast(cvUtil.cvLocalize('errors.error'));
				}
			} else {
				cvUtil.toast(resp.message);
			}
		}, function(err) {
			$("#content").unmask();
			if (err.responseText) {
				cvUtil.errorToast(err.responseText);
			} else {
				cvUtil.errorToast("");
			}
		});
	});
	$(document.body).on('click', '.last-failed-send-logs', function() {
		var jobId = $(this).attr("data-job-id");
		var redirectUrl = '/adminconsole/#/sendLogs/jobs/' + jobId;
		window.open(redirectUrl, '_blank');
	});
});
