$(document).on("ready", function() {
	$(".AddorRemoveCols").click(function(event) {
		var gridId = $(this).attr('id');
		gridId = gridId.substring(0, gridId.lastIndexOf("_"));
		Table.addOrRemoveColumns(gridId);
		event.stopPropagation();
		event.preventDefault();
	});

	$(".tableFilter").click(function(event) {
		var gridId = $(this).attr('id');
		gridId = gridId.substring(0, gridId.lastIndexOf("_"));
		Table.tableFilterColumns(gridId);
		$(this).toggleClass("filterOn");
	});
});
var mandatoryColList = []; //key:table_id, val:mandatory col list

function updateMandatoryList(gridid, aoColumns) {
	var columns = [];
	$.each(aoColumns, function(intIndex, objValue) {
		var column = objValue["sTitle"];
		var mandatory = objValue["bMandatoryCol"];
		if (mandatory == true) {
			columns.push(column);
		}
	});
	mandatoryColList.push({
		id : gridid,
		val : columns
	});
}
$.fn.dataTableExt.oApi.fnReloadLocal = function(oSettings, sNewData) {
	var oTable = this;
	oTable.oApi._fnClearTable(oSettings);

	var aData = (oSettings.sAjaxDataProp !== "") ? oTable.oApi._fnGetObjectDataFn(oSettings.sAjaxDataProp)(sNewData)
			: sNewData;

	for (var i = 0; i < aData.length; i++) {
		oTable.oApi._fnAddData(oSettings, aData[i]);
	}
	oSettings.aiDisplay = oSettings.aiDisplayMaster.slice();
	oTable.fnDraw();
};
var Table = {
	MAXROWS_TOPRINT_WITHOUT_DIALOG : 20000,
	requestString : {},
	Renderers : {}, //only global renderes can be added here, specific renderes should be added in respective js files as Table.Renderes.link=...

	configureAjaxTable : function(gridid, title, nodata, config, errorMessageOnLoadFailure) {
		config = config || {};
		config.fnServerData = config.fnServerData || function(sSource, aoData, fnCallback) {
			cvUtil.loadPageWithGET(sSource, aoData, fnCallback, function(result) {
				var oSettings = $("#" + gridid + CVTable.table).dataTable().fnSettings();
				var oldValue = oSettings.oLanguage.sEmptyTable;
				oSettings.oLanguage.sEmptyTable = errorMessageOnLoadFailure;
				fnCallback({
					"aaData" : []
				});
				oSettings.oLanguage.sEmptyTable = oldValue;
			});
		};
		return Table.configureTableCommon(gridid, title, nodata, config);
	},
	configureTable : function(gridid, title, data, nodata, config) {
		var defaultOptions = {
			"aaData" : data.aaData,
			"aoColumns" : data.aoColumns,
			"aoColumnDefs" : data.aoColumnDefs,
			"iTotalRecords" : data.iTotalRecords,
			"iDisplayLength" : data.iDisplayLength,
			"bUseRendered" : false,
			"bRetrieve" : true,
			"bServerSide" : false,
			"bFilter" : true,
			"bAutoWidth" : false,
			"sDom" : "Rlfrtip",
			"bInfo" : true,
			"aaSorting" : [],
			"oLanguage" : {
				"oPaginate" : {
					"sFirst" : '&nbsp;',
					"sNext" : '&nbsp;',
					"sPrevious" : '&nbsp;',
					"sLast" : '&nbsp;'
				},
				"sLengthMenu" : "Show _MENU_"
			},
			"fnDrawCallback" : function(oSettings) {
				if (Table.tableDrawCallBack) {
					Table.tableDrawCallBack(oSettings);
				}
			}
		};
		if (config) {
			for (x in config) {
				defaultOptions[x] = config[x];
			}
		}
		return Table.configureTableCommon(gridid, title, nodata, defaultOptions);
	},
	configureTableCommon : function(gridid, title, nodata, config) {
		nodata = nodata || "No data available";
		var options = {
			"iDisplayLength" : -1, //unless pagesize is explicitly set, show all
			"bUseRendered" : false,
			"bRetrieve" : true,
			"bServerSide" : false,
			"bFilter" : true,
			"bAutoWidth" : false,
			"sDom" : "Rlfrtip",
			"bInfo" : true,
			"aaSorting" : [],
			"oLanguage" : {
				"oPaginate" : {
					"sFirst" : '&nbsp;',
					"sNext" : '&nbsp;',
					"sPrevious" : '&nbsp;',
					"sLast" : '&nbsp;'
				},
				"sLengthMenu" : "Show _MENU_",
				"sEmptyTable" : nodata
			},
			"fnDrawCallback" : function(oSettings) {
				if (Table.tableDrawCallBack) {
					Table.tableDrawCallBack(oSettings);
				}
			}
		};
		if (config) {
			for (x in config) {
				options[x] = config[x];
			}
		}
		$.each(options.aoColumns, function(intIndex, objValue) {
			if (objValue.rendererType)
				objValue.fnRender = Table.Renderers[objValue["rendererType"]];
		});
		updateMandatoryList(gridid, options.aoColumns);

		var dataTabl = $('#' + gridid + CVTable.table).hasClass('initialized');
		if (dataTabl) {
			$('#' + gridid + CVTable.table).removeClass('initialized');
			$('#' + gridid + CVTable.table).dataTable().fnClearTable();
			$('#' + gridid + CVTable.table).dataTable().fnDestroy();
			$('#' + gridid + CVTable.table).empty();

		}
		$('#' + gridid + CVTable.table).addClass('initialized').dataTable(options);
		var dataTable = $('#' + gridid + CVTable.table).dataTable();
		$('#' + gridid + CVTable.table + ' thead th').each(function(index, value) {
			$(value).attr('title', $(value).text());
		});
		$("#" + gridid).show();
		Table.showHideAddRemoveColumsIcon(gridid);
		return dataTable;
	},
	fnGetKey : function(aoData, sKey) {
		for (var i = 0, iLen = aoData.length; i < iLen; i++) {
			if (aoData[i].name == sKey) {
				return aoData[i].value;
			}
		}
		return null;
	},
	showUiSelectColumns : function(gridid, columnString) {
		columnString = columnString.substring(0, columnString.lastIndexOf(":"));
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var items = columnString.split(':');
		$.each(items, function(index) {
			var current = items[index];
			var colNo = current.split("-")[0];
			var bVis = current.split("-")[1];
			var showCol = bVis == "true" ? true : false;
			console.log(colNo + "-" + showCol);
			oTable.fnSetColumnVis(colNo, showCol, false);
		});
	},
	addOrRemoveColumns : function(gridid) {
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var container = $("#" + gridid + '_Colums');

		var oSettings = oTable.fnSettings();
		var id = 0;
		$("#" + gridid + '_Colums').empty();

		var mandatoryColumns = [];
		$.each(mandatoryColList, function(intIndex, objValue) {
			if (objValue.id == gridid) {
				mandatoryColumns = objValue.val;
				return;
			}
		});
		var p = 0;
		for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
			var name = oSettings.aoColumns[iColumn].sTitle;
			var mandatoryCol = '';
			if (mandatoryColumns.length > 0) {
				$.each(mandatoryColumns, function(colIndex, column) {
					if (name == column) {
						//Mandatory columns will be disabled in addOrRemove list.
						mandatoryCol = 'disabled';
						return;
					}
				});
			}

			if (name == "" || $("<div>").html(name).text().length == 0) {
				continue;
			}

			if (mandatoryCol == 'disabled') {
				continue;
			}

			var html = "";
			id = iColumn;
			var visible = (oSettings.aoColumns[iColumn].bVisible == true) ? 'checked' : 'unchecked';
			html = '<li class="col1"><div id="' + gridid + ':cb_' + id + '" class="custom-cb addOrRemoveCheckBox ' +
					visible + '" data-state="' + visible + '" data-name="' + name +
					'"></div><span class="custom-cb-label">' + name + '</span></li>';
			container.append($(html));

		}

		$("#" + gridid + '_Colums').slideToggle('fast');
		$("#" + gridid + '_Button').toggleClass('activeNow');
		$(".reportColums_container").off("click");
		$(".reportColums_container").on("click", function(event) {
			var el = $(event.target).children(".addOrRemoveCheckBox");
			if (el.length == 0) {
				el = $(event.target);
				if ($(el).hasClass("addOrRemoveCheckBox")) {
					//do nothing
				} else {
					return;
				}
			}
			toggleCb($(el));
			event.stopPropagation();
			var id = $(el).attr('id');
			var columnNum = id.substring(id.lastIndexOf("_") + 1, id.length);
			var columnName = $(el).attr('data-name');
			var bVis = oSettings.aoColumns[columnNum].bVisible;
			bVis = bVis ? false : true;
			if (Table.requestString["tableColumns"] == undefined)
				Table.requestString["tableColumns"] = "";

			oTable.fnSetColumnVis(columnNum, bVis, false);
			var replaceStr = Table.getTableCols();
			Table.requestString["tableColumns"] = replaceStr;
			updateHash(true);

			var value = $("#" + gridid + "_FilterSelected").attr('value');
			if (value == 'true') {
				$("#" + gridid + "_FilterSelected").val('undefined');
				$("#filterRow_" + gridid).remove();
				$("#" + gridid + "_FilterButton").trigger('click');

				$("#" + gridid + "_filterText-" + columnNum + "-td").toggle();

			}

			oTable.fnAdjustColumnSizing(false);

		});
		$(".custom-cb-label").click(function(e) {
			$(this).prev(".custom-cb").trigger('click');
			e.stopPropagation();
		});
		$('html').click(function() {
			$("#" + gridid + '_Colums').slideUp('fast');
			$("#" + gridid + '_Button').removeClass('activeNow');
		});

	},
	getTableCols : function() {
		var tableColumns = "";
		var dataTabl = $('#' + gridid + '_table').hasClass('initialized');
		if (dataTabl) {
			var oTable = $('#' + gridid + '_table').dataTable();
			var oSettings = oTable.fnSettings();
			if (oSettings != null) {
				for (var j = 0; j < oSettings.aoColumns.length; j++) {
					tableColumns = tableColumns + oSettings.aoColumns[j].sName + "-" + oSettings.aoColumns[j].bVisible +
							":";
				}
			}
		}
		return tableColumns;
	},
	fnGetSearchString : function(oSettings) {
		var searchString = "";
		for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
			if (oSettings.aoColumns[iColumn].bVisible) {
				var operator = 'LIKE';
				var search = oSettings.aoColumns[iColumn].sSearch;
				if (typeof search == 'undefined' || search == "") {
					search = 'undefined';
					continue;
				}
				searchString = searchString + oSettings.aoColumns[iColumn].sName + ',' + search + ';';
			}
		}
		return searchString;
	},
	showHideAddRemoveColumsIcon : function(gridid) {
		var oTable = $("#" + gridid + CVTable.table).dataTable();
		var oSettings = oTable.fnSettings();

		var mandatoryColumns = [];
		$.each(mandatoryColList, function(intIndex, objValue) {
			if (objValue.id == gridid) {
				mandatoryColumns = objValue.val;
				return;
			}
		});
		var showIcon = true;

		if (mandatoryColumns.length == oSettings.aoColumns.length || oSettings.aoColumns.length <= 2) {
			showIcon = false;
		}

		if (showIcon) {
			$("#" + gridid + '_holder').show();
		} else {
			$("#" + gridid + '_holder').hide();
		}

	},//end of showHideAddRemoveColumsIcon()
	tableFilterColumns : function(gridid) {
		var oTable = $("#" + gridid + CVTable.table).dataTable();

		var oSettings = oTable.fnSettings();
		var value = $("#" + gridid + "_FilterSelected").attr('value');
		if (value.trim() == '' || value.trim() == 'undefined' || $('#filterRow_' + gridid).length == 0) {
			$("#" + gridid + "_FilterSelected").val('true');
			var appendTxt = '<tr id="filterRow_' + gridid + '">';
			for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
				var width = oSettings.aoColumns[iColumn].sWidth;
				var colName = oSettings.aoColumns[iColumn].sName;
				colName = colName.split(' ').join('_').split('(').join('_').split(')').join('_');
				appendTxt = appendTxt + '<td id="' + gridid + '_filterText-' + iColumn + '-td' +
						'"><input type="text" id="' + gridid + '_filterText-' + iColumn +
						'" class="inLineFilter inLineFilter' + colName + '" value="" width="' + width + '"/></td>';
			}
			appendTxt = appendTxt + '</tr>';
			$("tr:first", oTable).after(appendTxt);
			showHideFilterComps();
		} else if (value == 'false') {
			$("#" + gridid + "_FilterSelected").val('true');
			$('#filterRow_' + gridid).show();
			showHideFilterComps();
		} else if (value == 'true') {
			$("#" + gridid + "_FilterSelected").val('false');
			$('#filterRow_' + gridid).hide();
		}
		/*
		 * $("input").focusout(function () { var oTable = $("#"+gridid+CVTable.table).dataTable(); var
		 * oSettings = oTable.fnSettings(); var id = $(this).attr('id'); var value = $(this).attr('value');
		 * var colNum = id.substring(id.lastIndexOf("-")+1,id.length); if(oSettings.aoColumns[colNum]) {
		 * oSettings.aoColumns[colNum].sSearch = value; } if(value.trim() != "") {
		 * requestString["filteredTable"]=gridid; oTable.fnDraw(); } });
		 */

		$(".inLineFilter").keyup(function(event) {
			var serverCall = false;
			if (event.keyCode == 13) {
				for (var i = 0; i < oSettings.aoColumns.length; i++) {
					if (oSettings.aoColumns[i].bVisible) {
						var value = document.getElementById(gridid + "_filterText-" + i).value;
						if (value.trim() != "") {
							oSettings.aoColumns[i].sSearch = value;
							serverCall = true;
						}
					}
				}

				if (serverCall) {
					Table.requestString["filteredTable"] = gridid;
					oTable.fnDraw();
				}

			}

			if (event.keyCode == 46 || event.keyCode == 8) {
				var value = $(this).attr('value');
				if (value.trim() == "") {
					for (var i = 0; i < oSettings.aoColumns.length; i++) {
						if (oSettings.aoColumns[i].bVisible) {
							var value = document.getElementById(gridid + "_filterText-" + i).value;
							oSettings.aoColumns[i].sSearch = value;
							serverCall = true;

						}
					}
				}
				if (serverCall) {
					Table.requestString["filteredTable"] = gridid;
					oTable.fnDraw();
				}
			}
		});

		function adjustSize(oSettings) {
			for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
				var th = $(oSettings.aoColumns[iColumn].nTh)[0];
				$("#" + gridid + '_filterText-' + iColumn).width(parseInt(oSettings.aoColumns[iColumn].sWidth) - 14); //10 padding and 4 border
			}
		}

		/*
		 * $("input").focusin(function () { $(this).val(""); });
		 *  ;
		 */

		function showHideFilterComps() {
			adjustSize(oSettings);
			for (var iColumn = 0; iColumn < oSettings.aoColumns.length; iColumn++) {
				var id = '#' + gridid + '_filterText-' + iColumn + '-td';
				if (oSettings.aoColumns[iColumn].bVisible) {
					//	$(id+' input').width($(oSettings.aoColumns[iColumn].nTh).width()-4);
					$(id).show();
				} else {
					$(id).hide();
				}
			}
		}

	},
	onResize : function(th) {
		var index = $('th', th.parentNode).index(th);
		var inputEl = $($(th).parent().next().children()[index]).find('input');
		inputEl.width($(th).width() - 14);
	}
};
