function TimeFrame(options) {
	this.requestString = options.requestString;

	this.includePrediction = options.includePrediction || false;
	$('#lastN').spinner({
		min : 1,
		max : 9999
	});
	//	$('#relative').change(function() {
	//		$('#rangePanel :input').attr('disabled', true);
	//		$('#relativePanel :input').removeAttr('disabled');
	//	});
	//	$('#range').change(function() {
	//		$('#relativePanel :input').attr('disabled', true);
	//		$('#rangePanel :input').removeAttr('disabled');
	//	});	

	var timeZone = "";
	var tzOffset = "";

	var freqMenu = $("#frequency");
	freqMenu.change(function() {
		var value = this.options[this.selectedIndex].value;
		if (value == 'CurrentWeek' || value == 'CurrentMonth') {
			$('#lastN').attr('disabled', true);
			$('#rangePanel :input').removeAttr('disabled');
			$('#rangePanel :input').attr('disabled', true);
		} else if (value == 'Custom') {
			$('#rangePanel :input').removeAttr('disabled');
			$('#lastN').spinner("disable");
			var endDate = getCSTime(new Date());
			$('#endTime').datetimepicker("setDate", endDate);
			$('#startTime').datetimepicker("setDate", new Date(endDate.getTime() - (60 * 60 * 24 * 1000)));

		} else {
			$('#rangePanel :input').attr('disabled', true);
			$('#lastN').spinner("enable");
		}

	});

	if (this.includePrediction)
		$('#predictNext').spinner({
			min : 1,
			max : 9999
		});

	$('#startTime').datetimepicker({
		maxDate : 0,
		onClose : function(dateText, inst) {
			var endDateTextBox = $('#endTime');
			if (endDateTextBox.val() != '') {
				var testStartDate = new Date(dateText);
				var testEndDate = new Date(endDateTextBox.val());
				if (testStartDate > testEndDate)
					endDateTextBox.val(dateText);
			} else {
				var endDate = getCSTime(new Date());
				$('#endTime').datetimepicker("setDate", endDate);
			}
		},
		onSelect : function(selectedDateTime) {
			var start = $(this).datetimepicker('getDate');
			$('#endTime').datetimepicker('option', 'minDate', new Date(start.getTime()));
		}
	});
	$('#endTime').datetimepicker({
		maxDate : 0,
		onClose : function(dateText, inst) {
			var startDateTextBox = $('#startTime');
			if (startDateTextBox.val() != '') {
				var testStartDate = new Date(startDateTextBox.val());
				var testEndDate = new Date(dateText);
				if (testStartDate > testEndDate)
					startDateTextBox.val(dateText);
			} else {
				var testEndDate = new Date(dateText);
				$('#startTime').datetimepicker("setDate", new Date(testEndDate.getTime() - (60 * 1000)));
			}
		},
		onSelect : function(selectedDateTime) {
			var end = $(this).datetimepicker('getDate');

			$('#startTime').datetimepicker('option', 'maxDate', new Date(end.getTime() - (60 * 1000)));
		}
	});

	this.initComponentState = function(opts) {
		if (opts) {
			this.requestString = opts.requestString;
		}
		$('#frequency').val(requestString.frequency);

		if (this.requestString.timeFrameType.toLowerCase() == "range") {
			$('#lastN').spinner("disable");
			if (requestString.frequency == "Custom") {
				$('#rangePanel :input').removeAttr('disabled');
				var startTime = requestString.startTime;
				var dt = new Date(startTime.substr(0, 4), startTime.substr(4, 2) - 1, startTime.substr(6, 2), startTime
						.substr(8, 2), startTime.substr(10, 2));
				$('#startTime').datetimepicker("setDate", dt);

				startTime = requestString.endTime;
				var dt = new Date(startTime.substr(0, 4), startTime.substr(4, 2) - 1, startTime.substr(6, 2), startTime
						.substr(8, 2), startTime.substr(10, 2));
				$('#endTime').datetimepicker("setDate", dt);
			} else {
				$('#rangePanel :input').attr('disabled', true);
			}

		}
		if (this.requestString.timeFrameType.toLowerCase() == "relative") {
			$('#lastN').val(requestString.lastN);
			$('#rangePanel :input').attr('disabled', true);
			$('lastN').spinner("enable");

			if (requestString.frequency == "CurrentWeek" || requestString.frequency == "CurrentMonth") {
				$('#lastN').attr('disabled', true);
			}

		}
		if (this.includePrediction)
			$('#predictNext').val(requestString.predictNext);
	};

	this.updateTimeRange = function() {

		var freq = $('#frequency').val();
		requestString.frequency = freq;

		if (freq == 'Custom') {
			requestString.timeFrameType = "range";
			var startTime = $("#startTime").datetimepicker('getDate');
			requestString.startTime = "" + startTime.getFullYear() + pZ((startTime.getMonth() + 1)) +
					pZ(startTime.getDate()) + pZ(startTime.getHours()) + pZ(startTime.getMinutes());
			startTime = $("#endTime").datetimepicker('getDate');
			requestString.endTime = "" + startTime.getFullYear() + pZ((startTime.getMonth() + 1)) +
					pZ(startTime.getDate()) + pZ(startTime.getHours()) + pZ(startTime.getMinutes());
		} else if (freq == 'CurrentWeek' || freq == 'CurrentMonth') {
			requestString.timeFrameType = "range";
			var today = getCSTime(new Date());
			var month = today.getMonth() + 1;
			var year = today.getFullYear();
			var daysInMonth = (new Date(year, month, 0)).getDate();
			var startTime, endtime;

			if (freq == 'CurrentWeek') {
				var dayOfWeek = today.getDay();
				var dayOfWeekMilliseconds = (dayOfWeek - 1) * 24 * 60 * 60 * 1000;
				var dayOfMonth = today.getDate();
				var startTimeMilliseconds = today.getTime() - dayOfWeekMilliseconds;
				;
				var endtimeMilliseconds = startTimeMilliseconds + (6 * 24 * 60 * 60 * 1000);
				startTime = new Date(startTimeMilliseconds);
				endTime = new Date(endtimeMilliseconds);
			} else {
				startTime = new Date(year, today.getMonth(), 1);
				endTime = new Date(year, today.getMonth(), daysInMonth);
			}

			requestString.startTime = "" + startTime.getFullYear() + pZ((startTime.getMonth() + 1)) +
					pZ(startTime.getDate()) + "0000";
			requestString.endTime = "" + endTime.getFullYear() + pZ((endTime.getMonth() + 1)) + pZ(endTime.getDate()) +
					"2359";
		} else {
			requestString.lastN = $('#lastN').val();
			requestString.timeFrameType = "relative";
			var today = getCSTime(new Date());
			requestString.endTime = "" + today.getFullYear() + pZ((today.getMonth() + 1)) + pZ(today.getDate()) +
					"2359";
		}

		if (this.includePrediction)
			requestString.predictNext = $('#predictNext').val();
	};
	function pZ(value) {
		if (value < 10)
			return "0" + value;
		else
			return "" + value;
	}

	this.setTimeZone = function(tzStr, tzo) {
		timeZone = tzStr;
		tzOffset = tzo;
	};

	function getCSTime(d) {
		if (tzOffset) {
			var ctzDate = new Date(); // date in current/client time zone
			// need to add/subtract the CS timezone offset and GMT offset to get the current time equivalent of CS time. 
			var dt = new Date(d.getTime() - tzOffset * 60 * 1000 + ctzDate.getTimezoneOffset() * 60 * 1000);
			return dt;
		}
		return d;
	}
}
var TimeFrame = {
	frame : TimeFrame
};
