<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<fmt:bundle basename="localization.ReportsMessages">
	<fmt:message key="File" var="File" />
	<fmt:message key="CustomReport.SaveAs" var="SaveAs"/>
	<fmt:message key="CustomReport.Print" var="Print"/>
	<fmt:message key="CustomReport.Schedule" var="Schedule"/>
	<fmt:message key="CustomReport.Email" var="Email"/>
	<fmt:message key="Actions" var="actions"/>
	<fmt:message key="New_User" var="new_user"/>
	<fmt:message key="View_Users" var="view_user"/>
	<fmt:message key="View_Users" var="view_user"/>
	<fmt:message key="Refresh" var="refresh"/>
</fmt:bundle>
<fmt:bundle basename="localization.SurveyMessages">
<fmt:message key="Worldwide_Dashboard" var="worldwideDashboard" />
<fmt:message key="Dashboard" var="Dashboard" />
<fmt:message key="Worldwide Reports" var="worldwideReports" />
<fmt:message key="CommCell Groups" var="commCellGroups" />
<fmt:message key="CommCells" var="commCells" />
<fmt:message key="summary.link.sharedFolder" var="sharedFolderText" />
<fmt:message key="summary.link.sharepoint" var="sharepointText" />
<fmt:message key="summary.link.drive" var="driveText" />
<fmt:message key="common.label.loading" var="loading" />
	<jsp:include page="/survey/reports/surveyHeader.jsp">
		<jsp:param value="true" name="changePage" />
		<jsp:param name="welcomeMsg" value="Worldwide Dashboard" />
		<jsp:param name="searchCC" value="true" />
		<jsp:param name="showTabs" value="true" />
		<jsp:param name="dashboard" value="true" />
		<jsp:param name="includeDashboardBreadcrumb" value="true" />
		<jsp:param name="includeCROptionBeforeSearch" value="true" />
		<jsp:param value="true" name="exportPdf"/>
		<jsp:param value="true" name="exportHtml"/>
		<jsp:param value="true" name="printButton"/>
		<jsp:param value="true" name="exportEnabled"/>
		<jsp:param value="true" name="usersManagement"/>
		<jsp:param value="true" name="newDashboard" />
		<jsp:param value="true" name="reportsNav" />
		<jsp:param value="true" name="QuarterlyPPT" />
		<jsp:param value="true" name="showCloudDocs"/>
	</jsp:include>
<script nonce="${sessionScope.cspNonce}" type="text/javascript">
	var SurveySingleCommcellUser=null;
	var isPublicMetrics = ${applicationScope.isPublicMetricsCloud == "true" ? "true" : "false"};
		<c:if test="${sessionScope.SurveySingleCommcellUser != null and param.commUniId ==null}">
			SurveySingleCommcellUser=${sessionScope.SurveySingleCommcellUser};
		</c:if>
	console.log('SurveySingleCommcellUser = ' + SurveySingleCommcellUser);
	var slaDays = "${applicationScope.MetricsReportingSLADays}";

	var unsupportedReports = [2, 6, 7, 9, 10, 12, 13, 14, 38];
	var commUniId = cvUtil.getParameter('commUniId', "' '");
	var ccGroupId = cvUtil.getParameter('ccGroupId', -1);
	var companyId = cvUtil.getParameter('companyId', 0);
	var commCellId = 0;
	var commIpAddr = '';
	var CommGuiId = '';
	var clientName = '';
	var app = 'none';
	var collectTime = '';
	var regitrationCode = '';
	var availableTags;
	var isPublicMetricsCloud = false;
	var isRegisteredCommcellGroup = false;
	<c:if test="${applicationScope.isPublicMetricsCloud != null and applicationScope.isPublicMetricsCloud ==true}">
		isPublicMetricsCloud =true;
	</c:if>
	<c:if test="${requestScope.isRegisteredCommcellGroup != null and requestScope.isRegisteredCommcellGroup == true}">
		isRegisteredCommcellGroup =true;
	</c:if>

	if (commUniId == 0) {
		window.alert(cvUtil.cvLocalize("CommCell_Association_Required"));
		window.location.href='monitoringform.jsp';
	}
	window.tempCvIdtoMask= "undefined";
	var companyCommUniId = 0;
	<c:if test="${requestScope.CompanyCommUniId != null and requestScope.CompanyCommUniId > 0}">
		companyCommUniId = "${requestScope.CompanyCommUniId}";
	</c:if>

	var dashboardCommon = dashboardCommon || {};
	if(companyId > 0){
		dashboardCommon.CompanyNameFull = "${requestScope.CompanyNameFull}";
	}
	dashboardCommon.userGroupName = $('ul.nav .nav-customer-title').attr('title');

	dashboardCommon.loggedInUserName = "${sessionScope.username}";
    dashboardCommon.loggedInUserId = "${sessionScope.USERID}";

	$("#content").addClass("dashboardPage");

</script>
<c:set var="newDashboard" value="true" />
<c:set var="showMaps" value="false" />
<div class="dashboard-container">
	<c:choose>
		<c:when test="${applicationScope.isPublicMetricsCloud == 'true'}">
			<c:choose>
				<c:when test="${(param.commUniId > 0) || (param.companyId > 0 and requestScope.isRegisteredCommcellGroup == 'true')}">
					<%@include file="dashboard-cloud-company.jsp" %>
					<jsp:include page="../survey/surveyBase.jsp">
			        	<jsp:param value="true" name="includeExportSupport"/>
			     	</jsp:include>
				</c:when>
				<c:otherwise>
					<%@include file="dashboard-cloud-worldwide.jsp" %>
					<c:set var="showMaps" value="true" />
					<jsp:include page="../survey/surveyBase.jsp">
			        	<jsp:param value="true" name="includeExportSupport"/>
			     	</jsp:include>
				</c:otherwise>
			</c:choose>
		</c:when>
		<c:otherwise>
			<%@include file="dashboard-private.jsp" %>
		</c:otherwise>
	</c:choose>
</div>
<c:if test="${applicationScope.isPublicMetricsCloud == 'true'}" >
	<%@include file="/survey/reports/userManagement.jsp" %>
	<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/userManagement.js?${applicationScope.BUILD_TS}"></script>
</c:if>

</fmt:bundle>

<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/ba-debug.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/qtip/jquery.qtip.min.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/mustache.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highcharts/highcharts.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/survey_templates.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/common.js?${applicationScope.BUILD_TS}"></script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/survey.js?${applicationScope.BUILD_TS}"></script>

<c:if test="${newDashboard == 'true'}">
	<link rel="stylesheet" href="${pageContext.request.contextPath}/survey/css/dashboard.css?${applicationScope.BUILD_TS}">
	<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/survey-utils.js?${applicationScope.BUILD_TS}"></script>
	<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/dashboard-common.js?${applicationScope.BUILD_TS}"></script>
	<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/survey/js/dashboard-landing.js?${applicationScope.BUILD_TS}"></script>
	<c:if test="${showMaps == 'true'}">
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/map.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/drilldown.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/world-continents.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/asia.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/africa.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/europe.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/oceania.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/north-america.js?${applicationScope.BUILD_TS}"></script>
		<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/common/js/highmaps/south-america.js?${applicationScope.BUILD_TS}"></script>
	</c:if>
</c:if>



