<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>
<fmt:bundle basename="localization.ScheduleMessages">

	<jsp:include page="../common/header.jsp">
		<jsp:param value="true" name="includeMask" />
		<jsp:param value="true" name="includeSecHeader" />
		<jsp:param value="true" name="includeJqueryUI" />
		<jsp:param value="" name="titleLocalized" />
		<jsp:param value="dialog" name="displayMode" />
		<jsp:param value="true" name="includeTableSupport" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/clientDetails/css/summarystyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/css/cvTimepicker.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/schedule.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/customreports/css/shareReport.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/survey/css/executiveSummary.css" name="css"/>
		<jsp:param value="${pageContext.request.contextPath}/common/bootstrap/css/bootstrap.min.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/common/bootstrap/css/bootstrap-multiselect.css" name="css" />
	</jsp:include>

	<fmt:message key="schedule.day.monday" var="localMonday"/>
	<fmt:message key="schedule.day.tuesday" var="localTuesday"/>
	<fmt:message key="schedule.day.wednesday" var="localWednesday"/>
	<fmt:message key="schedule.day.thursday" var="localThursday"/>
	<fmt:message key="schedule.day.friday" var="localFriday"/>
	<fmt:message key="schedule.day.saturday" var="localSaturday"/>
	<fmt:message key="schedule.day.sunday" var="localSunday"/>
	<fmt:message key="schedule.time.hour" var ="hoursText" />
	<fmt:message key="schedule.time.minute" var ="minutesText" />
	<fmt:message key="schedule.time.AM" var ="AMText" />
	<fmt:message key="schedule.time.PM" var ="PMText" />
	<fmt:message key="schedule.label.confirmDelete" var="confirmDelete"/>
	<fmt:message key="schedule.label.errorMessage1" var="errorMessage1"/>
	<fmt:message key="schedule.label.nameLengthErrorMessage" var="nameLengthErrorMessage"/>
	<fmt:message key="schedule.label.endUserSecurityToolTip" var="endUserSecurityToolTip"/>
	<fmt:message key="schedule.label.enterScheduleName" var="enterScheduleName"/>


	<c:set var="sched" value="${requestScope.SCHEDULE}" />
	<c:set var="schedFreqType" value="${requestScope.SCHEDULE_FREQTYPE}" />

	<div style="text-align: left" id="scheduleContainer">
		<div id="schMask" class="addOn">

		<div id="formDiv">
		<form id="schForm" method="post">
		<div id="fieldContainer">
		<div id="schedDescription" class="schedule-field">
			<div class="labelContainer"><label for="description"><fmt:message key="schedule.label.name"/></label></div>
			<div class="inputContainer"> <input type="text" id="description" name="description" value=""/> </div>
		</div>
		<div class="custom-name-field">
	        <div class="labelContainer">
	            <fmt:message key="reports.reportCustomName"/>
	        </div>
	        <div class="inputContainer">
	            <input type="text" name="reportCustomName" id="reportCustomName" autocomplete="off">
	        </div>
	    </div>
		<div id="updateScheduleParams" class="editScheduleMsgs" style="display:none">
			<a href="#" id="updateScheduleParameters" data-target-url=""><fmt:message key="schedule.Update_schedule"/></a>
		</div>
		<input type="hidden" name="updatedUrl" id="updatedUrl"/>
		<div id="formOptions">
		<div class="labelContainer">
			<fmt:message key="reports.format"/>
		</div>
		<div class="inputContainer exportTypesContainer" id="formOptions">
			<select class="exportType" name="exportType">
						<c:forEach items="${requestScope.reportFormat}" var="exportTypeEntity" >
							<option value="${exportTypeEntity.value}" title="${exportTypeEntity.title}">${exportTypeEntity.title}</option>
						</c:forEach>
			</select>
		 </div>
		</div>
		<div id="componentOptions" class="schedule-field hidden">
			<div class="labelContainer" for="components"><fmt:message key="reports.selectComponents"/></div>
			<div class="inputContainer exportTypesContainer" id="formOptions">
				<select id="components" size="5" name="components" multiple="multiple"></select>
			 </div>
		</div>
		<div id="inlineOptions">
			<div id="emailTypeOptions" style="display:none;">
				<fmt:message key="reports.emailType"/> : <cv:cvRadioGroup entries="${requestScope.emailTypes}" name="emailType"/>
			</div>

			<div id="compressFile" class="inline-option notEmailBodyFriendly">
				<div class="custom-cb unchecked compressFile inline-custom-cb" data-state="unchecked" name="compressFile"></div>
					<span class="custom-cb-label compressFile"><fmt:message key="reports.compressFile" /></span>
					<input type="hidden" name="compressFile" value="" title="">
				</div>
			<div style="white-space:nowrap;" id="endUserSec" class="inline-option">
				<div class="custom-cb unchecked endUserSecurity inline-custom-cb" data-state="unchecked" name="endUserSecurity" id="endUserSecurityCheckBox"></div>
					<span class="custom-cb-label endUserSecurity" title="${endUserSecurityToolTip}" id="endUserSecurityText"><fmt:message key="reports.endUserSecurity" /></span>
					<input type="hidden" name="endUserSecurity" id="endUserSecurity" value="">
			</div>
			<div id="hideReportSummaryOption" class="inline-option" style="display:none;">
				<div class="custom-cb unchecked hideReportSummary inline-custom-cb" data-state="unchecked" name="hideReportSummary"></div>
					<span class="custom-cb-label"><fmt:message key="reports.hideReportSummary"/></span>
					<input type="hidden" name="hideReportSummary" value="" title="">
			</div>
		</div>

		<div id="executiveSummaryHide">
		<br/>

		<br/>
		</div>

		<div class="labelContainer">
			<label for="usersListToNotify"><fmt:message key="schedule.Email_to_Users"/></label>
		</div>
		<div class="inputContainer">
			<input type="hidden" name="usersListToNotify" id="users-list-to-notify"/>
			<div id="user-notify-container">
				<div class="caret-hold" id="users-to-notify-input-field-container">
					<input type="text" value="" id="users-to-notify-input-field"  autocomplete="off" >
				</div>

				<div id="user-notify-list-hold">
					<div id="users-notify-loading" class="users-to-notify-loading"><img src="${pageContext.request.contextPath}/common/img/jobProgress.gif"></div>
					<div id="selected-users-section" class="section-scroll-bar">
						<div id="selected-users-help-message-none-selected"><fmt:message key="schedule.none_selected"/></div>
						<div id="selected-users-list"></div>
					</div>
					<div id="available-users-section" class="section-scroll-bar">
						<b class="heading"><fmt:message key="schedule.Available_Users_Groups"/> <span id="users-available-meta">(<span id="available-user-limit"></span> / <span id="available-user-groups"></span>)</span></b>
						<input type="text" value="" id="available-users-search"  autocomplete="off" placeholder="<fmt:message key="schedule.Search_here"/>...">
						<div id="available-users-list"></div>
						<div id="available-users-loading" class="users-to-notify-loading"><img src="${pageContext.request.contextPath}/common/img/jobProgress.gif"></div>
					</div>
				</div>
			</div>
		</div>
		<div class="margin-top-10">
			<div class="labelContainer">
				<fmt:message key="reports.emailRecipients"/>
			</div>
			<div class="inputContainer">
				<input type="text" name="emails" id="emails" autocomplete="off">
			</div>
		</div>


		<!--<div id="includeSummaryInEmail">
		<div class="custom-cb unchecked includereportSummary" data-state="unchecked" name="includereportSummary"></div>
			<span class="custom-cb-label includereportSummary"><fmt:message key="reports.includeSummaryInEmail" /></span>
			<input type="hidden" name="includereportSummary" value="" title="">
		</div>-->


		<div class="networkPanel margin-top-5 notEmailBodyFriendly">
			<div>
				<div class="custom-cb unchecked networkShare inline-custom-cb" data-state="unchecked" name="networkShare"></div>
				<span class="custom-cb-label networkShare"><fmt:message key="reports.networkShare" /></span>
				<input type="hidden" name="networkShare" value="" title="">
			</div>
			<div class="networkPanelDetails">
				<div class="labelContainer padding-left-20">
					<label for="networkPath"><fmt:message key="reports.networkPath"/></label>
				</div>
				<div class="inputContainer">
					<input type="text" name="networkPath" id="networkPath">
				</div>

				<div class="labelContainer padding-left-20">
					<label for="networkUser"><fmt:message key="reports.networkUser"/></label>
				</div>
				<div class="inputContainer">
					<input type="text" name="networkUser" id="networkUser">
				</div>

				<div class="labelContainer padding-left-20">
					<label for="networkPassword"><fmt:message key="reports.networkPassword"/></label>
				</div>
				<div class="inputContainer">
					<input type="password" name="networkPassword" id="networkPassword" autocomplete="off">
					<input type="hidden" name="passwordChanged" id="passwordChanged" value="false">
				</div>
			</div>
		</div>
		<div id="samDescription" class="schedule-field customDocumentHides hidden">
			<div class="labelContainer"><label for="sam"><fmt:message key="schedule.label.sam"/></label></div>
			<div class="inputContainer"><input type="text" id="sam" name="sam" value=""/> </div>
		</div>
		<div id="tamDescription" class="schedule-field customDocumentHides hidden monthlyCustomDocumentHides">
			<div class="labelContainer"><label for="tam"><fmt:message key="schedule.label.tam"/></label></div>
			<div class="inputContainer"><input type="text" id="tam" name="tam" value=""/> </div>
		</div>
		<div id="durationDescription" class="schedule-field customDocumentHides hidden monthlyCustomDocumentHides">
			<div class="labelContainer"><label><fmt:message key="schedule.label.duration"/></label></div>
			<div class="inputContainer" id="time-frame-inputs">
				<label id="last-label" class="timeframeinput"><fmt:message key="schedule.Last"/></label>
				<select id="from-time" class="last12months timeframeinput"></select>
				<label id="months-label"><fmt:message key="schedule.monthly.months"/></label>
			</div>
		</div>
		<div id="locales-container">
			<div class="labelContainer">
				<label for="localeInfo"><fmt:message key="reports.language"/></label>
			</div>
			<div class="inputContainer">
				<select id="locales" name="localeInfo">
						<c:forEach items="${availableLocales}" var="LocaleEntity" >
							<option value="${LocaleEntity.locale}" title="${LocaleEntity.displayString}">${LocaleEntity.displayString}</option>
						</c:forEach>
				</select>
			</div>
		</div>
		<div id="freqOptions">
			<div class="labelContainer"><fmt:message key="schedule.label.frequency"/></div>
			<div class="inputContainer" id="formOptions"><cv:cvRadioGroup entries="${schedFreqType}" name="freqType"/></div>
		</div>

		<div id="dailyElements">
			<div class="labelContainer">
				<label for="activeStartTime"><fmt:message key="schedule.label.time"/></label>
			</div>
			<span id="activeStartTimeDisplay"></span>
			<input type="hidden" id="activeStartTime" name="activeStartTime" value="${sched.activeStartTime}" />
			<br/>

			<div class="margin-top-10">
				<div class="labelContainer">
					<fmt:message key="schedule.timezone"/>
				</div>
				<div class="inputContainer">
					<select id="timezone" name="timezone">
						<c:forEach items="${timeZonesList.timezones}" var="timezone" >
							<option value="${timezone.tzId}" title="${timezone.timezoneDisplayName}">${timezone.timezoneDisplayName}</option>
						</c:forEach>
					</select>
				</div>
			</div>

			<br />
		</div>

		<hr>

		<div id="freqDetails">
			<div id="weeklyElements">
				<ol id="daysToRunList" class="clearfix">
					<li><cv:cvCheckbox name="daysToRun0" styleClass="dayToRun" title="${localMonday}" checked="${sched.daysToRun[0]}" /></li>
					<li><cv:cvCheckbox name="daysToRun1" styleClass="dayToRun" title="${localTuesday}" checked="${sched.daysToRun[1]}" /></li>
					<li><cv:cvCheckbox name="daysToRun2" styleClass="dayToRun" title="${localWednesday}" checked="${sched.daysToRun[2]}" /></li>
					<li><cv:cvCheckbox name="daysToRun3" styleClass="dayToRun" title="${localThursday}" checked="${sched.daysToRun[3]}" /></li>
					<li><cv:cvCheckbox name="daysToRun4" styleClass="dayToRun" title="${localFriday}" checked="${sched.daysToRun[4]}" /></li>
					<li><cv:cvCheckbox name="daysToRun5" styleClass="dayToRun" title="${localSaturday}" checked="${sched.daysToRun[5]}" /></li>
					<li><cv:cvCheckbox name="daysToRun6" styleClass="dayToRun" title="${localSunday}" checked="${sched.daysToRun[6]}" /></li>
				</ol>
			</div>
			<div id="monthlyElements">
				<input type="radio" id="dateSelector" name="monthSelection" value="dateSelector"><label for="dateSelector">On day:</label>
				<input id="dateSpinner" name="dateValue" type="number" min="1" max="31">

				<input type="radio" id="daySelector" name="monthSelection" value="daySelector" checked><label for="daySelector">On the:</label>
				<span id="daySelectorInput">
					<select name="weekOfMonth" id="weekOfMonth">
						<option value="First"><fmt:message key="schedule.First" /></option>
						<option value="Last"><fmt:message key="schedule.Last" /></option>
						<option value="Second"><fmt:message key="schedule.Second" /></option>
						<option value="Third"><fmt:message key="schedule.Third" /></option>
						<option value="Fourth"><fmt:message key="schedule.Fourth" /></option>
					</select>
					<select name="dayOfWeek" id="dayOfWeek">
						<option value="Day"><fmt:message key="schedule.day.day" /></option>
						<option value="Weekday"><fmt:message key="schedule.day.Weekday" /></option>
						<option value="Weekend_Day"><fmt:message key="schedule.day.Weekend_Day" /></option>
						<option value="Monday"><fmt:message key="schedule.day.monday" /></option>
						<option value="Tuesday"><fmt:message key="schedule.day.tuesday" /></option>
						<option value="Wednesday"><fmt:message key="schedule.day.wednesday" /></option>
						<option value="Thursday"><fmt:message key="schedule.day.thursday" /></option>
						<option value="Friday"><fmt:message key="schedule.day.friday" /></option>
						<option value="Saturday"><fmt:message key="schedule.day.saturday" /></option>
						<option value="Sunday"><fmt:message key="schedule.day.sunday" /></option>
					</select>
				</span>
				<div>
					<label><fmt:message key="schedule.monthly.Repeat_every" /></label><input type="number" id="repeatNmonths" name="repeatNmonthsValue" min="1" max="24" value="1"> <label><fmt:message key="schedule.monthly.months" /></label>
				</div>
			</div>
			<div id="repeatNHoursElements" class="repeatNHoursElements">
			    <div class="custom-cb unchecked repeatEveryNHours" data-state="unchecked" name="repeatEveryNHours"></div>
			    <label class="custom-cb-label repeatEveryNHours"><fmt:message key="schedule.label.repeatEvery"/></label>
			    <span id="holdrepeatNHoursElementsData">
					<input id="everyNHoursSpinner" name="everyNHoursSpinner" type="number" value="8" min="0" max="24">
					<span><fmt:message key="schedule.label.hours"/></span>
					<input id="everyNMinsSpinner" name="everyNMinsSpinner" type="number" value="0" min="0" max="59">
					<span><fmt:message key="schedule.label.minutes"/></span>
					<span> <fmt:message key="schedule.label.until"/></span>
					<span id="timeElementUntil">
						<span id="activeEndTimeDisplay"></span>
						<input type="hidden" id="activeEndTime" name="activeEndTime" value="86100" />
					</span>
				</span>
			</div>
		</div>
		</div>
		</form>
		</div>

		</div>
		<div id="scheduleBottomContainer">
			<div class="leftBottomCorner" id="manageSchedulesLinkContainer" >
					<a href="${pageContext.request.contextPath}/reports/reports.jsp?report=scheduleSettings" target="_parent" id="manageSchedulesLink"><fmt:message key="schedule.manage"/></a>
			</div>
			<fmt:bundle basename="localization.messages">
				<div class="btns noabsolute" id="scheduleActionButtons" >
					<a href="#" id="closeButton"><fmt:message key="common.action.close" /></a>
					<a href="#" id="okButton" class="okSaveButton"><fmt:message key="common.action.save" /></a>
				</div>
			</fmt:bundle>
		</div>

	</div>
</fmt:bundle>
<fmt:bundle basename="localization.ReportsJSMessages">
	<fmt:message key="errors.invalid_email" var="invalid_email"/>
	<fmt:message key="errors.email_is_empty" var="email_is_empty"/>
</fmt:bundle>
<script nonce="${sessionScope.cspNonce}" >
	var localMsg = localMsg || {};
	localMsg.hours = "${hoursText}";
    localMsg.minutes = "${minutesText}";
    localMsg.AM = "${AMText}";
    localMsg.PM = "${PMText}";
    localMsg.nameLengthErrorMessage = "${nameLengthErrorMessage}";
    localMsg.enterScheduleName = "${enterScheduleName}";
    localMsg["errors.invalid_email"]="${invalid_email}";
    localMsg["errors.email_is_empty"]="${email_is_empty}";
	var confirmDeleteVar = "${confirmDelete}";
	var errorMessage1Text="${errorMessage1}";
	var defaultModel=${requestScope.SCHEDULE_JSON};
	var currentUrl=window.parent.document.URL;
	var networkShareEnabled=${requestScope.networkShareEnabled};
	var closeOnSave=true;
	${cv:jsLocalize("localMsg", "localization.ScheduleMessages", null)};
	var defaultTimeZoneId = "${sched.commServTimeZone}";
</script>

<jsp:include page="../common/footer.jsp">
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/encoder.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/cvTimepicker.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/js/tablebase.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/reportsUtil.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/reportSchedule.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/reports/js/emailSuggestion.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/thirdPartyV3/bootstrap-4.4.1/js/bootstrap.bundle.min.js" name="js" />
	<jsp:param value="${pageContext.request.contextPath}/common/bootstrap/js/bootstrap-multiselect.js" name="js" />
</jsp:include>

