<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<%@ taglib uri="/WEB-INF/cvtaglib.tld" prefix="cv" %>
<%@ taglib prefix="enhance" uri="/WEB-INF/webenhance.tld" %>

<script type="text/javascript" nonce="${sessionScope.cspNonce}">
	var isPublicMetricsCloud=false;
	<c:if test="${applicationScope.isPublicMetricsCloud != null and applicationScope.isPublicMetricsCloud ==true}">
		isPublicMetricsCloud=true;
	</c:if>
	if (window.location.pathname == '/webconsole/reports/'){
		if(window.location.hash){
			window.location.replace(cvUtil.getContextPath() + "/reports/index.jsp?page=Reports" + window.location.hash);
		}
		else{
			window.location.replace(cvUtil.getContextPath() + "/reports/index.jsp?page=Reports");
		}
	}
</script>
<script nonce="${sessionScope.cspNonce}" type="text/javascript" src="${pageContext.request.contextPath}/reports/js/reportsNav.js?${applicationScope.BUILD_TS}"></script>
<fmt:bundle basename="localization.ReportsMessages">
	<fmt:message key="File" var="File" />
	<fmt:message key="CustomReport.SaveAs" var="SaveAs"/>
	<fmt:message key="CustomReport.Print" var="Print"/>
	<fmt:message key="CustomReport.Schedule" var="Schedule"/>
	<fmt:message key="CustomReport.Email" var="Email"/>
	<fmt:message key="Profile" var="Profile" />
</fmt:bundle>

<jsp:include page="../softwarestore/loginframe/appStoreFrame.jsp">
	<jsp:param value="report" name="category"/>
	<jsp:param value="" name="subcategory"/>
</jsp:include>

<fmt:bundle basename="localization.SurveyMessages">
<fmt:message key="CommCell Groups" var="commCellGroups" />
<fmt:message key="CommCells" var="commCells" />
<fmt:message key="summary.link.sharedFolder" var="sharedFolderText" />
<fmt:message key="summary.link.sharepoint" var="sharepointText" />
<fmt:message key="summary.link.drive" var="driveText" />
<fmt:message key="common.label.loading" var="loading" />

<label class="vw-js-nav-trigger" for="vw-nav-trigger" title="Collapse/Open navigation" class="hidden-xs"><svg xmlns="http://www.w3.org/2000/svg" width="25" height="24" viewBox="0 0 25 24"><path d="M3,1v22h20V1H3z M7,21H5V3h2V21z M9,21V3h12v8h-7V8l-4.5,4l4.5,4v-3h7v8H9z" class="vw-close" /><path d="M3,1v22h20V1H3z M7,21H5V3h2V21z M21,21H9v-8h7v3l4.5-4L16,8v3H9V3h12V21z" class="vw-open"/></svg></label>
<c:if test="${(param.miniNav != null && param.miniNav == 'true') or (sessionScope.UserNavMenuSateCollapsed != null && sessionScope.UserNavMenuSateCollapsed == 'true')}">
	<c:set var="collapseNav" value="checked" scope="page" />
	<c:set var="hideElement" value="hide-element" scope="page" />
	<c:set var="subNavSmaller" value="vw-side-sub-nav-smaller" scope="page" />
</c:if>

<c:set var="metricsInstalled" value="${applicationScope.METRICS_INSTALLED}" />

<c:set var="surveyEnabled" value="false" />
<cv:secureTag name="Survey" id="14">
	<c:if test="${sessionScope.userHasReportsManagementCapabilities == true and metricsInstalled eq 'true'}"> 
		<c:set var="surveyEnabled" value="true" />
	</c:if>
</cv:secureTag>

<c:set var="singleCommCellUser" value="false" />
<c:set var="commUniId" value="${fn:escapeXml(param.commUniId)}" />
<enhance:out escapeXml="false">
	<c:set var="CommCellNameFull" value="${requestScope.CommCellNameFull}"/>
	<c:set var="CommCellName" value="${requestScope.CommCellName}"/>
</enhance:out>
<c:if test="${sessionScope.SurveySingleCommcellUser != null and surveyEnabled eq 'true'}">
	<c:set var="singleCommCellUser" value="true" />
	<c:if test="${commUniId == null || commUniId <= 0}">
		<c:set var="commUniId" value="${fn:escapeXml(sessionScope.SurveySingleCommcellUser)}" />
		<enhance:out escapeXml="false">
			<c:set var="CommCellNameFull" value="${requestScope.CommCellNameFull}"/>
			<c:set var="CommCellName" value="${requestScope.CommCellName}"/>
		</enhance:out>
	</c:if>
	<c:if test="${commUniId != null && commUniId > 0 && (empty CommCellName)}">
		<enhance:out escapeXml="false">
			<c:set var="CommCellNameFull" value="${sessionScope.SingleCommCellNameFull}"/>
			<c:set var="CommCellName" value="${sessionScope.SingleCommCellName}"/>
		</enhance:out>
	</c:if>
	
</c:if>

<input type="checkbox" id="vw-nav-trigger" class="vw-nav-trigger" ${collapseNav}>
<nav id="reportSideBar" class="vw-side-nav vw-side-nav-adjusted sidebar-options">



<!-- BEGIN:: PREPARE TITLE -->

<fmt:message var="navName" key="dashboard.label.Worldwide"/>
<fmt:message var="navNameTooltip" key="dashboard.label.Worldwide"/>

<c:set var="entityCommCellsCountStr" value="${sessionScope.WWCommCellsCountStr}" />
<c:if test="${param.showTabs == true && ((fn:escapeXml(param.ccGroupId) != null && fn:escapeXml(param.ccGroupId) > 0) || (fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0)) }">
	<c:set var="entityCommCellsCountStr" value="${requestScope.CGCommCellsCountStr}" />
	<c:set var="entityCommCellsCount" value="${requestScope.CGCommCellsCount}" />
	<c:if test="${(fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0)}">
		<c:set var="entityCommCellsCountStr" value="${requestScope.CompanyCommCellsCountStr}" />
		<c:set var="entityCommCellsCount" value="${requestScope.CompanyCommCellsCount}" />
	</c:if>
</c:if>

<c:choose>
	<c:when test="${commUniId > 0 }">
		<enhance:out escapeXml="false">
			<c:set var="navName" value="${CommCellName}" />
			<c:set var="navNameTooltip" value="${CommCellNameFull}" />
		</enhance:out>
	</c:when>
	<c:otherwise>
		<c:if test="${param.showTabs == true && ((fn:escapeXml(param.ccGroupId) != null && fn:escapeXml(param.ccGroupId) > 0) || (fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0)) && (commUniId <= 0) }">
			<c:set var="urlParams" value="" />
			<enhance:out escapeXml="false">
				<c:set var="entityName" value="${requestScope.CommCellGroupName}" />
				<c:set var="entityNameFull" value="${requestScope.CommCellGroupNameFull}" />
			</enhance:out>
			<c:if test="${(fn:escapeXml(param.ccGroupId) != null && fn:escapeXml(param.ccGroupId) > 0)}">
				<c:set var="urlParams" value="ccGroupId=${fn:escapeXml(param.ccGroupId)}" />
			</c:if>
			<c:if test="${(fn:escapeXml(param.companyId) != null && fn:escapeXml(param.companyId) > 0)}">
				<c:set var="urlParams" value="companyId=${fn:escapeXml(param.companyId)}" />
				<enhance:out escapeXml="false">
					<c:set var="entityName" value="${requestScope.CompanyName}" />
					<c:set var="entityNameFull" value="${requestScope.CompanyNameFull}" />
				</enhance:out>
			</c:if>
			<enhance:out escapeXml="false">
				<c:set var="navName" value="${entityName}" />
				<c:set var="navNameTooltip" value="${entityNameFull}" />
			</enhance:out>
		</c:if>
	</c:otherwise>
</c:choose>

<!-- END:: PREPARE TITLE -->


<!-- BEGIN:: PREPARE URLS -->

<c:set var="dashboardUrl" value="${pageContext.request.contextPath}/reports/index.jsp?page=Dashboard" />
<c:set var="reportsUrl" value="${pageContext.request.contextPath}/reports/index.jsp?page=Reports" />
<c:set var="commCellsUrl" value="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp" />
<c:set var="healthUrl" value="${pageContext.request.contextPath}/survey/reports/health.jsp" />
<c:if test="${surveyEnabled eq false}"> 
	<c:set var="healthUrl" value="${pageContext.request.contextPath}/health/health.jsp" />
</c:if>
<c:if test="${commUniId > 0 || param.ccGroupId > 0 || param.companyId > 0}">
	<enhance:out escapeXml="false">
		<c:url var="dashboardUrl" value="/survey/reports/dashboard.jsp">
			<c:if test="${not empty commUniId}">
				<c:param name="commUniId" value="${commUniId}" />
			</c:if>
			<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
				<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
			</c:if>
			<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
				<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
			</c:if>
		</c:url>
		<c:url var="reportsUrl" value="/survey/reports/commcellmonitoring.jsp">
			<c:if test="${not empty commUniId}">
				<c:param name="commUniId" value="${commUniId}" />
			</c:if>
			<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
				<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
			</c:if>
			<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
				<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
			</c:if>
		</c:url>
		<c:url var="commCellsUrl" value="/survey/reports/monitoringform.jsp">
			<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
				<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
			</c:if>
			<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
				<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
			</c:if>
		</c:url>
		<c:choose>
			<c:when test="${commUniId > 0 || (param.companyId > 0 and (empty param.commUniId or param.commUniId <= 0) and requestScope.CompanyCommUniId != null and requestScope.CompanyCommUniId > 0)}">
				<c:url var="healthUrl" value="/health/health.jsp">
					<c:choose>
						<c:when test="${not empty commUniId}">
							<c:param name="commUniId" value="${commUniId}" />
						</c:when>
						<c:otherwise>
							<c:if test="${param.companyId > 0 and (empty param.commUniId or param.commUniId <= 0) and requestScope.CompanyCommUniId != null and requestScope.CompanyCommUniId > 0}">
								<c:param name="commUniId" value="${requestScope.CompanyCommUniId}" />
							</c:if>
						</c:otherwise>
					</c:choose>
					<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
						<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
					</c:if>
					<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
						<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
					</c:if>
				</c:url>
			</c:when>
			<c:otherwise>
				<c:if test="${surveyEnabled eq true}">
					<c:url var="healthUrl" value="/survey/reports/health.jsp">
						<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
							<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
						</c:if>
						<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
							<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
						</c:if>
					</c:url>
				</c:if>
			</c:otherwise>
		</c:choose>
		<c:set var="profileUrl" value="" />
		<c:choose>
			<c:when test="${commUniId > 0 }">
				<c:url var="profileUrl" value="/survey/profile/profilecustdashboard.jsp">
					<c:if test="${not empty commUniId}">
						<c:param name="commUniId" value="${commUniId}" />
					</c:if>
					<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
						<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
					</c:if>
					<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
						<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
					</c:if>
				</c:url>
			</c:when>
			<c:otherwise>
				<c:url var="profileUrl" value="/survey/profile/profilecustdashboard.jsp">
					<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
						<c:param name="ccGroupId" value="${fn:escapeXml(param.ccGroupId)}" />
					</c:if>
					<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
						<c:param name="companyId" value="${fn:escapeXml(param.companyId)}" />
					</c:if>
				</c:url>
			</c:otherwise>
		</c:choose>
		
	</enhance:out>
</c:if>


<!-- END:: PREPARE URLS -->



<!-- BEGIN:: NON-SINGLE USER COMMCELL. Worldwide and CommCell Group levels are available -->	
<c:if test="${singleCommCellUser eq false}">
	<ul class="nav vw-apps-list js-reports-apps">
		<c:choose>
			<c:when test="${metricsInstalled}">
				<!-- <li class="other-options-li">
					<div class="other-options">
						<span class="glyphicon glyphicon-chevron-up"></span>
					</div>
				</li> -->
				<c:if test="${surveyEnabled == 'true'}">
					<li class="nav-customer-title nav-sec-title" title="${navNameTooltip}">
						<span class="sec-title ${hideElement}">
							${navName}
						</span>
					</li> 
				</c:if>
				
				<c:if test="${surveyEnabled == 'true'}">
					<li id="dashboard" class="true" data-div="Dashboard">
						<a href="${dashboardUrl}" title="
							<fmt:message key="Dashboard" />">
							<svg
								xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
								<path d="M15.79,14a.39.39,0,0,0-.39-.39H8a.49.49,0,0,0-.49.49V20a.61.61,0,0,0,.61.61h7.06a.61.61,0,0,0,.61-.61Z"/>
								<path d="M5.14,13.68h-2a.49.49,0,0,0-.49.49v6a.44.44,0,0,0,.44.44H5.18a.44.44,0,0,0,.44-.44v-6A.49.49,0,0,0,5.14,13.68Z"/>
								<rect x="17.67" y="4.54" width="4.7" height="16.12" rx="0.45" ry="0.45"/>
								<path d="M3,12.32H15.41a.36.36,0,0,0,.38-.33V5.12a.58.58,0,0,0-.58-.58h-12a.58.58,0,0,0-.58.58v6.74A.42.42,0,0,0,3,12.32Z"/>
							</svg>
							<span class="vw-text">
								<fmt:message key="Sidebar_Dashboard"/>
							</span>
						</a>
					</li>
				</c:if>
				<li id="reports" class="true" data-div="Reports">
					<a href="${reportsUrl}" title="
						<fmt:message key="Reports" />">
						<svg
							xmlns="http://www.w3.org/2000/svg"  width="25" height="25" viewBox="0 0 25 25">
							<rect  x="8.38" y="12.07" width="2.09" height="5.24"/>
							<rect  x="11.6" y="10.14" width="2.09" height="7.17"/>
							<rect  x="14.82" y="7.93" width="2.09" height="9.37"/>
							<path  d="M16.35,5.69,18,3.55a10.39,10.39,0,0,0-4.19-1.43v2.7A7.75,7.75,0,0,1,16.35,5.69Z"/>
							<path  d="M20.39,12.53a7.83,7.83,0,0,1-.17,1.62l2.4,1.38A10.46,10.46,0,0,0,19.26,4.45L17.64,6.59A7.79,7.79,0,0,1,20.39,12.53Z"/>
							<path  d="M12.58,20.34a7.8,7.8,0,0,1-.38-15.6V2.07A10.47,10.47,0,1,0,22,17l-2.32-1.33A7.8,7.8,0,0,1,12.58,20.34Z"/>
						</svg>
						<span class="vw-text">
							<fmt:message key="Sidebar_Reports"/>
						</span>
					</a>
				</li>
				<c:if test="${(applicationScope.isPublicMetricsCloud == null or applicationScope.isPublicMetricsCloud ne true) || (commUniId > 0 || param.ccGroupId > 0 || param.companyId > 0)}">
					<li id="health" class="true">
						<a href=${healthUrl} class="health_icon" title="<fmt:message key="Health" />">
							<svg
								xmlns="http://www.w3.org/2000/svg"  width="25" height="25" viewBox="0 0 25 25">
								<path d="M20.21,6.54a4.53,4.53,0,0,0-6.41,0,4.25,4.25,0,0,0-.53.65,4.52,4.52,0,0,0-7.91,4.3H4.09a1.61,1.61,0,1,0,0,3.23h4v0c5,5,5.07,5.06,5.1,5.08l.09,0a.24.24,0,0,0,.16-.06l6.78-6.77A4.54,4.54,0,0,0,20.21,6.54Zm-1.59,7H14.68l-1.12-2.14-2.29,5.12-2.18-7-1.78,4H4.09a.47.47,0,1,1,0-.95H6.68L9.25,6.86l2.18,7,2.06-4.61,1.79,3.43h3.33a.47.47,0,1,1,0,.95Z"/>
							</svg>
							<span class="vw-text">
								<fmt:message key="Sidebar_Health"/>
							</span>
							<span class="healthStatusIcon"></span>
						</a>
					</li>
				</c:if>
				<c:if test="${applicationScope.showProfileDashboard == true}">
					<li id="CommcellprofileTab" class="true hide" ><a href="${profileUrl}" title= "${CommCellNameFull} ${Profile}">
					<svg xmlns="http://www.w3.org/2000/svg" width="23" height="23" viewBox="0 0 25 25"><path  d="M8.75,18,12,16.11V12.4l3.9-2.23h0a1.64,1.64,0,0,0-.18-1.52V6.19s0,0,0-.07,0,0,0-.07V6h0a4,4,0,0,0-4.17-3.53A3.94,3.94,0,0,0,7.39,6.12s0,.08,0,.13V8.67a1.7,1.7,0,0,0,.18,2.16s.21.15.41.94a4.1,4.1,0,0,0,1.19,1.84,5.68,5.68,0,0,1,0,.66c-.28.59-1.5,1.13-2.82,1.55s-3.21.95-4,2.72-.36,3-.21,3.09c.42.33,3.39.81,5.79.94.56,0,1.16.08,1.78.1l-1-.53Z"/><polygon  points="9.84 18.46 12.65 16.81 15.51 18.46 15.51 21.71 12.65 23.37 9.84 21.71 9.84 18.46"/><polygon  points="13.03 12.92 15.83 11.27 18.7 12.92 18.7 16.17 15.83 17.83 13.03 16.17 13.03 12.92"/><polygon  points="16.28 18.46 19.08 16.81 21.95 18.46 21.95 21.71 19.08 23.37 16.28 21.71 16.28 18.46"/></svg>
						<span class="vw-text">${Profile}</span></a>
					</li>
				</c:if>
				<c:if test="${surveyEnabled == 'true'}">
					<li id="Commcells" class="true">
						<a href="${commCellsUrl}" title="
							<fmt:message key="CommCells" />"> 
							<svg
								xmlns="http://www.w3.org/2000/svg"  width="25" height="25" viewBox="0 0 25 25">
								<polygon  points="1.99 14.49 6.86 11.62 11.84 14.49 11.84 20.13 6.86 23.01 1.99 20.13 1.99 14.49"/>
								<polygon  points="7.52 4.87 12.39 1.99 17.37 4.87 17.37 10.51 12.39 13.38 7.52 10.51 7.52 4.87"/>
								<polygon  points="13.16 14.49 18.03 11.62 23.01 14.49 23.01 20.13 18.03 23.01 13.16 20.13 13.16 14.49"/>
							</svg>
							<span class="vw-text">
								<fmt:message key="Sidebar_CommCells"/> ${entityCommCellsCountStr}
							</span>
						</a>
					</li> 
					

				<%-- <li class="secondary-nav-title" title="">
					<span class="sec-title ${hideElement}">
						Global
					</span>
				</li> --%>
					<c:if  test="${applicationScope.isPublicMetricsCloud == true}">
						<li id="companies" class="true">
							<a href="${pageContext.request.contextPath}/survey/reports/viewReport.jsp?reportId=RegisteredCompanies" title="
								<fmt:message key="companies" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
									<path d="M12.49,24.45H3.09c-.25,0-.32-.07-.3-.3s0-.37,0-.56a.38.38,0,0,1,.42-.42c.51,0,.51,0,.51-.54q0-7.37,0-14.73c0-.43,0-.49.44-.62l5-1.63L13.82,4.1a.66.66,0,0,1,.6.06l6.58,4a.54.54,0,0,1,.28.53q0,7.05,0,14.1c0,.31,0,.31.31.32.51,0,.6.1.6.6,0,.22.06.53-.05.63s-.42.06-.65.06ZM14.1,4.87c0,.16,0,.24,0,.32q0,8.83,0,17.66c0,.32,0,.32.33.32h5.8c.33,0,.33,0,.33-.32q0-6.83,0-13.66a.57.57,0,0,0-.3-.55L15.19,5.54Zm-2.28,6.24h0c0-.2,0-.41,0-.61a.37.37,0,0,0-.44-.39l-.32.06-1.34.32-3.27.78c-.19,0-.35.14-.35.37s0,.75,0,1.12.17.4.46.36.37-.07.55-.11l4.34-.91a.4.4,0,0,0,.38-.45C11.83,11.49,11.83,11.3,11.83,11.11Zm0-3h0q0-.15,0-.3c0-.1,0-.2,0-.3a.37.37,0,0,0-.5-.38c-.23.05-.45.13-.67.19L6.43,8.56a.39.39,0,0,0-.33.37c0,.37,0,.75,0,1.12a.31.31,0,0,0,.36.31,1.54,1.54,0,0,0,.3,0l4.68-1.19a.42.42,0,0,0,.38-.47C11.83,8.47,11.83,8.3,11.83,8.12Zm0,6h0q0-.26,0-.51s0,0,0,0c0-.32-.17-.46-.48-.42s-.54.09-.81.14l-2.32.43L6.42,14a.36.36,0,0,0-.32.39c0,.33,0,.65,0,1a.36.36,0,0,0,.46.39l1.11-.15,3.77-.54a.4.4,0,0,0,.39-.41C11.84,14.5,11.83,14.3,11.83,14.11Zm0,3h0c0-.15,0-.3,0-.44,0-.46-.13-.58-.57-.53-.77.09-1.53.19-2.29.29l-2.52.34a.35.35,0,0,0-.34.39c0,.32,0,.64,0,1s.16.43.46.4l4.84-.41a.41.41,0,0,0,.43-.46C11.84,17.46,11.83,17.28,11.83,17.11ZM8.94,21.16h0l2.41-.06c.34,0,.48-.15.48-.49s0-.64,0-1-.13-.55-.55-.52l-4.8.37c-.29,0-.38.12-.39.42s0,.58,0,.86.13.48.49.47Z"/>
									<path d="M19.53,6.65c-.23-.14-.44-.26-.63-.4A.33.33,0,0,1,18.82,6c0-.3,0-.61,0-.91a.53.53,0,0,0-.25-.49l-2.9-2.1c-.45-.33-.91-.65-1.36-1a.51.51,0,0,0-.54-.08L6.83,4.12c-.73.28-.64.24-.64,1,0,.26,0,.53,0,.79a.23.23,0,0,1-.2.26c-.17,0-.34.1-.53.16,0-.11,0-.18,0-.26,0-.63,0-1.26,0-1.89a.39.39,0,0,1,.29-.42l4-1.52L14,.55a.39.39,0,0,1,.32,0q2.55,1.83,5.09,3.69a.42.42,0,0,1,.17.28c0,.65,0,1.29,0,1.94A.93.93,0,0,1,19.53,6.65Z"/>
								</svg>
								<c:set var="CompaniesCount" value="${sessionScope.CompaniesCountStr}" />
								<span class="vw-text">
									<fmt:message key="companies"/> ${CompaniesCount}
								</span>
							</a>
						</li>
					</c:if>
					<c:if test="${applicationScope.isPublicMetricsCloud eq false}">
						<li id="commcellGroups" class="true">
							<a href="${pageContext.request.contextPath}/survey/reports/monitoringform.jsp?ccGroups=true" title="
								<fmt:message key="CommCell_Groups" />">
								<svg
									xmlns="http://www.w3.org/2000/svg"  width="25" height="25" viewBox="0 0 25 25">
									<polygon  points="15.73 10.78 18.17 9.37 18.17 4.53 13.89 2.06 10.88 3.84 15.73 6.64 15.73 10.78"/>
									<polygon  points="18.74 10.32 15.73 12.09 15.73 12.22 15.68 12.25 20.39 14.97 20.39 19.14 23.01 17.63 23.01 12.79 18.74 10.32"/>
									<polygon  points="6.46 7.08 10.63 4.61 14.9 7.08 14.9 11.92 10.63 14.39 6.46 11.92 6.46 7.08"/>
									<polygon  points="11.3 15.34 15.47 12.87 19.75 15.34 19.75 20.18 15.47 22.65 11.3 20.18 11.3 15.34"/>
									<polygon  points="1.71 15.34 5.89 12.87 10.16 15.34 10.16 20.18 5.89 22.65 1.71 20.18 1.71 15.34"/>
								</svg>
								<c:set var="CCGroupsCount" value="${sessionScope.CCGroupsCountStr}" />
								<span class="vw-text">
									<fmt:message key="Sidebar_CommcellGroups"/> ${CCGroupsCount}
								</span>
							</a>
						</li>
					</c:if>

				</c:if>
			</c:when >
			<c:otherwise>
				<li id="reports" class="true" data-div="Reports" >
					<a href="${pageContext.request.contextPath}/reports/index.jsp?page=Reports" title="${requestScope.CommCellNameFull} 
						<fmt:message key="Reports" />">
						<svg
							xmlns="http://www.w3.org/2000/svg"  width="25" height="25" viewBox="0 0 25 25">
							<rect  x="8.38" y="12.07" width="2.09" height="5.24"/>
							<rect  x="11.6" y="10.14" width="2.09" height="7.17"/>
							<rect  x="14.82" y="7.93" width="2.09" height="9.37"/>
							<path  d="M16.35,5.69,18,3.55a10.39,10.39,0,0,0-4.19-1.43v2.7A7.75,7.75,0,0,1,16.35,5.69Z"/>
							<path  d="M20.39,12.53a7.83,7.83,0,0,1-.17,1.62l2.4,1.38A10.46,10.46,0,0,0,19.26,4.45L17.64,6.59A7.79,7.79,0,0,1,20.39,12.53Z"/>
							<path  d="M12.58,20.34a7.8,7.8,0,0,1-.38-15.6V2.07A10.47,10.47,0,1,0,22,17l-2.32-1.33A7.8,7.8,0,0,1,12.58,20.34Z"/>
						</svg>
						<span class="vw-text">
							<fmt:message key="Sidebar_Reports"/>
						</span>
					</a>
				</li>
				
				<cv:reportsTag name="cellAdministrativeRight" id="999">
					<c:set var="healthLink" value="${pageContext.request.contextPath}/health/health.jsp" />
					<li id="health" class="true">
						<a href=${healthLink} class="health_icon" title="${requestScope.CommCellNameFull}
							<fmt:message key="Health" />">
							<svg
								xmlns="http://www.w3.org/2000/svg"  width="25" height="25" viewBox="0 0 25 25">
								<path d="M20.21,6.54a4.53,4.53,0,0,0-6.41,0,4.25,4.25,0,0,0-.53.65,4.52,4.52,0,0,0-7.91,4.3H4.09a1.61,1.61,0,1,0,0,3.23h4v0c5,5,5.07,5.06,5.1,5.08l.09,0a.24.24,0,0,0,.16-.06l6.78-6.77A4.54,4.54,0,0,0,20.21,6.54Zm-1.59,7H14.68l-1.12-2.14-2.29,5.12-2.18-7-1.78,4H4.09a.47.47,0,1,1,0-.95H6.68L9.25,6.86l2.18,7,2.06-4.61,1.79,3.43h3.33a.47.47,0,1,1,0,.95Z"/>
							</svg>
							<span class="vw-text">
								<fmt:message key="Sidebar_Health"/>
							</span>
							<span class="healthStatusIcon"></span>
						</a>
					</li>
				</cv:reportsTag>
			</c:otherwise>
		</c:choose>
		<!-- BEGIN:: CONFIGURATION MENU -->
		<li id="reportsManager" class="true" >
			<a title="
				<fmt:message key="RM_Configuration" />">
				<svg
					xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
					<path d="M21.2,19.08a3.43,3.43,0,0,0,0-.46,3,3,0,0,0,0-.42l1.27-.78L22,16.32l-1.37.41a3.34,3.34,0,0,0-.71-.73l.34-1.42-1.12-.45-.67,1.26a3.33,3.33,0,0,0-.52,0,3.24,3.24,0,0,0-.61.06l-.75-1.22-1.11.48.42,1.4a3.32,3.32,0,0,0-.58.59L13.9,16.3l-.45,1.12,1.26.67a3.25,3.25,0,0,0,0,.52,3.19,3.19,0,0,0,.05.56l-1.22.75L14,21l1.38-.41a3.31,3.31,0,0,0,.71.68l-.32,1.36,1.12.45.66-1.23a3.2,3.2,0,0,0,1.09,0l.75,1.21,1.11-.48L20,21.17a3.33,3.33,0,0,0,.58-.61l1.43.34.45-1.12ZM18,19.89a1.27,1.27,0,1,1,1.28-1.27A1.28,1.28,0,0,1,18,19.89Z"/>
					<polygon points="12.49 1.78 12.49 8.11 18.82 8.11 12.49 1.78"/>
					<path d="M12.13,8.81a.35.35,0,0,1-.35-.35V1.78H5.45a.7.7,0,0,0-.71.71V20.77a.7.7,0,0,0,.71.71h7.33a5.91,5.91,0,0,1,.56-6.56l1-1a5.79,5.79,0,0,1,4.44-1.15v-4Zm-.35,6.42H7.45a.5.5,0,1,1,0-1h4.33a.5.5,0,0,1,0,1Zm3.37-3.67H7.39a.5.5,0,1,1,0-1h7.76a.5.5,0,0,1,0,1Z"/>
				</svg>
				<span class="vw-text">
					<fmt:message key="Sidebar_Configuration"/>
				</span>
				<span class="arrow-right ${hideElement}"
							style="visibility: visible;"></span>
			</a>
			<nav class="vw-side-sub-nav vw-side-sub-nav-adjusted ${subNavSmaller}"
								id="reportsManagerSubNav">
				<c:set var="isReportAdmin" value='false' scope="page" />
				<cv:reportsTag name="adminRight" id="999">
					<c:set var="isReportAdmin" value='true' scope="page" />
				</cv:reportsTag>
				<c:set var="cellAdminUser" value='false' scope="page" />
				<cv:reportsTag name="cellAdministrativeRight" id="999">
					<c:set var="cellAdminUser" value='true' scope="page" />
				</cv:reportsTag>
				<ul class="nav sub-vw-apps-list">
					<cv:reportsTag name="Reports.ManageReports" id="888">
						<li id="reportMgrLi" class="true settingHeaderLi "
										data-div="customReports">
							<a href="#" title="
								<fmt:message key="Sidebar_Reports" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
									<path d="M15.94,7.63H20L14.83,2.42v.44h0V6.52A1.11,1.11,0,0,0,15.94,7.63Z"/>
									<path d="M13.67,20.5l-.26.26-.08.12-1,2.86a.32.32,0,0,0,.3.42l.1,0,2.86-1,.12-.08.23-.23Z"/>
									<polygon points="18.85 15.33 14.26 19.91 16.62 22.26 21.21 17.69 18.85 15.33"/>
									<path d="M22.93,14.6l-1-1a1,1,0,0,0-1.35,0l-1.32,1.35,2.31,2.25L22.93,16a1,1,0,0,0,0-1.35Zm-2.72.26"/>
									<path d="M20.6,8.63H15.94a2.11,2.11,0,0,1-2.11-2.11V1.86l-.11-.11h-8A1.61,1.61,0,0,0,4.07,3.36V21.08a1.61,1.61,0,0,0,1.61,1.61h3.2l5.27-5.27V9.89h1.73v5.8l4.76-4.76V8.67Zm-10,9H8.83V13.3h1.73Zm2.65,0H11.49V11.71h1.73Z"/>
								</svg>
								<span class="vw-text-sub">
									<fmt:message key="Sidebar_Reports"/>
								</span>
							</a>
						</li>
					</cv:reportsTag>
					<cv:reportsTag name="Reports.ManageReports" id="888">
						<li id="dataSetMgrLi" class="true settingHeaderLi "
											data-div="Datasets">
							<a href="#" title="
								<fmt:message key="Sidebar_Dataset" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" viewBox="0 0 25 25" width="20" height="20">
									<path d="M 9.63 8.5 a 13.48 13.48 0 0 1 -4.94 -0.81 A 4.73 4.73 0 0 1 2.8 6.48 a 1.88 1.88 0 0 1 0 -2.74 A 5.37 5.37 0 0 1 5.15 2.42 a 15.05 15.05 0 0 1 6.24 -0.57 a 10.51 10.51 0 0 1 3.76 1 a 5.34 5.34 0 0 1 1.26 0.89 a 1.89 1.89 0 0 1 0 2.83 a 4.89 4.89 0 0 1 -1.67 1.06 a 12.83 12.83 0 0 1 -4.47 0.87 Z" />
									<path d="M 17 7 c 0 1 0 1.94 0 2.86 a 1.74 1.74 0 0 1 -0.48 0.89 a 5.09 5.09 0 0 1 -2.12 1.35 a 12.78 12.78 0 0 1 -4.32 0.81 a 13.85 13.85 0 0 1 -4.56 -0.57 a 6.3 6.3 0 0 1 -2.76 -1.53 a 1.77 1.77 0 0 1 -0.56 -1.41 c 0 -0.78 0 -1.56 0 -2.4 l 0.26 0.23 a 7.26 7.26 0 0 0 3 1.57 a 14.88 14.88 0 0 0 8.84 -0.18 A 6.62 6.62 0 0 0 17 7 Z" />
									<path d="M 17 11.34 V 13.6 a 8.7 8.7 0 0 0 -1.17 0.14 a 4.29 4.29 0 0 0 -3 3 c -0.06 0.17 -0.13 0.25 -0.28 0.28 a 14.4 14.4 0 0 1 -7.61 -0.52 a 5.42 5.42 0 0 1 -2.18 -1.35 a 1.76 1.76 0 0 1 -0.52 -1.37 c 0 -0.78 0 -1.57 0 -2.42 a 6.69 6.69 0 0 0 2.44 1.54 a 13.11 13.11 0 0 0 4.24 0.83 a 14.31 14.31 0 0 0 5.52 -0.76 A 6.79 6.79 0 0 0 17 11.34 Z" />
									<path d="M 2.23 15.7 a 8.63 8.63 0 0 0 4.7 2.14 a 15.28 15.28 0 0 0 5.34 0 l 0.23 0 a 15.27 15.27 0 0 0 0.16 1.69 a 14.41 14.41 0 0 0 0.51 1.6 c -0.33 0.06 -0.7 0.15 -1.08 0.2 A 16.22 16.22 0 0 1 5.63 21 a 6.63 6.63 0 0 1 -2.4 -1.12 a 2.26 2.26 0 0 1 -1 -1.57 c 0 -0.4 0 -0.82 0 -1.23 S 2.23 16.18 2.23 15.7 Z" />
									<path d="M 21.51 19.25 a 3.43 3.43 0 0 0 0 -0.46 a 3 3 0 0 0 0 -0.42 l 1.27 -0.78 l -0.47 -1.1 l -1.37 0.41 a 3.34 3.34 0 0 0 -0.71 -0.73 l 0.34 -1.42 l -1.12 -0.45 l -0.67 1.26 a 3.33 3.33 0 0 0 -0.52 0 a 3.24 3.24 0 0 0 -0.61 0.06 L 16.9 14.4 l -1.11 0.48 l 0.42 1.4 a 3.32 3.32 0 0 0 -0.58 0.59 l -1.42 -0.4 l -0.45 1.12 l 1.26 0.67 a 3.25 3.25 0 0 0 0 0.52 a 3.19 3.19 0 0 0 0.05 0.56 l -1.22 0.75 l 0.46 1.08 l 1.38 -0.41 a 3.31 3.31 0 0 0 0.71 0.68 l -0.32 1.36 l 1.12 0.45 L 17.86 22 A 3.2 3.2 0 0 0 19 22 l 0.75 1.21 l 1.11 -0.48 l -0.5 -1.41 a 3.33 3.33 0 0 0 0.58 -0.61 l 1.43 0.34 l 0.45 -1.12 Z m -3.2 0.81 a 1.27 1.27 0 1 1 1.28 -1.27 A 1.27 1.27 0 0 1 18.31 20.06 Z" />
								</svg>
								<span class="vw-text-sub">
									<fmt:message key="Sidebar_Dataset"/>
								</span>
							</a>
						</li>
					</cv:reportsTag>
					<li id="dataSetMgrLi" class="true settingHeaderLi "
									data-div="CustomDashboards">
						<a href="#" title="
							<fmt:message key="Sidebar_CustomDashboards" />">
							<svg
								xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25">
								<path d="M13.92,16.76l-.25.25-.08.11-.95,2.73a.31.31,0,0,0,.19.38l.1,0H13l2.72-.95.12-.08.22-.22Z"></path>
								<polygon points="18.85 11.84 14.48 16.2 16.73 18.44 21.09 14.09 18.85 11.84"></polygon>
								<path d="M22.73,11.15l-.95-1a1,1,0,0,0-1.28,0l-1.26,1.29,2.2,2.14,1.29-1.14a.94.94,0,0,0,0-1.29Z"></path>
								<path d="M4.15,12.89H2.28a.45.45,0,0,0-.46.46V19a.41.41,0,0,0,.41.41h2A.41.41,0,0,0,4.6,19V13.35A.46.46,0,0,0,4.15,12.89Z"></path>
								<path d="M20.32,4.74a.43.43,0,0,0-.43-.43H16.33a.42.42,0,0,0-.42.43v7.57l4.41-4.37Z"></path>
								<path d="M2.14,11.61H13.79a.33.33,0,0,0,.35-.31V4.86a.55.55,0,0,0-.54-.55H2.34a.55.55,0,0,0-.54.55v6.32A.38.38,0,0,0,2.14,11.61Z"></path>
								<path d="M14.14,13.19a.37.37,0,0,0-.36-.37H6.83a.47.47,0,0,0-.46.46v5.54a.58.58,0,0,0,.58.57H8.77l5.37-5.33Z"></path>
							</svg>
							<span class="vw-text-sub">
								<fmt:message key="Sidebar_CustomDashboards" />
							</span>
						</a>
					</li>
					<c:if test="${applicationScope.isPublicMetricsCloud == null or applicationScope.isPublicMetricsCloud == false}">
						<c:if test = "${(metricsInstalled == 'true' &&  isReportAdmin== 'true') || cellAdminUser == 'true'}">
							<li id="reportSettingsLi" class="true settingHeaderLi "
												data-div="reportSettings">
								<a href="#" title="
									<fmt:message key="Sidebar_Metrics_Reports" />">
									<svg
										xmlns="http://www.w3.org/2000/svg" viewBox="0 0 25 25" width="20" height="20">
										<path d="M 12.9 14.45 l -0.56 -0.28 a 4.1 4.1 0 0 0 -0.52 -0.2 l -0.28 -2 H 9.91 l -0.24 1.91 a 4.5 4.5 0 0 0 -1.27 0.48 L 6.8 13.18 L 5.65 14.34 l 1.2 1.51 l -0.32 0.6 l -0.24 0.8 l -1.91 0.28 v 1.59 l 2 0.24 a 4.46 4.46 0 0 0 0.4 1 L 5.53 22 l 1.12 1.15 l 1.51 -1.2 a 4.38 4.38 0 0 0 0.64 0.36 a 4.3 4.3 0 0 0 0.72 0.24 l 0.24 1.91 h 1.63 l 0.24 -1.91 A 4.46 4.46 0 0 0 12.87 22 l 1.48 1.15 L 15.5 22 l -1.16 -1.47 l 0.28 -0.52 l 0.28 -0.84 l 1.91 -0.28 V 17.27 l -2 -0.24 a 4.51 4.51 0 0 0 -0.44 -1 l 1.19 -1.59 l -1.16 -1.15 Z m -1.23 1.28 A 2.71 2.71 0 0 1 13 19.27 a 2.67 2.67 0 1 1 -1.36 -3.54 Z" />
										<path d="M 16.6 5.88 l -0.36 -1.47 L 15 4.53 V 6 a 3.39 3.39 0 0 0 -0.92 0.44 l -1.28 -0.8 l -0.8 0.92 l 1 1.07 l -0.28 0.52 l -0.16 0.6 L 11.22 9 l 0.08 1.24 h 1.47 a 3.38 3.38 0 0 0 0.4 0.76 l -0.8 1.28 l 0.92 0.8 l 1.07 -1 l 0.52 0.24 a 3.23 3.23 0 0 0 0.56 0.12 l 0.32 1.43 L 17 13.81 V 12.33 a 3.35 3.35 0 0 0 0.88 -0.48 l 1.2 0.76 l 0.8 -0.92 l -1 -1 l 0.16 -0.4 l 0.16 -0.64 l 1.39 -0.32 l -0.08 -1.24 H 19.07 a 3.38 3.38 0 0 0 -0.4 -0.76 L 19.47 6 l -0.92 -0.8 l -1.11 1 L 17 6 Z m 0 1.34 h 0 A 2 2 0 1 1 14 8.53 A 2 2 0 0 1 16.6 7.23 Z" />
										<path d="M 9.66 1.9 L 9.54 0.63 L 8.5 0.55 l -0.2 1.2 A 2.87 2.87 0 0 0 7.47 2 l -1 -0.8 l -0.76 0.68 l 0.72 1 l -0.24 0.36 L 6 3.74 L 4.8 3.86 l -0.08 1 L 6 5.09 l 0.24 0.68 l -0.8 1 l 0.72 0.8 l 1 -0.72 l 0.4 0.24 A 2.71 2.71 0 0 0 8 7.2 l 0.12 1.24 l 1 0.08 l 0.2 -1.2 a 2.83 2.83 0 0 0 0.8 -0.28 L 11 7.8 l 0.76 -0.68 l -0.64 -1 l 0.2 -0.32 l 0.2 -0.52 l 1.24 -0.12 l 0.08 -1 l -1.24 -0.2 l -0.24 -0.68 l 0.8 -1 l -0.68 -0.76 l -1.12 0.68 L 10 2 Z M 9.54 3 a 1.71 1.71 0 0 1 0.76 2.3 h 0 A 1.71 1.71 0 1 1 9.54 3 Z" />
									</svg>
									<span class="vw-text-sub">
										<fmt:message key="Sidebar_Metrics_Reports" />
									</span>
								</a>
							</li>
						</c:if>
					</c:if>
					<cv:reportsTag name="Reports.ManageDataSources" id="888">
						<li id="generalLi" class="true settingHeaderLi "
											data-div="managedDataSources">
							<a href="#" title="
								<fmt:message key="Sidebar_DataSources" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
									<ellipse  cx="6.67" cy="7.94" rx="4.35" ry="0.97"/>
									<path  d="M6.67,9.27c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1S11,11,11,10.49V8.3C11,8.83,9.08,9.27,6.67,9.27Z"/>
									<ellipse  cx="17.55" cy="2.26" rx="4.35" ry="0.97"/>
									<path  d="M17.55,3.6c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V2.62C21.9,3.16,20,3.6,17.55,3.6Z"/>
									<path  d="M17.55,6.18c-2.4,0-4.35-.44-4.35-1V7.4c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V5.2C21.9,5.74,20,6.18,17.55,6.18Z"/>
									<path  d="M17.55,8.76c-2.4,0-4.35-.44-4.35-1V10c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V7.79C21.9,8.32,20,8.76,17.55,8.76Z"/>
									<path  d="M9.63,12.06c0-.27.53-.51,1.39-.69v-.49c0,.54-1.95,1-4.35,1s-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1a15.06,15.06,0,0,0,3-.26V12.06Z"/>
									<path  d="M9.63,14.62v-.45a15.06,15.06,0,0,1-3,.26c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1a15.06,15.06,0,0,0,3-.26V14.62Z"/>
									<path  d="M9.63,17.26v-.45a15.06,15.06,0,0,1-3,.26c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1a15.06,15.06,0,0,0,3-.26V17.26Z"/>
									<path  d="M14.69,11.09c-.91-.18-1.49-.44-1.49-.73v.75c.37,0,.74,0,1.14,0Z"/>
									<path  d="M19,12.06v1.41c1.66-.14,2.86-.49,2.86-.91v-2.2c0,.54-1.95,1-4.35,1h-.09C18.42,11.52,19,11.77,19,12.06Z"/>
									<path  d="M19,15v1.1c1.66-.14,2.86-.49,2.86-.91V13c0,.42-1.19.77-2.86.91V15Z"/>
									<ellipse  cx="14.44" cy="12.43" rx="4.35" ry="0.97"/>
									<path  d="M14.44,13.76c-2.4,0-4.35-.44-4.35-1V15c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1v-2.2C18.79,13.33,16.84,13.76,14.44,13.76Z"/>
									<path  d="M14.44,16.35c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1v-2.2C18.79,15.91,16.84,16.35,14.44,16.35Z"/>
									<path  d="M14.44,18.93c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V18C18.79,18.49,16.84,18.93,14.44,18.93Z"/>
									<path  d="M14.44,21.51c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1v-2.2C18.79,21.07,16.84,21.51,14.44,21.51Z"/>
								</svg>
								<span class="vw-text-sub">
									<fmt:message key="Sidebar_DataSources" />
								</span>
							</a>
						</li>
					</cv:reportsTag>
					<li id="alarmsLi" class="true settingHeaderLi "
									data-div="alarmsSettings">
						<a href="#" title="
							<fmt:message key="Sidebar_Alerts" />">
							<svg
								xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
								<path d="M15.74,19.89l-.4.09a12.07,12.07,0,0,1-5.4,0l-.4-.09s.05,1.13.07,1.17a3.23,3.23,0,0,0,3,2h0a3.23,3.23,0,0,0,3.09-2.19S15.74,19.89,15.74,19.89Z"/>
								<path d="M20,15.29a8.34,8.34,0,0,1-2.21-5.52V9.3c0-3.2-.68-5.29-3.65-6a1.25,1.25,0,0,0-1.24-1.48h-.89a1.25,1.25,0,0,0-1.24,1.48c-3,.75-3.65,2.84-3.65,6v.47A8.34,8.34,0,0,1,5,15.29a1.31,1.31,0,0,0-.41.77c0,1.18.74,1.61,2.13,2.13h0a19.35,19.35,0,0,0,5.83.9,19.35,19.35,0,0,0,5.83-.9h0c1.39-.52,2.13-1,2.13-2.13A1.31,1.31,0,0,0,20,15.29Z"/>
							</svg>
							<span class="vw-text-sub">
								<fmt:message key="Sidebar_Alerts" />
							</span>
						</a>
					</li>
					<li id="schedulesLi" class="true settingHeaderLi "
									data-div="scheduleSettings">
						<a href="#" title="
							<fmt:message key="Sidebar_Schedules" />">
							<svg
								xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25.3">
								<rect x="6.26" y="4.56" width="1.79" height="1.79"/>
								<rect x="16.89" y="4.56" width="1.79" height="1.79"/>
								<path d="M19.73,4.53H19.3V6.25a.74.74,0,0,1-.74.74H17a.74.74,0,0,1-.74-.74V4.53H8.65V6.25A.74.74,0,0,1,7.92,7H6.37a.74.74,0,0,1-.74-.74V4.53H5.27A1.62,1.62,0,0,0,3.65,6.15V19.79a1.62,1.62,0,0,0,1.62,1.62H19.73a1.62,1.62,0,0,0,1.62-1.62V6.15A1.62,1.62,0,0,0,19.73,4.53ZM19.3,18.91a.87.87,0,0,1-.87.87H6.5a.87.87,0,0,1-.87-.87V10a.87.87,0,0,1,.87-.87H18.43a.87.87,0,0,1,.87.87Z"/>
								<rect x="6.76" y="11.14" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
								<rect x="11.18" y="11.14" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
								<rect x="15.61" y="11.14" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
								<rect x="6.76" y="15.3" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
								<rect x="11.18" y="15.3" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
								<rect x="15.61" y="15.3" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
							</svg>
							<span class="vw-text-sub">
								<fmt:message	key="Sidebar_Schedules" />
							</span>
						</a>
					</li>
				</ul>
			</nav>
		</li>
		<!-- END:: CONFIGURATION MENU -->
		<!-- BEGIN:: SOFTWARE STORE -->
		<c:set var="softwareStoreClassList" value="true software-store-item" />
		<c:if test="${applicationScope.SWStoreIsCVStore ne true}">
			<c:set var="softwareStoreClassList" value="true software-store-item hidden"></c:set>
		</c:if>
		<li id="appStoreLink" class="${softwareStoreClassList}" >
			<a title="
				<fmt:message key="Sidebar_Store_Title" />">
				<svg
					xmlns="http://www.w3.org/2000/svg" width="25" height="25" viewBox="0 0 25 25">
					<path d="M14.5,15.1l-1-.6h-.3v.2h0l-1.4-.9-.2-.2h-.5l.2.2h.3l1.5.9h.1v.2h.2l1,.6h.3a.3.3,0,0,0,.1-.2A.3.3,0,0,0,14.5,15.1Zm-.2.4h0l-1-.6h0l1,.6Zm.1-.1h-.1l-.9-.6h0l.9.6Zm.1-.2h0l-1-.6h0l1,.6Z"/>
					<path d="M8.1,12.3H7.5V10.9h.6ZM9.7,9.1l.4-.6L9,8.2v.7Zm-.7,3.1H8.4V10.3h.6ZM10.7,11a2.1,2.1,0,0,1,0,.4l.6.4a2.8,2.8,0,0,0-.9-3l-.4.6A2.1,2.1,0,0,1,10.7,11Zm-.9,1.3H9.2V9.7h.6Zm-1.2.8a2.1,2.1,0,0,1-.1-4.2V8.2a2.8,2.8,0,1,0,2.6,4l-.6-.4A2.1,2.1,0,0,1,8.7,13.1Zm9.7.9v-.5h.8v-.7h-.8l-.2-.5.5-.7-.5-.5-.6.5h-.6v-.8h-.7v.8l-.4.2-.7-.5-.5.5.5.6v.6h-.8v.7H15l.2.5-.5.6.5.5.6-.5h.6v.8h.7v-.8l.4-.2.7.5.5-.5Zm-1.9-.3a.7.7,0,0,1-.4-1,.7.7,0,0,1,1-.4.7.7,0,0,1,.4,1A.7.7,0,0,1,16.5,13.7Zm2.3-4.2h-.3V8.6h.3Zm.9-1.8.2-.3-.6-.2v.4Zm-.4,1.8H19V8.4h.3Zm1-.7V9l.4.2a1.6,1.6,0,0,0-.5-1.7l-.2.3A1.2,1.2,0,0,1,20.3,8.7Zm-.5.7h-.3V8h.3Zm-.6.5a1.2,1.2,0,0,1-.1-2.4V7.1a1.6,1.6,0,1,0,1.5,2.3l-.3-.2A1.2,1.2,0,0,1,19.1,9.9Zm-5.4-3h.5V6.2h-.4V5.9l.2-.4-.3-.2-.3.3H13V5.1h-.3v.4h-.2L12,5.5l-.2.3.3.3H12v.2h-.4v.4H12V7l-.2.3.3.2.3-.3h.3v.4h.3V7.4h.2l.4.2.2-.3Zm-1-.1a.4.4,0,0,1-.2-.5.4.4,0,0,1,.5-.2.4.4,0,0,1,.2.5A.4.4,0,0,1,12.8,6.8Zm0,4.3a.7.7,0,0,0,.9-.8.3.3,0,0,1,.1-.3l1.7-1.7h.3a.7.7,0,0,0,.7-.9l-.5.5-.6-.6.5-.5a.7.7,0,0,0-.9.8.3.3,0,0,1-.1.3L13.3,9.6l-.4.2a.7.7,0,0,0-.7.9l.5-.6.6.6Zm.9-.8a.3.3,0,0,1,.1-.3l1.7-1.7h.3a.7.7,0,0,0,.7-.9l-.5.5-.6-.6.5-.5a.7.7,0,0,0-.9.8.3.3,0,0,1-.1.3L13.3,9.6l-.4.2a.7.7,0,0,0-.7.9l.5-.6.6.6-.5.5A.7.7,0,0,0,13.7,10.4Zm5.8-7,.4-.4-.6-.3.2-.6H19V1.5l-.6.2-.3-.6-.4.4-.4-.4-.3.6-.6-.2v.6h-.6l.2.6-.6.3.4.4-.4.4.6.3-.2.6h.6v.6l.6-.2.3.6.4-.4.4.4.3-.6.6.2V4.7h.6l-.2-.6.6-.3ZM17.7,4.7a.4.4,0,1,1,.4-.4A.4.4,0,0,1,17.7,4.7Zm.2-.9h-.4l-.2-1.7H18ZM7.5,3.2a1.1,1.1,0,0,0-1.4.6,1.1,1.1,0,0,0,.6,1.4A1.1,1.1,0,0,0,8,4.6,1.1,1.1,0,0,0,7.5,3.2ZM6.9,4.5A.4.4,0,0,1,6.7,4a.4.4,0,0,1,.5-.2.4.4,0,0,1,.2.5A.4.4,0,0,1,6.9,4.5ZM8.3,1.3A3.1,3.1,0,0,0,4.2,2.9,3.2,3.2,0,0,0,5.8,7,3.1,3.1,0,0,0,9.9,5.4,3.2,3.2,0,0,0,8.3,1.3Zm.4.4a3,3,0,0,1,.9,1.1l-1.4.7L7.8,3ZM4.1,4.5a3,3,0,0,1,0-.6H5.7a1,1,0,0,0,0,.3ZM5.4,6.6a3,3,0,0,1-.9-1.1l1.4-.7.4.5ZM6.6,5.3a1.2,1.2,0,0,1-.6-1.6A1.2,1.2,0,0,1,7.5,3a1.2,1.2,0,0,1,.6,1.6A1.2,1.2,0,0,1,6.6,5.3Zm1.8-1a1.3,1.3,0,0,0,0-.3L10,3.8a3,3,0,0,1,0,.6Z"/>
					<path d="M5.9,19V13.5l6.8,1.7v5.3Zm0,.5v2.7L12.6,24V21.1ZM9,12.5H7.6l.8.3,1.2-.3H9Zm1-1.6v1.3l.3-.5v-.2h0v-.2a1.9,1.9,0,0,0,0-.4v-.2H10Zm-4.3,1-2.2.5,2.4,1.2.8-.2A3.1,3.1,0,0,1,5.7,11.8Zm5.9-.5v.6h0l1.1-.3Zm-4.4.2H6.9a1.9,1.9,0,0,0,.4.7ZM17,12.5h-.2l-.4.2.9.2h0Zm.8-1.5h0Zm-3,1.1H15l-.5-.7.8-.8.7.5h.2v-.3l-1.9-.4-1.6,1.4,2.2.6Zm6.6-.2-2.3-.5-.5.7v.3h.8v.9Zm-8.7,9.2V24l6.8-1.7v-3Zm6.8-2.4V13.5l-6.8,1.7v5.3Z"/>
				</svg>
				<span class="vw-text">
					<fmt:message key="Sidebar_Store"/>
				</span>
			</a>
		</li>
		<!-- END:: SOFTWARE STORE -->
	</ul>
	
</c:if>
<!-- END:: NON-SINGLE USER COMMCELL. Worldwide and CommCell Group levels are available -->
<c:if test="${singleCommCellUser eq true}">
	<!-- BEGIN:: SECOND MENU:: COMMCELL -->
<c:if  test="${commUniId > 0 }">
	<ul class="nav vw-apps-list js-reports-apps">
		<c:set var="ccDBLink" value="${pageContext.request.contextPath}/survey/reports/dashboard.jsp?commUniId=${commUniId}"/>
		<c:set var="ccReportsLink" value="${pageContext.request.contextPath}/survey/reports/commcellmonitoring.jsp?commUniId=${commUniId}"/>
		<c:set var="ccHealthLink" value="${pageContext.request.contextPath}/health/health.jsp?commUniId=${commUniId}"/>
		<c:set var="ccProfileLink" value="${pageContext.request.contextPath}/survey/profile/profilecustdashboard.jsp?commUniId=${commUniId}"/>
		<c:if test="${not empty fn:escapeXml(param.ccGroupId) && fn:escapeXml(param.ccGroupId) > 0}">
			<c:set var="ccDBLink" value="${pageContext.request.contextPath}/survey/reports/dashboard.jsp?commUniId=${commUniId}&ccGroupId=${fn:escapeXml(param.ccGroupId)}"/>
			<c:set var="ccReportsLink" value="${pageContext.request.contextPath}/survey/reports/commcellmonitoring.jsp?commUniId=${commUniId}&ccGroupId=${fn:escapeXml(param.ccGroupId)}"/>
			<c:set var="ccHealthLink" value="${pageContext.request.contextPath}/health/health.jsp?commUniId=${commUniId}&ccGroupId=${fn:escapeXml(param.ccGroupId)}"/>
			<c:set var="ccProfileLink" value="${pageContext.request.contextPath}/survey/profile/profilecustdashboard.jsp?commUniId=${commUniId}&ccGroupId=${fn:escapeXml(param.ccGroupId)}"/>
		</c:if>
		<c:if test="${not empty fn:escapeXml(param.companyId) && fn:escapeXml(param.companyId) > 0}">
			<c:set var="ccDBLink" value="${pageContext.request.contextPath}/survey/reports/dashboard.jsp?commUniId=${commUniId}&companyId=${fn:escapeXml(param.companyId)}"/>
			<c:set var="ccReportsLink" value="${pageContext.request.contextPath}/survey/reports/commcellmonitoring.jsp?commUniId=${commUniId}&companyId=${fn:escapeXml(param.companyId)}"/>
			<c:set var="ccHealthLink" value="${pageContext.request.contextPath}/health/health.jsp?commUniId=${commUniId}&companyId=${fn:escapeXml(param.companyId)}"/>
			<c:set var="ccProfileLink" value="${pageContext.request.contextPath}/survey/profile/profilecustdashboard.jsp?commUniId=${commUniId}&companyId=${fn:escapeXml(param.companyId)}"/>
		</c:if>
		<li class="nav-sec-title nav-customer-title" title="${CommCellNameFull}">
			<span class="sec-title ${hideElement}">${CommCellName}</span>
		</li>
		<li id="dashboard" class="true" >
			<a href="${ccDBLink}" title= "${CommCellNameFull} 
				<fmt:message key="Dashboard" />">
				<svg
					xmlns="http://www.w3.org/2000/svg" width="23" height="23" viewBox="0 0 25 25">
					<path d="M15.79,14a.39.39,0,0,0-.39-.39H8a.49.49,0,0,0-.49.49V20a.61.61,0,0,0,.61.61h7.06a.61.61,0,0,0,.61-.61Z"/>
					<path d="M5.14,13.68h-2a.49.49,0,0,0-.49.49v6a.44.44,0,0,0,.44.44H5.18a.44.44,0,0,0,.44-.44v-6A.49.49,0,0,0,5.14,13.68Z"/>
					<rect x="17.67" y="4.54" width="4.7" height="16.12" rx="0.45" ry="0.45"/>
					<path d="M3,12.32H15.41a.36.36,0,0,0,.38-.33V5.12a.58.58,0,0,0-.58-.58h-12a.58.58,0,0,0-.58.58v6.74A.42.42,0,0,0,3,12.32Z"/>
				</svg>
				<span class="vw-text">
					<fmt:message key="Sidebar_Dashboard"/>
				</span>
			</a>
		</li>
		<li id="reports" class="true" >
			<a href="${ccReportsLink}" title="${CommCellNameFull} 
				<fmt:message key="Reports" />">
				<svg
					xmlns="http://www.w3.org/2000/svg"  width="23" height="23" viewBox="0 0 25 25">
					<rect  x="8.38" y="12.07" width="2.09" height="5.24"/>
					<rect  x="11.6" y="10.14" width="2.09" height="7.17"/>
					<rect  x="14.82" y="7.93" width="2.09" height="9.37"/>
					<path  d="M16.35,5.69,18,3.55a10.39,10.39,0,0,0-4.19-1.43v2.7A7.75,7.75,0,0,1,16.35,5.69Z"/>
					<path  d="M20.39,12.53a7.83,7.83,0,0,1-.17,1.62l2.4,1.38A10.46,10.46,0,0,0,19.26,4.45L17.64,6.59A7.79,7.79,0,0,1,20.39,12.53Z"/>
					<path  d="M12.58,20.34a7.8,7.8,0,0,1-.38-15.6V2.07A10.47,10.47,0,1,0,22,17l-2.32-1.33A7.8,7.8,0,0,1,12.58,20.34Z"/>
				</svg>
				<span class="vw-text">
					<fmt:message key="Sidebar_Reports" />
				</span>
			</a>
		</li>
		<li id="health" class="true" >
			<a href="${ccHealthLink}" class="health_icon" title="${CommCellNameFull} 
				<fmt:message key="Health" />">
				<svg
					xmlns="http://www.w3.org/2000/svg" width="23" height="23" viewBox="0 0 25 25">
					<path d="M20.21,6.54a4.53,4.53,0,0,0-6.41,0,4.25,4.25,0,0,0-.53.65,4.52,4.52,0,0,0-7.91,4.3H4.09a1.61,1.61,0,1,0,0,3.23h4v0c5,5,5.07,5.06,5.1,5.08l.09,0a.24.24,0,0,0,.16-.06l6.78-6.77A4.54,4.54,0,0,0,20.21,6.54Zm-1.59,7H14.68l-1.12-2.14-2.29,5.12-2.18-7-1.78,4H4.09a.47.47,0,1,1,0-.95H6.68L9.25,6.86l2.18,7,2.06-4.61,1.79,3.43h3.33a.47.47,0,1,1,0,.95Z"/>
				</svg>
				<span class="vw-text">
					<fmt:message key="Sidebar_Health"/>
				</span>
				<span class="healthStatusIcon ${requestScope.HealthStatus}"></span>
			</a>
		</li>
		<c:if test="${applicationScope.showProfileDashboard == true}">
			<li id="CommcellprofileTab" class="true hide" >
				<a href="${ccProfileLink}" title= "${CommCellNameFull} ${Profile}">
					<svg
						xmlns="http://www.w3.org/2000/svg" width="23" height="23" viewBox="0 0 25 25">
						<path  d="M8.75,18,12,16.11V12.4l3.9-2.23h0a1.64,1.64,0,0,0-.18-1.52V6.19s0,0,0-.07,0,0,0-.07V6h0a4,4,0,0,0-4.17-3.53A3.94,3.94,0,0,0,7.39,6.12s0,.08,0,.13V8.67a1.7,1.7,0,0,0,.18,2.16s.21.15.41.94a4.1,4.1,0,0,0,1.19,1.84,5.68,5.68,0,0,1,0,.66c-.28.59-1.5,1.13-2.82,1.55s-3.21.95-4,2.72-.36,3-.21,3.09c.42.33,3.39.81,5.79.94.56,0,1.16.08,1.78.1l-1-.53Z"/>
						<polygon  points="9.84 18.46 12.65 16.81 15.51 18.46 15.51 21.71 12.65 23.37 9.84 21.71 9.84 18.46"/>
						<polygon  points="13.03 12.92 15.83 11.27 18.7 12.92 18.7 16.17 15.83 17.83 13.03 16.17 13.03 12.92"/>
						<polygon  points="16.28 18.46 19.08 16.81 21.95 18.46 21.95 21.71 19.08 23.37 16.28 21.71 16.28 18.46"/>
					</svg>
					<span class="vw-text">${Profile}</span>
				</a>
			</li>
		</c:if>
		<c:if test="${singleCommCellUser == 'true'}">
			<c:if test="${surveyEnabled == 'true'}">
				<li id="Commcells" class="true">
					<a href="<%=(request.getContextPath())%>/survey/reports/monitoringform.jsp" title="
						<fmt:message key="CommCells" />">
						<svg
							xmlns="http://www.w3.org/2000/svg"  width="23" height="23" viewBox="0 0 25 25">
							<polygon  points="1.99 14.49 6.86 11.62 11.84 14.49 11.84 20.13 6.86 23.01 1.99 20.13 1.99 14.49"/>
							<polygon  points="7.52 4.87 12.39 1.99 17.37 4.87 17.37 10.51 12.39 13.38 7.52 10.51 7.52 4.87"/>
							<polygon  points="13.16 14.49 18.03 11.62 23.01 14.49 23.01 20.13 18.03 23.01 13.16 20.13 13.16 14.49"/>
						</svg>
						<span class="vw-text">
							<fmt:message key="Sidebar_CommCells"/> ${sessionScope.WWCommCellsCountStr}
						</span>
					</a>
				</li>
			</c:if>
			<li id="reportsManager" class="true" >
				<a  title="
					<fmt:message key="RM_Configuration" />">
					<svg
						xmlns="http://www.w3.org/2000/svg" width="23" height="23" viewBox="0 0 25 25">
						<path d="M21.2,19.08a3.43,3.43,0,0,0,0-.46,3,3,0,0,0,0-.42l1.27-.78L22,16.32l-1.37.41a3.34,3.34,0,0,0-.71-.73l.34-1.42-1.12-.45-.67,1.26a3.33,3.33,0,0,0-.52,0,3.24,3.24,0,0,0-.61.06l-.75-1.22-1.11.48.42,1.4a3.32,3.32,0,0,0-.58.59L13.9,16.3l-.45,1.12,1.26.67a3.25,3.25,0,0,0,0,.52,3.19,3.19,0,0,0,.05.56l-1.22.75L14,21l1.38-.41a3.31,3.31,0,0,0,.71.68l-.32,1.36,1.12.45.66-1.23a3.2,3.2,0,0,0,1.09,0l.75,1.21,1.11-.48L20,21.17a3.33,3.33,0,0,0,.58-.61l1.43.34.45-1.12ZM18,19.89a1.27,1.27,0,1,1,1.28-1.27A1.28,1.28,0,0,1,18,19.89Z"/>
						<polygon points="12.49 1.78 12.49 8.11 18.82 8.11 12.49 1.78"/>
						<path d="M12.13,8.81a.35.35,0,0,1-.35-.35V1.78H5.45a.7.7,0,0,0-.71.71V20.77a.7.7,0,0,0,.71.71h7.33a5.91,5.91,0,0,1,.56-6.56l1-1a5.79,5.79,0,0,1,4.44-1.15v-4Zm-.35,6.42H7.45a.5.5,0,1,1,0-1h4.33a.5.5,0,0,1,0,1Zm3.37-3.67H7.39a.5.5,0,1,1,0-1h7.76a.5.5,0,0,1,0,1Z"/>
					</svg>
					<span class="vw-text">
						<fmt:message key="Sidebar_Configuration"/>
					</span>
					<span class="arrow-right ${hideElement}"
						style="visibility: visible;"></span>
				</a>
				<nav class="vw-side-sub-nav vw-side-sub-nav-adjusted ${subNavSmaller}"
							id="reportsManagerSubNav">
					<c:set var="isReportAdmin" value='false' scope="page" />
					<cv:reportsTag name="adminRight" id="999">
						<c:set var="isReportAdmin" value='true' scope="page" />
					</cv:reportsTag>
					<c:set var="cellAdminUser" value='false' scope="page" />
					<cv:reportsTag name="cellAdministrativeRight" id="999">
						<c:set var="cellAdminUser" value='true' scope="page" />
					</cv:reportsTag>
					<ul class="nav sub-vw-apps-list">
						<cv:reportsTag name="Reports.ManageReports" id="888">
							<li id="reportMgrLi" class="true settingHeaderLi "
										data-div="customReports">
								<a href="#" title="
									<fmt:message key="Sidebar_Reports" />">
									<svg
										xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25">
										<path d="M15.94,7.63H20L14.83,2.42v.44h0V6.52A1.11,1.11,0,0,0,15.94,7.63Z"/>
										<path d="M13.67,20.5l-.26.26-.08.12-1,2.86a.32.32,0,0,0,.3.42l.1,0,2.86-1,.12-.08.23-.23Z"/>
										<polygon points="18.85 15.33 14.26 19.91 16.62 22.26 21.21 17.69 18.85 15.33"/>
										<path d="M22.93,14.6l-1-1a1,1,0,0,0-1.35,0l-1.32,1.35,2.31,2.25L22.93,16a1,1,0,0,0,0-1.35Zm-2.72.26"/>
										<path d="M20.6,8.63H15.94a2.11,2.11,0,0,1-2.11-2.11V1.86l-.11-.11h-8A1.61,1.61,0,0,0,4.07,3.36V21.08a1.61,1.61,0,0,0,1.61,1.61h3.2l5.27-5.27V9.89h1.73v5.8l4.76-4.76V8.67Zm-10,9H8.83V13.3h1.73Zm2.65,0H11.49V11.71h1.73Z"/>
									</svg>
									<span class="vw-text-sub">
										<fmt:message key="Sidebar_Reports"/>
									</span>
								</a>
							</li>
							<c:if test = "${applicationScope.METRICS_INSTALLED == null or applicationScope.METRICS_INSTALLED == false}">
								<li id="tilesMgrLi" class="true settingHeaderLi " data-div="Tiles">
									<a href="#" title="
										<fmt:message key="Sidebar_Health_Tiles" />">
										<svg
											xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25">
											<path d="M11.3,4.5v8.3H3V4.5ZM3,22.1h8.3V13.8H3Zm17.6,0V13.8H12.3v8.3ZM16,3,13.9,9.9,20.8,12l2.1-6.9Z"/>
										</svg>
										<span class="vw-text-sub">
											<fmt:message key="Sidebar_Health_Tiles"/>
										</span>
									</a>
								</li>
							</c:if>
						</cv:reportsTag>
						<cv:reportsTag name="Reports.ManageReports" id="888">
							<li id="dataSetMgrLi" class="true settingHeaderLi "
										data-div="Datasets">
								<a href="#" title="
									<fmt:message key="Sidebar_Dataset" />">
									<svg
										xmlns="http://www.w3.org/2000/svg" viewBox="0 0 25 25" width="20" height="20">
										<path d="M 9.63 8.5 a 13.48 13.48 0 0 1 -4.94 -0.81 A 4.73 4.73 0 0 1 2.8 6.48 a 1.88 1.88 0 0 1 0 -2.74 A 5.37 5.37 0 0 1 5.15 2.42 a 15.05 15.05 0 0 1 6.24 -0.57 a 10.51 10.51 0 0 1 3.76 1 a 5.34 5.34 0 0 1 1.26 0.89 a 1.89 1.89 0 0 1 0 2.83 a 4.89 4.89 0 0 1 -1.67 1.06 a 12.83 12.83 0 0 1 -4.47 0.87 Z" />
										<path d="M 17 7 c 0 1 0 1.94 0 2.86 a 1.74 1.74 0 0 1 -0.48 0.89 a 5.09 5.09 0 0 1 -2.12 1.35 a 12.78 12.78 0 0 1 -4.32 0.81 a 13.85 13.85 0 0 1 -4.56 -0.57 a 6.3 6.3 0 0 1 -2.76 -1.53 a 1.77 1.77 0 0 1 -0.56 -1.41 c 0 -0.78 0 -1.56 0 -2.4 l 0.26 0.23 a 7.26 7.26 0 0 0 3 1.57 a 14.88 14.88 0 0 0 8.84 -0.18 A 6.62 6.62 0 0 0 17 7 Z" />
										<path d="M 17 11.34 V 13.6 a 8.7 8.7 0 0 0 -1.17 0.14 a 4.29 4.29 0 0 0 -3 3 c -0.06 0.17 -0.13 0.25 -0.28 0.28 a 14.4 14.4 0 0 1 -7.61 -0.52 a 5.42 5.42 0 0 1 -2.18 -1.35 a 1.76 1.76 0 0 1 -0.52 -1.37 c 0 -0.78 0 -1.57 0 -2.42 a 6.69 6.69 0 0 0 2.44 1.54 a 13.11 13.11 0 0 0 4.24 0.83 a 14.31 14.31 0 0 0 5.52 -0.76 A 6.79 6.79 0 0 0 17 11.34 Z" />
										<path d="M 2.23 15.7 a 8.63 8.63 0 0 0 4.7 2.14 a 15.28 15.28 0 0 0 5.34 0 l 0.23 0 a 15.27 15.27 0 0 0 0.16 1.69 a 14.41 14.41 0 0 0 0.51 1.6 c -0.33 0.06 -0.7 0.15 -1.08 0.2 A 16.22 16.22 0 0 1 5.63 21 a 6.63 6.63 0 0 1 -2.4 -1.12 a 2.26 2.26 0 0 1 -1 -1.57 c 0 -0.4 0 -0.82 0 -1.23 S 2.23 16.18 2.23 15.7 Z" />
										<path d="M 21.51 19.25 a 3.43 3.43 0 0 0 0 -0.46 a 3 3 0 0 0 0 -0.42 l 1.27 -0.78 l -0.47 -1.1 l -1.37 0.41 a 3.34 3.34 0 0 0 -0.71 -0.73 l 0.34 -1.42 l -1.12 -0.45 l -0.67 1.26 a 3.33 3.33 0 0 0 -0.52 0 a 3.24 3.24 0 0 0 -0.61 0.06 L 16.9 14.4 l -1.11 0.48 l 0.42 1.4 a 3.32 3.32 0 0 0 -0.58 0.59 l -1.42 -0.4 l -0.45 1.12 l 1.26 0.67 a 3.25 3.25 0 0 0 0 0.52 a 3.19 3.19 0 0 0 0.05 0.56 l -1.22 0.75 l 0.46 1.08 l 1.38 -0.41 a 3.31 3.31 0 0 0 0.71 0.68 l -0.32 1.36 l 1.12 0.45 L 17.86 22 A 3.2 3.2 0 0 0 19 22 l 0.75 1.21 l 1.11 -0.48 l -0.5 -1.41 a 3.33 3.33 0 0 0 0.58 -0.61 l 1.43 0.34 l 0.45 -1.12 Z m -3.2 0.81 a 1.27 1.27 0 1 1 1.28 -1.27 A 1.27 1.27 0 0 1 18.31 20.06 Z" />
									</svg>
									<span class="vw-text-sub">
										<fmt:message key="Sidebar_Dataset"/>
									</span>
								</a>
							</li>
						</cv:reportsTag>
						<li id="dataSetMgrLi" class="true settingHeaderLi "
									data-div="CustomDashboards">
							<a href="#" title="
								<fmt:message key="Sidebar_CustomDashboards" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25">
									<path d="M13.92,16.76l-.25.25-.08.11-.95,2.73a.31.31,0,0,0,.19.38l.1,0H13l2.72-.95.12-.08.22-.22Z"></path>
									<polygon points="18.85 11.84 14.48 16.2 16.73 18.44 21.09 14.09 18.85 11.84"></polygon>
									<path d="M22.73,11.15l-.95-1a1,1,0,0,0-1.28,0l-1.26,1.29,2.2,2.14,1.29-1.14a.94.94,0,0,0,0-1.29Z"></path>
									<path d="M4.15,12.89H2.28a.45.45,0,0,0-.46.46V19a.41.41,0,0,0,.41.41h2A.41.41,0,0,0,4.6,19V13.35A.46.46,0,0,0,4.15,12.89Z"></path>
									<path d="M20.32,4.74a.43.43,0,0,0-.43-.43H16.33a.42.42,0,0,0-.42.43v7.57l4.41-4.37Z"></path>
									<path d="M2.14,11.61H13.79a.33.33,0,0,0,.35-.31V4.86a.55.55,0,0,0-.54-.55H2.34a.55.55,0,0,0-.54.55v6.32A.38.38,0,0,0,2.14,11.61Z"></path>
									<path d="M14.14,13.19a.37.37,0,0,0-.36-.37H6.83a.47.47,0,0,0-.46.46v5.54a.58.58,0,0,0,.58.57H8.77l5.37-5.33Z"></path>
								</svg>
								<span class="vw-text-sub">
									<fmt:message key="Sidebar_CustomDashboards" />
								</span>
							</a>
						</li>
						<c:if test="${applicationScope.isPublicMetricsCloud == null or applicationScope.isPublicMetricsCloud == false}">
							<c:if test = "${(applicationScope.METRICS_INSTALLED == 'true' && isReportAdmin== 'true') || cellAdminUser == 'true'}">
								<li id="reportSettingsLi" class="true settingHeaderLi "
												data-div="reportSettings">
									<a href="#" title="
										<fmt:message key="Sidebar_Metrics_Reports" />">
										<svg
											xmlns="http://www.w3.org/2000/svg" viewBox="0 0 25 25" width="20" height="20">
											<path d="M 12.9 14.45 l -0.56 -0.28 a 4.1 4.1 0 0 0 -0.52 -0.2 l -0.28 -2 H 9.91 l -0.24 1.91 a 4.5 4.5 0 0 0 -1.27 0.48 L 6.8 13.18 L 5.65 14.34 l 1.2 1.51 l -0.32 0.6 l -0.24 0.8 l -1.91 0.28 v 1.59 l 2 0.24 a 4.46 4.46 0 0 0 0.4 1 L 5.53 22 l 1.12 1.15 l 1.51 -1.2 a 4.38 4.38 0 0 0 0.64 0.36 a 4.3 4.3 0 0 0 0.72 0.24 l 0.24 1.91 h 1.63 l 0.24 -1.91 A 4.46 4.46 0 0 0 12.87 22 l 1.48 1.15 L 15.5 22 l -1.16 -1.47 l 0.28 -0.52 l 0.28 -0.84 l 1.91 -0.28 V 17.27 l -2 -0.24 a 4.51 4.51 0 0 0 -0.44 -1 l 1.19 -1.59 l -1.16 -1.15 Z m -1.23 1.28 A 2.71 2.71 0 0 1 13 19.27 a 2.67 2.67 0 1 1 -1.36 -3.54 Z" />
											<path d="M 16.6 5.88 l -0.36 -1.47 L 15 4.53 V 6 a 3.39 3.39 0 0 0 -0.92 0.44 l -1.28 -0.8 l -0.8 0.92 l 1 1.07 l -0.28 0.52 l -0.16 0.6 L 11.22 9 l 0.08 1.24 h 1.47 a 3.38 3.38 0 0 0 0.4 0.76 l -0.8 1.28 l 0.92 0.8 l 1.07 -1 l 0.52 0.24 a 3.23 3.23 0 0 0 0.56 0.12 l 0.32 1.43 L 17 13.81 V 12.33 a 3.35 3.35 0 0 0 0.88 -0.48 l 1.2 0.76 l 0.8 -0.92 l -1 -1 l 0.16 -0.4 l 0.16 -0.64 l 1.39 -0.32 l -0.08 -1.24 H 19.07 a 3.38 3.38 0 0 0 -0.4 -0.76 L 19.47 6 l -0.92 -0.8 l -1.11 1 L 17 6 Z m 0 1.34 h 0 A 2 2 0 1 1 14 8.53 A 2 2 0 0 1 16.6 7.23 Z" />
											<path d="M 9.66 1.9 L 9.54 0.63 L 8.5 0.55 l -0.2 1.2 A 2.87 2.87 0 0 0 7.47 2 l -1 -0.8 l -0.76 0.68 l 0.72 1 l -0.24 0.36 L 6 3.74 L 4.8 3.86 l -0.08 1 L 6 5.09 l 0.24 0.68 l -0.8 1 l 0.72 0.8 l 1 -0.72 l 0.4 0.24 A 2.71 2.71 0 0 0 8 7.2 l 0.12 1.24 l 1 0.08 l 0.2 -1.2 a 2.83 2.83 0 0 0 0.8 -0.28 L 11 7.8 l 0.76 -0.68 l -0.64 -1 l 0.2 -0.32 l 0.2 -0.52 l 1.24 -0.12 l 0.08 -1 l -1.24 -0.2 l -0.24 -0.68 l 0.8 -1 l -0.68 -0.76 l -1.12 0.68 L 10 2 Z M 9.54 3 a 1.71 1.71 0 0 1 0.76 2.3 h 0 A 1.71 1.71 0 1 1 9.54 3 Z" />
										</svg>
										<span class="vw-text-sub">
											<fmt:message key="Sidebar_Metrics_Reports" />
										</span>
									</a>
								</li>
							</c:if>
						</c:if>
						<cv:reportsTag name="Reports.ManageDataSources" id="888">
							<li id="generalLi" class="true settingHeaderLi "
											data-div="managedDataSources">
								<a href="#" title="
									<fmt:message key="Sidebar_DataSources" />">
									<svg
										xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25">
										<ellipse  cx="6.67" cy="7.94" rx="4.35" ry="0.97"/>
										<path  d="M6.67,9.27c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1S11,11,11,10.49V8.3C11,8.83,9.08,9.27,6.67,9.27Z"/>
										<ellipse  cx="17.55" cy="2.26" rx="4.35" ry="0.97"/>
										<path  d="M17.55,3.6c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V2.62C21.9,3.16,20,3.6,17.55,3.6Z"/>
										<path  d="M17.55,6.18c-2.4,0-4.35-.44-4.35-1V7.4c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V5.2C21.9,5.74,20,6.18,17.55,6.18Z"/>
										<path  d="M17.55,8.76c-2.4,0-4.35-.44-4.35-1V10c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V7.79C21.9,8.32,20,8.76,17.55,8.76Z"/>
										<path  d="M9.63,12.06c0-.27.53-.51,1.39-.69v-.49c0,.54-1.95,1-4.35,1s-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1a15.06,15.06,0,0,0,3-.26V12.06Z"/>
										<path  d="M9.63,14.62v-.45a15.06,15.06,0,0,1-3,.26c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1a15.06,15.06,0,0,0,3-.26V14.62Z"/>
										<path  d="M9.63,17.26v-.45a15.06,15.06,0,0,1-3,.26c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1a15.06,15.06,0,0,0,3-.26V17.26Z"/>
										<path  d="M14.69,11.09c-.91-.18-1.49-.44-1.49-.73v.75c.37,0,.74,0,1.14,0Z"/>
										<path  d="M19,12.06v1.41c1.66-.14,2.86-.49,2.86-.91v-2.2c0,.54-1.95,1-4.35,1h-.09C18.42,11.52,19,11.77,19,12.06Z"/>
										<path  d="M19,15v1.1c1.66-.14,2.86-.49,2.86-.91V13c0,.42-1.19.77-2.86.91V15Z"/>
										<ellipse  cx="14.44" cy="12.43" rx="4.35" ry="0.97"/>
										<path  d="M14.44,13.76c-2.4,0-4.35-.44-4.35-1V15c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1v-2.2C18.79,13.33,16.84,13.76,14.44,13.76Z"/>
										<path  d="M14.44,16.35c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1v-2.2C18.79,15.91,16.84,16.35,14.44,16.35Z"/>
										<path  d="M14.44,18.93c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1V18C18.79,18.49,16.84,18.93,14.44,18.93Z"/>
										<path  d="M14.44,21.51c-2.4,0-4.35-.44-4.35-1v2.2c0,.54,1.95,1,4.35,1s4.35-.44,4.35-1v-2.2C18.79,21.07,16.84,21.51,14.44,21.51Z"/>
									</svg>
									<span class="vw-text-sub">
										<fmt:message key="Sidebar_DataSources" />
									</span>
								</a>
							</li>
						</cv:reportsTag>
						<li id="alarmsLi" class="true settingHeaderLi "
									data-div="alarmsSettings">
							<a href="#" title="
								<fmt:message key="Sidebar_Alerts" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25">
									<path d="M15.74,19.89l-.4.09a12.07,12.07,0,0,1-5.4,0l-.4-.09s.05,1.13.07,1.17a3.23,3.23,0,0,0,3,2h0a3.23,3.23,0,0,0,3.09-2.19S15.74,19.89,15.74,19.89Z"/>
									<path d="M20,15.29a8.34,8.34,0,0,1-2.21-5.52V9.3c0-3.2-.68-5.29-3.65-6a1.25,1.25,0,0,0-1.24-1.48h-.89a1.25,1.25,0,0,0-1.24,1.48c-3,.75-3.65,2.84-3.65,6v.47A8.34,8.34,0,0,1,5,15.29a1.31,1.31,0,0,0-.41.77c0,1.18.74,1.61,2.13,2.13h0a19.35,19.35,0,0,0,5.83.9,19.35,19.35,0,0,0,5.83-.9h0c1.39-.52,2.13-1,2.13-2.13A1.31,1.31,0,0,0,20,15.29Z"/>
								</svg>
								<span class="vw-text-sub">
									<fmt:message key="Sidebar_Alerts" />
								</span>
							</a>
						</li>
						<li id="schedulesLi" class="true settingHeaderLi "
									data-div="scheduleSettings">
							<a href="#" title="
								<fmt:message key="Sidebar_Schedules" />">
								<svg
									xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 25 25.3">
									<rect x="6.26" y="4.56" width="1.79" height="1.79"/>
									<rect x="16.89" y="4.56" width="1.79" height="1.79"/>
									<path d="M19.73,4.53H19.3V6.25a.74.74,0,0,1-.74.74H17a.74.74,0,0,1-.74-.74V4.53H8.65V6.25A.74.74,0,0,1,7.92,7H6.37a.74.74,0,0,1-.74-.74V4.53H5.27A1.62,1.62,0,0,0,3.65,6.15V19.79a1.62,1.62,0,0,0,1.62,1.62H19.73a1.62,1.62,0,0,0,1.62-1.62V6.15A1.62,1.62,0,0,0,19.73,4.53ZM19.3,18.91a.87.87,0,0,1-.87.87H6.5a.87.87,0,0,1-.87-.87V10a.87.87,0,0,1,.87-.87H18.43a.87.87,0,0,1,.87.87Z"/>
									<rect x="6.76" y="11.14" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
									<rect x="11.18" y="11.14" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
									<rect x="15.61" y="11.14" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
									<rect x="6.76" y="15.3" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
									<rect x="11.18" y="15.3" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
									<rect x="15.61" y="15.3" width="2.56" height="2.56" rx="0.75" ry="0.75"/>
								</svg>
								<span class="vw-text-sub">
									<fmt:message	key="Sidebar_Schedules" />
								</span>
							</a>
						</li>
					</ul>
				</nav>
			</li>
			<cv:secureTag name="Software Store" id="51">
				<li id="appStoreLink" class="true" >
					<a  title="
						<fmt:message key="Sidebar_Store_Title" />">
						<svg
							xmlns="http://www.w3.org/2000/svg" width="23" height="23" viewBox="0 0 25 25">
							<path d="M14.5,15.1l-1-.6h-.3v.2h0l-1.4-.9-.2-.2h-.5l.2.2h.3l1.5.9h.1v.2h.2l1,.6h.3a.3.3,0,0,0,.1-.2A.3.3,0,0,0,14.5,15.1Zm-.2.4h0l-1-.6h0l1,.6Zm.1-.1h-.1l-.9-.6h0l.9.6Zm.1-.2h0l-1-.6h0l1,.6Z"/>
							<path d="M8.1,12.3H7.5V10.9h.6ZM9.7,9.1l.4-.6L9,8.2v.7Zm-.7,3.1H8.4V10.3h.6ZM10.7,11a2.1,2.1,0,0,1,0,.4l.6.4a2.8,2.8,0,0,0-.9-3l-.4.6A2.1,2.1,0,0,1,10.7,11Zm-.9,1.3H9.2V9.7h.6Zm-1.2.8a2.1,2.1,0,0,1-.1-4.2V8.2a2.8,2.8,0,1,0,2.6,4l-.6-.4A2.1,2.1,0,0,1,8.7,13.1Zm9.7.9v-.5h.8v-.7h-.8l-.2-.5.5-.7-.5-.5-.6.5h-.6v-.8h-.7v.8l-.4.2-.7-.5-.5.5.5.6v.6h-.8v.7H15l.2.5-.5.6.5.5.6-.5h.6v.8h.7v-.8l.4-.2.7.5.5-.5Zm-1.9-.3a.7.7,0,0,1-.4-1,.7.7,0,0,1,1-.4.7.7,0,0,1,.4,1A.7.7,0,0,1,16.5,13.7Zm2.3-4.2h-.3V8.6h.3Zm.9-1.8.2-.3-.6-.2v.4Zm-.4,1.8H19V8.4h.3Zm1-.7V9l.4.2a1.6,1.6,0,0,0-.5-1.7l-.2.3A1.2,1.2,0,0,1,20.3,8.7Zm-.5.7h-.3V8h.3Zm-.6.5a1.2,1.2,0,0,1-.1-2.4V7.1a1.6,1.6,0,1,0,1.5,2.3l-.3-.2A1.2,1.2,0,0,1,19.1,9.9Zm-5.4-3h.5V6.2h-.4V5.9l.2-.4-.3-.2-.3.3H13V5.1h-.3v.4h-.2L12,5.5l-.2.3.3.3H12v.2h-.4v.4H12V7l-.2.3.3.2.3-.3h.3v.4h.3V7.4h.2l.4.2.2-.3Zm-1-.1a.4.4,0,0,1-.2-.5.4.4,0,0,1,.5-.2.4.4,0,0,1,.2.5A.4.4,0,0,1,12.8,6.8Zm0,4.3a.7.7,0,0,0,.9-.8.3.3,0,0,1,.1-.3l1.7-1.7h.3a.7.7,0,0,0,.7-.9l-.5.5-.6-.6.5-.5a.7.7,0,0,0-.9.8.3.3,0,0,1-.1.3L13.3,9.6l-.4.2a.7.7,0,0,0-.7.9l.5-.6.6.6Zm.9-.8a.3.3,0,0,1,.1-.3l1.7-1.7h.3a.7.7,0,0,0,.7-.9l-.5.5-.6-.6.5-.5a.7.7,0,0,0-.9.8.3.3,0,0,1-.1.3L13.3,9.6l-.4.2a.7.7,0,0,0-.7.9l.5-.6.6.6-.5.5A.7.7,0,0,0,13.7,10.4Zm5.8-7,.4-.4-.6-.3.2-.6H19V1.5l-.6.2-.3-.6-.4.4-.4-.4-.3.6-.6-.2v.6h-.6l.2.6-.6.3.4.4-.4.4.6.3-.2.6h.6v.6l.6-.2.3.6.4-.4.4.4.3-.6.6.2V4.7h.6l-.2-.6.6-.3ZM17.7,4.7a.4.4,0,1,1,.4-.4A.4.4,0,0,1,17.7,4.7Zm.2-.9h-.4l-.2-1.7H18ZM7.5,3.2a1.1,1.1,0,0,0-1.4.6,1.1,1.1,0,0,0,.6,1.4A1.1,1.1,0,0,0,8,4.6,1.1,1.1,0,0,0,7.5,3.2ZM6.9,4.5A.4.4,0,0,1,6.7,4a.4.4,0,0,1,.5-.2.4.4,0,0,1,.2.5A.4.4,0,0,1,6.9,4.5ZM8.3,1.3A3.1,3.1,0,0,0,4.2,2.9,3.2,3.2,0,0,0,5.8,7,3.1,3.1,0,0,0,9.9,5.4,3.2,3.2,0,0,0,8.3,1.3Zm.4.4a3,3,0,0,1,.9,1.1l-1.4.7L7.8,3ZM4.1,4.5a3,3,0,0,1,0-.6H5.7a1,1,0,0,0,0,.3ZM5.4,6.6a3,3,0,0,1-.9-1.1l1.4-.7.4.5ZM6.6,5.3a1.2,1.2,0,0,1-.6-1.6A1.2,1.2,0,0,1,7.5,3a1.2,1.2,0,0,1,.6,1.6A1.2,1.2,0,0,1,6.6,5.3Zm1.8-1a1.3,1.3,0,0,0,0-.3L10,3.8a3,3,0,0,1,0,.6Z"/>
							<path d="M5.9,19V13.5l6.8,1.7v5.3Zm0,.5v2.7L12.6,24V21.1ZM9,12.5H7.6l.8.3,1.2-.3H9Zm1-1.6v1.3l.3-.5v-.2h0v-.2a1.9,1.9,0,0,0,0-.4v-.2H10Zm-4.3,1-2.2.5,2.4,1.2.8-.2A3.1,3.1,0,0,1,5.7,11.8Zm5.9-.5v.6h0l1.1-.3Zm-4.4.2H6.9a1.9,1.9,0,0,0,.4.7ZM17,12.5h-.2l-.4.2.9.2h0Zm.8-1.5h0Zm-3,1.1H15l-.5-.7.8-.8.7.5h.2v-.3l-1.9-.4-1.6,1.4,2.2.6Zm6.6-.2-2.3-.5-.5.7v.3h.8v.9Zm-8.7,9.2V24l6.8-1.7v-3Zm6.8-2.4V13.5l-6.8,1.7v5.3Z"/>
						</svg>
						<span class="vw-text">
							<fmt:message key="Sidebar_Store"/>
						</span>
					</a>
				</li>
			</cv:secureTag>
		</c:if>
	</ul>
</c:if>
<!-- END:: SECOND MENU:: COMMCELL -->
</c:if>

</nav>
</fmt:bundle>
