<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>

<fmt:bundle basename="localization.ReportsMessages">

<c:set var="paramId" value="${fn:escapeXml(param.id)}" />

<div id="${paramId}" comp="${paramId}" data-component-type="METRICS_TABLE" class="clearFloat reportTable reportView ${paramId}_table">
				<h1>
				<c:if test="${param.collapsible == null || param.collapsible == 'true' }">
					<div class="arrowPlaceholder expand"></div>
				</c:if>
				<span id="${paramId}_title" class="reportstabletitle">${fn:escapeXml(param.tabletitle)}</span></h1>
				<div class="rptTblBtnEncDiv">
					<div id="${paramId}_holder" class="columnEditor dynamicDropDown hideOnExportFriendly">
							<input id="${paramId}_Button" class="AddorRemoveCols " type="button"	value="" title="<fmt:message key="AddRemoveCols"/>" />
								<ul id="${paramId}_Colums" class="reportColums_container"></ul>
					</div>
						<div id="${paramId}_Filter" class="reports_Filter hideOnExportFriendly">
								<input id="${paramId}_FilterButton" class="tableFilter" type="button" value=""  title="<fmt:message key="Filter_Cols"/>" />
								<input type="hidden" id="${paramId}_FilterSelected" />
						</div>
						<c:if test="${param.enableTableExcel != null && param.enableTableExcel == 'true' }">
							<div id='${paramId}_ExportExcel' class='reports_ExportExcel hideOnExportFriendly'>
								<input id='${paramId}_ExportExcelButton' class='tableExportExcel' type='button' value='' title='Export to CSV' />
							</div>
						</c:if>
						<c:if test="${param.enableAlarm != null && param.enableAlarm == 'true' }">
							<div id='${paramId}_Alarm' class='reports_Alarm hideOnExportFriendly'>
								<input id='${paramId}_AlarmButton' class='tableAlarm ' type='button' value='' title='Add Alert' />
							</div>
						</c:if>
						<c:if test="${param.enableTableExcel != null && param.enableTableExcel == 'true' }">
							<fmt:bundle basename="localization.ReportsPlusMessages">
								<div id='${paramId}_api' class='reports_api hideOnExportFriendly'>
										<input id='${paramId}_apiButton' class='tableApi' type='button' value='' title='<fmt:message key="DataSet.Preview.RESTAPI" />' />
								</div>
							</fmt:bundle>
						</c:if>
				</div>
				<c:if test="${param.filearchiver != null && param.filearchiver == 'true' }">
					<div>
						<ul class="horizontalList">
							<li>
								<div id="recalculateCostChk" class="custom-cb" data-state="unchecked"></div>
								<span class="custom-cb-label" >Recalculate cost using </span>
							</li>
						</ul>
						<input type="text" id="costTxt" value="0" style="width :50px;"/>per
						<select id="costPerSizeUnit">
							<option value="0">BYTES</option>
							<option value="1">KB</option>
							<option value="2">MB</option>
							<option value="3">GB</option>
							<option value="4">TB</option>
							<option value="5">PB</option>
						</select>
						<input id="btnSaveChanges" type="button" value="Apply" >
						<input id="btnReset" type="button" value="Reset" >
					</div>
				</c:if>

				<table id="${paramId}_table" class="display"></table>
				<div class="clearFloat"></div>
</div>

</fmt:bundle>

<!--
<table cellpadding="0" cellspacing="0" border="0" class="display" id="example">
	<thead>
		<tr>
			<c:forEach items="${client.contents}" var="item">
								<th width="20%" min-width="10px">columnName</th>
			</c:forEach>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td colspan="5" class="dataTables_empty">Loading data from server</td>
		</tr>
	</tbody>
	<tfoot>
		<tr>
		<c:forEach items="${client.contents}" var="item">
								<th></th>
		</c:forEach>
		</tr>
	</tfoot>
</table>
 -->
