<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>

<fmt:bundle basename="localization.ReportsPlusMessages">
	<jsp:include page="../common/header.jsp">
		<jsp:param value="true" name="includeMask" />
		<jsp:param value="" name="titleLocalized" />
		<jsp:param value="dialog" name="displayMode" />
		<jsp:param value="${pageContext.request.contextPath}/common/bootstrap/css/bootstrap.min.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reports/css/schedule.css" name="css" />
		<jsp:param value="${pageContext.request.contextPath}/reportsplus/css/common.css" name="css" />
	</jsp:include>

	<fmt:bundle basename="localization.ReportsJSMessages">
		<fmt:message key="Copied_To_ClipBoard" var="copiedToClipBoard"/>
	</fmt:bundle>

	<div id="restApiModal" class="rest-api-modal">
		<div class="rest-api-container">
			<code id="restApiCode"> </code>
			<button id="copyToClipBoard"
				class="btn btn-default btn-sm copy-clipboard-button-rest-api">
				<span class='sprite icon-reports rest-api-sprite'></span> <span
					class="rest-api-button-text"><fmt:message
						key="CustomReport.Component.CopyToClipboard" /></span>
			</button>
		</div>
		<fmt:bundle basename="localization.messages">
			<div class="btns rghtFloat">
				<a href="#" id="okButton" class="okSaveButton"><fmt:message
						key="common.action.close" /></a>
			</div>
		</fmt:bundle>
	</div>

<script nonce="${sessionScope.cspNonce}">
	var localMsg = localMsg || {};
	localMsg.copiedToClipBoard = "${copiedToClipBoard}";

	(function() {
		var data = cvUtil.getInitModalData();
		$("#restApiCode").text(data.restApiUrl);

		$("#copyToClipBoard").click(function() {
			copyRestApiUrlToClipboard();
		});

		$("#okButton").click(function(e) {
			cvUtil.closeModal();
			e.preventDefault();
		});

		function copyRestApiUrlToClipboard() {
			var el = document.createElement('textarea');
			el.value = data.restApiUrl;
			document.body.appendChild(el);
			el.select();
			document.execCommand('copy');
			document.body.removeChild(el);
			cvUtil.getTopWindow().cvUtil.toast(cvUtil.cvLocalize('copiedToClipBoard'), 1000, null, false);
		}
	})();

</script>

</fmt:bundle>