<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>
<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib uri="../WEB-INF/cvtaglib.tld" prefix="cv" %>
<jsp:include page="../common/header.jsp">
	<jsp:param name="title" value="report.resubmitJob"/>
	<jsp:param name="css" value="${pageContext.request.contextPath}/common/css/error.css"/>
	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css" />
	<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />
	<jsp:param name="bootstrapped" value="true"/>
</jsp:include>
<style>
.pglinks{
	display:block;
}
.resubmit-job-container{
	text-align:center;
	padding-top:30px;
}
.modal-dialog{
	margin-top:50px;
	width:450px;
}
.modal-body{
	padding-top: 38px;
    padding-bottom: 38px;
}
.modal-header{
	font-weight: bold;
	color: #069;
	padding-top: 12px;
    padding-bottom: 12px;
}

</style>
<div class="${cssClass}">
	<c:out value="${requestScope.message }" />
</div>

<div id="confirmation-modal" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
  <div class="modal-dialog">
  	<div class="modal-content">
  		<div class="modal-header"><fmt:message key="report.resubmitJob"></fmt:message></div>
		<div class="modal-body"><fmt:message key="report.resubmitMessage"></fmt:message></div>
		<div class="modal-footer">
			<button id="cancel-req" class="btn default"><fmt:message key="common.action.cancel" /></button>
			<button id="resubmit-job" class="btn btn-primary"><fmt:message key="common.action.proceed" /></button>
		</div>
	</div>

</div>
</div>

<div class="container resubmit-job-container success">
</div>


<jsp:include page="../common/footer.jsp" >
	<jsp:param name="bootstrapped" value="true"/>
    <jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
</jsp:include>


<script nonce="${sessionScope.cspNonce}"  type="text/javascript">

$(document).ready(function(){

	$('#confirmation-modal').modal('show');

	$('#resubmit-job').click(function(){
	    $("#confirmation-modal").mask("");
	    var jobId = cvUtil.getParameter("jobId");
	    params = {
	        jobId : jobId,
	        isReportSchedule : true
	    }
	    cvUtil.loadPageWithPOST(cvUtil.getContextPath() + '/reports/resubmitJob.do', params, function(resp) {
	        $("#confirmation-modal").unmask();
	        if (resp.errorCode != 0) {
	            cvUtil.errorToast(resp.errorMessage);
	        } else {
	            $('.resubmit-job-container').html(resp.message);
	            $('#confirmation-modal').modal('hide');
	        }
	    }, function(err) {
	    	$("#confirmation-modal").unmask();
	        if (err.responseText) {
	            cvUtil.errorToast(err.responseText);
	        } else {
	            cvUtil.errorToast("");
	        }
	    });
	});
	$('#cancel-req').click(function(){
		window.location.href = cvUtil.getContextPath() ;
	});
});
</script>
