<%@  taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@  taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt"%>

<fmt:bundle basename="localization.ReportsMessages">

<jsp:include page="../common/header.jsp">
	<jsp:param value="true" name="includeSecHeader" />
	<jsp:param value="true" name="exportOptions" />
	<jsp:param value="true" name="includeCROptions" />
	<jsp:param value="true" name="classicReport"/>

	<jsp:param value="SLA" name="title" />
	<jsp:param value="true" name="changePage" />
	<jsp:param value="SLA" name="headerTitle" />
	<jsp:param value="${pageContext.request.contextPath}/common/css/headerstyles.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/jquery.loadmask.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/reports.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/common/multiselect/css/ui.multiselect.css" name="css"/>
 	<jsp:param value="reports/reportsBase.jsp" name="jsp"/>
 	<jsp:param value="true" name="includeJqueryUI"/>
 	<jsp:param value="true" name="showSettings"/>
 	<jsp:param value="true" name="includeHistory"/>
 	<jsp:param value="true" name="includeTableSupport"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/responsive/css/reportsNav.css" name="css" />
	<jsp:param value="true" name="bootstrapped" />
	<jsp:param value="true" name="reportsNav" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/table.css" name="css" />
 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-cb.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/common/css/custom-select.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/actionButtons.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/reports/css/sla.css" name="css"/>
 	<jsp:param value="${pageContext.request.contextPath}/settings/settings.css" name="css" />
</jsp:include>

<fmt:message key="SLA.SelectCLientGroup" var="selectClientGroup"/>
<fmt:message key="SLA.Default" var="days_default"/>
<fmt:message key="TimeFrame.Custom" var="days_custom"/>
<fmt:message key="TimeFrame.1Day" var="days_one"/>
<fmt:message key="TimeFrame.N_Days" var="days_n"/>
<fmt:message key="Search" var="searchMessage" />
<fmt:message key="protectedClients" var="protectedClients" />
<fmt:message key="unprotectedClients" var="unprotectedClients" />

<c:if test="${param.viewBy == 'BackupsetSLA' }">
	<fmt:message key="protectedBackupsets" var="protectedClients" />
	<fmt:message key="unprotectedBackupsets" var="unprotectedClients" />
</c:if>

<form name="filters" id="filters">
	<div id="filterPane" class="clearfix hideOnExportFriendly">
		<span class="inlineDisplay"><fmt:message key="Client_Group" />:</span>
		<div class="inlineDisplay">
			<ul id="clientGroup">
				<li id="All" class="excludeFromSearch"><fmt:message key="All" /></li>
				<li class="excludeFromSearch"><input type="text" id="searchClientGroup" autocomplete="off"  placeholder="${searchMessage}"/></li>
				<c:if test="${sessionScope.ALLOW_INCLUDE_ALL ne 'true'}">
					<li id="clearAll" class="excludeFromSearch"><fmt:message key="UnselectAll"/></li>
				</c:if>

				<li id="loadingDummyGroup" class="excludeFromSearch"><fmt:message key="Loading" /></li>
			</ul>
		</div>
		<div class="inlineDisplay" >
			<span class="time-frame-label"><fmt:message key="TimeFrame" />:</span>
		</div>
		<div class="inlineDisplay">
			<ul class="horizontalList" id="timeframe">
				<%-- <li id="0_days"> <fmt:message key="SLA.Default" /> </li>
				<li id="1_days"> <fmt:message key="TimeFrame.1Day" /> </li>
				<li id="2_days"> <fmt:message key="TimeFrame.2Days" /> </li>
				<li id="3_days"> <fmt:message key="TimeFrame.3Days" /></li>
				<li id="5_days"> <fmt:message key="TimeFrame.5Days" /></li>
				<li id="7_days"> <fmt:message key="TimeFrame.7Days" /></li>
				<li id="14_days"> <fmt:message key="TimeFrame.14Days" /></li>
				<li id="30_days"> <fmt:message key="TimeFrame.30Days" /></li>
				<li id="-1_days"><fmt:message key="TimeFrame.Custom" /></li> --%>
			</ul>
			</div>
		<div class="inlineDisplay" >
			<span class="time-range hide">
				<fmt:message key="TimeFrame.From" /><input type='text' id='from' name='from' class='time_range' title=' <fmt:message key="ms.search.date_error" /> '/>
				<fmt:message key="TimeFrame.To" /><input type='text' id='to' name='to' class='time_range' title= ' <fmt:message key="ms.search.date_error"/> '/>
			</span>
		</div>

		<div class="rghtFloat">
			<span class="inlineDisplay"><fmt:message key="Job_Type" />:</span>
			<div class="jobTypeRightMargin inlineDisplay">
				<ul id="jobType">
					<li data-value="All" id="AllJobs"><fmt:message key="All" /></li>
					<li data-value="Full" id="FullJobs"><fmt:message key="Full" /></li>
				</ul>
			</div>
			<div class="inlineDisplay scheduled-jobs-ui">
				<span id='countScheduledJobs' class='custom-cb' data-state="unchecked"></span><fmt:message key="SLA.ConsiderScheduledJobs" />
			</div>
			<div class="inlineDisplay" id="viewButtons">
				<ul class="horizontalList toggleButtons">
					<li id="ByClient" title="<fmt:message key="By_Clients" />"> <fmt:message key="By_Clients" /> </li>
					<li id="ByAgentType"><fmt:message key="By_Agent" />	</li>
					<%-- <li id="BackupsetSLA"><fmt:message key="SLA.by_backupset" /></li> --%>
				</ul>
			</div>
		</div>
	</div>
</form>
<div id="commcelltext" class="leftFloat clearfix reportView commcellspan" comp="commcelltext"  data-component-type="EB_HTML">
<span class="smallFont"><fmt:message key="CommCell" />:</span> <span id="commcellspan"></span>
</div>
<div id="asoftext" class="rghtFloat clearfix reportView asofspan">
<span class="smallFont"><fmt:message key="DataAsOf" /></span> <span id="asofspan"></span>
</div>
<div id="reportTaskSummaryDiv" class="showOnExportFriendly clearFloat" comp="reportTaskSummaryDiv"  data-component-type="EB_HTML">
<div id="reportTaskSummary" class="tabular clearfix">

</div>
</div>
<div class="clearFloat"></div>

<div class="reportContent boxedTable">

		<div id="firstPage">
			<div class="chartPanel reportView slapie boxedChart boxed" id="chartPanel" comp="chartPanel" data-component-type="METRICS_CHART">
				<div  id="slapie_chartTitle" class="boxedChartTitle"><fmt:message key="SLA.ClientSlaTitle" /></div>
				<div id="slapie" class="slapie_hideifnodata piechartcontainer"></div>
				<div id="slaPercent" class="slapie_hideifnodata currentSLALabel slaPercent">
					<span id="slapiefooter"><fmt:message key="SLA.SlaPieFooter" />&nbsp;</span>
					<span id="currentSLALabel"></span>
				</div>
				<div class="slapie_showifnodata chartnodata">
					<span><fmt:message key="SLA.SlaNotAvailable" /></span>
				</div>
				<div id="slaNote" class="hideifnodata slaNote excludedClientsLabel reportView">
				<fmt:message key="Note" />: <span id="excludedClientsLabel"></span> <fmt:message key="SLA.ExcludedClients" />
				</div>
			</div>
			<div class="chartPanel reportView boxedChart boxed slatrend" id="chartPanel2" comp="chartPanel2" data-component-type="METRICS_CHART">
		    	<div  id="slatrend_chartTitle" class="boxedChartTitle"><fmt:message key="SLA.Trend" /></div>
	            <div id="slatrend_nodata" class="slatrend_showifnodata chartnodata"><fmt:message key="NoDataAvailable" /></div>
	            <div id="slatrend" class="slatrend_hideifnodata">
	            </div>
	        </div>
		</div>

		<div id="A1">
			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="protectedClients" />
				<jsp:param name="tabletitle" value='<fmt:message key="MetSLA" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>

		<div id="B1">
			<div class="chartPanel reportView unprotectedPie  boxedChart boxed" comp="chartPanel3" data-component-type="METRICS_CHART">
				<div  id="unprotectedPie_chartTitle" class="boxedChartTitle chartTitle1"><fmt:message key="MissedSLA" /></div>
				<div id="unprotectedPie_nodata" class="unprotectedPie_showifnodata chartnodata"><fmt:message key="NoDataAvailable" /></div>
				<div id="unprotectedPie" class="unprotectedPie_hideifnodata piechartcontainer"></div>
				<div class="slaNote">
					<a href="${pageContext.request.contextPath}/reportsplus/reportViewer.jsp?reportId=Excluded%20Subclient%20from%20SLA" target="_blank"> <fmt:message key="SLA.viewSubclientsExcludedFromSLA"/> </a>
				</div>
			</div>
			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="unprotectedClients" />
				<jsp:param name="tabletitle" value='<fmt:message key="MissedSLA" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>

		<div id="B2a">
				<jsp:include page="reportstable.jsp">
					<jsp:param name="id" value="failedClients" />
					<jsp:param name="tabletitle" value='<fmt:message key="SLA.FailedClients" />' />
					<jsp:param name="collapsible" value='false' />
				</jsp:include>
		</div>
		<div id="B2b">
			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="noJobFound" />
				<jsp:param name="tabletitle" value='<fmt:message key="SLA.ClientsWithNoJobs" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>
		<div id="B2c">
			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="noSchedule" />
				<jsp:param name="tabletitle" value='<fmt:message key="SLA.ClientsWithNoSchedule" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>
		<div id="B2d">
			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="snapNoBackupCopy" />
				<jsp:param name="tabletitle" value='<fmt:message key="SLA.SnapNoBackupCopy" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>
		<div id="B2e">
			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="filteredVM" />
				<jsp:param name="tabletitle" value='<fmt:message key="SLA.FilteredVM" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>

		<div id="C1">
			<div class="chartPanel reportView excludedClientsPie boxedChart boxed" comp="chartPanel4" data-component-type="METRICS_CHART">
				<div  id="excludedClientsPie_chartTitle" class="boxedChartTitle chartTitle1"><fmt:message key="excludedEntities" /></div>
				<div id="excludedClientsPie_nodata" class="excludedClientsPie_showifnodata chartnodata"><fmt:message key="NoDataAvailable" /></div>
				<div id="excludedClientsPie" class="excludedClientsPie_hideifnodata piechartcontainer">

				</div>
			</div>

			<jsp:include page="reportstable.jsp">
				<jsp:param name="id" value="excludedClients" />
				<jsp:param name="tabletitle" value='<fmt:message key="excludedClients" />' />
				<jsp:param name="collapsible" value='false' />
			</jsp:include>
		</div>

		<div id="agentSla" class="reportView agentSLABars">
			<ul id="slaLegend" class="rghtFloat clearfix">
			<li class="colorBlock aboveThreshold"/>
			<li class=""> &gt;&nbsp;<span id="thresholdText1"></span>%</li>
			<li class="withLeftMargin colorBlock belowThreshold"/>
			<li class="clearfix"> &lt;&nbsp;<span id="thresholdText2"></span>%</li>
			</ul>
			<div class="clearFloat"></div>
			<div class="boxed">
				<!-- <div  id="agentSLABars_chartTitle" class="chartTitle barstitle">
					<ul class="tabular clearfix">
					<li class="textcol col1"><h1><span id="agentSLABarsTitle"><fmt:message key="AgentType" /></span></h1></li>
					<li class="barcol"><h1><fmt:message key="SLA.Percentage" /></h1></li>
					<li class="textcol"><h1><fmt:message key="protectedClients" /></h1></li>
					<li class="textcol"><h1><fmt:message key="unprotectedClients" /></h1></li>
					</ul>
				</div>
				<div class="reportView agentSLABars slabars">
					<ul id="agentSLABars" class="tabular clearfix">

					</ul>
				</div> -->
				<div id="agentSLABars_nodata" class="showifnodata chartnodata" comp="agentSLABars_nodata" data-component-type="EB_HTML"><fmt:message key="NoDataAvailable" /></div>
				<div class="slabars">
					<table id="agentSLABars" class="drawn">
						<thead class="barstitle">
							<tr>
								<th><fmt:message key="AgentType" /></th>
								<th><fmt:message key="SLA.Percentage" /></th>
								<th>${protectedClients}</th>
								<th>${unprotectedClients}</th>
							</tr>
						</thead>
						<tbody>
						</tbody>
					</table>
				</div>
			</div>

			<div id="agent_slaNote" class="hideifnodata slaNote agent_excludedClientsLabel reportView" comp="agent_slaNote" data-component-type="EB_HTML">
				<fmt:message key="Note" />: <span id="agent_excludedClientsLabel"></span> <fmt:message key="SLA.ExcludedClients" />
			</div>
		</div>

</div>

<div id="exclude-sla-dialog" title='<fmt:message key="SLA.ExcludeFromSLA" />'>
	<div id="exclude-sla-dialog-wrapper" class="hide">
		<div><span class="reason-lbl"><fmt:message key="SLA.reason_for_exclusion" />:</span></div>
        <div>
        	<textarea id="slaReason" class="sla-reason" ></textarea>
        </div>
	</div>
</div>

<%@ include file="reportsBaseBody.jsp" %>

</fmt:bundle>
<jsp:include page="../common/footer.jsp">
<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.loadmask.cv.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/g.raphael.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/raphael-line.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/raphael/custom-pie.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/jquery.corner.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/ba-debug.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/reports/js/cvcharts.js" name="js"/>
  <jsp:param value="${pageContext.request.contextPath}/reports/js/sla.js" name="js"/>
  <jsp:param value="${pageContext.request.contextPath}/settings/settings.js" name="js"/>
  <jsp:param value="${pageContext.request.contextPath}/common/js/jquery.ui.sortable.min.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-cb.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/js/custom-select.js" name="js"/>
	<jsp:param value="${pageContext.request.contextPath}/common/multiselect/js/ui.multiselect.js" name="js"/>
	<jsp:param value="true" name="bootstrapped" />

</jsp:include>

<script nonce="${sessionScope.cspNonce}"  type="text/javascript">
    var isAllowIncludeAll = '${sessionScope.ALLOW_INCLUDE_ALL}';
    var localMsg = localMsg || {};
	localMsg.selectClientGroup="${selectClientGroup}";
	localMsg.sla_days_default="${days_default}";
	localMsg.sla_days_custom="${days_custom}";
	localMsg.sla_days_one="${days_one}";
	localMsg.sla_days_n="${days_n}";

</script>
