var PARAM_REPORT_ENUM = "reportEnum";
var PARAM_REPORT_UNIQID = "reportUniqId";
var PARAM_URL = "reportUrl";
var API_SCHEDULE_ADD = "/reports/addReportSchedule.do";

$(document).ready(function() {
	$("#componentSelection").hide();
	window.reportEnum = cvUtil.getParameterByName(PARAM_REPORT_ENUM);
	window.reportUniqId = cvUtil.getParameterByName(PARAM_REPORT_UNIQID);
	
	if(cv && cv.additionalSettings && cv.additionalSettings.Console && cv.additionalSettings.Console.showReportComponentSelection){
		var components = cvUtil.getParameterByName("components");
		if (components) {
			components = JSON.parse(components);
			$("#components").empty();
			$.each(components, function(key, component) {
				$("#components").append('<option value="' + component.id + '">' + component.label + '</option>');
			});
			$("#componentOptions").removeClass('hidden');
			$("#components").multiselect({
				includeSelectAllOption : true,
				selectAllValue : 'all'
			});
		}
	}
	$("form").bind("keypress", function(e) {
		if (e.keyCode == 13) {
			return false;
		}
	});
	$("#emails").focus();
	$("#okButton").click(function(e) {
		ok();
		e.preventDefault();
	});
	$("#cancelButton").click(function(e) {
		cvUtil.closeModal();
	});

	var userEmail = window.sessionStorage.getItem('userEmail');
	if (userEmail) {
		$("#emailForm #emails").val(userEmail + ",");
	}

	$("select.exportType").change(function(){
		var selectedExportType = $(this).val();

		setDialogStateForSelectedFormat(selectedExportType);
	});
});

function setDialogStateForSelectedFormat(selectedExportType) {
	if (selectedExportType && selectedExportType.toUpperCase() == 'EMAIL_BODY') {
		// disable compress
		$(".notEmailBodyFriendly").addClass('disabled');
	} else {
		$(".notEmailBodyFriendly").removeClass('disabled');
	}
}

function isWebAnalytics() {

	var path = parent.window.location.pathname;
	if (path != undefined && path != "" && path.indexOf("webanalytics") != -1) {
		return true;
	}
	return false;
}

function isAnalyticsReports() {
	var path = parent.window.location.pathname;
	if (path != undefined && path != "" && path.indexOf("cireports") != -1) {
		return true;
	}
	return false;
}
function isAnalyticsSummaryReport() {
	var path = parent.window.location.search;
	if (path != undefined) {
		var type = cvUtil.getParameterByName('type', path);
		if (type == "summary") {
			return true;
		}
	}
	return false;
}
function isReportsPlus() {
	var path = parent.window.location.pathname;
	if (path != undefined && path != "" && path.indexOf("reportsplus") != -1) {
		return true;
	}
	return false;
}
function ok() {
	if (!validateEmail()) {
		return;
	}

	var params = {};
	if (cvUtil.getTopWindow().convertToExportUrl) {
		var exportType = $(".exportType").val().toLowerCase();
		currentUrl = cvUtil.getTopWindow().convertToExportUrl(currentUrl, exportType); //currenturl is initialized in jsp
	}
	if (isWebAnalytics()) {
		if (currentUrl.indexOf("scheduled=false") > -1) {
			currentUrl = currentUrl.replace("scheduled=false", "scheduled=true");
		} else {
			currentUrl = currentUrl + "&scheduled=true";
		}

		API_SCHEDULE_ADD = "/webanalytics/addReportSchedule.do";
	}
	if (isReportsPlus()) {
		currentUrl = currentUrl + "&viewportWidth=1600";
		var componentsVal = $("#components").val();
		if (componentsVal && $("#components option").length > componentsVal.length) {
			currentUrl = currentUrl + "&showComponents=" + componentsVal.join(",");
		}
	}
	params[PARAM_URL] = currentUrl;
	console.debug("Adding one time schedule: " + params[PARAM_URL]);
	var submissionMessage = "";
	var paramString = window.location.search + '&'; //retain the paramaters that were passed to this page
	var formParams = $('form').serialize();
	if (isAnalyticsReports()) {
		API_SCHEDULE_ADD = "/cireports/addReportSchedule.do";
		if (!isAnalyticsSummaryReport()) {
			paramString = cvUtil.getTopWindow().getParamString(exportType);
			var parmObj = cvUtil.getParameterByName('format', paramString);
			if (parmObj == "ZIP") {
				formParams = formParams.replace("CSV", "ZIP");
			}
		}
	}
	var isError = false;
	var formUrl = params.reportUrl;
	if (formUrl.indexOf("reports/index.jsp") > 0) {
		var dashboardUrl = formUrl.replace("reports/index.jsp", "survey/reports/dashboard.jsp");
		params.reportUrl = dashboardUrl;
	}
	var result = cvUtil.loadSynchronously(cvUtil.getContextPath() + API_SCHEDULE_ADD + paramString + formParams,
			params,
			function(data) {
				isError = true;
				console.error("Email request failed: " + data);
				var message = cvUtil.getTopWindow().localMsg['Email_Submisssion_Failed_Notification'];
				if (data.responseText != undefined || data.responseText != "") {
					message += data.responseText.trim();
				}
				submissionMessage = message;
				if (!!message) {
					showMessage(message, true);
				}
			});
	if (!isError) {
		console.debug("Add schedule result: " + result);
		cvUtil.getTopWindow().reportsUtil.jobStatus.updateJobList(result, 'submitted');
		var message = cvUtil.getTopWindow().localMsg['Email_Submisssion_Successfull_Notification'];
		if (!!message) {
			message = message.replace('{0}', +result);
			showMessage(message);
		}
		submissionMessage = message;
	}
	cvUtil.logUserAction(cvUtil.getParameterByName("filePrefix", paramString), 'email', exportType, "Message=[" +
			submissionMessage + "]");
	cvUtil.closeModal();
}
function showMessage(message, isError) {
	if (isError) {
		cvUtil.getTopWindow().cvUtil.errorToast(message, null, null, true);
	} else {
		cvUtil.getTopWindow().cvUtil.toast(message, null, null, true);
	}
}